/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
   (c) Emmanuel CURIS 1996                                    */

#define _AJUSTE_ 

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "SYSTEME.H"

#include "EXAFS.H"
#include "GRAPHES.H"
#include "SCIENCE.H"

#include "LISSAGE.H"

double par_ajuste[10]; /* Les paramtres d'ajustement - 10 maximum */

#define AJU_DROITE 1
#define AJU_LOG    2

/* ---------- Ajustement de base : comparaison courbe thorique / exp par les moindre carrs */

Graphe *ajuste(Graphe *experience)
{
	Graphe *affine;
	unsigned long nbr_pts,index;
	register double *zone_x, *zone_y;
	double zones[10];
	char methode = AJU_DROITE, titre[100];

	nbr_pts = experience->nombre_point;
	sprintf(titre,"Ajustement de %s",experience->nom);
	affine = GRF_creer(nbr_pts, experience->type, experience->drapeaux.complexe, titre,
	                            experience->axe_x, experience->axe_y, experience->unit_x, experience->unit_y);
	if (affine == NULL) return NULL; /* Cration du graphe impossible */

	/* Ici, paramtrer choix de la mthode, interface,... */	

	switch (methode)
	{
	case AJU_DROITE:
		zones[0] = experience->x_min;
		zones[1] = experience->x_max;
		moindre2(experience, 1, 1, zones, par_ajuste);
		printf("Paramtres : pente = %f, ordonne  l'origine = %f\n",par_ajuste[1],par_ajuste[0]);
		evnt_keybd(); /* On attend qu'une touche soit presse */
		break;

	case AJU_LOG:
		break;
	}

	/* Pour une droite seulement */

	zone_x = affine->x;
	zone_y = affine->y;
	for (index = 0 ; index < nbr_pts ; index++)
	{
		*zone_x = *(experience->x + index);
		*zone_y = par_ajuste[0] + par_ajuste[1] * *zone_x;
		zone_x++; zone_y++;
	}
	
	/* On met les bornes */
	
	affine->x_min = experience->x_min;
	affine->x_max = experience->x_max;
	affine->y_min = *(affine->y);
	affine->y_max = *(affine->y);
	zone_y = affine->y + 1;
	for (index = 1 ; index < nbr_pts ; index++)
	{
		if ( *(zone_y) > affine->y_max ) affine->y_max = *(zone_y);
		if ( *(zone_y) < affine->y_min ) affine->y_min = *(zone_y);
		zone_y++;
	}

	return affine; /* a a fonctionn */
}
