/* Gestion des atomes
   Messages d'erreur

   12 dcembre 1997
     * Cration du fichier
     * Version texte ralise
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "SYSTEME.H"

#include "ATM_ERR.H"

#ifdef _FRANCAIS_

static const char *texte_messages[] = 
{
  "[3][ ------ Trop de liaisons ------ | "
     "|    Un atome ne peut d"e_AIGU"velopper "
     "| que 15 liaisons au plus.][ Annuler ]",

  "[1][ ------ Atomes superpos"e_AIGU"s ----- | "
     "|          Deux atomes du mod"e_GRAVE"le"
     "| occupent la m"e_CIRC"me position.][ Suite ]",

  "[1][ ------ Atomes chevauchants --- | "
     "| D'apr"e_GRAVE"s les rayons %s,"
     "| deux atomes se chevauchent.][ Suite ]",

  "[3][ -- Num"e_AIGU"ro atomique inconnu --- "
     "| Z demand"e_AIGU" : %d "
     "| seuls les "e_AIGU"l"e_AIGU"ments 1  119 sont"
     "| connus du programme...][Annuler]"
};

#endif
#ifdef _ENGLISH_

static const char *texte_messages[] = 
{
  "[3][ ------ Too much bonds ------ | "
     "|    A single atom can't make "
     "| more than 15 bonds.][ Cancel ]",

  "[1][ ---- Atom superposition ---- | "
     "|     wo atoms of the model are"
     "| at the same location.][ Continue ]",

  "[1][ ----- Overlapping atoms ---- | "
     "| According to the %s radii,"
     "| two atoms are overlapping][ Continue ]",

  "[3][ -- Unknown atomic number --- "
     "| Z asked : %d "
     "| LASE only knows elements"
     "| from 1 to 119.][ Cancel ]"
};

#endif

int ATM_ERREUR(unsigned int numero, ...)
{
  char texte[500]; /* Devrait suffire pour les messages courants... */
  char *adresse;
  va_list extra_parametres;

  va_start(extra_parametres, numero);

  switch (numero)
  {
  case TROP_LIAISONS:     /* Ces messages n'ont pas d'autre paramtre */
  case ATOMES_SUPERPOSES:
    adresse = (char *) texte_messages[numero];
    break;

  case ATOMES_CHEVAUCHANTS: /* 1 paramtre = chane */
    sprintf(texte, texte_messages[numero], va_arg(extra_parametres, char *));
    adresse = texte;
    break;

  case ELEMENT_INCONNU: /* 1 paramtre = entier (int) */
    sprintf(texte, texte_messages[numero], va_arg(extra_parametres, int));
    adresse = texte;
    break;

  default:
    printf("Une erreur de type inconnu est survenue.n");
    printf("    Code de l'erreur : %d\n", numero);
    printf("Merci de me contacter en pr"e_AIGU"cisant comment l'erreur est survenue\n");
  }

  va_end(extra_parametres);

  return form_alert(1, adresse);
}
