/* Tout ce qui est gestion et autres des atomes
           (Dveloppement sur station)
   (C) 1997, Emmanuel CURIS

	tat : il faudrait travailler sur l'effacement -> remodelage des liaisons si besoin...

    5 fvrier 1998
     * Inclus "gem_gene.h" = pour les dfinitions GEM...
     * Fonction gnrique d'import des atomes : ATM_import()
     * Rarrang l'historique

    6, 9 janvier 1998
     * Continuation de ATM_num_atomique() : devrait marcher jusqu' l'lment 103...
     * Premire adaptation sous Turbo C

   10, 18 dcembre 1997
     * Cration de ATM_num_atomique() : numro atomique associ au symbole donn
     * On continue le paramtrage des infos atomiques

   22 & 23 novembre 1997
     * Cration du fichier
     * Entre des paramtres de base - de H  Zn
     * Routine de cration d'un nouvel atome
*/

#define _ATOMES_ 

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "SYSTEME.H"

#include "EXAFS.H"
#include "ATOMES.H"
#include "ATM_ERR.H"
#include "ATM_RSC.H"

/* Tableau regroupant toutes les donnes sur les atomes connus */
/* lectrongativits selon Allred-Rochow, calle sur Pauling  */
/* Rayons exprims en pm (1 pm = 10^12 m)                      */

ATM_infos ATM_donnees[130] = {
  {"H" , "Hydrog"e_GRAVE"ne",  1.00794  , 2.20,  37, 120, 0, NULL},
  {"He", "H"e_AIGU"lium"   ,  4.002602 , 5.50,   0, 160, 0, NULL},
  {"Li", "Lithium"  ,  6.941    , 0.97, 134, 181, 0, NULL},
  {"Be", "B"e_AIGU"ryllium",  9.012182 , 1.47,  90,   0, 0, NULL},
  {"B" , "Bore"     , 10.811    , 2.01,  86,   0, 0, NULL},
  {"C" , "Carbone"  , 12.0107   , 2.5 ,  11, 169, 0, NULL},
  {"N" , "Azote"    , 14.00674  , 3.07,  75, 155, 0, NULL},
  {"O" , "Oxyg"e_GRAVE"ne"  , 15.9994   , 3.5 ,  73, 151, 0, NULL},
  {"F" , "Fluor"    , 18.9984032, 4.1 ,  71, 147, 0, NULL},
  {"Ne", "N"e_AIGU"on"     , 20.1797   , 4.84,   0, 160, 0, NULL},
  {"Na", "Sodium"   , 22.9989770, 1.01, 154, 227, 0, NULL},
  {"Mg", "Magn"e_AIGU"sium", 24.3050   , 1.23, 130, 171, 0, NULL},
  {"Al", "Aluminium", 26.981538 , 1.47, 118, 205, 0, NULL},
  {"Si", "Silicium" , 28.0855   , 1.74, 117, 210, 0, NULL},
  {"P" , "Phosphore", 30.973761 , 2.06, 106, 182, 0, NULL},
  {"S" , "Soufre"   , 32.066    , 2.44, 102, 180, 0, NULL},
  {"Cl", "Chlore"   , 35.4527   , 2.83,  99, 177, 0, NULL},
  {"Ar", "Argon"    , 39.948    , 3.20,   0, 189, 0, NULL},
  {"K" , "Potassium", 39.0983   , 0.91, 196, 275, 0, NULL},
  {"Ca", "Calcium"  , 40.078    , 1.04, 174,   0, 0, NULL},
  {"Sc", "Scandium" , 44.955910 , 1.20, 144,   0, 0, NULL},
  {"Ti", "Titane"   , 47.867    , 1.32, 132,   0, 0, NULL},
  {"V" , "Vanadium" , 50.9415   , 1.45, 125,   0, 0, NULL},
  {"Cr", "Chrome"   , 51.9961   , 1.56, 127,   0, 0, NULL},
  {"Mn", "Mangan"e_GRAVE"se", 54.93804  , 1.60, 143,   0, 0, NULL},
  {"Fe", "Fer"      , 55.845    , 1.64, 122,   0, 0, NULL},
  {"Co", "Cobalt"   , 53.933200 , 1.7 , 126,   0, 0, NULL},
  {"Ni", "Nickel"   , 58.6934   , 1.75, 120, 161, 0, NULL},
  {"Cu", "Cuivre"   , 63.546    , 1.75, 138, 141, 0, NULL},
  {"Zn", "Zinc"     , 65.39     , 1.66, 125, 140, 0, NULL},
  {"Ga", "Gallium"  , 69.723    , 1.82, 121, 188, 0, NULL},
  {"Ge", "Germanium", 72.61     , 2.02, 122,   0, 0, NULL},
  {"As", "Arsenic"  , 74.92160  , 2.82, 120, 185, 0, NULL},
  {"Se", "S"e_AIGU"l"e_AIGU"nium" , 78.96     , 2.48, 117, 190, 0, NULL},
  {"Br", "Brome"    , 79.904    , 2.74, 114, 185, 0, NULL},
  {"Kr", "Krypton"  , 83.80     , 2.94, 115, 201, 0, NULL},
  {"Rb", "Rubidium" , 85.4678   , 0.89, 211, 242, 0, NULL},
  {"Sr", "Strontium", 87.62     , 0.97, 192,   0, 0, NULL},
  {"Y" , "Yttrium"  , 88.90585  , 1.11, 162,   0, 0, NULL},
  {"Zr", "Zirconium", 91.224    , 1.22, 145,   0, 0, NULL},
  {"Nb", "Niobium"  , 92.90638  , 1.23, 134,   0, 0, NULL},
  {"Mo", "Molybd"e_GRAVE"ne", 95.94     , 1.30, 129,   0, 0, NULL},
  {"Tc", "Techn"e_AIGU"tium", 98       , 1.36,   0,   0, 0, NULL},
  {"Ru", "Ruth"e_AIGU"nium", 101.07    , 1.42, 124,   0, 0, NULL},
  {"Rh", "Rhodium"  , 102.90550 , 1.45, 125,   0, 0, NULL},
  {"Pd", "Palladium", 106.42    , 1.35, 128, 161, 0, NULL},
  {"Ag", "Argent"   , 107.8682  , 1.42, 134, 171, 0, NULL},
  {"Cd", "Cadmium"  , 112.411   , 1.46, 141, 159, 0, NULL},
  {"In", "Indium"   , 114.818   , 1.49, 144, 191, 0, NULL},
  {"Sn", E_AIGU"tain"    , 118.710   , 1.72, 141, 218, 0, NULL},
  {"Sb", "Antimoine", 121.760   , 1.82, 140, 220, 0, NULL},
  {"Te", "Tellure"  , 127.60    , 2.01, 136, 208, 0, NULL},
  {"I" , "Iode"     , 126.90447 , 2.21, 133, 200, 0, NULL},
  {"Xe", "X"e_AIGU"non"    , 131.29    , 2.40, 128, 218, 0, NULL},
  {"Cs", "C"e_AIGU"sium"   , 132.90545 , 0.86, 230, 260, 0, NULL},
  {"Ba", "Baryum"   , 137.327   , 0.97, 198,   0, 0, NULL},
  {"La", "Lanthane" , 138.9055  , 1.08, 169,   0, 0, NULL},
  {"Ce", "C"e_AIGU"rium"   , 140.116   , 1.08, 165,   0, 0, NULL},
  {"Pr", "Pras"e_AIGU"odyme", 140.90765, 1.07, 165,   0, 0, NULL},
  {"Nd", "N"e_AIGU"odyme"  , 144.24    , 1.07, 164,   0, 0, NULL},
  {"Pm", "Prom"e_AIGU"thium", 145      , 1.07,   0,   0, 0, NULL},
  {"Sm", "Samarium" , 150.36    , 1.07, 166,   0, 0, NULL},
  {"Eu", "Europium" , 151.964   , 1.01, 185,   0, 0, NULL},
  {"Gd", "Gadolinium", 157.25   , 1.11, 161,   0, 0, NULL},
  {"Tb", "Terbium"   , 158.92534, 1.10, 159,   0, 0, NULL},
  {"Dy", "Dysprosium", 162.50   , 1.10, 159,   0, 0, NULL},
  {"Ho", "Holmium"  , 164.93032 , 1.10, 158,   0, 0, NULL},
  {"Er", "Erbium"   , 167.26    , 1.11, 157,   0, 0, NULL},
  {"Tm", "Thulium"  , 168.93421 , 1.11, 156,   0, 0, NULL},
  {"Yb", "Ytterbium", 173.04    , 1.06, 170,   0, 0, NULL},
  {"Lu", "Lut"e_AIGU"tium" , 174.967   , 1.14, 156,   0, 0, NULL},
  {"Ha", "Hafnium"  , 178.49    , 1.23, 146,   0, 0, NULL},
  {"Ta", "Tantale"  , 180.9479  , 1.33, 136,   0, 0, NULL},
  {"W" , "Tungst"e_GRAVE"ne", 183.84    , 1.40, 138,   0, 0, NULL},
  {"Re", "Rh"e_AIGU"nium"  , 186.207   , 1.46, 128,   0, 0, NULL},
  {"Os", "Osmium"   , 190.23    , 1.52, 126,   0, 0, NULL},
  {"Ir", "Iridium"  , 192.217   , 1.55, 126,   0, 0, NULL},
  {"Pt", "Platine"  , 195.078   , 1.44, 128, 172, 0, NULL},
  {"Au", "Or"       , 196.96655 , 1.41, 136, 168, 0, NULL},
  {"Hg", "Mercure"  , 200.59    , 1.44, 144, 152, 0, NULL},
  {"Tl", "Thallium" , 204.3833  , 1.44, 153, 198, 0, NULL},
  {"Pb", "Plomb"    , 207.2     , 1.5 , 154, 201, 0, NULL},
  {"Bi", "Bismuth"  , 208.98038 , 1.67, 152, 240, 0, NULL},
  {"Po", "Polonium" , 209       , 1.76, 153,   0, 0, NULL},
  {"At", "Astate"   , 210       , 1.90, 145,   0, 0, NULL},
  {"Rn", "Radon"    , 222       , 2.06,   0,   0, 0, NULL},
};

Atome *ATM_premier, *ATM_dernier;

/* ~~~~~~~~~~~~~~~~ Cration, effacement, ... des atomes ~~~~~~~~~~~~~~~~~~~~~~ */

Atome *ATM_creer(int numero_atomique, double x, double y, double z, int nbr_lies, Atome **lies, float charge, double rayon)
{
  Atome *atome = NULL;

  atome = (Atome *) malloc( (size_t) sizeof(Atome) );
  if (atome == NULL)
  {
    ERREUR(MANQUE_MEMOIRE);
    return NULL;
  }

  /* On ralise l'enchanement des atomes */

  if (ATM_premier == NULL)
  {
    ATM_premier = atome;
    atome->suivant = NULL;
    atome->precedent = NULL;
    ATM_dernier = atome;
  }
  else
  {
    ATM_dernier->suivant = atome;
    atome->precedent = ATM_dernier;
    atome->suivant   = NULL;
    ATM_dernier = atome;
  }

  /* On remplit avec les donnes transmises */

  atome->num_atomique = numero_atomique;
  atome->x = x;
  atome->y = y;
  atome->z = z;
  /*  printf("Coordonnes : %f %f %f\n", atome->x, atome->y, atome->z); */
  atome->charge = charge;
  if (rayon <= 0) /* Valeur absurde --> on prend le rayon de covalence des tables */
  {
    if ( (numero_atomique > 0) && (numero_atomique < 130) )
    {
      atome->rayon = ATM_donnees[numero_atomique].rayon_covalent;
    }
    else
      atome->rayon = -1;
  }
  else
    atome->rayon = rayon;

  if ( (nbr_lies == 0) || (lies == NULL) )
  {
    atome->nombre_lies = 0;
  }
  else
  {
    int i;

    if (nbr_lies > 15)
    {
      ATM_ERREUR(TROP_LIAISONS);
      nbr_lies = 15;
    }

    atome->nombre_lies = nbr_lies;
    for (i = 0 ; i < nbr_lies ; i++)
    {
      (atome->lies)[i] = lies[i];
    }    
  }

  return atome; /* L'atome nouvellement cr */
}

/* ------------------ Effacement d'un atome -----------------------------------------------------\
 |   Renvoie un int, sans usage actuel
 |
 | atome : l'atome qu'il faut effacer
 \---------------------------------------------------------------------------------------------- */

int ATM_efface(Atome *atome)
{
  if (atome == NULL) return 0; /* Atome inexistant */

  if (atome == ATM_premier) /* On efface le premier atome */
  {
    if (atome->suivant == NULL) /* C'est aussi le dernier */
    {
      ATM_dernier = NULL;
      ATM_premier = NULL;
    }
    else
    {
      ATM_premier = atome->suivant;
      ATM_premier->precedent = NULL; /* Nouveau premier atome */
    }
  }
  else if (atome == ATM_dernier)
  {
    ATM_dernier = atome->precedent;
    ATM_dernier->suivant = NULL; /* Nouveau dernier atome */
  }
  else
  {
    atome->precedent->suivant = atome->suivant;
    atome->suivant->precedent = atome->precedent;
  }

  free(atome);

  /* Il faut s'occuper de revoir les liaisons */

  return 0; /* Pas de probleme */
}

/* ~~~~~~~~~~~~~~~~~~ Quelques fonctions d'interface sympathiques ~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ------------------ Renvoi le numro atomique de l'lment de symbole considr ---------------\
 |    Renvoie 0 si le code est inconnu.                                                          |
 |    Si code du type Fe1 : utilise que Fe pour dterminer...                                |
 |                                                                                               |
 | symbole : chane dont les 2 premiers caractres doivent tre le symbole                       |
 \---------------------------------------------------------------------------------------------- */

int ATM_num_atomique(char *symbole)
{
  char lettre_1, lettre_2;

  if (symbole == NULL) return 0; /* Aucun symbole envoy */

  lettre_1 = symbole[0];
  lettre_2 = symbole[1];

  if ( (lettre_1 < 'A') && (lettre_1 > 'Z') )
    return 0; /* Symbole sans signification chimique, a priori */

  if ( (lettre_2 < 'a') && (lettre_2 > 'z') ) /* On a donc un symbole  une lettre seulement */
  {
    switch (lettre_1)
    {
    case 'B': return BORE;
    case 'C': return CARBONE;
    case 'D': return HYDROGENE; /* D = Deutrium = Hydrogne donc... */
    case 'F': return FLUOR;
    case 'H': return HYDROGENE;
    case 'I': return IODE;
    case 'N': return AZOTE;
    case 'O': return OXYGENE;
    case 'P': return PHOSPHORE;
    case 'S': return SOUFRE;
    case 'T': return HYDROGENE; /* T = Tritium donc hydrogne... */
    case 'U': return URANIUM;
    case 'V': return VANADIUM;
    case 'W': return TUNGSTENE;
    case 'Y': return YTTRIUM;
    default:
      return 0; /* Symbole non dfini */
    }
  }

  /* On est ici -> on utilise un symbole  deux lettres... */

  switch (lettre_1) /* Premire lettre du symbole */
  {
  case 'A':
    switch (lettre_2) /* Seconde lettre du symbole */
    {
    case 'c': return ACTINIUM; /* Ac */
    case 'g': return ARGENT;   /* Ag */
    case 'l': return ALUMINIUM;/* Al */
    case 'm': return AMERICIUM;/* Am */
    case 'r': return ARGON;    /* Ar */
    case 's': return ARSENIC;  /* As */
    case 't': return ASTATE;   /* At */
    case 'u': return OR;       /* Au */
    default: return 0; /* Pas de symbole dfini */
    }

  case 'B':
    switch (lettre_2)
    {
    case 'a': return BARYUM;    /* Ba */
    case 'e': return BERYLLIUM; /* Be */
    case 'i': return BISMUTH;   /* Bi */
    case 'k': return BERKELIUM; /* Bk */
    case 'r': return BROME;     /* Br */
    default: return BORE; /* B */
    }

  case 'C':
    switch (lettre_2)
    {
    case 'a': return CALCIUM;     /* Ca */
    case 'd': return CADMIUM;     /* Cd */
    case 'e': return CERIUM;      /* Ce */
    case 'f': return CALIFORNIUM; /* Cf */
    case 'l': return CHLORE;      /* Cl */
    case 'm': return CURIUM;      /* Cm */
    case 'o': return COBALT;      /* Co */
    case 'r': return CHROME;      /* Cr */
    case 's': return CESIUM;      /* Cs */
    case 'u': return CUIVRE;      /* Cu */
    default: return CARBONE; /* C */
    }

  case 'D':
    switch (lettre_2)
    {
    case 'y': return DYSPROSIUM;  /* Dy */
    default: return HYDROGENE; /* D = deutrium, donc hydrogne */
    }

  case 'E':
    switch (lettre_2)
    {
    case 'r': return ERBIUM;      /* Er */
    case 's': return EINSTEINIUM; /* Es */
    case 'u': return EUROPIUM;    /* Eu */
    default: return 0;
    }

  case 'F':
    switch (lettre_2)
    {
    case 'e': return FER;      /* Fe */
    case 'm': return FERMIUM;  /* Fm */
    case 'r': return FRANCIUM; /* Fr */
    default: return FLUOR; /* F = fluor */
    }

  case 'G':
    switch (lettre_2)
    {
    case 'a': return GALLIUM;    /* Ga */
    case 'd': return GADOLINIUM; /* Gd */
    case 'e': return GERMANIUM;  /* Ge */
    default: return 0;
    }

  case 'H':
    switch (lettre_2)
    {
    case 'a': return HAFNIUM; /* Ha */
    case 'e': return HELIUM;  /* He */
    case 'f': return HAFNIUM; /* Hf */
    case 'g': return MERCURE; /* Hg */
    case 'o': return HOLMIUM; /* Ho */
    default: return HYDROGENE;
    }

  case 'I':
    if (lettre_2 == 'n') return INDIUM;  /* In */
    if (lettre_2 == 'r') return IRIDIUM; /* Ir */
    return IODE;

  case 'K':
  	if (lettre_2 == 'r') return KRYPTON; /* Kr */
  	return POTASSIUM;

  case 'L':
    if (lettre_2 == 'a') return LANTHANE;   /* La */
    if (lettre_2 == 'i') return LITHIUM;    /* Li */
    if (lettre_2 == 'r') return LAWRENCIUM; /* Lr */
    if (lettre_2 == 'u') return LUTETIUM;   /* Lu */
    if (lettre_2 == 'w') return LAWRENCIUM; /* Lw - 2 symboles pendant un temps... */
    return 0;

  case 'M':
    if (lettre_2 == 'd') return MENDELEVIUM; /* Md */
    if (lettre_2 == 'g') return MAGNESIUM;   /* Mg */
    if (lettre_2 == 'n') return MANGANESE;   /* Mn */
    if (lettre_2 == 'o') return MOLYBDENE;   /* Mo */
    return 0;
    
  case 'N':
    if (lettre_2 == 'a') return SODIUM;    /* Na */
    if (lettre_2 == 'b') return NIOBIUM;   /* Nb */
    if (lettre_2 == 'd') return NEODYME;   /* Nd */
    if (lettre_2 == 'e') return NEON;      /* Ne */
    if (lettre_2 == 'i') return NICKEL;    /* Ni */
    if (lettre_2 == 'o') return NOBELIUM;  /* No */
    if (lettre_2 == 'p') return NEPTUNIUM; /* Np */
    return AZOTE;

  case 'O':
    if (lettre_2 == 's') return OSMIUM;  /* Os */
    return OXYGENE;

  case 'P':
    if (lettre_2 == 'a') return PROTACTINIUM; /* Pa */
    if (lettre_2 == 'b') return PLOMB;        /* Pb */
    if (lettre_2 == 'd') return PALLADIUM;    /* Pd */
    if (lettre_2 == 'm') return PROMETHIUM;   /* Pm */
    if (lettre_2 == 'o') return POLONIUM;     /* Po */
    if (lettre_2 == 'r') return PRASEODYME;   /* Pr */
    if (lettre_2 == 't') return PLATINE;      /* Pt */
    if (lettre_2 == 'u') return PLUTONIUM;    /* Pu */
    return PHOSPHORE;

  case 'R':
    if (lettre_2 == 'a') return RADIUM;    /* Ra */
    if (lettre_2 == 'b') return RUBIDIUM;  /* Rb */
    if (lettre_2 == 'e') return RHENIUM;   /* Re */
    if (lettre_2 == 'h') return RHODIUM;   /* Rh */
    if (lettre_2 == 'n') return RADON;     /* Rn */
    if (lettre_2 == 'u') return RUTHENIUM; /* Ru */
    return 0;

  case 'S':
    if (lettre_2 == 'b') return ANTIMOINE; /* Sb */
    if (lettre_2 == 'c') return SCANDIUM;  /* Sc */
    if (lettre_2 == 'e') return SELENIUM;  /* Se */
    if (lettre_2 == 'i') return SILICIUM;  /* Si */
    if (lettre_2 == 'm') return SAMARIUM;  /* Sm */
    if (lettre_2 == 'n') return ETAIN;     /* Sn */
    if (lettre_2 == 'r') return STRONTIUM; /* Sr */
    return SOUFRE;

  case 'T':
    if (lettre_2 == 'a') return TANTALE;    /* Ta */
    if (lettre_2 == 'b') return TERBIUM;    /* Tb */
    if (lettre_2 == 'c') return TECHNETIUM; /* Tc */
    if (lettre_2 == 'e') return TELLURE;    /* Te */
    if (lettre_2 == 'h') return THORIUM;    /* Th */
    if (lettre_2 == 'i') return TITANE;     /* Ti */
    if (lettre_2 == 'l') return THALLIUM;   /* Tl */
    if (lettre_2 == 'm') return THULIUM;    /* Tm */
    return HYDROGENE; /* T = tritium donc hydrogne */

  case 'U': return URANIUM;

  case 'V': return VANADIUM;

  case 'W': return TUNGSTENE;

  case 'X':
    if (lettre_2 == 'e') return XENON; /* Xe */
    return 0;

  case 'Y':
    if (lettre_2 == 'b') return YTTERBIUM;   /* Yb */
    return YTTRIUM;

  case 'Z':
    if (lettre_2 == 'n') return ZINC;      /* Zn */
    if (lettre_2 == 'r') return ZIRCONIUM; /* Zr */
    return 0;
  }

  return 0; /* Par dfaut, aucun atome dfini */
}

/* ----------------- Routine d'import des atomes ----------------------\
 |    Ne renvoie rien - ne reoit aucun paramtres                     |
 \-------------------------------------------------------------------- */

void ATM_import(void)
{
  if ( ext_formdo(IMPORTE_ATOMES) == IMP_ATM_ANNULE )
    return;

  if ( OBJ_choisit(IMPORTE_ATOMES, ATM_IMP_ASCII, QUESTION) )
  {
    /*		ATM_ascii(); /* On importe un fichier ASCII */
  }
  else if ( OBJ_choisit( IMPORTE_ATOMES, IMP_ATM_JNL, QUESTION) )
  {
    JNL_charge(); /* On importe un fichier *.JNL (origine : la CCDC) */
  }
  else if ( OBJ_choisit(IMPORTE_ATOMES, IMP_ATM_COR, QUESTION) )
  {
    COR_charge(); /* On importe un fichier *.COR (origine : la CCDC) */
  }
}
