/* Petit programme C pour extraire les infos des fichiers sortis par quest
   (C) Emmanuel CURIS, novembre 1997 - fvrier 1998

  11 fvrier 1998
    * Corrig COR_ligne() : dtectait pas la fin du fichier -> boucle sans fin !

   5 fvrier 1998
    * Modifi les noms des procdures de chargement en JNL_... (charge les fichiers *.JNL)
    * Ajout les fonctions de chargement des fichiers *.COR : COR_...
    * Corrig JNL_fichier : comptait 2 fois chaque ligne !
    * Inclus "atm_rsc.h" et "rsc.h" pour utiliser ler arbres d'import
             <string.h> pour les oprations de chanes
    * Chargement des fichiers *.COR fonctionne :-)

  7, 12 janvier 1998
  	* Travail sur le chargement : install le dbogage -> 2 des 3 fichiers passent
    * Rcupr le fichier sur la station - travail sur Atari maintenant
    * Supprim la fonction main(), devenu inutile
    * Chang les noms des fonctions : suffixe CCDB_
    * Ajout inclusion des fonctions GEM
    * Ajout procdure de choix du fichier : CCDB_charge()
    * Ajout identificateur : _LIT_CCDB_
*/

#define _LIT_CCDB_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifdef _UNIX_

# include "../SYSTEME.H"
# include "../EXAFS.H"
# include "../DEBUG.H"

#else

# include "..\SYSTEME.H"
# include "..\EXAFS.H"
# include "..\DEBUG.H"

#endif /* _UNIX_ */

#include <SCIENCE.H> /* Pour M_PI */

#include "ATOMES.H"
#include "ATM_ERR.H"
#include "ATM_RSC.H"
#include "LIT_CCDB.H"

Maille maille; /* La maille du cristal lu */

/* ~~~~~~~~~~~~~~~ Lecture des fichiers *.COR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ------------- Appel du slecteur : choix du fichier  charger -------------\
 |  Ne renvoie rien et n'utilise rien                                         |
 \--------------------------------------------------------------------------- */

void COR_charge(void)
{
  char **liste_noms;
  int nbr_fichiers, index;

  liste_noms = CH_selecteur("*.COR", "Fichier de coordonn"e_AIGU"es de la CCDC", 0, NULL, &nbr_fichiers);
  if (liste_noms == NULL) return; /* Aucun fichier  traiter */

  for (index = 0 ; index < nbr_fichiers ; index++)
  {
    int retour;

    sprintf(_intermediaire, "%s%s%c", nom_fichier, liste_noms[index], 0);

    retour = COR_fichier(_intermediaire);
    if (retour == TOUT_VA_BIEN)
    {
    }
    else
    {
      ERREUR(retour); /* Erreur lors du chargement */
    }
    free(liste_noms[index]);
  }
  free(liste_noms);
}

/* -------------- Lecture proprement dite du fichier ---------------------------\
 |   Renvoie un code en cas d'erreur                                            |
 |                                                                              |
 | nom_fichier : le nom du fichier qu'il faut charger                           |
 \----------------------------------------------------------------------------- */

int COR_fichier(char *nom_fichier)
{
  unsigned long nbr_lignes = 1;
  int type_ligne;
  FILE *fichier; /* le fichier que l'on va lire */

  if (nom_fichier == NULL)
    return NOM_VIDE;

  fichier = fopen(nom_fichier,"r");
  if (fichier == NULL)
    return ERREUR_LECTURE;

  /* Il faut commencer par sauter les coordonnes inintressantes */

  if ( OBJ_choisit(IMPORTE_ATOMES, IMP_COR_REF, QUESTION) ) /* On a donn une ref. */
  {
    char ref_lu[20], *reference;
    int nbr_lus;

    reference = lit_chaine(IMPORTE_ATOMES, IMP_ATM_REF, 0, NULL, TXT_COPIER);
	  
    nbr_lus = fscanf(fichier, "%s", ref_lu);
    while ( strncmp(ref_lu, reference, strlen(reference)) ) /* Les chanes sont diffrentes */
    {
      nbr_lus = fscanf(fichier, "%s", ref_lu);
      if (nbr_lus == EOF) /* Fin du fichier atteinte */
      {
	printf("Fin du fichier atteinte - chane non trouv"e_AIGU"e\n");
	evnt_keybd();
	return ERREUR_LECTURE;
      }
    }

    nbr_lus = fgetc(fichier); /* On saute la fin de la ligne */
    while ( (nbr_lus != '\n') && (nbr_lus != 10) && (nbr_lus != 13) )
    {
      nbr_lus = fgetc(fichier);
    }
  }
  else
  {
    int car_lu;
    int num_compose = 0, num_voulu = prend_valeur(IMPORTE_ATOMES, IMP_ATM_NUM_LIT);

    while (num_compose < num_voulu)
    {
      if ( COR_ligne(fichier, FAUX) == SEPARATEUR ) /* On change de compos */
	num_compose++;
			
      car_lu = fgetc(fichier);
      if (car_lu == EOF)
      {
	printf("Fin du fichier atteinte - chane non trouv"e_AIGU"e\n");
	evnt_keybd();
	return ERREUR_LECTURE;
      }

      while (car_lu != '\n') /* On passe la fin de la ligne */
      {
	car_lu = fgetc(fichier);
      }
    }
  }

  /* On est l : on commence la lecture des coordonnes */

  type_ligne = COR_ligne(fichier, VRAI);
  while ( type_ligne == DONNEES )
  {
    int car_lu;

    nbr_lignes++; /* On passe  la ligne suivante */

    /* On ignore la fin de la ligne */

    car_lu = fgetc(fichier);

#ifdef _D_CCDB_
    fprintf(debogage, "On ignore la fin de la ligne (ligne d)\n", nbr_lignes);
#endif

     while (car_lu != '\n')
     {
       car_lu = fgetc(fichier);
#ifdef _D_CCDB_
       fprintf(debogage, "%d (car : %c)\n", car_lu, (char) car_lu);
#endif
       if ( (car_lu == EOF) || ( (char) car_lu == 10) || ( (char) car_lu == 13) ) /* Pour voir */
       {
	 car_lu = '\n';
       }
     }

    type_ligne = COR_ligne(fichier, VRAI);
  }

#ifdef _D_CCDB_
  fprintf(debogage, "Fin du fichier atteinte - %ld lignes (dont %ld utiles)\n", nbr_lignes, nbr_util);
#endif

  fclose(fichier);

  return TOUT_VA_BIEN;
}

/* -------------- Lecture d'une ligne de coordonnes (fichier *.COR) --------------\
 |    Renvoie le type de ligne lu                                                  |
 |                                                                                 |
 | fichier     : le fichier que l'on est en train de traiter                       |
 | creer_atome : VRAI -> on cr un atome  partir des infos lues                  |
 \-------------------------------------------------------------------------------- */

int COR_ligne(FILE *fichier, boolean creer_atome)
{
  int num_atomique, nbr_lus;
  double x, y, z;
  char nom_atome[50];

  nbr_lus =  fscanf(fichier, "%s", nom_atome);
  if (nbr_lus <= 0) /* Problme de lecture */
    return EOF; /* On n'arrive plus  lire */

  /*  printf("Type d'atome : %s\n", nom_atome); */
  num_atomique = ATM_num_atomique(nom_atome); /* Quel atome charge-t-on ? */
  if (num_atomique == 0) /* Symbole chimique inconnu */
  {
    return SEPARATEUR; /* On passe en fait au compos suivant */
  }

  /* On lit les coordonnes */
  fscanf(fichier, "%lf%lf%lf", &x, &y, &z);
  /*  printf("Coordonnes : (%f, %f, %f)\n", x, y, z); */

  if ( creer_atome ) /* On veut crer un atome  partir de a */
  {
    ATM_creer(num_atomique, x, y, z, 0, NULL, 0, 0);
  }

  return DONNEES;
}

/* ~~~~~~~~~~~~~~~ Lecture des fichiers *.JNL ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ------------- Appel du slecteur : choix du fichier  charger -------------\
 |  Ne renvoie rien et n'utilise rien                                         |
 \--------------------------------------------------------------------------- */

void JNL_charge(void)
{
	char **liste_noms;
	int nbr_fichiers, index;

	liste_noms = CH_selecteur("*.JNL", "Journal d'une session avec la CCDC", 0, NULL, &nbr_fichiers);
	if (liste_noms == NULL) return; /* Aucun fichier  traiter */

	for (index = 0 ; index < nbr_fichiers ; index++)
	{
		int retour;

		sprintf(_intermediaire, "%s%s%c", nom_fichier, liste_noms[index], 0);

		retour = JNL_fichier(_intermediaire);
		if (retour == TOUT_VA_BIEN)
		{
		}
		else
		{
			ERREUR(retour); /* Erreur lors du chargement */
		}
		free(liste_noms[index]);
	}
	free(liste_noms);
}

/* -------------- Lecture proprement dite du fichier ---------------------------\
 |   Renvoie un code en cas d'erreur                                            |
 |                                                                              |
 | nom_fichier : le nom du fichier qu'il faut charger                           |
 \----------------------------------------------------------------------------- */

int JNL_fichier(char *nom_fichier)
{
  unsigned long nbr_lignes = 1, nbr_util = 0;
  int type_ligne;
  FILE *fichier; /* le fichier que l'on va lire */
  char debut = FAUX;

  if (nom_fichier == NULL)
    return NOM_VIDE;

  fichier = fopen(nom_fichier,"r");
  if (fichier == NULL)
    return ERREUR_LECTURE;

  type_ligne = JNL_ligne(fichier, nbr_util);
  while ( type_ligne != EOF )
  {
    nbr_lignes++; /* On passe  la ligne suivante */

    if (type_ligne != LIGNE_VIDE)
    {
      /* On ignore la fin de la ligne */

      int car_lu = fgetc(fichier);

#ifdef _D_CCDB_
			fprintf(debogage, "On ignore la fin de la ligne (ligne d)\n", nbr_lignes);
#endif

      while (car_lu != '\n')
      {
				car_lu = fgetc(fichier);
#ifdef _D_CCDB_
				fprintf(debogage, "%d (car : %c)\n", car_lu, (char) car_lu);
#endif
				if ( (car_lu == EOF) || ( (char) car_lu == 10) || ( (char) car_lu == 13) ) /* Pour voir */
				{
					car_lu = '\n';
				}
      }
    }
#ifdef _D_CCDB_
	 else
	 {
	 	 fprintf(debogage, "On vient de lire une ligne vide\n");
	 }
#endif

    if (type_ligne == SEPARATEUR)
    {
#ifdef _D_CCDB_
			fprintf(debogage, "On vient d'atteindre la partie intressante\n");
#endif
      debut = VRAI;
    }

    if ( (type_ligne == DONNEES) && (debut == VRAI) )   /* On vient de lire une ligne de donnes */
      nbr_util++;

    /* On passe  la ligne suivante */

    type_ligne = JNL_ligne(fichier, nbr_util);
  }

#ifdef _D_CCDB_
  fprintf(debogage, "Fin du fichier atteinte - %ld lignes (dont %ld utiles)\n", nbr_lignes, nbr_util);
#endif

  fclose(fichier);

  return TOUT_VA_BIEN;
}

/* ----- Lecture d'une ligne du fichier. Renvoie le type de ligne lue... ----- */

int JNL_ligne(FILE *fichier, unsigned long nbr_util)
{
  int car_lu;
  float cote_a, cote_b, cote_c, alpha, beta, gamma; /* Paramtres de maille */
  float x, y, z;
  char nom_atome[50];

  car_lu = fgetc(fichier);
  if ( (car_lu == '\n') || ( (char) car_lu == 10) || ( (char) car_lu == 13) ) /* Fichiers Mac/PC/Unix */
  {
#ifdef _D_CCDB_
    fprintf(debogage, " La ligne tait vide\n");
#endif
    return LIGNE_VIDE;
  }

	if ( (car_lu >> 8) == 13 )
	{
		return LIGNE_VIDE;
	}

  if (car_lu == EOF)
    return EOF;

  if (car_lu == '#')
  {
#ifdef _D_CCDB_
    fprintf(debogage, " Ligne de commentaire\n");
#endif
    return COMMENTAIRE;
  }

  if (car_lu == '-') /* Ligne commenant par un - --> les donnes sont aprs (?) */
  {
#ifdef _D_CCDB_
	  fprintf(debogage, "On vient d'atteindre la ligne de sparation\n");	
#endif
    return SEPARATEUR;
  }

  if ( car_lu == ' ' )   /* Ligne commenant par un espace --> donnes ( vrifier) */
  {
    if (nbr_util == 2) /* Dimensions de la cellule */
    {
      float coef_c;

      fscanf(fichier, "%f %f %f", &cote_a, &cote_b, &cote_c);
      fscanf(fichier, "%f %f %f", &alpha, &beta, &gamma);
      /* Conversion des angles en radians... */
      alpha *= M_PI / 180;
      beta  *= M_PI / 180;
      gamma *= M_PI / 180;

      maille.x_vect_a = cote_a; /* Premier vecteur align sur le vecteur a */
      maille.x_vect_b = cote_b * cos(gamma); /* gamma = (a, b), par convention */
      maille.y_vect_b = cote_b * sin(gamma);
      maille.x_vect_c = cote_c * cos(beta);  /* beta = (a, c) */
      maille.y_vect_c = cote_c * ( cos(alpha) - cos(gamma) * cos(beta) ) / sin(gamma);
      coef_c = maille.x_vect_c * maille.x_vect_c - maille.y_vect_c * maille.y_vect_c;
      maille.z_vect_c = sqrt(cote_c * cote_c - coef_c);
    }
    else if (nbr_util > 2)
    {
      float X, Y, Z; /* Coordonnes relles de l'atome, dans un repre orthonorm */
      int num_atomique;

      fscanf(fichier, "%s %f %f %f", nom_atome, &x, &y, &z);

      /* On ralise le changement de repre : lues = x * a + y * b + z * c */

      X = maille.x_vect_a * x + maille.x_vect_b * y + maille.x_vect_c * z;
      Y =                       maille.y_vect_b * y + maille.y_vect_c * z;
      Z =                                             maille.z_vect_c * z;

      num_atomique = ATM_num_atomique(nom_atome); /* Recherche du n atomique d'aprs le nom */

#ifdef _D_CCDB_
      fprintf(debogage, "Atome %s : X = %f, Y = %f, Z = %f; Numro %d\n", nom_atome, X, Y, Z, num_atomique);
#endif

      ATM_creer(num_atomique, X, Y, Z, 0, NULL, 0, 0); /* On cr un atome associ */
    }

    return DONNEES;
  }

#ifdef _D_CCDB_
	fprintf(debogage, "Ligne ne servant  rien - ignore. Commenait par %d (%c)\n", car_lu, (char) car_lu);
#endif

  return BLAH_BLAH; /* Ligne ne servant  rien */
}
