/* Bibliothque X-Window pour les interfaces
            Routines de gestion des arbres GEM
	    Fichier  inclure
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 26 mars 1998
   * Cration du fichier
*/

#ifndef _X_ARBRES_H_

#define _X_ARBRES_H_

#include "X_objets.h"

/* --------- Arbre d'objet GEM adapt  X-Window */

typedef struct
{
  OBJECT *adresse;   /* Adresse de la racine de l'arbre considr */

  union
  {
    boolean (*arbre)(int num_obj, int x, int y); /* Fonction de gestion de l'arbre */
    boolean (*menu) (int option);                /* Cas d'un menu */
  } fonction;
  boolean (*clavier)(unsigned int touche, int etat, int *renvoi); /* Gestion du clavier */

  short int type;    /* Type d'arbre : 0 = tjrs form_do, 1 = mixte, 2 = tjrs fentre */

  int premier_edit;  /* Premier objet ditable de l'arbre */
  int edit_courant;  /* objet ditable actif   de l'arbre */
  int dernier_edit;  /* Dernier objet ditable de l'arbre */
  int pos_curseur;   /* Position du curseur dans l'objet ditable courant */

  boolean ouvert; /* VRAI si l'arbre est ouvert */

  void *pointeur; /* Pointeur libre pour l'utilisateur */

  /* -------- Ici, ce qui est en plus pour X-Window -------- */

  int nbr_objets;  /* Nombre d'objets dans l'arbre */

  Window *objets;  /* objets[i] = index de la fentre X qui correspond  l'objet i */

} Arbre;

void ARB_init(int num_arbre, boolean adapte);

Arbre *quel_arbre(OBJECT *objet);

#include "X_fenetres.h" /* Pour avoir la dfinition de fenetre */

Fenetre *appelle_arbre(int arbre, int attributs, char *titre, char mode);
Fenetre *ARB_fenetre(Arbre *arbre);

int ARB_message(int arbre, unsigned int temps);

int GER_ssmenu(int arbre, int largeur, int x, int y);

void PRP_defileur(int arbre, int prem_texte, int dern_texte,
		  int avant, int apres, int fd_asc, int bouton_asc,
                  int arbre_textes, int texte_1, int texte_2, int num_depart, int num_select);
int GER_defileur(int arbre, int prem_texte, int dern_texte,
		 int avant, int apres, int fd_asc, int bouton_asc,
                 int arbre_textes, int texte_1, int texte_2, int *num_depart, int *num_select,
                 int objet, int x_souris, int y_souris);

void PDFL_textes(int arbre, int prem_texte, int dern_texte, int avant, int apres,
		 int fd_asc, int bouton_asc,
                 unsigned long nbr_textes, char **textes, boolean *choisi,
		 unsigned long num_choisi,
                 int max_long, unsigned long prem_affiche);
int GDFL_textes(int arbre, int prem_texte, int dern_texte, int avant, int apres,
		int fd_asc, int bouton_asc,
                unsigned long nbr_textes, char **textes, boolean *choisi,
		unsigned long *num_choisi,
                int max_long, unsigned long *prem_affiche, int objet, int y_souris);

int gere_ascenseur(int num_arbre, int premier, int min, int max, int pas, boolean mode,
		   int obj_clic, int x, int y);

float gere_fascenseur(int num_arbre, int premier, float min, float max, float pas, boolean mode,
		      int obj_clic, int x, int y);

#endif /* _X_ARBRES_H_ */
