/* Bibliothque X-Window pour les interfaces
            Routines de gestion du clavier
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS - Cration le 29 mai 1998
*/

#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* #include <time.h> */

#define _LIBRAIRIE_X_ /* Pour accder aux fonctions internes aussi */

#include <Bib_X.h>

/* ********* Traitement automatique d'un vnement clavier ******** */

int EVNT_clavier(Fenetre *fenetre, XKeyEvent *clavier)
{
  KeySym touche;
  unsigned int touche_gem;

  if (fenetre == NULL) /* Pas une fentre GEM classique */
    return FAUX;

  if (fenetre->type == GEM_FENETRE) /* Fentre de type GEM */
  {
    int retour = CLAV_arbre(fenetre->arbre, clavier);

    if (retour < 0) /* On a utilis un bouton pour sortir de l'arbre */
    {
      if (fenetre->arbre->fonction.menu) /* Une fonction associe  l'arbre */
      {
	int x, y; /* Coordonnes souris */

	return (fenetre->arbre->fonction.arbre)(-retour, x, y);
      }
      else /* Fonctionnement par dfaut */
      {
	return _QUITTER; /* On demande de quitter l'arbre */
      }
    }

    if (retour == VRAI) /* Trait */
      return VRAI;
  }

  /* On rcupre le code de la touche utilise */

  touche_gem = XToucheVersGEM(clavier, TOUCHE_PRESSEE, &touche);
  if (touche_gem == 0)
  {
    printf("Touche X sans quivalent GEM : %ld\n", touche);
  }

  if ( (touche_gem >> 8) == 255 )
  {
    /*    printf("Touche  fonction spciale interne\n"); */
    return VRAI;
  }

  if ( fenetre->clavier ) /* Fonction de gestion du clavier associe  cette fentre */
  {
    int retour;

    retour = (fenetre->clavier)(fenetre, touche_gem, _etat);
    if (retour != FAUX) /* trait */
      return retour;
  }

  /* Par dfaut : on s'occupe du menu */

  return CLAV_menu(clavier);
}

/* -------------- Gestion du clavier pour un arbre ------------------------ */

int CLAV_arbre(Arbre *arbre, XKeyEvent *clavier)
{
  KeySym touche; /* tat des touches spciales */
  char tampon[128];
  
  XLookupString(clavier, tampon, 128, &touche, (XComposeStatus *) NULL);

  if ( (touche == XK_Control_L) || (touche == XK_Control_R) )
  {
    _etat |= K_CTRL; /* On appuie sur Control aussi */
    return VRAI; /* Trait */
  }

  if ( touche == XK_Shift_L )
  {
    _etat |= K_LSHIFT;
    return VRAI;
  }

  if ( touche == XK_Shift_R )
  {
    _etat |= K_RSHIFT;
    return VRAI;
  }

  if (touche == XK_Return) /* Return : on vrifie l'existence d'un objet EXIT */
  {
    int obj;

    for (obj = ROOT ; obj < arbre->nbr_objets ; obj++)
    {
      if ( (OB_FLAGS(arbre->adresse, obj) & DEFAULT)
	   && !(OB_STATE(arbre->adresse, obj) & DISABLED) )
      {

	if (arbre->fonction.menu) /* Il y a une fonction de gestion */
	  return (arbre->fonction.arbre)(obj, 0, 0);

	if ( (OB_FLAGS(arbre->adresse, obj) & EXIT)
	     || (OB_FLAGS(arbre->adresse, obj) & TOUCHEXIT) )
	  return -obj; /* On renvoie le numro d'objet de sortie */
      }
    }
  }

  if (arbre->premier_edit > ROOT) /* Il y a un objet ditable quelconque */
  {
    TEDINFO *tedinfo = (arbre->adresse)[arbre->edit_courant].ob_spec.tedinfo;
    unsigned int dernier_car; /* Dernier caractre entr dans un objet ditable */

    switch (touche) /* Pour avoir les touches spciales */
    {
    case XK_Return: /* Passer au champ ditable suivant */
    case XK_Down:
    case XK_Tab:
      if (arbre->edit_courant < arbre->dernier_edit)
      {
	int obj;

	objc_edit(arbre->adresse, arbre->edit_courant, 0, arbre->pos_curseur, ED_END, &obj);

	for (obj = arbre->edit_courant + 1 ; obj <= arbre->dernier_edit ; obj++)
	{
	  if ( (OB_FLAGS(arbre->adresse, obj) & EDITABLE)
	       && !(OB_STATE(arbre->adresse, obj) & DISABLED) ) /* Objet ditable non dsactiv */
	  {
	    arbre->edit_courant = obj;
	    objc_edit(arbre->adresse, obj, 0, 
		      arbre->pos_curseur, ED_INIT, &(arbre->pos_curseur));
	    return VRAI;
	  }
	}
	printf("Problme : marqu comme ayant un ditable aprs - non trouv !\n");
	printf("Edit_courant : %d - dernier_edit : %d\n", arbre->edit_courant, arbre->dernier_edit);
	return FAUX;
      }
      break;
      
    case XK_Up: /* Passer au champ ditable prcdent */
      if (arbre->edit_courant > arbre->premier_edit)
      {
	int obj;

	objc_edit(arbre->adresse, arbre->edit_courant, 0, arbre->pos_curseur, ED_END, &obj);

	for (obj = arbre->edit_courant - 1 ; obj >= arbre->premier_edit ; obj--)
	{
	  if ( (OB_FLAGS(arbre->adresse, obj) & EDITABLE)
	       && !(OB_STATE(arbre->adresse, obj) & DISABLED) ) /* Objet ditable non dsactiv */
	  {
	    arbre->edit_courant = obj;
	    objc_edit(arbre->adresse, obj, 0, 
		      arbre->pos_curseur, ED_INIT, &(arbre->pos_curseur));
	    return VRAI;
	  }
	}
	printf("Problme : marqu comme ayant un ditable avant - non trouv !\n");
	return FAUX;
      }
      break;

    case XK_BackSpace: /* Traites dans objc_edit */
    case XK_Escape:
      touche &= 0xFF; /* On ne garde que le code ASCII */
      break;

    case XK_Delete:   /* Delete : on efface un caractre */
      dernier_car = OBJ_der_caractere(tedinfo);
      if (arbre->pos_curseur < dernier_car)
      {
	int i;

	for (i = arbre->pos_curseur ; i < dernier_car ; i++)
	{
	  (tedinfo->te_ptext)[i] = (tedinfo->te_ptext)[i + 1];
	}

	if (dernier_car == tedinfo->te_txtlen - 1) /* La chane tait complte */
	  (tedinfo->te_ptext)[dernier_car] = 0;

	objc_draw(arbre->adresse, arbre->edit_courant, MAX_DEPTH, 0, 0,
		  OB_WIDTH(arbre->adresse, arbre->edit_courant),
		  OB_HEIGHT(arbre->adresse, arbre->edit_courant) );

	objc_edit(arbre->adresse, arbre->edit_courant, 0,
		  arbre->pos_curseur, ED_END + 1, &(arbre->pos_curseur) );
      }
      return VRAI;

    case XK_Right:    /* Curseur vers la droite */
      dernier_car = OBJ_der_caractere(tedinfo);
      if (arbre->pos_curseur < dernier_car)
      {
	objc_edit(arbre->adresse, arbre->edit_courant, 0,
		  arbre->pos_curseur, ED_END, &(arbre->pos_curseur) );
	arbre->pos_curseur++;
	objc_edit(arbre->adresse, arbre->edit_courant, 0,
		  arbre->pos_curseur, ED_END + 1, &(arbre->pos_curseur) );
      }
      return VRAI;

    case XK_Left:     /* Curseur vers la gauche */
      if (arbre->pos_curseur > 0)
      {
	objc_edit(arbre->adresse, arbre->edit_courant, 0,
		  arbre->pos_curseur, ED_END, &(arbre->pos_curseur) );
	arbre->pos_curseur--;
	objc_edit(arbre->adresse, arbre->edit_courant, 0,
		  arbre->pos_curseur, ED_END + 1, &(arbre->pos_curseur) );
      }
      return VRAI;
    }

    if ( (touche >= XK_KP_Space) && (touche <= XK_KP_9) )
    {
      printf("Pav numrique - %c\n", tampon[0]);
      touche += XK_0 - XK_KP_0; /* Pav numrique, version numrique */
    }

    if ( (touche >= 0) && (touche < 256) ) /* Touche clavier classique : octet 2  0 -> latin 1 */
    {
      objc_edit(arbre->adresse, arbre->edit_courant, touche,
		arbre->pos_curseur, ED_CHAR, &(arbre->pos_curseur) );
    }

    return VRAI; /* Traitement a russi - toujours s'il y a des objets ditables */
  }

  if ( touche > 0 ) /* Il y a bien eu quelque chose ? */
  {
   
  }

  return FAUX; /* Traitement a chou */
}

/* ******** quelques  macros  gnrales de gestion du clavier **************** */

/* ***
 *  Renvoie un code de touche au format atari  partir d'un code X-Windows
 *
 * si renvoie 0 : aucune touche correspondante
 * si renvoie 255 comme code clavier : touche X  fonction interne dfinie
 * *** */

unsigned int XToucheVersGEM(XKeyEvent *clavier, int mode, KeySym *touche_X)
{
  KeySym touche;
  char tampon[128];
  unsigned int touche_gem;

  XLookupString(clavier, tampon, 128, &touche, (XComposeStatus *) NULL);

  if (touche_X) /* Utilisateur veut aussi le code X */
    *touche_X = touche;

  if ( (touche == XK_Control_L) || (touche == XK_Control_R) )
  {
    if (mode == TOUCHE_PRESSEE)
      _etat |= K_CTRL; /* On appuie sur Control aussi */
    else
      _etat &= ~K_CTRL; /* On relche Control */
    return (255 << 8); /* Trait */
  }

  if ( touche == XK_Shift_L )
  {
    if (mode == TOUCHE_PRESSEE)
      _etat |= K_LSHIFT;
    else
      _etat &= ~K_LSHIFT; /* On relche Shift de gauche */
    return (255 << 8);
  }

  if ( touche == XK_Shift_R )
  {
    if (mode == TOUCHE_PRESSEE)
      _etat |= K_RSHIFT;
    else
      _etat &= ~K_RSHIFT; /* On relche Shift de droite */
    return (255 << 8);
  }

  switch (touche)
  {
  case XK_Up: /* Flche vers le haut */
    touche_gem = (72 << 8); /* Code clavier sur atari de la flche vers le haut */
    break;

  case XK_Down: /* Flche vers le bas */
    touche_gem = (80 << 8);
    break;

  case XK_Right:
    touche_gem = (77 << 8);
    break;

  case XK_Left:
    touche_gem = (78 << 8);
    break;

  case XK_Return:
    touche_gem = 13;
    break;

  default:
    touche_gem = tampon[0]; /* Code ASCII... */
    if (_etat & K_CTRL)
    {
      if ( (touche_gem >= 'A') && (touche_gem <= 'Z') )
	touche_gem -= 'A' + 1;
      else if ( (touche_gem >= 'a') && (touche_gem <= 'z') )
	touche_gem -= 'a' + 1;
    }
  }

  return touche_gem;
}


