/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Dclarations des fonctions
   Bibliothque d'vnements (EVNT lib)

   *** Voir  finir le evnt_multi pour qu'il soit propre ***

*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include <Bib_X.h>

int EVNT_redessin(Fenetre *fenetre, XExposeEvent *redessin); /* Dans X_gene.c */
int EVNT_relache (XKeyEvent *clavier);                       /* Dans X_gene.c */

/* -------- On attend un vnement clavier -------- */

unsigned int evnt_keybd(void)
{
  char tampon[10];
  unsigned int touche;
  KeySym code;
  XEvent evenement;

  if (_premiere_fenetre == NULL)
  {
    printf("evnt_keybd : aucune fentre X ouverte -> cela bloquerait le programme !\n");
    return 32; /* On simule appui sur espace */
  }

  XMaskEvent(_Display, KeyPressMask | KeyReleaseMask, &evenement);
  XLookupString(&(evenement.xkey), tampon, 9, &code, NULL);

  touche = tampon[0];
  return touche;
}

/* -------- On attend un vnement clic souris  ---- */

int evnt_button(int clics, unsigned int masque_voulu, unsigned int etat_voulu,
		int *pmx, int *pmy, int *pmb, int *pks)
{
  XEvent evenement;
  Window racine, fille;
  int x, y, x_racine, y_racine;
  unsigned int masque, boutons = 0;

  if (_premiere_fenetre == NULL)
  {
    printf("evnt_keybd : aucune fentre X ouverte -> cela bloquerait le programme !\n");
    return 0; /* On simule appui sur rien du tout */
  }

  /*  printf("Masque voulu : %u (tat: %d)", masque_voulu, etat_voulu); */

  XQueryPointer(_Display, _Fen_redessin, &racine, &fille, &x_racine, &y_racine, &x, &y, &masque);
  if ( (masque & Button1Mask) && (masque_voulu & 1) )
    boutons |= 1;
  if ( (masque & Button2Mask) && (masque_voulu & 2) )
    boutons |= 2;
  if ( (masque & Button3Mask) && (masque_voulu & 4) )
    boutons |= 4;
  if ( (masque & Button4Mask) && (masque_voulu & 8) )
    boutons |= 8;
  if ( (masque & Button5Mask) && (masque_voulu & 16) )
    boutons |= 16;

  /*  printf(" - masque actuel : %u (etat : %u)\n", masque, boutons); */

  while (etat_voulu != boutons) /* tant que l'on n'a pas le masque demand */
  {
    XMaskEvent(_Display, ButtonPressMask | ButtonReleaseMask, &evenement);

    x = evenement.xbutton.x;
    y = evenement.xbutton.y;
    if ( evenement.type == ButtonPress ) /* On appuie sur le bouton */
    {
      int bouton_gem = evenement.xbutton.button - Button1;
      if ( masque_voulu & (1 << bouton_gem) ) /* On s'intresse  ce bouton */
	boutons |= (1 << bouton_gem);
    }
    else /* On relche le bouton */
    {
      int bouton_gem = evenement.xbutton.button - Button1;
      if ( masque_voulu & (1 << bouton_gem) ) /* On s'intresse  ce bouton */
	boutons &= ~(1 << bouton_gem);
    }
  }

/*  printf("Masque final : %u (etat : %u)\n", masque, boutons); */

  *pmx = x; *pmy = y; *pmb = 0; /* Manque tat des touches spciales */
  return 0;
}

int  evnt_mouse      (int flags, int x, int y, int width, int height,
		      int  *pmx, int  *pmy,
		      int  *pmb, int  *pks);
int  evnt_mesag      (int  *pbuff);
int  evnt_timer      (unsigned int locnt, unsigned int hicnt);

/* -------- On attend n'importe quel vnement -------- */

int evnt_multi(unsigned int flags, unsigned int bclk, unsigned int bmsk, unsigned int bst,
	       unsigned int m1flags,
	       unsigned int m1x, unsigned int m1y, unsigned int m1w, unsigned int m1h,
	       unsigned int m2flags,
	       unsigned int m2x, unsigned int m2y, unsigned int m2w, unsigned int m2h,
	       int *msg_tampon, unsigned int tlc, unsigned int thc,
	       int *x_souris, int *y_souris, int *boutons,
	       int *pks, unsigned int *touche, int *n_clics)
{
  Fenetre *fenetre; /* Fentre concerne par l'vnement */
  KeySym code;
  XEvent evenement, ancien;
  long masque = 0;
  char tampon[10];
  int sortie = FAUX; /* VRAI quand on a reu un vnement correct */
  unsigned long temps, compteur;

  if (flags == 0) /* On ne veut aucun vnement */
    return 0;

  if (_premiere_fenetre == NULL)
  {
    printf("evnt_multi : aucune fentre X ouverte -> cela bloquerait le programme !\n");
    return 0; /* On ne simule aucun vnement */
  }
  /*  else
    printf("On est dans evnt_multi\n"); */

  if (flags & MU_KEYBD) /* On veut le clavier */
    masque |= KeyPressMask | KeyReleaseMask;

  if (flags & MU_BUTTON)
    masque |= ButtonPressMask | ButtonReleaseMask;

  if ( (flags & MU_M1) || (flags & MU_M2) )
  {
    masque |= PointerMotionMask;
  }

  if (flags & MU_MESAG)
  {
    masque |= ExposureMask;    /* Pour les redessins */
    masque |= ButtonPressMask; /* Pour les messages de fentre */
    /*    masque |= ; Il faudrait celui pour les changements de taille */

    msg_tampon[1] = 0;
    msg_tampon[2] = 0;
  }

  if (flags & MU_TIMER)
  {
    compteur = ( (unsigned long) tlc ) + ( ( (unsigned long) thc ) << 16 );
    temps = clock();
    while ( XPending(_Display) == 0 ) /* Aucun vnement */
    {
      if ( (clock() - temps) >= compteur )
	return MU_TIMER;
    }
  }

  ancien.type = 0;
  *n_clics = 0;

  do
  {
    XMaskEvent(_Display, masque, &evenement); /* On attend l'vnement */

    fenetre = quelle_fenetre(evenement.xany.window);
    if (fenetre == NULL) /* Pas une fentre de l'utilisateur, forcment... */
    {
      if ( (clock() - temps) >= compteur )
	return MU_TIMER;

      /* Il faudra quand mme intgrer le cas du menu... */
      continue;
    }

    if ( evenement.type == ButtonRelease )
    {
      if ( EVNT_relache_bouton(fenetre, &(evenement.xbutton)) == VRAI )
	ancien.type = 0;
      else if (ancien.type == ButtonPress) /* Le clic a bien t reu... */
	ancien.xbutton = evenement.xbutton;
      else
	ancien.type = 0;
    }
    else if ( evenement.type == ButtonPress )
    {
      EVNT_clic(fenetre, &(evenement.xbutton), &ancien, n_clics);
      if (flags & MU_MESAG) /* Sinon, sert  rien... */
      {
	Fenetre *fen_gem;
	int handle_gem = 0;

	/* handle GEM = numro de la structure de fentre, en fait... */
	for (handle_gem = 0, fen_gem = _premiere_fenetre ; fen_gem != fenetre ;
	     handle_gem++, fen_gem = fen_gem->suivante);

	msg_tampon[3] = handle_gem; /* handle GEM de la fentre associe... */

	if (fenetre->closer == evenement.xbutton.window) /* Clic sur le bouton de fermeture */
	{
	  msg_tampon[0] = WM_CLOSED;
	  sortie = MU_MESAG;
	}
      }
    }
    else
    {
      if ( (ancien.type == ButtonRelease)
	|| (ancien.type == ButtonPress) ) /* Il y avait un clic enregistr */
      {
	if (flags & MU_BUTTON)
	{
	  /*	  if (ancien.xbutton.state & Button3Mask)
	    *n_clics = 2; /* 3e bouton : simule le double clic du gauche */
	  /*	  else
	    *n_clics = 1; */

	  _bouton = 0; /* Aucun bouton sinon */
	  if (ancien.xbutton.button == Button1)
	  {
	    *boutons = 1;
	    _bouton = 1;
	  }
	  if (ancien.xbutton.button == Button2)
	  {
	    *boutons = 2;
	    _bouton = 2;
	  }
	  
	  _x_souris = ancien.xbutton.x;
	  _y_souris = ancien.xbutton.y;
	  *x_souris = _x_souris;
	  *y_souris = _y_souris;
	  /*	  printf("On est ici\n"); */
	  sortie = MU_BUTTON;
	  break;
	}
      }

      switch (evenement.type) /* Suivant le type d'vnement */
      {
      case KeyPress:   /* vnement clavier */
	XLookupString(&(evenement.xkey), tampon, 9, &code, NULL);
	
	*touche = tampon[0];
	sortie = MU_KEYBD;
	break;

      case KeyRelease:
	EVNT_relache( &(evenement.xkey) );
	break;

      case MotionNotify: /* Curseur souris dplac */
	/* Faire les tests d'entre / sortie des rectangles */
	*x_souris = evenement.xmotion.x;
	*y_souris = evenement.xmotion.y;
	sortie = MU_M1; /* Juste pour les essais */
	break;

      case Expose: /* Redessin */
	if (fenetre->handle == evenement.xexpose.window) /* Fentre vraiment */
	{
	  Fenetre *fen_gem;
	  int handle_gem = 0;
	  
	  /* handle GEM = numro de la structure de fentre, en fait... */
	  for (handle_gem = 0, fen_gem = _premiere_fenetre ; fen_gem != fenetre ;
	       handle_gem++, fen_gem = fen_gem->suivante);

	  msg_tampon[0] = WM_REDRAW; /* Message de redessin */
	  msg_tampon[3] = handle_gem; /* handle GEM de la fentre associe... */
	  msg_tampon[4] = evenement.xexpose.x;
	  msg_tampon[5] = evenement.xexpose.y;
	  msg_tampon[6] = evenement.xexpose.width;
	  msg_tampon[7] = evenement.xexpose.height;
	  sortie = MU_MESAG;
	}
	else
	  EVNT_redessin(fenetre, &(evenement.xexpose) ); /* Redessins internes */
	break;
      }
    }

    if (flags & MU_TIMER)
    {
      do
      {
	if ( (clock() - temps) >= compteur )
	  sortie |= MU_TIMER;
      } while ( XPending(_Display) == 0 );
    }

  } while (sortie == FAUX);

  return sortie;
}

int evnt_dclick(int rate, int setit);
