/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Dclarations des fonctions
   Bibliothque d'vnements (EVNT lib)

*/

#ifndef _X_EVNT_LIB_H_

#define _X_EVNT_LIB_H_

unsigned int evnt_keybd (void);
int  evnt_button     (int clicks, unsigned int mask, unsigned int state,
		      int *pmx, int  *pmy,
		      int  *pmb, int  *pks);
int  evnt_mouse      (int flags, int x, int y, int width, int height,
		      int  *pmx, int  *pmy,
		      int  *pmb, int  *pks);

/* ~~~~~~~~~~ Les messages GEM prdfinis ~~~~~~~~~~ */

#define MN_SELECTED     10 /* On a appel une option de menu */
#define WM_REDRAW       20 /* Message de redessin */
#define WM_TOPPED       21 /* Passage au premier plan */
#define WM_CLOSED       22 /* Fermeture */
#define WM_FULLED       23 /* Plein cran */
#define WM_ARROWED      24 /* Clic sur une flche */
#define WM_HSLID        25 /* Ascenseur horizontal */
#define WM_VSLID        26 /* Ascenseur vertical */
#define WM_SIZED        27 /* Changement de taille */
#define WM_MOVED        28 /* Dplacement de la fentre */
#define WM_NEWTOP       29 /* for compatibility  - non document */
#define WM_UNTOPPED     30 /* Non document */
#define WM_ONTOP        31 /* Quand fentre passe au premier plan */
#define WM_OFFTOP       32 /* Quand fentre disparat du premier plan */
#define WM_BOTTOM       33 /* Passage en arrire plan */
#define WM_ICONIFY      34 /* On demande de l'iconifier */
#define WM_UNICONIFY    35 /* On demande de la dsiconifier */
#define WM_ALLICONIFY   36 /* On demande de tout iconifier */
#define WM_TOOLBAR      37 /* Message d'un arbre en barre d'info */

#define PR_FINISH       33 /*  quoi diable correspond-il ??? */

#define AC_OPEN         40
#define AC_CLOSE        41

#define AP_TERM         50
#define AP_TFAIL        51
#define AP_RESCHG       57
#define SHUT_COMPLETED  60
#define RESCH_COMPLETED 61
#define AP_DRAGDROP     63

#define CH_EXIT         80

/* ~~~~~~~~~~ Sous-commandes des messages de fentre ~~~~~~~~ */

#define WA_SUBWIN        1
#define WA_KEEPWIN       2

#define WA_UPPAGE        0 /* Window Arrow Up Page    */
#define WA_DNPAGE        1 /* Window Arrow Down Page  */
#define WA_UPLINE        2 /* Window Arrow Up Line    */
#define WA_DNLINE        3 /* Window Arrow Down Line  */
#define WA_LFPAGE        4 /* Window Arrow Left Page  */
#define WA_RTPAGE        5 /* Window Arrow Right Page */
#define WA_LFLINE        6 /* Window Arrow Left Line  */
#define WA_RTLINE        7 /* Window Arrow Right Line */

int  evnt_mesag      (int  *pbuff);

int  evnt_timer      (unsigned int locnt, unsigned int hicnt);

/* ~~~~~~~~~~ Masque d'vnements pour evnt_multi ~~~~~~~~~~~ */

#define MU_KEYBD    0x0001
#define MU_BUTTON   0x0002
#define MU_M1       0x0004
#define MU_M2       0x0008
#define MU_MESAG    0x0010
#define MU_TIMER    0x0020
#define MU_M3       0x0040
#define MU_SYSMESAG 0x0080
#define MU_POSTEV   0x1000

int  evnt_multi      (unsigned int flags, unsigned int bclk, unsigned int bmsk, unsigned int bst,
		      unsigned int m1flags,
		      unsigned int m1x, unsigned int m1y, unsigned int m1w, unsigned int m1h,
		      unsigned int m2flags,
		      unsigned int m2x, unsigned int m2y, unsigned int m2w, unsigned int m2h,
		      int  *mepbuff, unsigned int tlc, unsigned int thc,
		      int  *pmx, int  *pmy, int  *pmb,
		      int  *pks, unsigned int  *pkr, int  *pbr);

/* Pour compatibilit interne... */

#define Evnt_multi  evnt_multi

int  evnt_dclick     (int rate, int setit);

#endif /* _X_EVNT_LIB_H_ */
