/**** Bibliothque mixte GEM / X_windows
  (C) 1998 Emmanuel CURIS

            Gestion des fentres - compatible gem_fen.c [rfrence]
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "Bib_X.h"

/* ~~~~~~~~~~~~~~~ Fonctions  usage interne ~~~~~~~~~~~~~~~~~~~~~~~ */

int FEN_ote_evenement(Window fenetre);
void OBJ_creer_fenetres(Arbre *arbre, Window mere, int objet, int obj_pere);

/* ~~~~~~~~~~~~~~~ Routines de cration de fentres ~~~~~~~~~~~~~~~~ */

/* -------------- Cration de la fentre X + attributs --------------\
 |  Renvoie VRAI si tout s'est bien pass, <0 sinon                  |
 \------------------------------------------------------------------ */

int FEN_creation(Fenetre *fenetre, int attributs)
{
  Window handle;
  XSetWindowAttributes parametres; /* De la fentre X */
  unsigned int unit_car; /* Unit de largeur & hauteur des boutons... */

  if (fenetre == NULL)
    return -1;

  /* On tche d'ouvrir la fentre */

  parametres.background_pixel = _Couleurs[GRIS].pixel; /* Fond en blanc */
  parametres.event_mask = KeyPressMask | KeyReleaseMask | ButtonPressMask
    | StructureNotifyMask
    | PointerMotionMask | EnterWindowMask | LeaveWindowMask
    | ButtonReleaseMask | ExposureMask; /* vnements transmis */

  handle = XCreateWindow(_Display, _Fen_racine, fenetre->x, fenetre->y,
			 fenetre->larg, fenetre->haut, 2, CopyFromParent,
			 InputOutput, _Visual, CWBackPixel | CWEventMask, &parametres);
  if (handle == 0) /* Fentre n'a pas pu tre cre */
  {
    ERREUR(TROP_FENETRES);
    return -2;
  }
  fenetre->handle = handle;

  unit_car  = _Fonte->max_bounds.ascent /* + _Fonte->max_bounds.descent */;
  unit_car += _Fonte->ascent;

  parametres.event_mask = KeyPressMask | KeyReleaseMask | ButtonPressMask
    | PointerMotionMask | EnterWindowMask | LeaveWindowMask
    | ButtonReleaseMask | ExposureMask; /* vnements transmis */

  if (attributs & CLOSER) /* Bouton de fermeture */
  {
    parametres.background_pixel = _Couleurs[GRIS_FONCE].pixel;

    fenetre->closer = XCreateWindow(_Display, handle, 0, 0, unit_car, unit_car,
				    1, CopyFromParent, InputOutput, _Visual,
				    CWBackPixel | CWEventMask, &parametres);
  }
  else
    fenetre->closer = 0;

  if (attributs & NAME)   /* Il y a un titre  */
  {
    if (fenetre->titre == NULL) /* Pas de titre */
      fenetre->titre = "Biblioth"e_GRAVE"que GEM pour X_Window - (C) 1998, Emmanuel CURIS";

    FEN_titre(fenetre, fenetre->titre);
  }
  else
    FEN_titre(fenetre, "");

  if (attributs & INFO) /* Il y a des infos */
  {
    int x_inf = 0;
    int largeur; /* hauteur : pour accueillir la fonte */

    largeur  = fenetre->larg - 1;
    if (attributs & CLOSER) /* Il y a aussi un bouton de fermeture */
    {
      x_inf += unit_car; /* Bouton de fermeture carr */
      largeur -= unit_car;
    }

    parametres.background_pixel = _Couleurs[GRIS].pixel;

    fenetre->barre_d_infos = XCreateWindow(_Display, handle,
					   x_inf, 0, largeur, unit_car,
					   1, CopyFromParent, InputOutput, _Visual,
					   CWBackPixel | CWEventMask, &parametres);

    if (fenetre->infos == NULL) /* Pas de ligne d'infos */
      fenetre->infos = "Gestion GEM "e_AIGU"tendue, Emmanuel CURIS";
    FEN_infos(fenetre, fenetre->infos);
  }
  else
    fenetre->barre_d_infos = 0; /* Aucune fentre associe */

  if ( attributs & UPARROW )
  {
    int x_fl = 0, y_fl = 0;

    x_fl = fenetre->larg - unit_car;

    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->fleche_haute = XCreateWindow(_Display, handle, x_fl, y_fl, unit_car, unit_car,
					  1, CopyFromParent, InputOutput, _Visual,
					  CWBackPixel | CWEventMask, &parametres);
  }
  else
    fenetre->fleche_haute = 0;

  if (attributs & VSLIDE)
  {
    int x_asc = 0, y_asc = 0;
    unsigned int haut_asc;

    x_asc = fenetre->larg - unit_car;
    haut_asc = fenetre->haut;

    if (attributs & UPARROW)
    {
      y_asc += unit_car;
      haut_asc -= unit_car;
    }

    if (attributs & DNARROW)
      haut_asc -= unit_car;

    parametres.background_pixel = _Couleurs[GRIS_FONCE].pixel;
    fenetre->fond_asc_vertical = XCreateWindow(_Display, handle,
					       x_asc, y_asc, unit_car, haut_asc,
					       1, CopyFromParent, InputOutput, _Visual,
					       CWBackPixel | CWEventMask, &parametres);

    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->bouton_asc_vertical = XCreateWindow(_Display, fenetre->fond_asc_vertical,
						 -1, -1, unit_car, haut_asc,
						 1, CopyFromParent, InputOutput, _Visual,
						 CWBackPixel | CWEventMask, &parametres);
    XMapWindow(_Display, fenetre->bouton_asc_vertical);
  }
  else
  {
    fenetre->fond_asc_vertical = 0;
    fenetre->bouton_asc_vertical = 0;
  }

  if ( attributs & DNARROW )
  {
    int x_fl, y_fl;

    x_fl = fenetre->larg - unit_car;
    y_fl = fenetre->haut - unit_car;

    if ( attributs & (ASC_HORIZONTAL) )
      y_fl -= (unit_car + 2);
    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->fleche_basse = XCreateWindow(_Display, handle, x_fl, y_fl, unit_car, unit_car,
					  1, CopyFromParent, InputOutput, _Visual,
					  CWBackPixel | CWEventMask, &parametres);
  }
  else
    fenetre->fleche_basse = 0;

  if ( attributs & LFARROW )
  {
    int x_fl = 0, y_fl;

    y_fl = fenetre->haut - unit_car - 2;

    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->fleche_gauche = XCreateWindow(_Display, handle, x_fl, y_fl, unit_car, unit_car,
					  1, CopyFromParent, InputOutput, _Visual,
					  CWBackPixel | CWEventMask, &parametres);
  }
  else
    fenetre->fleche_gauche = 0;

  if (attributs & HSLIDE)
  {
    int x_asc = 0, y_asc;
    unsigned int larg_asc;

    y_asc = fenetre->haut - unit_car - 2;
    larg_asc = fenetre->larg;

    if (attributs & ASC_VERTICAL)
    {
      larg_asc -= unit_car;
    }

    if (attributs & LFARROW)
    {
      x_asc += unit_car;
      larg_asc -= unit_car;
    }

    if (attributs & RTARROW)
      larg_asc -= (unit_car + 1);

    parametres.background_pixel = _Couleurs[GRIS_FONCE].pixel;
    fenetre->fond_asc_horizontal = XCreateWindow(_Display, handle,
						 x_asc, y_asc, larg_asc, unit_car,
						 1, CopyFromParent, InputOutput, _Visual,
						 CWBackPixel | CWEventMask, &parametres);

    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->bouton_asc_horizontal = XCreateWindow(_Display, fenetre->fond_asc_horizontal,
						   -1, -1, larg_asc, unit_car,
						   1, CopyFromParent, InputOutput, _Visual,
						   CWBackPixel | CWEventMask, &parametres);
    XMapWindow(_Display, fenetre->bouton_asc_horizontal);
  }
  else
  {
    fenetre->fond_asc_horizontal = 0;
    fenetre->bouton_asc_horizontal = 0;
  }

  if ( attributs & RTARROW )
  {
    int x_fl, y_fl;

    x_fl = fenetre->larg - unit_car - 1;
    y_fl = fenetre->haut - unit_car - 2;

    if ( attributs & (ASC_VERTICAL) )
      x_fl -= unit_car;
    parametres.background_pixel = _Couleurs[GRIS].pixel;
    fenetre->fleche_droite = XCreateWindow(_Display, handle, x_fl, y_fl, unit_car, unit_car,
					   1, CopyFromParent, InputOutput, _Visual,
					   CWBackPixel | CWEventMask, &parametres);
  }
  else
    fenetre->fleche_droite = 0;

  return VRAI; /* Tout s'est bien pass */
}

/* -------------- Cration d'une fentre, cas le plus gnral ------------\
 | Renvoie un pointeur sur la structure dcrivant la fentre              |
 |                                                                        |
 | attributs : ceux que la fentres doit avoir (comme wind_create)        |
 | infos     : adresse de la chane d'informations                        |
 | titre     : adresse de la chane de titre                              |
 | redessin  : adresse de la fonction  appeler pour le redessin          |
 | ascenseur : adresse de la fonction de gestion des ascenseurs           |
 | clavier   : adresse de la fonction de gestion du clavier               |
 | clic      : adresse de la fonction de gestion du clic souris           |
 | message   : adresse de la fonction de gestion des messages             |
 | rect      : adresse de la fonction de gestion de MU_RECT1 (pointeur)   |
 | temps     : adresse de la fonction de gestion du timer                 |
 \----------------------------------------------------------------------- */

Fenetre *creer_fenetre(int attributs, char *titre, char *infos,
                       void (*redessin) (Fenetre *, int, int, int, int),
                       void (*ascenseur) (Fenetre *, int, int, int),
		       boolean (*clavier)(Fenetre *, unsigned int, int),
                       boolean (*clic)   (Fenetre *, int, int, int, int, int),
                       boolean (*message)(Fenetre *),
		       boolean (*rect)   (Fenetre *, int, int),
		       boolean (*temps)  (Fenetre *) )
{
  int retour;
  unsigned int larg = 800, haut = 600; /* Fentre en 800 par 600 par dfaut */
  Fenetre *fenetre;
  Window handle; /* Index de la fentre X associe */

  fenetre = (Fenetre *) malloc( sizeof(Fenetre) ); /* Place de la structure */
  if (fenetre == NULL)
  {
    ERREUR(MANQUE_MEMOIRE);
    printf("dans X_fenetres.c\n");
    return NULL;
  }

  fenetre->handle    = handle;    /* Les paramtres de la fentre */
  fenetre->attributs = attributs;
  fenetre->larg = larg; /* Dimensions externes de la fentre */
  fenetre->haut = haut;
  fenetre->titre = titre;
  fenetre->infos = infos;

  retour = FEN_creation(fenetre, attributs);
  if (retour < 0)
  {
    free(fenetre);
    return NULL;
  }

  if (_premiere_fenetre == NULL)
  {
    _premiere_fenetre = fenetre;
    _derniere_fenetre = fenetre;
  }
  else
  {
    _derniere_fenetre->suivante = fenetre;
    _derniere_fenetre = fenetre;
  }
  fenetre->suivante = NULL;       /* Forcment, par construction */

  fenetre->ascenseur = ascenseur; /* Toutes les routines de gestion */
  fenetre->clavier   = clavier;
  fenetre->clic      = clic;
  fenetre->message   = message;
  fenetre->rect      = rect;
  fenetre->redessin  = redessin;
  fenetre->temps     = temps;

  fenetre->w_x = 0; fenetre->w_y = 0;
  fenetre->w_larg = larg; fenetre->w_haut = haut; /* Zone de travail */
  if ( (attributs & CLOSER) || (attributs & INFO) )
  {
    fenetre->w_y    += _Fonte->max_bounds.ascent + _Fonte->max_bounds.descent;
    fenetre->w_y    += _Fonte->ascent /* + _Fonte->descent */;
    fenetre->w_haut -= fenetre->w_y; /* On perd tout a comme place */
  }
  if ( attributs & ASC_VERTICAL ) /* Il y a un ascenseur vertical */
  {
    fenetre->w_larg -= _Fonte->max_bounds.ascent + _Fonte->max_bounds.descent;
    fenetre->w_larg -= _Fonte->ascent;
  }
  if ( attributs & ASC_HORIZONTAL ) /* Il y a un ascenseur horizontal */
  {
    fenetre->w_haut -= _Fonte->max_bounds.ascent + _Fonte->max_bounds.descent;
    fenetre->w_haut -= _Fonte->ascent;
  }

  fenetre->type = 0;       /* Sans type par dfaut */
  fenetre->drapeaux.repliee  = FAUX; /* En pleine extension */
  fenetre->drapeaux.redessin = FAUX;
  fenetre->drapeaux.icone    = FAUX;
  fenetre->drapeaux.pointeur = FAUX;
  fenetre->drapeaux.ouverte  = FAUX; /* Pas encore ouverte  */

  fenetre->adresse  = NULL;   /* Pas de complment d'infos ailleurs      */
  fenetre->pointeur = NULL;
  fenetre->numero_arbre = 0; /* Pas non plus d'arbre associ par dfaut */
  fenetre->arbre  = NULL;
  fenetre->taille = NULL;    /* Pas d'infos de taille particulires     */

  fenetre->msg_masque.taille       = 0; /* par dfaut, aucun message n'a de traitement spcial */
  fenetre->msg_masque.position     = 0;
  fenetre->msg_masque.plein_ecran  = 0;
  fenetre->msg_masque.premier_plan = 0;
  fenetre->msg_masque.arriere_plan = 0;
  fenetre->msg_masque.fermeture    = 0;
  fenetre->msg_masque.autres       = 0;
  fenetre->msg_masque.utilisateur  = 0;

  return fenetre;
}

/* -------------- Cration d'une fentre, pour un arbre GEM --------------\
 | Renvoie le pointeur sur la structure de la fentre cre               |
 |
 | attributs : attributs de la fentre qui doivent tre prsents          |
 | numero_arbre : numro de l'arbre associ  la fentre                  |
 | titre : titre qu'aura la fentre (NULL => titre par dfaut)            |
 \----------------------------------------------------------------------- */

Fenetre *creer_gem_fenetre(int attributs, int numero_arbre, char *titre)
{
  Arbre   *arbre;
  Fenetre *fenetre;
  OBJECT  *adresse;
  int x, y, larg, haut;

  /* On vrifie qu'il ne reste pas une structure associe  cet arbre */
  for (fenetre = _premiere_fenetre; fenetre ; fenetre = fenetre->suivante)
  {
    if ( fenetre->numero_arbre == numero_arbre ) /* Fentre pour cet arbre dj existante */
    {
      if (fenetre->handle == -1) /* Juste un "fantme" de fentre */
      {
	int handle;
	
	handle = FEN_reouvre(fenetre);
	if (handle <= 0) /* Problme */
	  return NULL;
	return fenetre;
      }
      
      if (fenetre->drapeaux.ouverte == FAUX) /* Fentre X existe mais pas ouverte */
      {
	FEN_reouvre(fenetre);
	return fenetre;
      }

      /* On passe la fentre au premier plan - comment ? */
      return fenetre;
    }
  }

  /* Si on est l, c'est que la cration est compltement nouvelle */

  fenetre = creer_fenetre(attributs, titre, NULL, 
                          (void (*)(Fenetre *, int, int, int, int)) NULL,
			  (void (*)(Fenetre *, int, int, int)) NULL, /* On gre automatiquement */
                          (boolean (*)(Fenetre *, unsigned int, int)) NULL,
			  (boolean (*)(Fenetre *, int, int, int, int, int)) NULL,
			  (boolean (*)(Fenetre *)) NULL,
                          (boolean (*)(Fenetre *, int, int)) NULL,
			  (boolean (*)(Fenetre *)) NULL);
  if (fenetre == NULL) /* Fentre n'a pas pu tre cre */
    return NULL;

  arbre = arbres + numero_arbre;
  adresse = arbres[numero_arbre].adresse;

  larg = OB_WIDTH(adresse, ROOT);
  haut = OB_HEIGHT(adresse, ROOT);

  OB_X(adresse, ROOT) = fenetre->w_x;
  OB_Y(adresse, ROOT) = fenetre->w_y;
  larg += fenetre->larg - fenetre->w_larg; /* Correction pour les lments de fentre */
  haut += fenetre->haut - fenetre->w_haut;

  fenetre->numero_arbre  = numero_arbre;
  fenetre->arbre         = arbre;
  fenetre->type          = GEM_FENETRE;     /* Fentre GEM */

  fenetre->taille = XAllocSizeHints();
  if ( fenetre->taille ) /* A pu tre cr */
  {
    fenetre->taille->flags = PMinSize | PMaxSize; /* On ne peut pas en changer la taille */
    fenetre->taille->min_width  = larg;
    fenetre->taille->min_height = haut;
    fenetre->taille->max_width  = larg;
    fenetre->taille->max_height = haut;
    XSetWMNormalHints(_Display, fenetre->handle, fenetre->taille);
  }

  /* On cr les fentres pour les boutons */

  OBJ_creer_fenetres(arbre, fenetre->handle, ROOT, -1); /* On cr tous les objets */

  ouvre_fenetre(fenetre, x, y, larg, haut);

  arbres[numero_arbre].ouvert = VRAI; /* L'arbre est ouvert */

  return fenetre;
}

/* -------------- Cration d'une fentre mixte (arbre GEM + utilisateur) -\
 | Renvoie le pointeur sur la structure de la fentre cre               |
 |                                                                        |
 | attributs    : attributs de la fentre qui doivent tre prsents       |
 | clavier      : routine de gestion du clavier                           |
 | clic         : routine de gestion du clic souris                       |
 | message      : routine de gestion des messages (fermeture,...)         |
 | mode    : GAUCHE si arbre  gauche, HAUT si en haut, AUCUN si rien,... |
 | numero_arbre : numro de l'arbre associ  la fentre                  |
 | rect         : routine de gestion du pointeur                          |
 | redessin     : adresse de la fonction de redessin                      |
 | temps        : routine de gestion du timer                             |
 \----------------------------------------------------------------------- */

Fenetre *creer_mixte_fenetre(int attributs, int numero_arbre, char mode, 
			     void (*redessin)(Fenetre *, int, int, int, int),
			     boolean (*clavier)(Fenetre *, unsigned int, int),
			     boolean (*clic)   (Fenetre *, int, int, int, int, int),
			     boolean (*message)(Fenetre *),
			     boolean (*rect)   (Fenetre *, int, int),
			     boolean (*temps)  (Fenetre *) )
{
  Fenetre *fenetre;
  OBJECT *adresse;
  int x, y, larg = -1, haut = -1, i; /* De l'arbre que l'on va mettre */

  /* On vrifie que la fentre n'est pas dj ouverte */

  if (_premiere_fenetre != NULL) /* Il y a dj des fentre existantes */
  {
    for (fenetre = _premiere_fenetre ; fenetre != NULL ; fenetre = fenetre->suivante )
    {
      if ( ( (fenetre->type == GEM_FENETRE) || (fenetre->type == MIXTE_FENETRE) )
          && (fenetre->numero_arbre == numero_arbre) )
      {
	if (fenetre->drapeaux.ouverte == FAUX) /* La fentre existe mais n'est pas ouverte... */
	  FEN_reouvre(fenetre);
	FEN_premierplan(fenetre);
	
	return fenetre; /* et on a fini */
      }
    }
  }

  fenetre = creer_fenetre(attributs, NULL, NULL, redessin,
			  (void (*)(Fenetre *, int, int, int)) NULL,
			  clavier, clic, message, rect, temps);
  if (fenetre == NULL) /* Fentre n'a pas pu tre cre */
  	return NULL;

  adresse = arbres[numero_arbre].adresse;
  fenetre->type         = MIXTE_FENETRE; /* Fentre GEM mixte      */
  fenetre->numero_arbre = numero_arbre;  /* Arbre de cette fentre */
  fenetre->arbre = arbres + numero_arbre;

  ouvre_fenetre(fenetre, x_gem, y_gem, larg_gem, haut_gem);
  fenetre->drapeau      = (boolean) mode;
  arbres[numero_arbre].ouvert = VRAI; /* L'arbre est ouvert */

  OBJ_creer_fenetres(fenetre->arbre, fenetre->handle, ROOT, -1); /* On cr tous les objets */

  if (mode == DROITE) /* Arbre sur le bord droit de la fentre */
  {
    x = fenetre->w_x + fenetre->w_larg - OB_WIDTH(adresse, ROOT);
  }
  else
  {
    x = fenetre->w_x;
  }
  if (mode == BAS)
  {
    y = fenetre->w_y + fenetre->w_haut - OB_HEIGHT(adresse,ROOT);
  }
  else
  {
    y = fenetre->w_y;
  }
  OBJ_position(numero_arbre, ROOT, x, y, &i, &i);

  if ( (mode == GAUCHE) || (mode == DROITE) )
    haut = fenetre->w_haut;
  if ( (mode == BAS) || (mode == HAUT) )
    larg = fenetre->w_larg;

  OBJ_taille(numero_arbre, ROOT, larg, haut, &i, &i);

  return fenetre;
}

void OBJ_creer_fenetres(Arbre *arbre, Window mere, int objet, int obj_pere)
{
  OBJECT *adresse;
  XSetWindowAttributes attributs;
  int x, y;
  unsigned int larg, haut;
  unsigned int bord = 1, couleur_bord = NOIR, motif;
  unsigned long liste_attributs = CWEventMask | CWBorderPixel | CWBackPixel;
  signed char ep_bord;

  adresse = arbre->adresse; /* Adresse de l'arbre */

  attributs.event_mask = KeyPressMask | KeyReleaseMask | ButtonPressMask
    | ButtonReleaseMask | ExposureMask; /* Tous vnements transmis */
  attributs.background_pixel = _Couleurs[GRIS].pixel; /* Fond gris clair par dfaut */

  x    = OB_X(adresse, objet);
  y    = OB_Y(adresse, objet);
  larg = OB_WIDTH(adresse, objet);
  haut = OB_HEIGHT(adresse, objet);

  switch ( OB_TYPE(adresse, objet) )
  {
  case G_BOX:
  case G_BOXCHAR:
    couleur_bord = (unsigned int) ( (OB_SPEC(adresse, objet) & 0xF0) >> 12 ); /* Couleur bord */
    ep_bord = (signed char) ( (OB_SPEC(adresse, objet) & 0xFF00) >> 16 ); /* paisseur bord */
    if (ep_bord > 0) /* paisseur positive -> vers l'extrieur */
    {
      bord = (unsigned int) ep_bord;
      bord --;
    }
    else
      bord = (unsigned int) (-ep_bord);

    motif = (unsigned int) ( (OB_SPEC(adresse, objet) & 0x70) >> 4 );
    if ( motif == 0 ) /* Motif de remplissage = blanc */
      attributs.background_pixel = _Couleurs[BLANC].pixel;
    else if ( motif < 7 ) /* Pas plein */
      attributs.background_pixel = _Couleurs[GRIS_FONCE].pixel;

    bord = 1; /* Carrment plus joli... */
    x--; y--;
    break;

  case G_USERDEF:
    bord = 0;
    couleur_bord = GRIS;
    break;

  case G_TEXT:  /* Texte ou texte ditable, sans cadre */
  case G_FTEXT:
  case G_IMAGE:
    bord = 0;
    break;

  case G_BOXTEXT:
  case G_FBOXTEXT: /* Texte ou texte ditable encadr */
    bord = 1;
    break;

  case G_IBOX:
    bord = 3;
    x -= 2; y-= 2;
    break; 

  case G_BUTTON:
    bord = 1;
    x -=1; y -= 1;
    break;

  case G_STRING:
    bord = 0; /* Pas de bord */
    break;

  case G_ICON:
    break;

  case G_TITLE:
    break;

  case G_CICON:
    break;
  }

  if ( (OB_FLAGS(adresse, objet) & EXIT) || (OB_FLAGS(adresse, objet) & TOUCHEXIT) )
  {
    bord += 1;
    x--; y--;
  }

  if ( OB_FLAGS(adresse, objet) & DEFAULT )
  {
    bord += 1;
    x--; y--;
  }

  /* On cr la fentre de l'objet */

  attributs.border_pixel = _Couleurs[couleur_bord].pixel;
  (arbre->objets)[objet] = XCreateWindow(_Display, mere, x, y, larg, haut, bord,
					 CopyFromParent, InputOutput, CopyFromParent,
					 liste_attributs, &attributs);

  if ( !(OB_FLAGS(adresse, objet) & HIDETREE) )   /* Objet visible */
    XMapWindow(_Display, (arbre->objets)[objet]); /* On affiche donc la fentre */

  /* S'il y a des fils */

  if ( OB_HEAD(adresse, objet) != -1 )
  {
    OBJ_creer_fenetres(arbre, (arbre->objets)[objet], OB_HEAD(adresse, objet), objet);
  }

  /* S'il y a des objets de mme niveau */

  if (  ( OB_NEXT(adresse, objet) != -1 ) /* un objet  la suite */
     && ( OB_NEXT(adresse, objet) != obj_pere) ) /* et ce n'est pas le pre */
  {
    OBJ_creer_fenetres(arbre, mere, OB_NEXT(adresse, objet), obj_pere);
  }
}

/* ------------ Mise en place d'informations diverses pour la fentre -------- */

int FEN_ascenseur(Fenetre *fenetre, int asc, int position, int taille)
{
  int x_asc, y_asc;
  unsigned int larg_asc, haut_asc;
  if (fenetre == NULL) return -1;

  if (asc == ASC_VERTICAL) /* Cas de l'ascenseur vertical */
  {
    int i;
    unsigned int haut_fond, j;
    Window w;

    if (fenetre->fond_asc_vertical == 0) return -2; /* Pas d'ascenseur */

    XGetGeometry(_Display, fenetre->fond_asc_vertical, &w, &i, &i, &j, &haut_fond, &j, &j);
    XGetGeometry(_Display, fenetre->bouton_asc_vertical, &w,
		 &x_asc, &y_asc, &larg_asc, &haut_asc, &j, &j);

    if (taille > 0)
    {
      haut_asc = (unsigned int) ( (((float) taille) / 1000.0) * haut_fond );
    }

    if (position >= 0)
    {
      haut_fond -= haut_asc;
      y_asc = (int) ( (((float) position) / 1000.0) * haut_fond );
    }

    XMoveResizeWindow(_Display, fenetre->bouton_asc_vertical, x_asc, y_asc, larg_asc, haut_asc);
    return VRAI;
  }

  if (asc == ASC_HORIZONTAL) /* Cas de l'ascenseur vertical */
  {
    int i;
    unsigned int larg_fond, j;
    Window w;

    if (fenetre->fond_asc_horizontal == 0) return -2; /* Pas d'ascenseur */

    XGetGeometry(_Display, fenetre->fond_asc_horizontal, &w, &i, &i, &larg_fond, &j, &j, &j);
    XGetGeometry(_Display, fenetre->bouton_asc_horizontal, &w,
		 &x_asc, &y_asc, &larg_asc, &haut_asc, &j, &j);

    if (taille > 0)
    {
      larg_asc = (unsigned int) ( (((float) taille) / 1000.0) * larg_fond );
    }

    if (position >= 0)
    {
      larg_fond -= larg_asc;
      x_asc = (int) ( (((float) position) / 1000.0) * larg_fond );
    }

    XMoveResizeWindow(_Display, fenetre->bouton_asc_horizontal, x_asc, y_asc, larg_asc, haut_asc);
    return VRAI;
  }

  return -2; /* Ascenseur de type inconnu */
}

int FEN_infos(Fenetre *fenetre, char *infos)
{
  if (fenetre == NULL) return -1;
  if (infos == NULL  ) return -2;

  fenetre->infos = infos;

  if (fenetre->barre_d_infos == 0) return -3; /* Pas de barre d'infos ! */
  if (fenetre->handle == 0) return 1;
  if (fenetre->drapeaux.ouverte == FAUX) return 1;

  FOBJ_infos.ob_spec.texte = fenetre->infos;
  OBJ_dessine(fenetre->barre_d_infos, &FOBJ_infos);

  return 1;
}

Fenetre *FEN_premierplan(Fenetre *fenetre)
{
  if (fenetre == NULL) return NULL;

  XRaiseWindow(_Display, fenetre->handle);
  return fenetre;
}

int FEN_titre(Fenetre *fenetre, char *titre)
{
  if (fenetre == NULL) return -1;
  if (titre == NULL  ) return -3;

  fenetre->titre = titre;

  if (fenetre->handle == 0) return -2;

  XStoreName(_Display, fenetre->handle, titre);
  return 0;
}

/* -------------- Ouverture d'une fentre, pour voir -------------------- */

/* -------------- Procdure d'ouverture la plus simple -------------------\
 | Renvoie FAUX si l'ouverture n'a pas pu avoir lieu, VRAI sinon          |
 |                                                                        |
 | fenetre    : structure de la fentre  ouvrir                          |
 | x, y       : position de la fentre                                    |
 | larg, haut : dimensions totales de la fentre                          |
 \----------------------------------------------------------------------- */

int ouvre_fenetre(Fenetre *fenetre, int x, int y, int larg, int haut)
{
  if (fenetre == NULL) return FAUX;
  if (fenetre->drapeaux.ouverte == VRAI)
  {
    ERREUR(FEN_OUVERTE);
    return FAUX;
  }

  fenetre->x = x;
  fenetre->y = y;

  if (larg < 16) larg = 16; /* larg = 0 ou haut = 0 : plante X-Windows */
  if (haut < 16) haut = 16;

  change_taille_fenetre(fenetre, larg, haut); /* On met  la bonne taille */
  XMoveResizeWindow(_Display, fenetre->handle, x, y, (unsigned int) larg, (unsigned int) haut);

  XMapWindow(_Display, fenetre->handle);
  XMapSubwindows(_Display, fenetre->handle);

  fenetre->drapeaux.ouverte = VRAI; /* La fentre est ouverte */

  if (fenetre->type == GEM_FENETRE)
  {
    int premier_edit = fenetre->arbre->premier_edit;

    if (premier_edit > ROOT) /* Il y en a bien un */
    {
      int pos_curseur;

      fenetre->arbre->edit_courant = premier_edit;
      objc_edit(fenetre->arbre->adresse, premier_edit, 0,
		pos_curseur, ED_INIT, &pos_curseur); /* On place le curseur */
      fenetre->arbre->pos_curseur = pos_curseur;
    }
  }

  return VRAI;
}

/* ------------- Rouverture d'une fentre existante -------------------- */

int FEN_reouvre(Fenetre *fenetre)
{
  if (fenetre == NULL) return -1;

  if (fenetre->handle == -1) /* Il n'y a pas de fentre GEM associe -> on la cre */
  {
    int retour = FEN_creation(fenetre, fenetre->attributs);
    if (retour != VRAI)
    {
      ERREUR(TROP_FENETRES); /* Trop de fentres ouvertes */
      return -1;
    }
  }
  
  return ouvre_fenetre(fenetre, fenetre->x, fenetre->y, fenetre->larg, fenetre->haut);
}

/* Cherche la fentre (au sens GEM)  laquelle appartient la fente (X) indique */

Fenetre *quelle_fenetre(Window fenetre)
{
  Fenetre *resultat;

  if (_premiere_fenetre == NULL) return NULL; /* Aucune fentre... */

  for (resultat = _premiere_fenetre ; resultat ; resultat = resultat->suivante)
  {
    if (resultat->handle                == fenetre) return resultat;
    if (resultat->closer                == fenetre) return resultat;
    if (resultat->barre_d_infos         == fenetre) return resultat;
    if (resultat->fleche_haute          == fenetre) return resultat;
    if (resultat->fleche_basse          == fenetre) return resultat;
    if (resultat->fond_asc_vertical     == fenetre) return resultat;
    if (resultat->bouton_asc_vertical   == fenetre) return resultat;
    if (resultat->fleche_gauche         == fenetre) return resultat;
    if (resultat->fleche_droite         == fenetre) return resultat;
    if (resultat->fond_asc_horizontal   == fenetre) return resultat;
    if (resultat->bouton_asc_horizontal == fenetre) return resultat;

    if ( (resultat->type == GEM_FENETRE) || (resultat->type == MIXTE_FENETRE) )
    {
      Arbre *arbre = resultat->arbre;
      int i;

      for (i = 0 ; i < arbre->nbr_objets ; i++)
	if ( (arbre->objets)[i] == fenetre )
	  return resultat;
    }
  }

  return NULL; /* Fentre non trouve */
}

/* --- Correspondance entre les fenetres et les handle GEM (numro de structure) --- */

int quel_handle(Fenetre *fenetre)
{
  int handle;
  Fenetre *i;

  for (i = _premiere_fenetre, handle = 0 ; i != fenetre ; i = i->suivante, handle++);

  return handle;
}

/* ~~~~~~~~~~~~ Fermeture des fentres ~~~~~~~~~~~~ */

/* -------------- Fermeture sans destruction d'une fentre ---------------\
 |  Ne renvoie rien du tout                                               |
 |                                                                        |
 |  fenetre : la fentre que l'on veut fermer                             |
 |  detruit : FAUX ==> on ne fait que fermer la fentre GEM               |
 |            VRAI ==> on la dtruit aussi MAIS on garde la structure     |
 \----------------------------------------------------------------------- */

void FEN_ferme(Fenetre *fenetre, boolean detruit)
{
  if (fenetre == NULL) return;

  if ( (fenetre->type == GEM_FENETRE) || (fenetre->type == MIXTE_FENETRE) )
    (fenetre->arbre)->ouvert = FAUX; /* On ferme l'arbre */

  if (fenetre->drapeaux.ouverte == VRAI) /* La fentre est effectivement ouverte */
    XUnmapWindow(_Display, fenetre->handle);

  if (detruit == VRAI) /* On veut dtruire la fentre sans perdre les infos */
  {
    XDestroyWindow(_Display, fenetre->handle);
    fenetre->handle = -1;         /* Fentre n'existe plus... */
  }

  fenetre->drapeaux.ouverte = FAUX; /* Fentre ferme */
}

/* -------------- Fermeture totale (destruction) d'une fentre -----------\
 |                                                                        |
 | fenetre : pointeur sur la structure de la fentre  dtruire           |
 \----------------------------------------------------------------------- */

int ferme_fenetre(Fenetre *fenetre)
{
  Window handle;
  Fenetre *avant, *apres;

  if (fenetre == NULL) return -1; /* Rien  faire... */

  if ( (fenetre->type == GEM_FENETRE) || (fenetre->type == MIXTE_FENETRE) )
    (fenetre->arbre)->ouvert = FAUX; /* On ferme l'arbre */

  handle = fenetre->handle; /* Fermeture proprement dite          */
  if (handle != -1)         /* Il y a bien une fentre X associe */
  {
    FEN_ote_evenement(handle); /* Supprime tout vnement pour une fentre _et ses filles_ */

    XDestroyWindow(_Display, handle);
  }

  if (fenetre->taille) /* Il y a des infos de taille */
  {
    XFree(fenetre->taille);
  }

  /* On efface la structure de la liste des fentres */

  apres = fenetre->suivante;
  if (fenetre == _premiere_fenetre)
  {
    avant = NULL;
  }
  else
  {
    avant = _premiere_fenetre;
    while ( avant->suivante != fenetre )
      avant = avant->suivante;
    
    avant->suivante = apres; /* On isole donc la structure de la chane */
  }
  free(fenetre); /* Et on libre la mmoire */
  
  if (apres == NULL) /* Pas de fentre aprs => on vient d'effacer la dernire de la liste */
    _derniere_fenetre = avant;
  if (avant == NULL) /* Pas de fentre avant => on vient d'effacer la premire de la liste */
    _premiere_fenetre = apres;

  return 0; /*Tout s'est bien pass */
}

/* -- Supprime tous les vnements qui concernent une fentre et ses filles */

int FEN_ote_evenement(Window fenetre)
{
  Window pere, racine, *enfants = NULL;
  XEvent evenement;
  unsigned int nbr_enfants;
  long masque = 0xFFFFL; /* Tous les vnements, si je ne m'abuse... */

  /*   long masque = KeyPressMask | KeyReleaseMask | ButtonPressMask | ButtonReleaseMask 
       | EnterWindowMask | LeaveWindowMask | PointerMotionMask | PointerMotionHintMask
       | Button1MotionMask | Button2MotionMask | Button3MotionMask | Button4MotionMask
       | Button5MotionMask | ButtonMotionMask | KeymapStateMask | ExposureMask
       | VisibilityChangeMask | StructureNotifyMask | ResizeRedirectMask
       | SubstructureNotifyMask | SubstructureRedirectMask | FocusChangeMask 
       | PropertyChangeMask | ColormapChangeMask | OwnerGrabButtonMask; */

  /* on rcupre les enfants */

  XQueryTree(_Display, fenetre, &racine, &pere, &enfants, &nbr_enfants);
  if (enfants) /* Il y a des enfants */
  {
    unsigned int i;

    for (i = 0 ; i < nbr_enfants ; i++)
      FEN_ote_evenement(enfants[i]); /* On s'occupe du fils */

    XFree(enfants); /* On libre la mmoire */
  }
    
  /* On limine tout vnement se rapportant  cette fentre */

  while ( XCheckWindowEvent(_Display, fenetre, masque, &evenement) );
  return 0; /* Tout s'est bien pass */
}

/* -------- Envoyer un message de redessin  une fentre -------- */

boolean FEN_redessin(Fenetre *fenetre)
{
  XEvent redessin;

  if (fenetre == NULL) /* Fentre n'existe pas... */
    return FAUX;

  if (fenetre->handle == 0) /* Fentre X n'existe pas */
    return FAUX;

  if (fenetre->drapeaux.ouverte == FAUX) /* Fentre pas ouverte */
    return FAUX;

  redessin.type = Expose;
  redessin.xexpose.window = fenetre->handle;
  redessin.xexpose.x = fenetre->w_x;
  redessin.xexpose.y = fenetre->w_y;
  redessin.xexpose.width  = fenetre->w_larg;
  redessin.xexpose.height = fenetre->w_haut;
  redessin.xexpose.count  = 0;

  XSendEvent(_Display, fenetre->handle, False, 0, &redessin);

  return VRAI;
}

/* -------- Redimensionnement d'une fentre -> modif des lments associs -------- */

int change_taille_fenetre(Fenetre *fenetre, int nv_larg, int nv_haut)
{
  int delta_x, delta_y;
  Window w;
  int x, y;
  unsigned int larg, haut, j;

  delta_x = nv_larg - fenetre->larg;
  delta_y = nv_haut - fenetre->haut;

  if ( (delta_x == 0) && (delta_y == 0) )
    return 0;

  /* On s'occupe de tout le dcor de la fentre */

  if (fenetre->barre_d_infos)
  {
    XGetGeometry(_Display, fenetre->barre_d_infos, &w, &x, &y, &larg, &haut, &j, &j);
    XResizeWindow(_Display, fenetre->barre_d_infos, delta_x + larg, haut);
  }
  if (fenetre->fleche_haute)
  {
    XGetGeometry(_Display, fenetre->fleche_haute, &w, &x, &y, &larg, &haut, &j, &j);
    XMoveWindow(_Display, fenetre->fleche_haute, delta_x + x, y);
  }
  if (fenetre->fond_asc_vertical)
  {
    int x_asc, y_asc;
    unsigned int l_asc, h_asc;
    float facteur_pos, facteur_taille;

    XGetGeometry(_Display, fenetre->fond_asc_vertical, &w, &x, &y, &larg, &haut, &j, &j);
    XGetGeometry(_Display, fenetre->bouton_asc_vertical, &w,
		 &x_asc, &y_asc, &l_asc, &h_asc, &j, &j);
    XMoveResizeWindow(_Display, fenetre->fond_asc_vertical,
		      delta_x + x, y, larg, haut + delta_y);

    facteur_taille = ( (float) h_asc ) / (float) haut;
    if ( haut != h_asc ) /* Poussoir plus petit que l'ascenseur */
    {
      facteur_pos  = 1 - facteur_taille;
      facteur_pos /= (float) (haut - h_asc);
      facteur_pos *= (float) (haut + delta_y);
    }
    else
      facteur_pos = 1; /* Pas de raison de changer la taille */

    XMoveResizeWindow(_Display, fenetre->bouton_asc_vertical,
		      x_asc, (unsigned int) (y_asc * facteur_pos),
		      l_asc, (unsigned int) ((haut + delta_y) * facteur_taille));
  }
  if (fenetre->fleche_basse)
  {
    XGetGeometry(_Display, fenetre->fleche_basse, &w, &x, &y, &larg, &haut, &j, &j);
    XMoveWindow(_Display, fenetre->fleche_basse, delta_x + x, y + delta_y);
  }
  if (fenetre->fleche_gauche)
  {
    XGetGeometry(_Display, fenetre->fleche_gauche, &w, &x, &y, &larg, &haut, &j, &j);
    XMoveWindow(_Display, fenetre->fleche_gauche, x, y + delta_y);
  }
  if (fenetre->fond_asc_horizontal)
  {
    int x_asc, y_asc;
    unsigned int l_asc, h_asc;
    float facteur_pos, facteur_taille;

    XGetGeometry(_Display, fenetre->fond_asc_horizontal, &w, &x, &y, &larg, &haut, &j, &j);
    XGetGeometry(_Display, fenetre->bouton_asc_horizontal, &w,
		 &x_asc, &y_asc, &l_asc, &h_asc, &j, &j);
    XMoveResizeWindow(_Display, fenetre->fond_asc_horizontal,
		      x, y + delta_y, larg + delta_x, haut);

    facteur_taille = ( (float) l_asc ) / (float) larg;
    if ( larg != l_asc ) /* Poussoir plus petit que l'ascenseur */
    {
      facteur_pos  = 1 - facteur_taille;
      facteur_pos /= (float) (larg - l_asc);
      facteur_pos *= (float) (larg + delta_x);
    }
    else
      facteur_pos = 1;
    XMoveResizeWindow(_Display, fenetre->bouton_asc_horizontal,
		      (unsigned int) (x_asc * facteur_pos), y_asc,
		      (unsigned int) ((larg + delta_x) * facteur_taille), h_asc);
  }
  if (fenetre->fleche_droite)
  {
    XGetGeometry(_Display, fenetre->fleche_droite, &w, &x, &y, &larg, &haut, &j, &j);
    XMoveWindow(_Display, fenetre->fleche_droite, delta_x + x, y + delta_y);
  }

  /* On enregistre le changement de taille */

  fenetre->larg = nv_larg;
  fenetre->haut = nv_haut;
  fenetre->w_larg += delta_x;
  fenetre->w_haut += delta_y;

  /* Si fentre demande un message de redessin en cas de changement de taille, on le fait */

  if ( fenetre->drapeaux.redessin == VRAI )
    FEN_redessin(fenetre);

  return 1; /* Pas de problme */
}
