/* Bibliothque X-Window pour les interfaces
	    Tout ce qui se rapporte aux fentres
	    Fichier  inclure
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 26 mars 1998
   * Cration du fichier
*/

#ifndef _X_FENETRES_H_

#define _X_FENETRES_H_ 

#include "X_arbres.h" /* Pour la structure Arbre */

typedef struct fenetre   /* La structure fentre.........            */
{
  struct fenetre *suivante;  /* Chanage des structures de fentre                 */
  Window handle;             /* Le handle de la fentre associe  cette structure */
  int    attributs;          /* Attributs de cette fentre                         */
  int x,y,larg,haut;         /* Coordonnes externes de la fentre                 */
  int w_x,w_y,w_larg,w_haut; /* Coordonnes internes de la fentre                 */
  int o_x,o_y,o_larg,o_haut; /* Anciennes coordonnes, avant plein cran           */
  int type;                  /* 1 = GEM, 2 = Image, 3 = mixte - 0:utilisateur      */
  int numero_arbre;          /* Numro de l'arbre d'objet ou de l'image            */
  boolean drapeau;           /* Pour un drapeau utilisateur quelqconque...         */
  struct                     /* Une srie de drapeaux divers                       */
  {
    unsigned repliee : 1; /* VRAI si elle est replie   */
    unsigned icone   : 1; /* VRAI si elle est iconifie */
    unsigned redessin: 1; /* VRAI si il faut tout redessiner en cas de changement de taille */
    unsigned pointeur: 1; /* VRAI si elle contient un pointeur souris */
    unsigned ouverte : 1; /* VRAI si elle est ouverte   */
    unsigned util_3  : 1; /* Utilisateur, 3 */
    unsigned util_2  : 1; /* Utilisateur, 2 */
    unsigned util_1  : 1; /* Utilisateur, 1 */
  } drapeaux;

  char *titre;               /* Ligne de titre                                     */
  char *infos;               /* Ligne d'informations                               */
  Arbre *arbre;              /* Adresse de l'arbre associ  la fentre            */
  void *adresse;             /* Adresse de qq chose associ  la fentre : utilisateur */
  void *pointeur;            /* Adresse d'une autre chose associe  la fentre: utilisateur */

  void (*redessin)  (struct fenetre *, int x, int y, int larg, int haut);    /* Redessin   */
  void (*ascenseur) (struct fenetre *, int type, int ss_type, int position); /* Ascenseurs */
  boolean (*clavier)(struct fenetre *, unsigned int touche, int etat);       /* Clavier    */
  boolean (*clic)   (struct fenetre *, int bouton, int n_clic, int etat, int x, int y); /* Clic */
  boolean (*message)(struct fenetre *);
  boolean (*rect)   (struct fenetre *, int x, int y); /* Premier vnement rectangle => pointeur */
  boolean (*temps)  (struct fenetre *);             /* Gestion du timer                   */

  struct
  {
    unsigned taille      : 1; /* VRAI -> appeler message si chgmt de taille */
    unsigned position    : 1; /* et ainsi de suite...                 */
    unsigned plein_ecran : 1;
    unsigned premier_plan: 1;
    unsigned arriere_plan: 1;
    unsigned fermeture   : 1;
    unsigned autres      : 1;
    unsigned utilisateur : 1;
  } msg_masque; /* Spcifie les messages qui doivent tre transmis  la fentre */

  /* ---------- Spcifique  X-Windows ------------ */

  Window closer;

  Window barre_d_infos;

  Window fleche_haute;
  Window fleche_basse;
  Window fond_asc_vertical;
  Window bouton_asc_vertical;

  Window fleche_gauche;
  Window fond_asc_horizontal;
  Window bouton_asc_horizontal;
  Window fleche_droite;

  XSizeHints *taille; /* Paramtres de taille : pour le WM */
} Fenetre;

/* Les attributs possibles (en plus de ceux de base) */
/* Remarque : ne sont pas utiles sous X FULLER, MOVER, SIZER, HOTCLOSE, ICONIFIER */

#define TOUS_SF_ASC    NAME|CLOSER|FULLER|MOVER|INFO|SIZER|HOTCLOSE /* Tout sauf les ascenseurs */
#define ASC_VERTICAL   (UPARROW|DNARROW|VSLIDE) /* Tout pour l'ascenseur vertical   */
#define ASC_HORIZONTAL (LFARROW|RTARROW|HSLIDE) /* --------------------- horizontal */
#define TOUS_BOUTONS   0xFFFF                   /* Tous les gadgets de fentre prsents */

/* Les types de fentre prdfinis */

#define GEM_FENETRE   1 /* Fentre contenant un arbre GEM */
#define IMAGE_FENETRE 2 /* Fentre contenant une image    */
#define MIXTE_FENETRE 3 /* Arbre GEM + zone utilisateur   */
#define TEXTE_FENETRE 4 /* Fentre texte - ENCORE RIEN DE FAIT */

/* Position de l'arbre pour une fentre mixte */

#define AUCUN 	0 /* Arbre de fentre mixte de taille fixe */
#define GAUCHE  1 /*   "    "    "      "   occupe toute la hauteur  gauche */
#define DROITE  2 /*   "    "    "      "      "     "    "    "    " droite */
#define HAUT    3 /*   "    "    "      "      "     "    " largeur en haut  */
#define BAS     4 /*   "    "    "      "      "     "    "    "    "  bas   */

/* ~~~~~~~~~~ Cration, fermeture, ... de fentres ~~~~~~~~~~~~ */

Fenetre *creer_fenetre(int attributs, char *titre, char *infos, 
                       void (*redessin)  (Fenetre *, int, int, int, int),
                       void (*ascenseur) (Fenetre *, int, int, int),
		       boolean (*clavier)(Fenetre *, unsigned int, int),
                       boolean (*clic)   (Fenetre *, int, int, int , int, int),
                       boolean (*message)(Fenetre *),
		       boolean (*rect)   (Fenetre *, int, int),
		       boolean (*temps)  (Fenetre *) );

Fenetre *creer_gem_fenetre  (int attributs, int numero_arbre, char *titre);
Fenetre *creer_mixte_fenetre(int attributs, int numero_arbre, char mode, 
			     void (*redessin)(Fenetre *, int, int, int, int),
			     boolean (*clavier)(Fenetre *, unsigned int, int),
			     boolean (*clic)   (Fenetre *, int, int, int, int, int),
			     boolean (*message)(Fenetre *),
			     boolean (*rect)   (Fenetre *, int, int),
			     boolean (*temps)  (Fenetre *) );

int FEN_reouvre  (Fenetre *fenetre);
int ouvre_fenetre(Fenetre *fenetre, int x, int y, int larg, int haut);

void FEN_ferme    (Fenetre *fenetre, boolean detruit); /* Juste la fentre   */
int  ferme_fenetre(Fenetre *fenetre); /* Fentre _et_ structure associe */

Fenetre *quelle_fenetre(Window fenetre);   /* Conversion fen X / fen GEM    */
int      quel_handle   (Fenetre *fenetre); /* Conversion FEN * / handle GEM */

int FEN_ascenseur(Fenetre *fenetre, int asc, int pos, int taille);
int FEN_infos(Fenetre *fenetre, char *infos);
int FEN_titre(Fenetre *fenetre, char *titre);
Fenetre *FEN_premierplan(Fenetre *fenetre);

boolean FEN_redessin(Fenetre *fenetre);

#ifdef _LIBRAIRIE_X_

int FEN_creation         (Fenetre *fenetre, int attributs); /* Cration d'une fentre */
int FEN_ote_evenement    (Window fenetre);

int change_taille_fenetre(Fenetre *fenetre, int nv_larg, int nv_haut);

#endif /* _LIBRAIRIE_X_ */

#endif /* _X_FENETRES_H_ */
