/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de formulaires (FORM lib)
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include <Bib_X.h>

int form_do(OBJECT *adresse, int prem_edit)
{
  int num_arbre;

  if (adresse == NULL)
    return -1;

  for (num_arbre = 0 ; arbres[num_arbre].adresse != adresse ; num_arbre++)
  {
    if (num_arbre > _nbr_arbres) /* On a dpass */
      return -2;
  }

  return ext_formdo(num_arbre);
}

int form_dial(int dtype, int ix, int iy, int iw, int ih, int x, int y, int w, int h)
{
  return 0; /* Fonction sans aucun intrt sous X */
}

/* -------- Botes d'alerte -------- */

int form_alert(int defbut, const char *chaine)
{
  char *fin_txt;
  char *lignes[5] = {NULL, NULL, NULL, NULL, NULL};  /* 5 lignes de texte */
  char *boutons[3] = {NULL, NULL, NULL}; /* 3 boutons */
  int num_icone, i;
  int bouton_sortie = 0;

  if (chaine == NULL)
    return -1;

  if (*chaine != '[')
  {
    printf("Format du message d'alerte incorrect\n");
    return -2;
  }
  chaine++; /* Pointeur sur le numro de l'icne */

  num_icone = *chaine - '0';
  /*  printf("On demande l'icne numro : %d\n", num_icone); */

  while (*chaine != ']')
  {
    if (chaine == NULL) /* Fin de la chane */
    {
      printf("Format du message d'alerte incorrect\n");
      return -2;
    }
    chaine++;
  }

  chaine++;
  if (*chaine != '[')
  {
    printf("Format du message d'alerte incorrect\n");
    return -2;
  }
  chaine++;

  /* On lit les lignes */

  for (i = 0 ; i < 5 ; i++) /* 5 lignes max. */
  {
    char *pos_cr;
    unsigned long lg_ligne;

    fin_txt = strchr(chaine, '|');
    pos_cr  = strchr(chaine, ']');
    if ( (fin_txt == NULL) || (pos_cr < fin_txt) )
      fin_txt = pos_cr;

    if (fin_txt == NULL)
    {
      printf("Format du message d'alerte incorrect\n");
      return -2;
    }

    lg_ligne = fin_txt - chaine;
    lignes[i] = (char *) malloc(lg_ligne + 2); /* Il faudra rajouter un NULL  la fin */
    if (lignes[i] == NULL)
    {
      printf("Mmoire insuffisante pour afficher une bote d'alerte\n");
      return -3;
    }

    strncpy(lignes[i], chaine, lg_ligne);
    lignes[i][lg_ligne] = 0; /* On finit par un zro - inutile : pourquoi ? */
    chaine = fin_txt; /* On passe  la ligne suivante */

    OB_SPEC(Boite_d_alerte, i + 1)   = (long) lignes[i];
    OB_FLAGS(Boite_d_alerte, i + 1) &= ~HIDETREE;

    if (*chaine == ']') /* Dernire ligne */
    {
      i++;
      break;
    }
    chaine++;
  }
  for ( ; i < 5 ; i++)
  {
    lignes[i] = NULL;
    OB_FLAGS(Boite_d_alerte, i + 1) |= HIDETREE;
  }

  chaine++; /* On commence les boutons */
  if (*chaine != '[')
  {
    printf("Format du message d'alerte incorrect\n");
    return -2;  
  }

  chaine++;

  /* On lit les boutons */

  for (i = 0 ; i < 3 ; i++) /* 3 boutons max. */
  {
    char *pos_cr;
    unsigned long lg_bouton;

    fin_txt = strchr(chaine, '|');
    pos_cr  = strchr(chaine, ']');
    if ( (fin_txt == NULL) || (pos_cr < fin_txt) )
      fin_txt = pos_cr;

    if (fin_txt == NULL)
    {
      printf("Format du message d'alerte incorrect\n");
      return -2;
    }

    lg_bouton = fin_txt - chaine;
    boutons[i] = (char *) malloc(lg_bouton + 2); /* Il faudra rajouter un NULL  la fin */
    if (boutons[i] == NULL)
    {
      printf("Mmoire insuffisante pour afficher une bote d'alerte\n");
      return -3;
    }

    strncpy(boutons[i], chaine, lg_bouton);
    boutons[i][lg_bouton] = 0; /* On finit par un zro */
    chaine = fin_txt; /* On passe  la ligne suivante */

    Boite_d_alerte[6 + i].ob_spec.texte = boutons[i];
    OB_FLAGS(Boite_d_alerte, 6 + i) &= ~HIDETREE;
    OB_FLAGS(Boite_d_alerte, 6 + i) &= ~DEFAULT;

    if (*chaine == ']') /* Dernire ligne */
    {
      i++;
      break;
    }
    chaine++;
  }
  for ( ; i < 3 ; i++ )
  {
    boutons[i] = NULL;
    OB_FLAGS(Boite_d_alerte, i + 6) |= HIDETREE;
    OB_FLAGS(Boite_d_alerte, 6 + i) &= ~DEFAULT;
  }

  /* On fait ce que l'on a  faire */

  if ( (defbut > 0) && (defbut < 4) )
    OB_FLAGS(Boite_d_alerte, 6 + defbut - 1) |= DEFAULT;

  bouton_sortie = ext_formdo(_nbr_arbres);

  /* On libre tout */

  for (i = 0 ; i < 3 ; i++)
  {
    free(boutons[i]);
    free(lignes[i]);
  }
  for ( ; i < 5 ; i++)
    free(lignes[i]);

  return (bouton_sortie - 5); /* Renvoi 1 si bouton le plus  gauche cliqu */
}

int form_error(int errnum);

/* -------- Centrer un arbre  l'cran - sans grand intrt en gnral :-) ---- */

int form_center(OBJECT *adresse, int *x, int *y, int *larg, int *haut)
{
  if (adresse == NULL)
    return -1;

  *larg = OB_WIDTH(adresse, ROOT);
  *haut = OB_HEIGHT(adresse, ROOT);

  *x = ( WidthOfScreen(_Ecran) - *larg ) / 2;
  *y = ( HeightOfScreen(_Ecran) - *haut ) / 2;

  /* Et on ne touche surtout pas  ob_x et ob_y car RELATIF  LA FENTRE -> toujours en 0,0... */
  return 0;
}

int  form_keybd      (OBJECT *form, int obj, int nxt_obj,
		      unsigned int thechar, int  *pnxt_obj, unsigned int  *pchar);

int form_button(OBJECT *adresse, int objet, int n_clics, int *pnxt_obj)
{
  int num_arbre;
  int i;

  if (adresse == NULL)
    return -1;

  if ( OB_STATE(adresse, objet) & DISABLED ) /* Object inactif : rien  faire */
    return 0;

  for (num_arbre = 0 ; arbres[num_arbre].adresse != adresse ; num_arbre++)
    if (num_arbre > _nbr_arbres)
    {
      printf("form_button : pas d'arbre associ - traitement impossible\n");
      return -2;
    }

  if ( objet >= arbres[num_arbre].nbr_objets )
  {
    printf("form_button : pas d'objet %d dans cet arbre\n", objet);
    return -3;
  }

  *pnxt_obj = objet; /* cas le plus frquent */

  for ( i = n_clics ; i > 0 ; i-- )
  {
    OBJ_choisit(num_arbre, objet, ECHANGE);
  }

  return 0;
}

