/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de diverses choses (GRAF lib) */

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include "Bib_X.h"

int  graf_rubbox   (int xorigin, int yorigin, int wmin, int hmin, int *pwend, int *phend);
int  graf_dragbox  (int w, int h, int sx, int sy, int xc, int yc, 
		    int wc, int hc, int *pdx, int *pdy);
int  graf_mbox     (int w, int h, int srcx, int srcy, int dstx, int dsty);
void graf_growbox  (int stx, int sty, int stw, int sth, int finx, int finy, int finw, int finh);
void graf_shrinkbox(int finx, int finy, int finw, int finh, int stx, int sty, int stw, int sth);
int  graf_watchbox (OBJECT *tree, int obj, int instate, int outstate);

/* Dplacer un objet dans un autre */

int graf_slidebox(OBJECT *adresse, int pere, int objet, int sens)
{
  Window f_pere, f_fils;
  int num_arbre;

  if (adresse == NULL)
    return -1;

  for (num_arbre = 0 ; arbres[num_arbre].adresse != adresse ; num_arbre++)
    if (num_arbre > _nbr_arbres + 1)
    {
      printf("graf_slidebox : arbre inexistant\n");
      return -2;
    }

  if (arbres[num_arbre].ouvert == FAUX)
  {
    printf("graf_slidebox : arbre non ouvert\n");
    return -4;
  }

  if ( ( pere >= arbres[num_arbre].nbr_objets) 
       || (objet >= arbres[num_arbre].nbr_objets) )
  {
    printf("graf_slidbox : objet(s) inexistant(s)\n");
    return -3;
  }

  f_pere = (arbres[num_arbre].objets)[pere];
  f_fils = (arbres[num_arbre].objets)[objet];

  return X_ascenseur(f_pere, f_fils, sens);
}

/* --------------- Ralisation effective de graf_slidebox : fentre X dans fentre X ------------\
 |   Renvoie la position de la fentre en pour milles dans la direction demande                 |
 |
 | mere  : la fentre X servant de fond
 | fille : la fentre X fille, que l'on dplace
 | sens  : VERTICAL ou HORIZONTAL
 \---------------------------------------------------------------------------------------------- */

int X_ascenseur(Window mere, Window fille, boolean sens)
{
  int x_fille, y_fille, x_mere, y_mere, j;
  unsigned int haut_fille, larg_fille, larg_mere, haut_mere, i;
  Window racine;
  XEvent evenement;
  long masque = ButtonReleaseMask | PointerMotionMask; /* Dplacement ou fin de clic seulement */
  int x_souris, y_souris;

  XGetGeometry(_Display, fille, &racine, &x_fille, &y_fille, &larg_fille, &haut_fille, &i, &i);
  XGetGeometry(_Display, mere, &racine, &x_mere, &y_mere, &larg_mere, &haut_mere, &i, &i);

  if ( (larg_mere == larg_fille) && (sens == HORIZONTAL) )
    return 0;
  if ( (haut_mere == haut_fille) && (sens == VERTICAL) )
    return 0;

  XQueryPointer(_Display, mere, &racine, &racine, &j, &j, &x_souris, &y_souris, &i);

/* #ifndef _DEVELOPPE_ /* Version de dveloppement : on ne monopolise pas le pointeur
		       sinon, si plante pendant ce temps, souris bloque -> serveur X bloqu ! */

  if ( XGrabPointer(_Display, mere, False, masque, GrabModeAsync, GrabModeAsync, mere,
		    None, CurrentTime) == GrabSuccess ) /* On a pu rserver la souris */
  {
/* #endif /* _DEVELOPPE_ */
    do
    {
      XMaskEvent(_Display, masque, &evenement);

      if (evenement.xany.window != mere)
	printf("Pas la bonne fentre !\n");

      if ( evenement.type == MotionNotify ) /* Souris dplace */
      {
	if (sens == VERTICAL)
	{
	  y_fille += (evenement.xmotion.y - y_souris);
	  if (y_fille < 0)
	    y_fille = 0;
	  if (y_fille + haut_fille >= haut_mere)
	    y_fille = haut_mere - haut_fille; 
	  y_souris = evenement.xmotion.y;
	}
	else
	{
	  x_fille += (evenement.xmotion.x - x_souris);
	  if (x_fille < 0)
	    x_fille = 0;
	  if (x_fille + larg_fille > larg_mere)
	    x_fille = larg_mere - larg_fille;
	  x_souris = evenement.xmotion.x;
	}

	XMoveWindow(_Display, fille, x_fille, y_fille);
      }
    }
    while ( evenement.type != ButtonRelease );

/* #ifndef _DEVELOPPE_ */

    XUngrabPointer(_Display, CurrentTime); /* On libre la souris */
    /*    XPutBackEvent(_Display, &evenement); /* On rappelle que l'on a relach */
  }

/* #endif /* _DEVELOPPE_ */

  if (sens == VERTICAL)
  {
    float pos;

    pos = (float) y_fille / ( (float) (haut_mere - haut_fille) );
    if (pos < 0)
      pos = 0; /* Pour tre tranquille */
    return (int) (pos * 1000.0);
  }
  else
  {
    float pos;

    pos = (float) x_fille / ( (float) (larg_mere - larg_fille) );
    if (pos < 0)
      pos = 0;
    return (int) (pos * 1000.0);
  }
}

int  graf_handle   (int *pwchar, int *phchar, int *pwbox, int *phbox);

int graf_mouse(int m_number, MFORM *m_addr)
{
  switch (m_number)
  {
  case M_OFF: /* Curseur visible / invisible : sans intrt sous X... */
  case M_ON:
    return m_number;

  }

  return m_number;
}

void graf_mkstate  (int *pmx, int *gpmy, int *pmstate, int *pkstate);
