/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de diverses choses (GRAF lib) */

#ifndef _X_GRAF_LIB_H_

#define _X_GRAF_LIB_H_ 

#include "../SYSTEME.H"

/* Mouse Forms */

#define ARROW            0
#define TEXT_CRSR        1
#define HOURGLASS        2
#define BUSY_BEE         2 /* for compatibility */
#define POINT_HAND       3
#define FLAT_HAND        4
#define THIN_CROSS       5
#define THICK_CROSS      6
#define OUTLN_CROSS      7
#define M_PUSH         100
#define M_POP          101
#define USER_DEF       255
#define M_OFF          256
#define M_ON           257

/* Mouse Form Definition Block */

typedef struct mfstr
{
  int mf_xhot;
  int mf_yhot;
  int mf_nplanes;
  int mf_fg;
  int mf_bg;
  int mf_mask [16];
  int mf_data [16];
} MFORM;

int  graf_rubbox   (int xorigin, int yorigin, int wmin, int hmin, int *pwend, int *phend);
int  graf_dragbox  (int w, int h, int sx, int sy, int xc, int yc, 
		    int wc, int hc, int *pdx, int *pdy);
int  graf_mbox     (int w, int h, int srcx, int srcy, int dstx, int dsty);
void graf_growbox  (int stx, int sty, int stw, int sth, int finx, int finy, int finw, int finh);
void graf_shrinkbox(int finx, int finy, int finw, int finh, int stx, int sty, int stw, int sth);
int  graf_watchbox (OBJECT *tree, int obj, int instate, int outstate);

#define VERTICAL   1 /* Sens pour graf_slidebox */
#define HORIZONTAL 0

int  graf_slidebox (OBJECT *tree, int parent, int obj, int isvert);
int  graf_handle   (int *pwchar, int *phchar, int *pwbox, int *phbox);
int  graf_mouse    (int m_number, MFORM *m_addr);
void graf_mkstate  (int *pmx, int *gpmy, int *pmstate, int *pkstate);

#ifdef _LIBRAIRIE_X_ /* Fonctions internes  la librairie */

int X_ascenseur(Window mere, Window fille, boolean sens);

#endif /* _LIBRAIRIE_X_ */

#endif /* _X_GRAF_LIB_H_ */
