/* Bibliothque X-Window pour les interfaces
   Routines pour les menus (barre de menu et sous-menus "pop-up")

   (C) 1998, Emmanuel CURIS - Cration le 11 septembre 1998
*/

#ifndef _X_MENU_

#define _X_MENU_ /* vite les inclusions multiples */

#ifdef _LIBRAIRIE_X_ 

#include "X_objets.h"

typedef struct
{
  OBJECT *adresse;  /* Adresse de l'arbre = menu     */
  Window racine;    /* Fentre d'affichage du menu   */
  int nbr_titres;   /* Nombre de titres dans le menu */
  int prem_titre;   /* Index du premier titre dans l'arbre            */
  Window *titres;   /* Les titres des menus                           */
  int *prem_option; /* Index de la premire option, pour chaque titre */
  int *nbr_options; /* Nombre d'options pour chaque titre */

  boolean (*gestion)(int option); /* Fonction qui gre le menu */
} Menu; /* Affichage d'un menu */

#endif

/* ---------------- Installation d'une barre de menu -----------------\
 |    Remplace la barre existante s'il y en a dj une                |
 |                                                                    |
 | num_arbre : arbre GEM  installer comme menu                       |
 | gestion   : routine de gestion du menu                             |
 \------------------------------------------------------------------- */

int installe_menu(int num_arbre, boolean (*gestion)(int option) );

/* ---------------- Suppression de la barre de menu ---------------- */

int supprime_menu(void);

#ifdef _LIBRAIRIE_X_

int CLIC_menu(int num_titre);                          /* Clic sur un des titres du menu */

#endif /* _LIBRAIRIE_X_ */

#endif /* _X_MENU_ */
