/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque d'objets (OBJC lib)
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <Bib_X.h>

extern int OBJ_der_caractere(TEDINFO *tedinfo);

int objc_add    (OBJECT  *tree, int parent, int child);
int objc_delete (OBJECT  *tree, int delob);

int objc_draw(OBJECT *adresse, int num_obj, int profond, int x, int y, int larg, int haut)
{
  int num_arbre;
  Window handle;

  for (num_arbre = 0 ; arbres[num_arbre].adresse != adresse ; num_arbre++);

  handle = (arbres[num_arbre].objets)[num_obj]; /* Fentre associe  l'objet GEM tudi */

  OBJ_dessine(handle, adresse + num_obj);
  return 0; /* Pas d'erreur */
}

int objc_find   (OBJECT  *tree, int startob, int depth, int mx, int my);

int objc_offset(OBJECT *adresse, int objet, int *poffx, int *poffy)
{
  if (adresse == NULL)
    return -1;

  *poffx = OB_X(adresse, objet); /* Sous X, semble plus raisonnable */
  *poffy = OB_Y(adresse, objet); /* Car tout est compt en coords. relatives... */

  return 0;
}

int objc_order  (OBJECT  *tree, int mov_obj, int newpos);

int objc_edit(OBJECT *adresse, int objet, int caractere, int pos_cur, int type, int *nv_pos)
{
  TEDINFO *tedinfo;
  char masque, car, code_clavier;
  int max_pos; /* Position maximale du curseur dans le texte */
  int arbre;

  if (adresse == NULL)
    return -1;

  if ( !(OB_FLAGS(adresse, objet) & EDITABLE) )
    return -2; /* Objet n'est pas ditable ! */

  if ( (OB_TYPE(adresse, objet) != G_FTEXT)
       && (OB_TYPE(adresse, objet) != G_FBOXTEXT) )
    return -3; /* Objet n'est pas un objet texte pouvant tre dit ! */

  tedinfo = adresse[objet].ob_spec.tedinfo;
  if (tedinfo == NULL)
    return -4; /* Pas de TEDINFO */

  max_pos = tedinfo->te_txtlen - 1; /* Position du curseur maximale */
  if (pos_cur > max_pos)
    pos_cur = max_pos;

  switch (type)
  {
  case ED_INIT: /* On affiche le curseur, aprs l'avoir plac */
    for (pos_cur = 0 ; (pos_cur < max_pos) && ( (tedinfo->te_ptext)[pos_cur]) ; pos_cur++);
    if (pos_cur == max_pos)
      pos_cur--;
    *nv_pos = pos_cur; /* Position courante du curseur */

    break;

  case ED_CHAR: /* On essaye d'ajouter un caractre */
    car = (char) (caractere);
    code_clavier = (char) (caractere >> 8);

    if (car == 0)
    {
      /*      switch (code_clavier)
      {
      case 0:
	return VRAI;
      } */
      printf("Fonctionne pas encore...\n");
    }
    else if (car < 32)
    {
      int i;

      switch (car)
      {
      case 8: /* Backspace */
	if (pos_cur > 0) /* On est sur le premier caractre ==> BackSpace sans effet */
	{
	  int dernier_car = OBJ_der_caractere(tedinfo);

	  if ( pos_cur == dernier_car ) /* On est sur le dernier caractre de la chane */
	  {
	    (tedinfo->te_ptext)[pos_cur - 1] = 0; /* Fin de chane */
	  }
	  else
	  {
	    for (i = pos_cur - 1 ; i < dernier_car ; i++)
	    {
	      (tedinfo->te_ptext)[i] = (tedinfo->te_ptext)[i + 1];
	    }
	    (tedinfo->te_ptext)[dernier_car - 1] = 0; /* Fin de chane */
	  }

	  pos_cur--; /* Curseur dcal d'un cran vers la gauche */
	  *nv_pos = pos_cur;
	  objc_draw(adresse, objet, MAX_DEPTH,
		    0, 0, OB_WIDTH(adresse, objet), OB_HEIGHT(adresse, objet));
	}
	break;

      case 27: /* Escape : on vide le champ */
	for (i = 0 ; i < tedinfo->te_txtlen ; i++)
	  (tedinfo->te_ptext)[i] = 0;

	pos_cur = 0;
	*nv_pos = 0;
	break;

      default:
	printf("Code de contrle : code %d\n", car);
      }

      objc_draw(adresse, objet, MAX_DEPTH,
		0, 0, OB_WIDTH(adresse, objet), OB_HEIGHT(adresse, objet));
    }
    else /* Code ASCII normal */
    {
      boolean valide = FAUX; /* VRAI : caractre valide -> pas de problme */
      masque = (tedinfo->te_pvalid)[pos_cur]; /* Caractre du masque */

      switch (masque)
      {
      case 'a': /* Lettre + espace */
	break;

      case 'F': /* Nom de fichier + * ? */
	break;

      case 'n': /* Chiffre, lettre, espace */
	break;

      case 'N': /* n, mais majuscules seules */
	break;

      case 'p': /* Chemin */
	break;

      case 'P': /* Chemin + * ? */
	break;

      case 'x': /* N'importe quoi, mais en majuscules */
	if ( (car >= 'a') && (car <= 'z') )
	  car += 'A' - 'a'; /* Conversion en majuscules */

#if ISO_8859_1

	if ( (car >= '') && (car <= '') )
	  car += '' - '';

#endif /* ISO_8859_1 */

	(tedinfo->te_ptext)[pos_cur] = car;
	pos_cur++;
	valide = VRAI;
	break;

      case 'X': /* N'importe quoi */
	(tedinfo->te_ptext)[pos_cur] = car;
	pos_cur++;
	valide = VRAI;
	break;

      case '9': /* Un chiffre, quelconque */
	if ( (car >= '0') && (car <= '9') ) /* On met des chiffres */
	{
	  (tedinfo->te_ptext)[pos_cur] = car;
	  pos_cur++;
	  valide = VRAI;
	}
	break;
      }

      if ( valide == FAUX ) /* Caractre invalide */
      {
	char *deb_vide, *pos_future;
	unsigned int i = 0;
	int j = -1;

	while (j < pos_cur) /* On cherche la position _relle_ dans le champ */
	{
	  if ( (tedinfo->te_ptmplt)[i] == '_' ) /* Caractre modifiable */
	  {
	    j++;
	  }
	  i++;
	}
	i--; /* Donc (tedinfo->te_ptmplt)[i] = caractre actuellement modifi */
	deb_vide = tedinfo->te_ptmplt + i;
	printf("Chane ultrieure : %s\n", deb_vide);

	pos_future = strchr(deb_vide, car);
	if ( (pos_future == NULL) && (car == ',') )
	  pos_future = strchr(deb_vide, '.');
	else if ( (pos_future == NULL) && (car == '.') )
	  pos_future = strchr(deb_vide, ',');
	if ( pos_future ) /* Il y a bien ce caractre aprs */
	{
	  printf("Caractre trouv...\n");

	  while (deb_vide != pos_future)
	  {
	    if ( *deb_vide == '_' ) /* Caractre ditable */
	    {
	      (tedinfo->te_ptext)[pos_cur] = ' '; /* On remplit avec des espaces */
	      pos_cur++;
	    }
	    deb_vide++; /* Caractre suivant */
	  }
	}
      }

      if (pos_cur >= max_pos)
	pos_cur = max_pos - 1; /* On ne peut pas dpasser le dernier */

      *nv_pos = pos_cur; /* On reste sur le dernier */

      objc_draw(adresse, objet, MAX_DEPTH,
		0, 0, OB_WIDTH(adresse, objet), OB_HEIGHT(adresse, objet));
    }
    break;

  case ED_END: /* Rien de spcial  faire */
    objc_draw(adresse, objet, MAX_DEPTH,
	      0, 0, OB_WIDTH(adresse, objet), OB_HEIGHT(adresse, objet));
    return 0;
  }

  for (arbre = 0 ; arbres[arbre].adresse != adresse ; arbre++);

  /* On recherche o est le curseur */

  if (arbres[arbre].ouvert == VRAI)
  {
    int pos_curseur = -1;
    char *texte = tedinfo->te_ptmplt;
    int x_curseur = 0;

    if ( pos_cur == max_pos ) /* Curseur en fin de champ ditable */
    {
      /*      printf("Curseur en fin de champ ditable\n"); */
      texte = tedinfo->te_ptmplt + tedinfo->te_tmplen - 1;
      pos_curseur = tedinfo->te_tmplen - 1;
      while ( (*texte != '_') && (*texte != 0) )
      {
	pos_curseur--;
	texte--;
      }
    }
    else
    {
      int i = -1;
      do
      {
	while ( *texte != '_' )
	{
	  pos_curseur++; /* On se place sur le premier caractre ditable */
	  texte++;
	}
	
	i++; /* On se place aprs le caractre suivant */
	pos_curseur++;
	texte++;
      } while (i < pos_cur);
    }

    x_curseur = XTextWidth(_Fonte, tedinfo->te_ptmplt, pos_curseur);
    if (tedinfo->te_just == TE_CNTR) /* Texte centr */
    {
      char *texte = faire_chaine(tedinfo);
      unsigned int larg_txt = XTextWidth(_Fonte, texte, strlen(texte));

      x_curseur += ( OB_WIDTH(adresse, objet) -  larg_txt ) >> 1;
    }
    XSetForeground(_Display,  _GC_objets, _Couleurs[NOIR].pixel); /* Curseur noir */
    XDrawLine(_Display, (arbres[arbre].objets)[objet], _GC_objets, 
	      x_curseur, 0, x_curseur, OB_HEIGHT(adresse, objet) );
  }

  return 0; /* Pas de problme */
}

int objc_change(OBJECT *arbre, int drawob, int depth, int xc, int yc, int wc, int hc,
		int nestate, int redraw);
