/* Bibliothque GEM / X_windows tendue
   (C) Emmanuel CURIS, avril 1998

   Gestion des objets GEM
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "Bib_X.h"

#include "X_motifs.h"

Pixmap PIX_inactif;

/**************** Fonctions  usage interne dfinies ailleurs ************/

int CLIC_arbre   (Arbre *arbre, XButtonEvent *souris, int *bouton); /* Dans X_gene.c */
int EVNT_redessin(Fenetre *fenetre, XExposeEvent *redessin);
int EVNT_relache (XKeyEvent *clavier);

/* -------- Gestion d'un arbre bloquant -----------\
 | Renvoie le bouton utilis pour quitter          |
 |   -1 : gros problme...                         |
 |                                                 |
 | num_arbre : le numro de l'arbre  traiter      |
 \------------------------------------------------ */

int ext_formdo(int num_arbre)
{
  Arbre *arbre = arbres + num_arbre; /* Arbre utilis */
  Fenetre *fen_arbre;
  int sortie = FAUX;
  int bouton_sortie = 0;

  fen_arbre = creer_gem_fenetre(NAME, num_arbre, "Arbre bloquant");
  if (fen_arbre == NULL)
    return -1;

  do
  {
    XEvent evenement;
    int retour;

    Fenetre *fen_evenement;
    XNextEvent(_Display, &evenement);
    fen_evenement = quelle_fenetre(evenement.xbutton.window);

    switch (evenement.type)
    {
    case KeyPress:
      retour = CLAV_arbre(arbre, &(evenement.xkey));
      if (retour < 0 )
      {
	bouton_sortie = -retour;
	sortie = _QUITTER;
      }
      break;

    case KeyRelease:
      EVNT_relache( &(evenement.xkey) );
      break;

    case Expose: /* Redessin : rien de spcial */
      _Fen_redessin = evenement.xexpose.window;
      EVNT_redessin(fen_evenement, &(evenement.xexpose) );
      break;

    case ButtonPress:
      if (fen_evenement == fen_arbre) /* Seuls les clics sur l'arbre sont enregistrs */
      {
	if ( evenement.xbutton.window != fen_arbre->handle) /* Clic sur un truc sympa... */
	{
	  sortie = CLIC_arbre(arbre, &(evenement.xbutton), &bouton_sortie);
	}
      }
      break;
    }
  } while (sortie != _QUITTER); /* Tant qu'on a pas cliqu sur un objet de sortie */

  OBJ_choisit(num_arbre, bouton_sortie, FORCE_NON);

  ferme_fenetre(fen_arbre);
  return bouton_sortie;
}

void dessine_objet(int num_arbre, int objet)
{
  /* A priori, sous X : trs simple, il suffit de redessiner. Pas de pb. de clipping */

  if ( arbres[num_arbre].ouvert == VRAI ) /* Arbre effectivement ouvert */
    OBJ_dessine( arbres[num_arbre].objets[objet], arbres[num_arbre].adresse + objet);
}

/* ------ fonctions de dessin internes ---------\
 |                                              |
 | fenetre : la fentre correspondant au bouton |
 | objet   : pointeur sur _l'objet_ lui-mme    |
 \--------------------------------------------- */

int OBJ_dessine(Window fenetre, OBJECT *objet)
{
  int type; /* Type de l'objet dessin */
  int x_obj = 0, y_obj = 0, larg_obj, haut_obj; /* Dimensions de l'objet */
  int x_txt, y_txt, larg_txt, haut_txt;
  unsigned long l_txt;

  XSetLineAttributes(_Display, _GC_objets, 1, LineSolid, CapButt, JoinMiter);

  if (objet->ob_type < 0) /* Objet interne */
  {
    XSetFillStyle(_Display, _GC_objets, FillSolid);
    DOBJ_interne(fenetre, objet);
    return 0;
  }
  else
  {
    larg_obj = objet->ob_width;  /* Longueur et largeur */
    haut_obj = objet->ob_height;
  }

  if (objet->ob_flags & HIDETREE) /* Tout s'est bien pass */
    return 0;

  if ( objet->ob_state & DISABLED )
  {
    XGCValues valeurs;

    valeurs.fill_style = FillOpaqueStippled;
    valeurs.stipple = PIX_inactif;

    XChangeGC(_Display, _GC_objets, GCStipple | GCFillStyle, &valeurs);
  }
  else
    XSetFillStyle(_Display, _GC_objets, FillSolid);

  type = objet->ob_type;   /* Type de l'objet */

  XSetLineAttributes(_Display, _GC_objets, 1, LineSolid, CapButt, JoinMiter); /* Style de ligne */

  switch (objet->ob_type)
  {
  case G_BUTTON: /* Boutons proprement dits */
  case G_TITLE:  /* Titre des menus : comme des boutons... */
    DOBJ_bouton(fenetre, objet);
    break;
    
  case G_BOX:
  case G_IBOX:
    DOBJ_boite(fenetre, objet);
    break;

  case G_STRING:
    DOBJ_chaine(fenetre, objet);
    break;

  case G_FTEXT:
  case G_FBOXTEXT:
  case G_TEXT:
  case G_BOXTEXT:
  {
    TEDINFO *tedinfo = objet->ob_spec.tedinfo;
    char *texte = NULL;

    if ( objet->ob_flags & EDITABLE )
    {
      XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);       /* Le fond en blanc */
      XFillRectangle(_Display,fenetre,_GC_objets, 0, 0, larg_obj, haut_obj);

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XDrawLine(_Display, fenetre, _GC_objets, 0, 0, larg_obj, 0);
      XDrawLine(_Display, fenetre, _GC_objets, 0, 0, 0, haut_obj);

      XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel); /* Ct gris clair : 3D */
      XDrawLine(_Display, fenetre, _GC_objets, 0, haut_obj - 1, larg_obj, haut_obj - 1);
      XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 1, 0, larg_obj - 1, haut_obj);
    }
    else
    {
      XSetForeground(_Display, _GC_objets, _Couleurs[GRIS].pixel);
      XFillRectangle(_Display,fenetre,_GC_objets, 0, 0, larg_obj, haut_obj);
    }

    if ( (type == G_FTEXT) || (type == G_FBOXTEXT) )
      texte = faire_chaine(tedinfo); /* On fait la chane  afficher */
    else
      texte = tedinfo->te_ptext;

    if (texte) /* On a pu crer la chane */
    {
      l_txt = strlen(texte);
      larg_txt = XTextWidth(_Fonte, texte, l_txt);
      haut_txt = _Fonte->ascent + _Fonte->descent;
      if (tedinfo->te_just == TE_CNTR)
	x_txt = (larg_obj - larg_txt) / 2;
      else if (tedinfo->te_just == TE_RIGHT)
	x_txt = larg_obj - larg_txt;
      else
	x_txt = 2;                               /* On justifie  droite    */
      y_txt = haut_obj / 2 + _Fonte->ascent / 2; /* On centre verticalement */
      
      XSetForeground(_Display,_GC_objets, _Couleurs[(tedinfo->te_color & 0x0F00) >> 8].pixel);
      XDrawString(_Display, fenetre, _GC_objets, x_txt, y_txt, texte, l_txt);

      if ( (type == G_FTEXT) || (type == G_FBOXTEXT) )
	free(texte); /* On libre cette chane temporaire - seulement si a t cre... */
    }
  }
    break;

  case G_USERDEF: /* Objet utilisateur */
    {
      PARMBLK parametres;
      int i;

      for (i = 0 ; i < _nbr_arbres ; i++)
      {
	if ( (objet >= arbres[i].adresse)
	  && (objet <= arbres[i].adresse + arbres[i].nbr_objets) )
	  break;
      }

      parametres.pb_tree = arbres[i].adresse;
      parametres.pb_obj  = (int) (objet - arbres[i].adresse); /* Index de l'objet */
      parametres.pb_prevstate = objet->ob_state;
      parametres.pb_currstate = objet->ob_state; /* C'est juste et uniquement du redessin... */
      parametres.pb_x = 0; /* objet->ob_x; */
      parametres.pb_y = 0; /* objet->ob_y; */
      parametres.pb_w = objet->ob_width;
      parametres.pb_h = objet->ob_height;
      parametres.pb_xc = 0; /* objet->ob_x; */
      parametres.pb_yc = 0; /* objet->ob_y; */
      parametres.pb_wc = objet->ob_width;
      parametres.pb_hc = objet->ob_height;
      parametres.pb_parm = (objet->ob_spec.util)->ub_parm;

      _Fen_redessin = fenetre; /* Pour tre sr de bien dessiner dedans, mme si appel direct */
      ((objet->ob_spec.util)->ub_code)(&parametres);
    }  
    break;

  case G_BOXCHAR: /* Bote contenant _1_ caractre */
    DOBJ_boxchar(fenetre, objet);
  }

  if ( objet->ob_state & CROSSED )
  {
    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);

    XDrawLine(_Display, fenetre, _GC_objets, x_obj, y_obj, larg_obj, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, x_obj, haut_obj, larg_obj, y_obj);
  }

  if ( objet->ob_state & CHECKED )
  {
    int larg_car = _Fonte->max_bounds.width + 1,
        haut_car = _Fonte->max_bounds.ascent + _Fonte->ascent;

    if ( objet->ob_state & SELECTED )
      XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
    else
      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XSetLineAttributes(_Display, _GC_objets, 2, LineSolid, CapButt, JoinMiter);
    XDrawLine(_Display, fenetre, _GC_objets, x_obj + (int) (0.25 * larg_car), y_obj + (haut_car >> 1),
	      x_obj + larg_car, y_obj + (int) (0.75 * haut_car) );
    XDrawLine(_Display, fenetre, _GC_objets, x_obj + larg_car, y_obj + (int) (0.75 * haut_car),
	      x_obj + (int) (1.75 * larg_car), y_obj + (int) (0.25 * haut_car) );
  }

  return 0; /* Pas d'erreur */
}

void DOBJ_boite(Window fenetre, OBJECT *objet)
{
  int x_obj = 0, y_obj = 0, larg_obj, haut_obj;
  int couleur_fond, motif;

  x_obj    = objet->ob_x;
  y_obj    = objet->ob_y;
  larg_obj = objet->ob_width;
  haut_obj = objet->ob_height;

  couleur_fond = objet->ob_spec.autre & 0xF;
  if (couleur_fond == BLANC)
    couleur_fond = GRIS; /* Pour enjoliver l'aspect 3D */

  motif = (objet->ob_spec.autre & 0x70) >> 4; /* Trame de remplissage... */
  if (motif == 0) /* Pas de trame -> "blanc" */
    couleur_fond = GRIS; /* Donc 3D */

  /* Petit essai pour voir ce que donne la 3D : rend trs bien :-) */

  XSetForeground(_Display,_GC_objets, _Couleurs[couleur_fond].pixel); /* Fond de la couleur */
  XFillRectangle(_Display,fenetre,_GC_objets, 0, 0, larg_obj - 1, haut_obj -1);

  if ( (motif < 7) && (motif > 0) ) return; /* Pas de 3D si tram */

  XSetLineAttributes(_Display, _GC_objets, 1, LineSolid, CapButt, JoinMiter);
  XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 0, larg_obj, 0);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 1, larg_obj - 1, 1);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 0, 0, haut_obj);
  XDrawLine(_Display, fenetre, _GC_objets, 1, 0, 1, haut_obj - 1);

  XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel); /* Ct en gris --> 3D */
  XDrawLine(_Display, fenetre, _GC_objets, 0, haut_obj - 1, larg_obj, haut_obj - 1);
  XDrawLine(_Display, fenetre, _GC_objets, 1, haut_obj - 2, larg_obj, haut_obj - 2);
  XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 1, 0, larg_obj - 1, haut_obj);
  XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 2, 1, larg_obj - 2, haut_obj);
}

void DOBJ_bouton(Window fenetre, OBJECT *objet)
{
  char *texte;
  int larg_obj, haut_obj;
  int x_txt, y_txt;
  unsigned long l_txt;
  unsigned int larg_txt;

  larg_obj = objet->ob_width;
  haut_obj = objet->ob_height;
  texte    = objet->ob_spec.texte;

  /* On met l'aspect 3D */

  if ( objet->ob_state == SELECTED)
  {
    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel); /* Le fond en gris */
    XFillRectangle(_Display, fenetre, _GC_objets, 0, 0, larg_obj, haut_obj);

    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 0, larg_obj, 0);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 1, larg_obj - 1, 1);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 0, 0, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, 1, 0, 1, haut_obj - 1);

    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS].pixel); /* Ct gris clair : 3D */
    XDrawLine(_Display, fenetre, _GC_objets, 0, haut_obj, larg_obj, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, 1, haut_obj - 1, larg_obj, haut_obj - 1);
    XDrawLine(_Display, fenetre, _GC_objets, larg_obj, 0, larg_obj, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 1, 1, larg_obj - 1, haut_obj);
  }
  else
  {
    XSetForeground(_Display,_GC_objets, _Couleurs[GRIS].pixel); /* Fond gris clair */
    XFillRectangle(_Display,fenetre,_GC_objets, 0, 0, larg_obj, haut_obj);

    XSetLineAttributes(_Display, _GC_objets, 1, LineSolid, CapButt, JoinMiter);
    XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 0, larg_obj, 0);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 1, larg_obj - 1, 1);
    XDrawLine(_Display, fenetre, _GC_objets, 0, 0, 0, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, 1, 0, 1, haut_obj - 1);

    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel); /* Ct en gris --> 3D */
    XDrawLine(_Display, fenetre, _GC_objets, 0, haut_obj - 1, larg_obj, haut_obj - 1);
    XDrawLine(_Display, fenetre, _GC_objets, 1, haut_obj - 2, larg_obj, haut_obj - 2);
    XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 1, 0, larg_obj - 1, haut_obj);
    XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 2, 1, larg_obj - 2, haut_obj);
  }

  if (texte == NULL)
    return; /* Pas de texte associ */

  if ( (texte[0] < 32) && strlen(texte) == 1 ) /* Pour les ascenseurs... */
  {
    XPoint points[4];

    switch ( texte[0] )
    {
    case 1: /* Flche vers le haut */
      points[0].x = (short) larg_obj / 2;
      points[0].y = 4;
      points[1].x = (short) larg_obj - 3;
      points[1].y = (short) haut_obj - 4;
      points[2].x = 2;
      points[2].y = points[1].y;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 2: /* Flche vers le bas */
      points[0].x = (short) larg_obj / 2;
      points[0].y = (short) haut_obj - 5;
      points[1].x = (short) larg_obj - 2;
      points[1].y = 2;
      points[2].x = 2;
      points[2].y = points[1].y;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 3: /* Flche vers la droite */
      points[0].x = (short) larg_obj - 4;
      points[0].y = (short) haut_obj/2;
      points[1].x = 2;
      points[1].y = 4;
      points[2].x = points[1].x;
      points[2].y = (short) haut_obj - 4;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 4: /* Flche vers la gauche */
      points[0].x = 2;
      points[0].y = (short) haut_obj/2;
      points[1].x = (short) larg_obj - 4;
      points[1].y = 4;
      points[2].x = points[1].x;
      points[2].y = (short) haut_obj - 4;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 5: /* Croix de fermeture */
      points[0].x = 3;
      points[0].y = 3;
      points[1].x = (short) larg_obj - 3;
      points[1].y = (short) haut_obj - 3;
      points[2].x = 3;
      points[2].y = points[1].y;
      points[3].x = points[1].x;
      points[3].y = 3;

      XSetLineAttributes(_Display, _GC_objets, 2, LineSolid, CapButt, JoinMiter);
      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XDrawSegments(_Display, fenetre, _GC_objets, (XSegment *) points, 2);
      return;

    default:
      printf("Code spcial : %d\n", texte[0]);
    }
  }

  /* On met le texte */

  l_txt = strlen(texte);
  larg_txt = XTextWidth(_Fonte, texte, l_txt);
  x_txt  = (larg_obj - larg_txt) / 2; /* On centre */    
  y_txt  = (haut_obj + _Fonte->ascent) / 2;
      
  XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
  XDrawString(_Display, fenetre, _GC_objets, x_txt, y_txt, texte, l_txt);
}

void DOBJ_boxchar(Window fenetre, OBJECT *objet)
{
  int larg_obj, haut_obj;
  int x_texte, y_texte, larg_texte;
  unsigned char code;

  larg_obj = objet->ob_width;
  haut_obj = objet->ob_height;
  DOBJ_boite(fenetre, objet); /* Pour le fond et tout et tout */
  code = (unsigned char) ( (objet->ob_spec.autre & 0xFF000000) >> 24);

  if ( code < 32 ) /* Pour les ascenseurs... */
  {
    XPoint points[4];

    switch ( code )
    {
    case 1: /* Flche vers le haut */
      points[0].x = (short) larg_obj / 2;
      points[0].y = 4;
      points[1].x = (short) larg_obj - 3;
      points[1].y = (short) haut_obj - 4;
      points[2].x = 2;
      points[2].y = points[1].y;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 2: /* Flche vers le bas */
      points[0].x = (short) larg_obj / 2;
      points[0].y = (short) haut_obj - 5;
      points[1].x = (short) larg_obj - 2;
      points[1].y = 2;
      points[2].x = 2;
      points[2].y = points[1].y;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 3: /* Flche vers la droite */
      points[0].x = (short) larg_obj - 4;
      points[0].y = (short) haut_obj/2;
      points[1].x = 2;
      points[1].y = 4;
      points[2].x = points[1].x;
      points[2].y = (short) haut_obj - 4;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 4: /* Flche vers la gauche */
      points[0].x = 2;
      points[0].y = (short) haut_obj/2;
      points[1].x = (short) larg_obj - 4;
      points[1].y = 4;
      points[2].x = points[1].x;
      points[2].y = (short) haut_obj - 4;
      points[3] = points[0];

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
      return;

    case 5: /* Croix de fermeture */
      points[0].x = 3;
      points[0].y = 3;
      points[1].x = (short) larg_obj - 3;
      points[1].y = (short) haut_obj - 3;
      points[2].x = 3;
      points[2].y = points[1].y;
      points[3].x = points[1].x;
      points[3].y = 3;

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XDrawSegments(_Display, fenetre, _GC_objets, (XSegment *) points, 2);
      return;

    default:
      printf("Code spcial : %d\n", code);
    }
  }

  /* On met le texte */

  larg_texte = XTextWidth(_Fonte, (char *) &code, 1);
  x_texte  = (larg_obj - larg_texte) / 2; /* On centre */    
  y_texte  = (haut_obj + _Fonte->ascent) / 2;

  XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
  XDrawString(_Display, fenetre, _GC_objets, x_texte, y_texte, (char *) &code, 1);
}

void DOBJ_chaine(Window fenetre, OBJECT *objet)
{
  int larg_obj, haut_obj;
  int y_texte;
  size_t lg_texte;

  larg_obj = objet->ob_width;
  haut_obj = objet->ob_height;

  /* On dessine le fond */

  if ( objet->ob_state & SELECTED ) /* Fond noir */
  {
    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);  /* Fond noir   */
    XFillRectangle(_Display, fenetre, _GC_objets, 0, 0, larg_obj, haut_obj);    
    XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel); /* Texte blanc */
  }
  else
  {
    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS].pixel);  /* Fond noir   */
    XFillRectangle(_Display, fenetre, _GC_objets, 0, 0, larg_obj, haut_obj);    
    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel); /* Texte blanc */
  }

  /* On met le texte */

  lg_texte   = strlen(objet->ob_spec.texte);
  y_texte = (haut_obj + _Fonte->ascent) / 2;

  XDrawString(_Display, fenetre, _GC_objets, 1, y_texte, objet->ob_spec.texte, lg_texte);
}

void DOBJ_interne(Window fenetre, OBJECT *objet)
{
  char *texte;
  int x_obj, y_obj;
  unsigned int larg_obj, haut_obj, unit_car;
  unsigned int i;
  Window racine;
  XPoint points[4];

  unit_car = _Fonte->max_bounds.ascent + _Fonte->ascent;

  if ( (objet->ob_type == G_INFOS) ||
       (objet->ob_type == G_ASC_VERT) || (objet->ob_type == G_ASC_HOR) )
  {
    XGetGeometry(_Display, fenetre, &racine, &x_obj, &y_obj, &larg_obj, &haut_obj, &i, &i);
  }
  else
  {
    larg_obj = unit_car;
    haut_obj = unit_car;
  }

  /* Le fond 3D */

  XSetForeground(_Display, _GC_objets, _Couleurs[GRIS].pixel); /* Fond gris clair */
  XFillRectangle(_Display, fenetre, _GC_objets, 0, 0, larg_obj, haut_obj);

  XSetLineAttributes(_Display, _GC_objets, 1, LineSolid, CapButt, JoinMiter);
  XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 0, larg_obj, 0);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 1, larg_obj - 1, 1);
  XDrawLine(_Display, fenetre, _GC_objets, 0, 0, 0, haut_obj);
  XDrawLine(_Display, fenetre, _GC_objets, 1, 0, 1, haut_obj - 1);

  XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel); /* Ct en gris --> 3D */
  XDrawLine(_Display, fenetre, _GC_objets, 0, haut_obj - 1, larg_obj, haut_obj - 1);
  XDrawLine(_Display, fenetre, _GC_objets, 1, haut_obj - 2, larg_obj, haut_obj - 2);
  XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 1, 0, larg_obj - 1, haut_obj);
  XDrawLine(_Display, fenetre, _GC_objets, larg_obj - 2, 1, larg_obj - 2, haut_obj);

  /* La partie spcifique du dessin */

  switch (objet->ob_type)
  {
  case G_CLOSER:
    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);       /* Ct en gris --> 3D */
    XSetLineAttributes(_Display, _GC_objets, 2, LineSolid, CapButt, JoinMiter);
    XDrawLine(_Display, fenetre, _GC_objets, 5, 5, larg_obj - 5, haut_obj - 5);
    XDrawLine(_Display, fenetre, _GC_objets, 5, haut_obj - 5, larg_obj - 5, 5);
    return;

  case G_INFOS:
    texte = objet->ob_spec.texte;
    if (texte) /* Il y a bien un texte associ */
    {
      int y_texte;
      unsigned int larg_texte;
      size_t lg_texte;

      lg_texte = strlen(texte);
      larg_texte = XTextWidth(_Fonte, texte, lg_texte);
      y_texte  = (haut_obj + _Fonte->ascent) / 2;

      XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
      XDrawString(_Display, fenetre, _GC_objets, 5, y_texte, texte, lg_texte);
    }
    return;

  case G_FLECHE_HAUT:
    points[0].x = (short) larg_obj / 2;
    points[0].y = 5;
    points[1].x = (short) larg_obj - 5;
    points[1].y = (short) haut_obj - 5;
    points[2].x = 5;
    points[2].y = points[1].y;
    points[3] = points[0];

    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XFillPolygon(_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
    return;

  case G_FLECHE_BAS:
    points[0].x = (short) larg_obj / 2;
    points[0].y = (short) haut_obj - 5;
    points[1].x = (short) larg_obj - 5;
    points[1].y = 5;
    points[2].x = 5;
    points[2].y = points[1].y;
    points[3] = points[0];

    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XFillPolygon(_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
    return;

  case G_FLECHE_GAUCHE:
    points[0].x = 5;
    points[0].y = (short) haut_obj/2;
    points[1].x = (short) larg_obj - 5;
    points[1].y = 5;
    points[2].x = points[1].x;
    points[2].y = (short) haut_obj - 5;
    points[3] = points[0];

    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
    return;

  case G_FLECHE_DROITE:
    points[0].x = (short) larg_obj - 5;
    points[0].y = (short) haut_obj/2;
    points[1].x = 5;
    points[1].y = 5;
    points[2].x = points[1].x;
    points[2].y = (short) haut_obj - 5;
    points[3] = points[0];

    XSetForeground(_Display, _GC_objets, _Couleurs[NOIR].pixel);
    XFillPolygon  (_Display, fenetre, _GC_objets, points, 4, Convex, CoordModeOrigin);
    return;
  }
}

/* ------------- Fabrication de la chane  afficher d'un objet ditable ---------------- */

char *faire_chaine(TEDINFO *tedinfo)
{
  char *resultat;
  int index_chaine,index_texte=0;

  resultat = malloc( tedinfo->te_tmplen + 1);
  if (resultat == NULL)
  {
    ERREUR(MANQUE_MEMOIRE);
    printf("dans X_objets.c\n");
    return NULL;
  }

  for (index_chaine = 0; index_chaine < tedinfo->te_tmplen ; index_chaine++)
  {
    if ( (tedinfo->te_ptmplt)[index_chaine] == '_' ) /* Caractre ditable */
    {
      if ( (tedinfo->te_ptext)[index_texte] == 0) /* Fin du texte */
	resultat[index_chaine] = '_';
      else
      {
	resultat[index_chaine] = (tedinfo->te_ptext)[index_texte];
	index_texte++; /* Caractre suivant de l'entre */
      }
    }
    else
      resultat[index_chaine] = (tedinfo->te_ptmplt)[index_chaine];
  }

  return resultat;
}

/* Donne le nombre de caractres dans le texte modifiable
   On a donc te_ptext[cette valeur] = 0 si moins que te_txtlen */

int OBJ_der_caractere(TEDINFO *tedinfo)
{
  int position;

  for (position = 0; position < tedinfo->te_txtlen ; position++)
    if ( (tedinfo->te_ptext)[position] == 0 ) /* Chane s'interrompt avant */
      return position;

  return tedinfo->te_txtlen; /* Sinon, chane complte */
}

/* -------------------- Objet choisit (selected ou checked) ou non choisit ----------------------\
 |    Renvoie l'tat de l'objet aprs l'opration (VRAI : choisi, FAUX : non choisi) 
 |    Remarque : demander l'change d'tat d'un bouton radio revient  le slectionner.
 |
 | num_arbre : numro de l'arbre contenant l'objet  modifier
 | num_objet : numro de l'objet  modifier
 | mettre    : opration  faire. FORCE_NON = on dchoisit, FORCE_OUI = on choisit,              |
 |                               ECHANGE = on bascule de l'un  l'autre, QUESTION = on lit juste |
 \---------------------------------------------------------------------------------------------- */

boolean OBJ_choisit(int num_arbre, int num_objet, boolean mettre)
{
  OBJECT *adresse = arbres[num_arbre].adresse;

  switch ( OB_TYPE(adresse, num_objet) )
  {
  case G_TEXT:     /* Texte et apparents : structure TEDINFO           */
  case G_BOXTEXT:  /* Ces objets ne sont pas slectionnables normalement... */
  case G_FTEXT:
  case G_FBOXTEXT:
    return FAUX; /* Ces objets ne sont jamais choisis */

  case G_IBOX:     /* Genre IBOX -> si caractre vide, on met ce qu'il faut */
    if (mettre == ECHANGE)
    {
      if ( OB_STATE(adresse, num_objet) & CHECKED )
	mettre = FORCE_NON;
      else
	mettre = FORCE_OUI;
    }

    if (mettre == FORCE_OUI)
    {
      if ( OB_FLAGS(adresse, num_objet) & RBUTTON ) /* Bouton Radio -> on dsactive les autres */
      {
	int pere = -1, objet, der_objet = num_objet;
	
	while (pere == -1) /* Tant que l'on n'a pas trouv le pre */
	{
	  objet = OB_NEXT(adresse, der_objet); /* Objet suivant */
	  if ( OB_TAIL(adresse, objet) == der_objet ) /* C'est que c'est le pre */
	  {
	    pere = objet;
	    objet = OB_HEAD(adresse, pere); /* Le premier fils */
	  }
	  else
	    der_objet = objet; /* On passe au suivant */
	}
	
	/* Maintenant, on parcours tous les fils et on dsactive ce qui n'est pas bon */

        while (objet != pere) /* Tant que l'on n'est pas revenu sur le pre */
        {
	  if ( OB_FLAGS(adresse, objet) & RBUTTON ) /* C'est un bouton Radio */
	  {
	    if (objet == num_objet) /* C'est le bouton que l'on doit activer */
	      OB_STATE(adresse, objet) |=  CHECKED;
	    else                    /* C'est un autre objet -> on saute */
	      OB_STATE(adresse, objet) &= ~CHECKED;
	    dessine_objet(num_arbre, objet); /* On redessine */
	  }
	  objet = OB_NEXT(adresse, objet); /* On passe  l'objet suivant */
        }
      }
      else
      {
	OB_STATE(adresse, num_objet) |=  CHECKED;
	dessine_objet(num_arbre, num_objet); /* On redessine */
      }
    }
    else if (mettre == FORCE_NON)
    {
      OB_STATE(adresse, num_objet) &= ~CHECKED;
      dessine_objet(num_arbre, num_objet);
    }
    
    if ( OB_STATE(adresse, num_objet) & CHECKED ) /* Si QUESTION, on doit tester... */
      return VRAI;
    else
      return FAUX;

  case G_BUTTON:  /* Bouton : on ne se pose pas de question */
    if (mettre == ECHANGE)
    {
      if ( OB_FLAGS(adresse, num_objet) & RBUTTON ) /* Radio bouton -> n'a pas de sens */
	mettre = FORCE_OUI;
      else if ( OB_STATE(adresse, num_objet) & SELECTED )
	mettre = FORCE_NON;
      else
	mettre = FORCE_OUI;
    }
    
    if (mettre == FORCE_OUI) /* On rend slectionn */
    {
      if ( OB_FLAGS(adresse, num_objet) & RBUTTON ) /* Bouton Radio -> on dsactive les autres */
      {
	int pere = -1, objet, der_objet = num_objet;
	
	while (pere == -1) /* Tant que l'on n'a pas trouv le pre */
	{
	  objet = OB_NEXT(adresse, der_objet); /* Objet suivant */
	  if ( OB_TAIL(adresse, objet) == der_objet ) /* C'est que c'est le pre */
	  {
	    pere = objet;
	    objet = OB_HEAD(adresse, pere); /* Le premier fils */
	  }
	  else
	    der_objet = objet; /* On passe au suivant */
	}
	
	/* Maintenant, on parcours tous les fils et on dsactive ce qui n'est pas bon */

        while (objet != pere) /* Tant que l'on n'est pas revenu sur le pre */
        {
	  if ( OB_FLAGS(adresse, objet) & RBUTTON ) /* C'est un bouton Radio */
	  {
	    if (objet == num_objet) /* C'est le bouton que l'on doit activer */
	      OB_STATE(adresse, objet) |=  SELECTED;
	    else                    /* C'est un autre objet -> on saute */
	      OB_STATE(adresse, objet) &= ~SELECTED;
	    dessine_objet(num_arbre, objet); /* On redessine */
	  }
	  objet = OB_NEXT(adresse, objet); /* On passe  l'objet suivant */
        }
      }
      else /* Cas simple */
      {
	OB_STATE(adresse, num_objet) |=  SELECTED; /* On active sans se poser de question */
	dessine_objet(num_arbre, num_objet); /* On redessine */
      }
    }
    else if (mettre == FORCE_NON)
    {
      OB_STATE(adresse, num_objet) &= ~SELECTED;
      dessine_objet(num_arbre, num_objet);
    }

    if ( OB_STATE(adresse, num_objet) & SELECTED ) /* Si QUESTION, on doit tester... */
      return VRAI;
    else
      return FAUX; 
    
  default:
    if ( OB_FLAGS(adresse, num_objet) & SELECTABLE ) /* L'objet est slectionnable */
    {
      if (mettre == ECHANGE)
      {
	if ( OB_STATE(adresse, num_objet) & SELECTED )
	  mettre = FORCE_NON;
	else
	  mettre = FORCE_OUI;
      }

      if (mettre == FORCE_OUI) /* On rend slectionn */
      {
	if ( OB_FLAGS(adresse, num_objet) & RBUTTON ) /* Bouton Radio -> on dsactive les autres */
	{
	  int pere = -1, objet, der_objet = num_objet;
	
	  while (pere == -1) /* Tant que l'on n'a pas trouv le pre */
	  {
	    objet = OB_NEXT(adresse, der_objet); /* Objet suivant */
	    if ( OB_TAIL(adresse, objet) == der_objet ) /* C'est que c'est le pre */
	    {
	      pere = objet;
	      objet = OB_HEAD(adresse, pere); /* Le premier fils */
	    }
	    else
	      der_objet = objet; /* On passe au suivant */
	  }
	
	  /* Maintenant, on parcours tous les fils et on dsactive ce qui n'est pas bon */

	  while (objet != pere) /* Tant que l'on n'est pas revenu sur le pre */
	  {
	    if ( OB_FLAGS(adresse, objet) & RBUTTON ) /* C'est un bouton Radio */
	    {
	      if (objet == num_objet) /* C'est le bouton que l'on doit activer */
		OB_STATE(adresse, objet) |=  SELECTED;
	      else                    /* C'est un autre objet -> on saute */
		OB_STATE(adresse, objet) &= ~SELECTED;
	      dessine_objet(num_arbre, objet); /* On redessine */
	    }
	    objet = OB_NEXT(adresse, objet); /* On passe  l'objet suivant */
	  }
	}
	else /* Cas simple */
	{
	  OB_STATE(adresse, num_objet) |=  SELECTED; /* On active sans se poser de question */
	  dessine_objet(num_arbre, num_objet); /* On redessine */
	}
      }
      else if (mettre == FORCE_NON)
      {
	OB_STATE(adresse, num_objet) &= ~SELECTED;
	dessine_objet(num_arbre, num_objet);
      }
    }
    
    if ( OB_STATE(adresse, num_objet) & SELECTED ) /* Si QUESTION, on doit tester... */
      return VRAI;
    else
      return FAUX;
  }
}

/* -------------------- Objet actif (non disabled) ou inactif (disabled) ------------------------\
 |    Renvoie l'tat de l'objet aprs l'opration (VRAI : activ, FAUX : dsactiv)              |
 |                                                                                               |
 | num_arbre : numro de l'arbre contenant l'objet  modifier                                    |
 | num_objet : numro de l'objet  modifier                                                      |
 | mettre    : opration  faire. FORCE_NON = on dsactive, FORCE_OUI = on active,               |
 |                               ECHANGE = on bascule de l'un  l'autre, QUESTION = on lit juste |
 \---------------------------------------------------------------------------------------------- */

boolean OBJ_active(int num_arbre, int num_objet, boolean mettre)
{
  OBJECT *adresse = arbres[num_arbre].adresse;

  if (num_objet <= ROOT) /* Numro d'objet ngatif ou racine : modif. invalide */
    return VRAI;

  /* On veut juste changer : inactif -> actif et actif -> inactif */

  if (mettre == ECHANGE)
  {
    if ( OB_STATE(adresse, num_objet) & DISABLED ) /* Objet inactif */
      mettre = FORCE_OUI;
    else
      mettre = FORCE_NON;
  }

  if ( ( OB_TYPE(adresse, num_objet) == G_FTEXT) ||  /* Objet ditable -> problmes de curseur */
       ( OB_TYPE(adresse, num_objet) == G_FBOXTEXT ) )
  {
    boolean ouvert = FAUX; /* VRAI si arbre ouvert au premier plan -> curseur  mettre */
    
    if (mettre == QUESTION) /* On se contente de poser la question */
    {
      if ( OB_STATE(adresse, num_objet) & DISABLED )
	return FAUX; /* Objet inactif */
      else
	return VRAI; /* Objet actif   */
    }

    ouvert  = (arbres[num_arbre].ouvert == VRAI); /* VRAI si arbre ouvert */
    ouvert |= (num_arbre == _PRG_arbre); /* en particulier, si arbre en premier plan */

    if ( mettre == FORCE_OUI ) /* On rend l'objet actif */
    {
      OB_STATE(adresse, num_objet) &= ~DISABLED;

      if ( num_objet > arbres[num_arbre].dernier_edit ) /* Aprs le dernier ditable courant */
      {
	arbres[num_arbre].dernier_edit = num_objet; /* Nouveau dernier ditable */
	if ( arbres[num_arbre].premier_edit == ROOT ) /* Il n'y avait aucun objet ditable avant */
	{
	  int pos_curseur = 0; /* Donc on a celui-l, on y met le curseur */

	  arbres[num_arbre].premier_edit = num_objet; /* Devient aussi le premier ditable */
	  arbres[num_arbre].edit_courant = num_objet;
	  /*	  if (ouvert)
	    Objc_edit(adresse, num_objet, 0, pos_curseur, ED_INIT, &pos_curseur); */
	  
	  arbres[num_arbre].pos_curseur = pos_curseur;
	}
      }
      else if ( num_objet < arbres[num_arbre].premier_edit ) /* Avant le 1er ditable: devient le premier */
      {
	  arbres[num_arbre].premier_edit = num_objet;
      }

      dessine_objet(num_arbre, num_objet);

      return VRAI; /* Arbre actif */
    }

    OB_STATE(adresse, num_objet) |= DISABLED; /* On inactive l'objet */

    if ( ( num_objet == arbres[num_arbre].edit_courant ) /* Objet ditable courant */
	 && ( ouvert ) ) /* Et arbre ouvert... */
    {
      int pos_curseur = arbres[num_arbre].pos_curseur; /* On coupe le curseur    */
      /*      Objc_edit(adresse, num_objet, 0, pos_curseur, ED_END, &pos_curseur); */
      arbres[num_arbre].pos_curseur = pos_curseur;
    }

    if ( num_objet == arbres[num_arbre].premier_edit ) /* Premier objet ditable */
    {
      int suivant = 1;

      if ( arbres[num_arbre].premier_edit == arbres[num_arbre].dernier_edit ) /* Un seul objet ditable */
      {
	arbres[num_arbre].premier_edit = ROOT; /* Plus d'objet ditable dans l'arbre */
	arbres[num_arbre].edit_courant = ROOT;
	arbres[num_arbre].dernier_edit = ROOT;
	dessine_objet(num_arbre, num_objet);
	return FAUX;
      }

      /* Ici : il y a d'autres objets ditables -> on passe au suivant */
      
      arbres[num_arbre].premier_edit = ROOT;
      while ( OB_NEXT(adresse, suivant) != -1 ) /* Il y a des objets aprs */
      {
	if ( (OB_FLAGS(adresse, suivant) & EDITABLE) && !(OB_STATE(adresse, suivant) & DISABLED) )
	{
	  arbres[num_arbre].premier_edit = suivant; /* Premier objet ditable actif */
	  break;
	}
	suivant++; /* On passe  l'objet suivant */
      }
      if ( arbres[num_arbre].premier_edit == ROOT ) /* Aucun objet ditable restant */
      {
	arbres[num_arbre].edit_courant = ROOT;
	arbres[num_arbre].dernier_edit = ROOT;
	dessine_objet(num_arbre, num_objet);
	return FAUX;				
      }
    }

    if ( num_objet == arbres[num_arbre].dernier_edit ) /* Dernier ditable */
    {
      int precedent = num_objet;

      arbres[num_arbre].dernier_edit = ROOT; /* A priori, aucun avant */
      while ( precedent > 0 ) /* On ne teste pas la racine */
      {
	if ( (OB_FLAGS(adresse, precedent) & EDITABLE) && !(OB_STATE(adresse, precedent) & DISABLED) )
	{
	  arbres[num_arbre].dernier_edit = precedent; /* Premier objet ditable actif */
	  break;
	}
	precedent--; /* On passe  l'objet prcdent */
      }
      if ( arbres[num_arbre].dernier_edit == ROOT ) /* Aucun objet ditable restant */
      {
	arbres[num_arbre].edit_courant = ROOT;
	arbres[num_arbre].premier_edit = ROOT;
	dessine_objet(num_arbre, num_objet);
	return FAUX;				
      }
    }

    if ( num_objet == arbres[num_arbre].edit_courant ) /* On a dsactiv l'objet sur lequel tait le curseur */
    {
      int nv_courant, pos_curseur = 0;
      
      if ( num_objet < arbres[num_arbre].premier_edit )
	nv_courant = arbres[num_arbre].premier_edit;
      else if ( num_objet > arbres[num_arbre].dernier_edit )
	nv_courant = arbres[num_arbre].dernier_edit;
      else /* On cherche l'objet suivant */
      {
	nv_courant = num_objet;
	while ( OB_NEXT(adresse, nv_courant) != -1 ) /* Il y a des objets derrire */
	{
	  if ( (OB_FLAGS(adresse, nv_courant) & EDITABLE) && !(OB_STATE(adresse, nv_courant) & DISABLED) )
	    break;
	  nv_courant++;
	}
      }

      if ( ouvert )
      {
	/* On met le curseur sur cet objet */
	/*	Objc_edit(adresse, nv_courant, 0, pos_curseur, ED_INIT, &pos_curseur); */
	arbres[num_arbre].pos_curseur = pos_curseur;
      }
      arbres[num_arbre].edit_courant = nv_courant;
    }
    
    dessine_objet(num_arbre, num_objet); /* On dessine tout a */
    return FAUX; /* Pour l'instant, on ne fait rien */
  }
  
  /* Tous les autres objets : on dsactive sans se poser de question */

  if (mettre == FORCE_OUI)      /* On rend actif   */
    OB_STATE(adresse, num_objet) &= ~DISABLED;
  else if (mettre == FORCE_NON) /* On rend inactif */
    OB_STATE(adresse, num_objet) |=  DISABLED;
  dessine_objet(num_arbre, num_objet);
  
  if ( OB_STATE(adresse, num_objet) & DISABLED ) /* Si QUESTION, on doit tester... */
    return FAUX;
  else
    return VRAI; 
}

/* -------------------- Objet visible ou invisible ----------------------------------------------\
 |    Renvoie l'tat de l'objet aprs l'opration (VRAI : visible, FAUX : invisible)             |
 |                                                                                               |
 | num_arbre : numro de l'arbre contenant l'objet  modifier                                    |
 | num_objet : numro de l'objet  modifier                                                      |
 | mettre    : opration  faire. FORCE_NON = on rend invisible, FORCE_OUI = on rend visible,    |
 |                               ECHANGE = on bascule de l'un  l'autre, QUESTION = on lit juste |
 \---------------------------------------------------------------------------------------------- */

boolean OBJ_cache(int num_arbre, int num_objet, boolean mettre)
{
  OBJECT *adresse = arbres[num_arbre].adresse;

  /* Ici, le rsultat est indpendant du type d'objet... */

  if (mettre == ECHANGE)
  {
    if ( OB_FLAGS(adresse, num_objet) & HIDETREE ) /* L'objet est invisible */
      mettre = FORCE_OUI; /* On rend donc visible */
    else
      mettre = FORCE_NON; /* On rend invisible */
  }

  if (mettre == FORCE_OUI)
  {
    OB_FLAGS(adresse, num_objet) &= ~HIDETREE; /* On rend visible */
    if ( arbres[num_arbre].ouvert == VRAI ) /* Arbre effectivement ouvert */
      XMapWindow(_Display, arbres[num_arbre].objets[num_objet]);
  }
  else if (mettre == FORCE_NON)
  {
    OB_FLAGS(adresse, num_objet) |=  HIDETREE; /* On rend invisible */
    if ( arbres[num_arbre].ouvert == VRAI ) /* Arbre effectivement ouvert */
      XUnmapWindow(_Display, arbres[num_arbre].objets[num_objet]);
  }
    
  if ( OB_STATE(adresse, num_objet) & SELECTED ) /* Si QUESTION, on doit tester... */
    return VRAI;
  else
    return FAUX;
}

/* ~~~~~~~~~~~~~~~~ criture de valeurs diverses dans les objets ~~~~~~~~~~~~~~~~ */

/* -------------------- Installation d'une chane de caractres ---------------------------------\
 |   Ne renvoie rien
 |
 | arbre   : arbre contenant l'objet  modifier
 | objet   : numro de l'objet  modifier
 | l_max   : nombre maximal de caractres  copier (pour les chanes, boutons,...)
 | texte   : pointeur sur la chaine  installer
 | mode    : TXT_COPIER   ==> on copie la chane  la place de l'ancienne                        |
 |           TXT_REMPLACE ==> on change l'adresse de l'objet pour qu'il pointe sur texte         |
 \---------------------------------------------------------------------------------------------- */

void met_chaine(int arbre, int objet, unsigned long l_max, char *texte, char mode)
{
  OBJECT *adresse;
  char *chaine;
  unsigned long i;

  if (texte == NULL) return; /* Rien  faire */

  adresse = arbres[arbre].adresse;
  
  if (mode == TXT_REMPLACE) /* On se contente de changer l'adresse */
  {
    switch ( OB_TYPE(adresse, objet) )
    {
    case G_TEXT:     /* Genre texte avec curseurs */
    case G_FTEXT:
    case G_BOXTEXT:
    case G_FBOXTEXT:
      adresse[objet].ob_spec.tedinfo->te_ptext = texte;
    break;

    case G_BUTTON: /* Genre texte direct */
    case G_STRING:
      adresse[objet].ob_spec.texte = texte;
    break;
    }

    dessine_objet(arbre, objet); /* On force le redessin */
    return;
  }

  /* On fait une recopie */

  switch ( OB_TYPE(adresse, objet) )
  {
  case G_TEXT:     /* Genre texte avec curseurs */
  case G_FTEXT:
  case G_BOXTEXT:
  case G_FBOXTEXT:
    chaine = adresse[objet].ob_spec.tedinfo->te_ptext;  /* Le texte          */
    l_max  = adresse[objet].ob_spec.tedinfo->te_txtlen - 1; /* Longueur maximale */
    break;

  case G_STRING:   /* Genre chane ou bouton   */
  case G_BUTTON:
    chaine = adresse[objet].ob_spec.texte;
    break;
    
  default:        /* Genre inconnu, donc pas de recopie - on quitte */
    return;
  }

  if ( l_max > strlen(texte) ) /* Aucun problme */
  {
    l_max = strlen(texte);
  }

  for (i = 0 ; i < l_max ; i++)
    chaine[i] = texte[i];
  chaine[l_max] = 0; /* Chane doit finir par un octet nul */
  
  if ( (OB_TYPE(adresse, objet) == G_FTEXT)
       || (OB_TYPE(adresse, objet) == G_FBOXTEXT) ) /* Objet ditable */
  {
    for ( ; i < adresse[objet].ob_spec.tedinfo->te_txtlen - 1 ; i++)
      chaine[i] = 0; /* On termine par des 0 pour tre tranquille */

    if ( ( objet == arbres[arbre].edit_courant )
	 && ( arbres[arbre].ouvert == VRAI ) ) /* L'arbre est ouvert */
    {
      int x = arbres[arbre].pos_curseur;
      objc_edit(adresse, objet, 0, x, ED_END, &x);
      objc_edit(adresse, objet, 0, x, ED_INIT, &x);
      arbres[arbre].pos_curseur = x;
    }
  }

  dessine_objet(arbre, objet); /* On force le redessin de l'objet modifi */
}

void met_valeur(int arbre, int objet, int valeur)
{
   OBJECT *adresse;
   char *chaine;

   adresse = arbres[arbre].adresse;

   switch (OB_TYPE(adresse,objet))     /* O est le texte ? */
   {
   case G_TEXT:
   case G_FTEXT:
   case G_BOXTEXT:
   case G_FBOXTEXT:
      chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
      break;

   case G_BUTTON:
   case G_STRING:
      chaine = (char *) OB_SPEC(adresse,objet);
      break;

   case G_ICON:
      chaine = ((ICONBLK *) OB_SPEC(adresse,objet))->ib_ptext;
      break;

   case G_BOXCHAR:
      if (valeur > 9) valeur = 9; /* Le nombre ne peut avoir qu'un seul chiffre... */
      if (valeur < 0) valeur = 0;
      chaine = (char *) &(OB_SPEC(adresse,objet));
      chaine[3]  = '0' + valeur;
      return;
   }
   sprintf(chaine,"%d",valeur);

   dessine_objet(arbre, objet); /* On redessine */
}

/* -------------- Met une valeur "long" dans un champ GEM ---------- */

void met_lvaleur(int arbre, int objet, long valeur)
{
  OBJECT *adresse;
  char *chaine;

  adresse = arbres[arbre].adresse;

  switch (OB_TYPE(adresse,objet))     /* O est le texte ? */
  {
  case G_TEXT:
  case G_FTEXT:
  case G_BOXTEXT:
  case G_FBOXTEXT:
    chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
    break;

  case G_BUTTON:
  case G_STRING:
    chaine = (char *) OB_SPEC(adresse,objet);
    break;

  case G_ICON:
    chaine = ((ICONBLK *) OB_SPEC(adresse,objet))->ib_ptext;
    break;

  default:
    printf("On est ici, on ne devrait pas!\n");
  }

  sprintf(chaine,"%ld",valeur);

  dessine_objet(arbre, objet);
}

/* -------------- Met une valeur "unsigned long" dans un champ GEM - */

void met_ulvaleur(int arbre, int objet, unsigned long valeur)
{
   OBJECT *adresse;
   char *chaine;

   adresse = arbres[arbre].adresse;

   switch (OB_TYPE(adresse,objet))     /* O est le texte ? */
   {
   case G_TEXT:
   case G_FTEXT:
   case G_BOXTEXT:
   case G_FBOXTEXT:
      chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
      break;

   case G_BUTTON:
   case G_STRING:
      chaine = (char *) OB_SPEC(adresse,objet);
      break;

   case G_ICON:
      chaine = ((ICONBLK *) OB_SPEC(adresse,objet))->ib_ptext;
      break;
   }
   sprintf(chaine,"%ld",valeur);

   dessine_objet(arbre, objet);
}

/* -------------- Met une valeur "float" dans un champ GEM --------- */

void met_fvaleur(int arbre, int objet, double valeur)
{
  OBJECT *adresse;
  char *pos_point, *pos_debut, *pos_fin;
  char inter[50];
  double max_valeur;

  adresse = arbres[arbre].adresse;
  if ( ( OB_TYPE(adresse, objet) == G_BUTTON )
    || ( OB_TYPE(adresse, objet) == G_STRING ) )
  {
    char *chaine = adresse[objet].ob_spec.texte;
    sprintf(chaine, "%3.2f", valeur);
  }

  if ( ( OB_TYPE(adresse, objet) == G_TEXT     )
    || ( OB_TYPE(adresse, objet) == G_BOXTEXT  )
    || ( OB_TYPE(adresse, objet) == G_FTEXT    )
    || ( OB_TYPE(adresse, objet) == G_FBOXTEXT ) )
  {
    TEDINFO *tedinfo = adresse[objet].ob_spec.tedinfo;
    unsigned long max_long = tedinfo->te_txtlen; /* Longueur max. de texte */
    char *chaine = tedinfo->te_ptext;  /* Adresse de la chane affiche */
    char *masque = tedinfo->te_ptmplt; /* Adresse du masque             */
    char *point;

    pos_point = strchr(masque,'.');   /* Position du point dcimal              */
    if (pos_point == NULL)
      pos_point = strchr(masque,','); /* Ou de la virgule dcimale */
    if (pos_point == NULL)            /* Ni l'un, ni l'autre -> on met un entier... */
      met_lvaleur(arbre, objet, (long) valeur);
    
    pos_debut = strchr(masque,'_');   /* Position du premier caractre ditable */
    if (pos_debut == NULL)            /* Pas de caractre ditable              */
      return;

    pos_fin = masque + strlen(masque) - 1;
    while (*pos_fin != '_') /* Dernier caractre ditable */
      pos_fin--;

    if (pos_fin == pos_debut) /* Un seul caractre ditable */
    {
      if (valeur < 0) valeur = 0;
      if (valeur > 9) valeur = 9;
      *chaine = '0' + (int) valeur;
      dessine_objet(arbre, objet);
      return; /* On a fini */
    }

    if (valeur < 0)
    {
      *chaine = '-'; /* Premier caractre : signe moins */
      chaine++;
      pos_debut++;
      max_long--; /* Un caractre de moins */
      valeur = -valeur; /* On ne travaille qu'avec les positifs */
    }

    max_valeur = pow(10, pos_point - pos_debut) - 1; /* Plus grand nombre possible */
    if ( max_valeur <= valeur )
    {
      unsigned int i;

      for (i = 0 ; i < max_long ; i++)
	chaine[i] = '9';

      dessine_objet(arbre, objet);
      return;
    }

    pos_debut = strchr(masque,'_');   /* Position du premier caractre ditable */
    sprintf(inter, "%f", valeur);
    point = strchr(inter, '.');
    
    /* On met la partie entire */

    {
      char *point_mis, *point_lu = point - 1;

      for (point_mis = tedinfo->te_ptext + (pos_point - pos_debut) - 1 ;
	   point_mis >= chaine ; /* Pour ne pas effacer le - ventuel */
	   point_mis--)
      {
	if (point_lu >= inter)
	{
	  *point_mis = *point_lu;
	  point_lu--;
	}
	else
	  *point_mis = ' ';
      }
    }

    /* On met la partie dcimale */

    {
      char *lu = point + 1;
      char *ecrit = tedinfo->te_ptext + (pos_point - pos_debut);
      boolean non_nul = FAUX; /* VRAI si non nul */

      /* On vrifie qu'il y a autre chose que des 0... */

      for (lu = point + 1; *lu != 0 ; lu++)
	if (*lu != '0')
	{
	  non_nul = VRAI;
	  break;
	}

      if (non_nul == FAUX) /* Ce ne sont que des zros : on s'arrte l */
      {
	(tedinfo->te_ptext)[ (pos_point - pos_debut) ] = 0;
	dessine_objet(arbre, objet);
	return;
      }

      /* On est l : c'est que c'est non-nul */

      for (lu = point + 1 ;
	   (*lu != 0) && (ecrit < tedinfo->te_ptext + tedinfo->te_txtlen) ;
	   lu++, ecrit++)
      {
	*ecrit = *lu;
      }
    }
    
    dessine_objet(arbre, objet);
  }

  dessine_objet(arbre, objet);
}

/* ~~~~~~~~~~~~~~~~~~~~ Lecture d'une valeur dans un objet contenant du texte ~~~~~~~~~~~~~~~~~~ */

/* -------------------- Lecture d'une chane de caractres --------------------------------------\
 |   Renvoie l'adresse de la chane affiche dans l'objet (informatif surtout...)                |
 |
 | arbre : arbre contenant l'objet  lire
 | objet : numro de l'objet  lire
 | l_max : nombre maximal de caractres que l'on peut crire dans texte (0 final non compris)    |
 | texte : pointeur sur la chane contenant la chane lu                                         |
 | mode  : TXT_COPIER   ==> on copie la chane  la place de l'ancienne                          |
 |         TXT_REMPLACE ==> on ne fait que renvoyer l'adresse de la chane que l'on veut lire    |
 \---------------------------------------------------------------------------------------------- */

char *lit_chaine(int arbre, int objet, unsigned long l_max, char *texte, char mode)
{
	OBJECT *adresse;
	char *chaine;
	unsigned long l_chaine, i;

	adresse = arbres[arbre].adresse;
	switch ( OB_TYPE(adresse, objet) )
	{
	case G_STRING:   /* Chane ou bouton : OB_SPEC contient l'adresse de la chaine */
	case G_BUTTON:
		chaine = (char *) OB_SPEC(adresse, objet);
		break;

	case G_TEXT:     /* Texte et apparents : structure TEDINFO */
	case G_BOXTEXT:
	case G_FTEXT:
	case G_FBOXTEXT:
		chaine   = ( (TEDINFO *) OB_SPEC(adresse, objet) )->te_ptext;
		break;

	default:         /* Objet de type inconnu, ou sans texte associ -> on quitte */
		return NULL;
	}

	if ( (mode == TXT_REMPLACE) /* On ne veut que l'adresse */
	  || (texte == NULL) ) /* Pas de chaine cible */
		return chaine;

	l_chaine = strlen(chaine);
	if (l_max < l_chaine)
		l_chaine = l_max; /* Nombre de caractres au maximum, 0 non compris */

	for (i = 0 ; i <= l_chaine ; i++) /* On recopie dans la chane voulue */
		texte[i] = chaine[i];

	return chaine;
}

/* -------------- Lit une valeur "int" dans un champ GEM ----------- */

int prend_valeur(int arbre, int objet)
{
   OBJECT *adresse;
   char *chaine;

   adresse = arbres[arbre].adresse;
   switch (OB_TYPE(adresse,objet))
   {
   case G_BUTTON:
   case G_STRING:
      chaine = adresse[objet].ob_spec.texte;
      return atoi(chaine);

   case G_TEXT:
   case G_BOXTEXT:
   case G_FTEXT:
   case G_FBOXTEXT:
      chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
      return atoi(chaine);

   case G_BOXCHAR:
      return ( (adresse[objet].ob_spec.autre >> 24) - '0' );
   }
   return 0;
}

/* -------------- Lit une valeur "long" dans un champ GEM ----------- */

long prend_lvaleur(int arbre, int objet)
{
   OBJECT *adresse;
   char *chaine;

   adresse = arbres[arbre].adresse;
   switch (OB_TYPE(adresse,objet))
   {
   case G_BUTTON:
   case G_STRING:
      chaine = (char *) OB_SPEC(adresse,objet);
      return atol(chaine);

   case G_TEXT:
   case G_BOXTEXT:
   case G_FTEXT:
   case G_FBOXTEXT:
      chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
      return atol(chaine);
   }
   return 0;
}

/* ------------------------ Lit une valeur "unsigned long" dans un arbre GEM ----------------- */

unsigned long prend_ulvaleur(int arbre, int objet)
{
   OBJECT *adresse;
   char *chaine;

   adresse = arbres[arbre].adresse;
   switch (OB_TYPE(adresse,objet))
   {
   case G_BUTTON:
   case G_STRING:
      chaine = (char *) OB_SPEC(adresse,objet);
      return (unsigned long) atol(chaine);

   case G_TEXT:
   case G_BOXTEXT:
   case G_FTEXT:
   case G_FBOXTEXT:
      chaine = ((TEDINFO *) OB_SPEC(adresse,objet))->te_ptext;
      return (unsigned long) atol(chaine);
   }
   return 0;
}

/* ------------------------- Lit une valeur "float" dans un arbre GEM ------------------------ */

float prend_fvaleur(int arbre, int objet)
{
  OBJECT *adresse;
  float a;

  adresse = arbres[arbre].adresse;

  if ( ( OB_TYPE(adresse,objet) == G_BUTTON ) || ( OB_TYPE(adresse,objet) == G_STRING ) )
  {
    return atof( adresse[objet].ob_spec.texte);
  }

  if ( ( OB_TYPE(adresse,objet) == G_TEXT  ) || ( OB_TYPE(adresse,objet) == G_BOXTEXT  )
    || ( OB_TYPE(adresse,objet) == G_FTEXT ) || ( OB_TYPE(adresse,objet) == G_FBOXTEXT ) )
  {
    char *chaine, *pos_debut;
    char *resultat;
    unsigned int i = 0;
    TEDINFO *tedinfo = adresse[objet].ob_spec.tedinfo;

    chaine = tedinfo->te_ptext;

    resultat = (char *) malloc( tedinfo->te_txtlen + 2); /* point dcimal + 0 final ventuel */
    if (resultat == NULL)
    {
      ERREUR(MANQUE_MEMOIRE);
      printf("dans X_objets.c\n");
      return 0;
    }
    resultat[0] = 0;

    pos_debut = strchr(tedinfo->te_ptmplt, '_');     /* Position du premier caractre ditable */

    if ( *chaine == 0 )
      return 0.0;

    if ( (*chaine == '-') || (*chaine == '.') ) /* Cas du signe ou de .xxxx */
    {
      resultat[0] = *chaine;
      resultat[1] = 0;
      i++;
      chaine++;
      pos_debut++;
    }
    if ( *chaine == '+' ) /* Inutile de prciser le signe + */
    {
      chaine++;
      pos_debut++;
    }
    if ( *chaine == ',' ) /* On n'a indiqu que la partie dcimale */
    {
      resultat[0] = '.';
      resultat[1] = 0;
      i++;
      chaine++;
      pos_debut++;      
    }

    while (*pos_debut == '_') /* Partie entire + signe, ou (si commence par .) partie dcimale */
    {
      if ( *chaine == 0 ) /* Fin de la chane entre */
      {
	resultat[i] = 0;
	break;
      }

      if ( ( *chaine >= '0' ) && ( *chaine <= '9' ) )/* Chiffre : seuls valables */
      {
	resultat[i++] = *chaine;
	resultat[i] = 0;
      }
      pos_debut++;
      chaine++;
    }

    if ( *chaine == 0 ) /* Chane finie */
    {
      float a = atof(resultat);
      free(resultat);
      return a;
    }

    if ( (*pos_debut == '.') || (*pos_debut == ',') ) /* Point dcimal */
    {
      if (resultat[0] != '.') /* Il n'y a pas dj un point dcimal */
      {
	resultat[i] = '.';
	i++;
	resultat[i] = 0;
      }
      pos_debut++;
    }

    while (*pos_debut == '_') /* Partie dcimale */
    {
      if ( *chaine == 0 ) /* Fin de la chane entre */
	break;

      if ( ( *chaine >= '0' ) && ( *chaine <= '9' ) )/* Chiffre : seuls valables */
      {
	resultat[i++] = *chaine;
	resultat[i] = 0;
      }
      pos_debut++;
      chaine++;
    }

    a = atof(resultat);
    free(resultat);
    return a;
  }

  return 0.0;
}

/* -------------------- Modifier la position de l'objet -----------------------------------------\
 |   On suppose que l'on travaille en coordonnes relatives au pre
 |   Valeur ngative -> on ne modifie pas
 |
 | arbre : l'arbre contenant l'objet
 | objet : l'objet  modifier
 | x, y  : nouvelles coordonnes  modifier
 | nv_x, nv_y : contient les nouvelles coordonnes
 \---------------------------------------------------------------------------------------------- */

void OBJ_position(int arbre, int objet, int x, int y, int *nv_x, int *nv_y)
{
  OBJECT *adresse = arbres[arbre].adresse;

  if (x >= 0)
    OB_X(adresse, objet) = x;
  else
    x = OB_X(adresse, objet);

  if (y >= 0)
    OB_Y(adresse, objet) = y;
  else
    y = OB_Y(adresse, objet);

  if (nv_x) *nv_x = OB_X(adresse, objet); /* On lit les nouvelles coordonnes   */
  if (nv_y) *nv_y = OB_Y(adresse, objet); /* Sauf si NULL -> pas intressant... */
  
  if ( (x >= 0) || (y >= 0) ) /* Si on a bien chang quelque chose... */
  {
    if ( arbres[arbre].ouvert == VRAI ) /* Arbre ouvert -> dplacer la fentre associe */
    {
      Window fenetre = (arbres[arbre].objets)[objet];

      XMoveWindow(_Display, fenetre, x, y); 

      if (objet != ROOT) /* Autre chose que la racine */
      {
	while ( OB_NEXT(adresse, objet) > objet )
	  objet++;

	objet = OB_NEXT(adresse, objet);
	OBJ_dessine( (arbres[arbre].objets)[objet], adresse + objet );
      }
    }
  }
}

/* -------------------- Modifier les dimensions d'un objet ---------------------------------------\
 |   On suppose que l'on travaille en coordonnes relatives au pre
 |   Valeur ngative -> on ne modifie pas
 |
 | arbre            : l'arbre contenant l'objet
 | objet            : l'objet  modifier
 | larg, haut       : nouvelles dimensions de l'objet
 | nv_larg, nv_haut : contient les nouvelles dimensions
 \---------------------------------------------------------------------------------------------- */

void OBJ_taille(int arbre, int objet, int larg, int haut, int *nv_larg, int *nv_haut)
{
  OBJECT *adresse = arbres[arbre].adresse;

  if (larg >= 0)
    OB_WIDTH(adresse, objet) = larg;
  else
    larg = OB_WIDTH(adresse, objet);

  if (haut >= 0)
    OB_HEIGHT(adresse, objet) = haut;
  else
    haut = OB_HEIGHT(adresse, objet);

  if (nv_larg) *nv_larg = OB_WIDTH (adresse, objet); /* On lit les nouvelles dimensions */
  if (nv_haut) *nv_haut = OB_HEIGHT(adresse, objet); /* sauf si NULL : pas intressant  */

  if ( (larg >= 0) || (haut >= 0) ) /* Si on a bien chang quelque chose... */
  {
    if ( arbres[arbre].ouvert == VRAI ) /* Changer la taille de la fentre associe */
    {
      Window fenetre = (arbres[arbre].objets)[objet];

      XResizeWindow(_Display, fenetre, larg, haut);
    }
  }
}

/* ~~~~~~~~~~~~~~~~ Quelques objets USERDEF prdfinis ~~~~~~~~~~~~~~~~ */

int USR_separateur(PARMBLK *parametres)
{
  int x_debut, y_debut, x_fin, y_fin;

  if (parametres->pb_h > parametres->pb_w) /* Objet plus haut que large => sparateur vertical */
  {
    x_debut = parametres->pb_x + (parametres->pb_w >> 1);
    y_debut = parametres->pb_y ;
    x_fin   = x_debut;
    y_fin   = parametres->pb_y + parametres->pb_h;

    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut + 1, y_debut, x_fin + 1, y_fin);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut - 1, y_fin  , x_fin + 1, y_fin);

    XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut - 1, y_debut, x_fin - 1, y_fin);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut - 1, y_debut, x_fin - 1, y_debut);
  }
  else /* Objet plus large que haut => sparateur horizontal */
  {
    x_debut = parametres->pb_x;
    y_debut = parametres->pb_y + (parametres->pb_h >> 1);
    x_fin   = parametres->pb_x + parametres->pb_w;
    y_fin   = y_debut;

    XSetForeground(_Display, _GC_objets, _Couleurs[GRIS_FONCE].pixel);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut, y_debut - 1, x_fin, y_fin   - 1);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_fin  , y_debut - 1, x_fin, y_debut + 1);

    XSetForeground(_Display, _GC_objets, _Couleurs[BLANC].pixel);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut, y_debut + 1, x_fin  , y_fin   + 1);
    XDrawLine(_Display, _Fen_redessin, _GC_objets, x_debut, y_debut - 1, x_debut, y_debut + 1);
  }

  return parametres->pb_currstate; /* tat courant du bouton */
}
