/* Bibliothque mixte GEM / X-Windows
          Chargement des ressources
   (C) 1998, Emmanuel CURIS

 1er avril 1998
  * Cration du fichier
  * Rcupr les dfinitions des en-ttes du fichier *.RSC dans xaes.h
  * Dfinition des types portables  pour viter les problmes de taille des int
*/

#ifndef _X_CHARGE_RESSOURCE_H_

#define _X_CHARGE_RESSOURCE_H_

/* define INVERSE */ /* Dcommenter si codage type Intel */

#define INT_16 0
#define INT_32 1

#if INT_16 /* int de 16 bits, comme sur Atari */

typedef long LONG;
typedef int  WORD;
typedef unsigned int  UWORD;
typedef unsigned long ULONG;

#endif

#if INT_32 /* int de 32 bits : unix */

typedef int                LONG;
typedef short int          WORD;
typedef unsigned short int UWORD;
typedef unsigned int       ULONG;

#endif

#define CDECL 

typedef struct rshdr
{
  UWORD rsh_vrsn;
  UWORD rsh_object;
  UWORD rsh_tedinfo;
  UWORD rsh_iconblk;       /* list of ICONBLKS          */
  UWORD rsh_bitblk;
  UWORD rsh_frstr;
  UWORD rsh_string;
  UWORD rsh_imdata;        /* image data                */
  UWORD rsh_frimg;
  UWORD rsh_trindex;
  UWORD rsh_nobs;          /* counts of various structs */
  UWORD rsh_ntree;
  UWORD rsh_nted;
  UWORD rsh_nib;
  UWORD rsh_nbb;
  UWORD rsh_nstring;
  UWORD rsh_nimages;
  UWORD rsh_rssize;        /* total bytes in resource   */
} RSHDR;

typedef struct
{
  UWORD rsh_vrsn;       /* should be 3                                 */
  UWORD rsh_extvrsn;	/* not used, initialised to 'IN' for Interface */
  ULONG rsh_object;
  ULONG rsh_tedinfo;
  ULONG rsh_iconblk;	/* list of ICONBLKS			       */
  ULONG rsh_bitblk;
  ULONG rsh_frstr;
  ULONG rsh_string;
  ULONG rsh_imdata;	/* image data				       */
  ULONG rsh_frimg;
  ULONG rsh_trindex;
  ULONG rsh_nobs; 	/* counts of various structs 		       */
  ULONG rsh_ntree;
  ULONG rsh_nted;
  ULONG rsh_nib;
  ULONG rsh_nbb;
  ULONG rsh_nstring;
  ULONG rsh_nimages;
  ULONG rsh_rssize;	/* total bytes in resource   */
} RSXHDR;

typedef struct
{
  unsigned long deb_objets;
  unsigned long deb_tedinfo;
  unsigned long deb_iconblk;
  unsigned long deb_bitblk;
  unsigned long deb_ch_libres;
  unsigned long deb_chaines;
  unsigned long deb_images;
  unsigned long deb_img_libres;
  unsigned long table_arbres;
  unsigned long nbr_objets;
  unsigned long nbr_arbres;
  unsigned long nbr_tedinfos;
  unsigned long nbr_iconblk;
  unsigned long nbr_bitblk;
  unsigned long nbr_chaines;
  unsigned long nbr_images;
  unsigned long taille_ressource;
} RSC_infos;

/* --------- Infos ncessaires pour charger et grer le ressource --------- */

typedef struct ressource
{
  struct ressource *suivant;
  BITBLK   *Bitblk;
  CICON    *Cicon;
  CICONBLK *Ciconblk;
  ICONBLK  *Iconblk;
  OBJECT   *Object;
  TEDINFO  *Tedinfo;
  char     *Chaines;
  char     *Chaines_libres;
  void     *Images_libres;
  unsigned long nombre_arbres;
  unsigned long nombre_chaines;
  unsigned long nombre_objets;
} Ressource;

int        RSC_charge     (const char *nom, Ressource *ressource);
Ressource *RSC_creer      (void);                 /* Crer des infos de ressource */
int        RSC_effacer    (Ressource *ressource); /* Perdre un ressource inutile  */
void       RSC_tt_effacer (void);
int        RSC_lit_adresse(Ressource *ressource, int type, int index, void *adresse);

/* !!!! Les fonctions rsrc_??? sont dans X_rsrc_lib.h !!!! */
/*      (fonctions compatibles AES de base...)             */

#endif /* _X_CHARGE_RESSOURCE_H */

