/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de base VDI (fonctions v_xxx) */

#ifndef _X_V_LIB_H_

#define _X_V_LIB_H_ 

#include "../SYSTEME.H"

/****** Control library ******************************************************/

#define OW_FILE          0 /* output device type in the low-order byte */
#define OW_SERIAL        1
#define OW_PARALLEL      2
#define OW_DEVICE        3
#define OW_NOCHANGE    255

#define OW_LETTER1       0 /* page size index in the high-order byte */
#define OW_HALF          5
#define OW_B5           10
#define OW_LETTER2      20
#define OW_A4           30
#define OW_LEGAL        40
#define OW_DOUBLE       50
#define OW_BROAD        55
#define OW_INDIRECT    255 /* use work_in [101] and work_in [102] */

void v_get_driver_info (int device_id, int info_select, unsigned char *info_string);
void v_opnwk           (int *work_in, int *handle, int *work_out);
void v_clswk           (int handle);
void v_clrwk           (int handle);
void v_updwk           (int handle);

/* Pas de diffrence entre une station virtuelle et une station physique */

#define v_opnvwk v_opnwk
#define v_clsvwk v_clswk

void v_set_app_buff    (void *address, int nparagraphs);
int  v_bez_on          (int handle);
int  v_bez_off         (int handle);
int  v_bez_qual        (int handle, int prcnt);
void v_pat_rotate      (int handle, int angle);

/****** Output library *******************************************************/

void v_pline           (int handle, int count, int *xy);
void v_pmarker         (int handle, int count, int *xy);
void v_gtext           (int handle, int x, int y, char *string);
void v_etext           (int handle, int x, int y, unsigned char *string, int *offsets);
void v_fillarea        (int handle, int count, int *xy);
void v_cellarray       (int handle, int *pxyarray, int row_length,
                          int el_used, int num_rows, int wrt_mode, int *colarray);
void v_bar             (int handle, int *pxyarray);
void v_arc             (int handle, int x, int y, int radius, int begang, int endang);
void v_pieslice        (int handle, int x, int y, int radius, int begang, int endang);
void v_circle          (int handle, int x, int y, int radius);
void v_ellipse         (int handle, int x, int y, int xradius, int yradius);
void v_ellarc          (int handle, int x, int y, int xradius, int yradius,
			int begang, int endang);
void v_ellpie          (int handle, int x, int y, int xradius,
			int yradius, int begang, int endang);
void v_rbox            (int handle, int *xyarray);
void v_rfbox           (int handle, int *xyarray);
void v_justified       (int handle, int x, int y, char *string,
			int length, int word_space, int char_space);
void v_contourfill     (int handle, int x, int y, int index);
void v_bez             (int handle, int count, int *xyarr,
			unsigned char *bezarr, int *minmax, int *npts, int *nmove);
void v_bez_fill        (int handle, int count, int *xyarr,
                          unsigned char *bezarr, int *minmax, int *npts, int *nmove);
void v_get_pixel       (int handle, int x, int y, int *pel, int *index);
void v_show_c          (int handle, int reset);
void v_hide_c          (int handle);
void v_exit_cur        (int handle);
void v_enter_cur       (int handle);
void v_curup           (int handle);
void v_curdown         (int handle);
void v_curright        (int handle);
void v_curleft         (int handle);
void v_curhome         (int handle);
void v_eeos            (int handle);
void v_eeol            (int handle);
void v_curtext         (int handle, char *string);
void v_rvon            (int handle);
void v_rvoff           (int handle);
void v_hardcopy        (int handle);
void v_dspcur          (int handle, int x, int y);
void v_rmcur           (int handle);
void v_form_adv        (int handle);
void v_output_window   (int handle, int *xyarray);
void v_clear_disp_list (int handle);
void v_bit_image       (int handle, char *filename,
                          int aspect, int x_scale, int y_scale,
                          int h_align, int v_align, int *xyarray);
void v_alpha_text      (int handle, char *string);
void v_sound           (int handle, int frequency, int duration);
void v_meta_extents    (int handle, int min_x, int min_y, int max_x, int max_y);
void v_write_meta      (int handle, int num_intin, int *intin, int num_ptsin, int *ptsin);
void v_copies          (int handle, int count);
void v_orient          (int handle, int orientation);
void v_tray            (int handle, int tray);
int  v_xbit_image      (int handle, char *filename, int aspect,
                          int x_scale, int y_scale,
                          int h_align, int v_align, int rotate,
                          int background, int foreground, int *xy);
void v_setrgbi         (int handle, int primtype, int r, int g, int b, int i);
void v_topbot          (int handle, int height,
                          int *char_width, int *char_height,
                          int *cell_width, int *cell_height);
void v_offset          (int handle, int offset);
void v_fontinit        (int handle, int fh_high, int fh_low);
void v_escape2000      (int times);

#endif /* _X_V_LIB_H_ */









