/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque fourre-tout base VDI (fonctions v?_xxx) */

#ifndef _X_VDIVERS_LIB_H_

#define _X_VDIVERS_LIB_H_ 

#include "../SYSTEME.H"

typedef struct memform
{
  void *FD_addr; /* Adresse de l'image (0 = cran) */
  int FD_width;     /* Largeur (pixels) */
  int FD_height;    /* Hauteur (pixels) */
  int FD_wd_width;  /* Largeur (mots)   */
  int FD_stand;     /* 0 = non standard (pilote); 1 = standard (VDI) */
  int FD_plane;     /* Nombre de plans  */
  int FD_r1;
  int FD_r2;
  int FD_r3;
} MFDB;

void vex_butv     (int handle, int (*usercode)(int etat), int (* *savecode)(int etat));
void vex_curv     (int handle, int (*usercode)(int x, int y), int (* *savecode)(int x, int y));
void vex_motv     (int handle, int (*usercode)(int x, int y), int (* *savecode)(int x, int y));
void vex_timv     (int handle, int (*tim_addr)(void), int (* *old_addr)(void), int *scale);

void vm_coords    (int handle, int llx, int lly, int urx, int ury);
void vm_filename  (int handle, char *filename);
void vm_pagesize  (int handle, int pgwidth, int pgheight);

void vr_recfl     (int handle, int *pxyarray);
void vr_trnfm     (int handle, MFDB *srcMFDB, MFDB *desMFDB);

void vro_cpyfm    (int handle, int wr_mode, int *xy, MFDB *srcMFDB, MFDB *desMFDB);

void vrq_choice   (int handle, int in_choice, int *out_choice);
void vrq_locator  (int handle, int initx, int inity, int *xout, int *yout, int *term);
void vrq_string   (int handle, int length, int echo_mode, int *echo_xy, char *string);
void vrq_valuator (int handle, int val_in, int *val_out, int *term);

void vrt_cpyfm    (int handle, int wr_mode, int *xy, MFDB *srcMFDB, MFDB *desMFDB, int *index);

void vt_alignment (int handle, int dx, int dy);
void vt_axis      (int handle, int xres, int yres, int *xset, int *yset);
void vt_origin    (int handle, int xorigin, int yorigin);
void vt_resolution(int handle, int xres, int yres, int *xset, int *yset);

#endif /* _X_VDIVERS_LIB_H_ */









