/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de fentres (WINDows library)

*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <Bib_X.h>

int FEN_creation(Fenetre *fenetre, int attributs); /* Dans X_fenetres.c */

int wind_create(unsigned int attributs, int x, int y, int larg, int haut)
{
  Fenetre *fenetre, *fen_gem;
  int handle = 0;
  char *nom = NULL, *infos = NULL;

  if (_premiere_fenetre == NULL) /* Aucune fentre cre */
  {
    if ( attributs & NAME )
      nom = "Sans nom";

    if ( attributs & INFO )
      infos = "Pas d'informations disponibles";

    fenetre = creer_fenetre(attributs, nom, infos, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

    if (fenetre == NULL) /* Problme de cration de la fentre */
      return -1;
  }
  else /* On cherche la premire fentre libre (Window = 0) */
  {
    boolean aucune = FAUX;
    int i;

    fenetre = _premiere_fenetre;
    while (fenetre->handle > 0) /* Fentre ouverte */
    {
      i++;
      fenetre = fenetre->suivante;
      if (fenetre == NULL) /* En fait, aucune ne convient */
      {
	aucune = VRAI;
	break;
      }
    }

    if (aucune == VRAI) /* Aucune fentre ne convient */
    {
      if ( attributs & NAME )
	nom = "Sans nom";
      if ( attributs & INFO )
	infos = "Pas d'informations disponibles";

      fenetre = creer_fenetre(attributs, nom, infos, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

      if (fenetre == NULL) /* Problme de cration de la fentre */
	return -1;
    }
    else /* La struct. existe, mais wind_delete -> pas de X associ */
    {
      fenetre->x = x;
      fenetre->y = y;
      fenetre->larg = larg;
      fenetre->haut = haut;

      fenetre->titre = "Sans nom";
      fenetre->infos = "Aucune information disponible";

      FEN_creation(fenetre, attributs);
    }

    /* Ici, on peut travailler avec la fentre */

    if (fenetre->taille == NULL)
    {
      fenetre->taille = XAllocSizeHints();
    }

    if ( fenetre->taille ) /* A pu tre cr */
    {
      fenetre->taille->flags = PMinSize | PMaxSize; /* On ne peut pas en changer la taille */
      fenetre->taille->min_width  = 16;
      fenetre->taille->min_height = 16; /* Taille minimale GEM ? */
      fenetre->taille->max_width  = larg;
      fenetre->taille->max_height = haut;
      XSetWMNormalHints(_Display, fenetre->handle, fenetre->taille);
    }
  }

  /* On cherche maintenant le n de la struct. qui correspond */

  for (handle = 0, fen_gem = _premiere_fenetre ; fen_gem != fenetre ; 
       handle++, fen_gem = fen_gem->suivante);

  return handle; /* Tout s'est bien pass */
}

int wind_open       (int handle, int wx, int wy, int ww, int wh);

int wind_close      (int handle);

int wind_delete     (int handle);

int wind_get(int handle, int fonction, ...)
{
  int i, retour;
  int *par_1, *par_2, *par_3, *par_4;
  Fenetre *fenetre;
  va_list args;

  if (handle < 0) return -1;

  if (fonction == WF_TOP) /* Quoi qu'il arrive, toujours considre au premier plan */
  {
    va_start(args, fonction);
    par_1 = va_arg(args, int *);
    *par_1 = handle; /* Vu le clipping automatique sous X, on ne va pas se fatiguer :-) */
    va_end(args);
    return 0;
  }

  for (i = 0, fenetre = _premiere_fenetre ;
       (i < handle) && (fenetre != NULL) ;
       i++, fenetre = fenetre->suivante);

  if (fenetre == NULL)
  {
    /*    printf("La fentre de handle %d n'existe pas\n", handle);
    printf("Handle maximal de fentre : %d\n", i); */
    return -1;
  }

  if (fenetre->handle == 0)
  {
    printf("La fentre de handle %d a t dtruite\n", handle);
    return -2;
  }

  va_start(args, fonction);

  switch(fonction)
  {
  case WF_WORKXYWH: /* Coordonnes de travail */
    par_1 = va_arg(args, int *); *par_1 = fenetre->w_x;
    par_2 = va_arg(args, int *); *par_2 = fenetre->w_y;
    par_3 = va_arg(args, int *); *par_3 = fenetre->w_larg;
    par_4 = va_arg(args, int *); *par_4 = fenetre->w_haut;
    retour = 0;
    break;

  default: /* Non support */
    retour = -2;
  }

  va_end(args);

  return retour; /* Non trait */
}

/* --------------- Installer les paramtres de fentre --------------- */

int wind_set(int handle, int fonction, ...)
{
  int i;
  char *texte;
  Fenetre *fenetre;
  va_list args;

  if (handle < 0) /* Fentre inconnue */
    return -1;

  for (i = 0, fenetre = _premiere_fenetre ;
       (i < handle) && (fenetre != NULL);
       i++, fenetre = fenetre->suivante);

  if (fenetre == NULL)
  {
    printf("La fentre de handle %d n'existe pas\n", handle);
    printf("Handle maximal de fentre : %d\n", i);
    return -1;
  }

  if (fenetre->handle == 0)
  {
    printf("La fentre de handle %d a t dtruite\n", handle);
    return -2;
  }

  va_start(args, fonction); /* On initialise la lecture des lments multiples */

  switch (fonction)
  {
  case WF_NAME:
    break;

  case WF_INFO:
    texte = va_arg(args, char *);
    fenetre->infos = texte;
    /* Forcer redessin de la ligne d'infos */
    break;
  }

  va_end(args); /* On a fini avec les arguments multiples */
  return 0;
}

int  wind_find       (int mx, int my);

/* --------------- wind_update() : n'a pas de sens sous X... */

int  wind_update     (int beg_update)
{
  return 0;
}

int wind_calc(int demande, unsigned int attributs, int x, int y, int w, int h,
	      int *px, int *py, int *pw, int *ph)
{
  int haut_car; /* C'est l'unit de base... */

  haut_car  = _Fonte->max_bounds.ascent + _Fonte->max_bounds.descent;
  haut_car += _Fonte->ascent + _Fonte->descent;

  *px = x; /* De toute faon, ce sera voisin */
  *py = y;
  *pw = w;
  *ph = h;

  if (demande == WC_WORK) /* Complet -> travail */
  {
    if ( (attributs & CLOSER) || (attributs & INFO) )
    {
      *py += haut_car; /* Dcalage pour la barre d'infos*/
      *ph -= haut_car;
    }

    if ( attributs & ASC_VERTICAL )
    {
      *pw -= haut_car;
    }
  }
  else if (demande == WC_BORDER) /* Travail -> complet */
  {
    if ( (attributs & CLOSER) || (attributs & INFO) )
    {
      *py -= haut_car; /* Dcalage pour la barre d'infos*/
      *ph += haut_car;
    }

    if ( attributs & ASC_VERTICAL )
    {
      *pw += haut_car;
    }
  }
  else
    return -1;

  return 0;
}

void wind_new        (void);

int  wind_apfind     (int mx, int my);

