/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
   Dfinitions des messages d'erreur pour le traitement gnral des spectres
   (c) Emmanuel CURIS 1998
   
   FICHIER A INCLURE

  25 mars 1998
    * Dfinitions des alertes par Interface => inclusion de alerte.h

  16 mars 1998
    * Cration du fichier
    * Rcupr les messages d'erreur dans graphes.h
*/

#ifndef _ERREURS_H_

#define _ERREURS_H_ 

#include "ALERTES.H"  /* Les codes d'erreur, en fait, pour le programme gnral */
#include "ATM_ERR.H"  /* Codes d'erreur, gestion d'un ensemble d'atomes (modle structural) */
#include "ERR_EXT.H"  /* Codes d'erreur, extraction des signaux exprimentaux   */
#include "ERR_EXF.H"  /* Codes d'erreur EXAFS */
#include "ERR_LISS.H" /* Codes d'erreurs LISSAGE */
#include "XAN_ERRS.H" /* Codes d'erreur XANES */

#define MAX_ALERTE 23 /* Au-del, message inconnu... */

/* ------------- Fonctions de traitement des erreurs ------------------- */

#if defined(_A_FP_CLASS_) /* Fonctions IEEE prsentes sous forme de fp_class */

# include <math.h>
# include <fp_class.h>

# define is_inf(x) ( (fp_class(x) == FP_POS_INF) || (fp_class(x) == FP_NEG_INF) )
# define is_nan(x) ( (fp_class(x) == FP_SNAN) || (fp_class(x) == FP_QNAN) )

#elif defined(_A_IS_INF_) /* Fonctions IEEE prsentes sous forme de isinf/isnan */

# include <math.h>

# define is_inf(x) isinf(x)
# define is_nan(x) isnan(x)

#else /* Fonctions IEEE absentes, il faut les routines de test personnelles */

int is_inf(double x); /* Renvoie VRAI si x = +/-Inf */
int is_nan(double x); /* Renvoie VRAI si x = NaN    */

#endif

/* ------------- Affichage des messages d'erreur ----------------------- */

int EXF_ERREUR  (int num_erreur); /* Affiche un message d'erreur du programme */

int ATM_ERREUR  (unsigned int num_erreur, ...);           /* Dans atomes/atm_err.c  */
int EXAFS_ERREUR(unsigned int num_erreur, ...);           /* Dans exafs/err_exf.c   */
int EXT_ERREUR  (unsigned int num_erreur, int parametre); /* Dans extrait/erreurs.c */
int LIS_ERREUR  (unsigned int num_erreur);                /* Dans lissage/erreurs.c */
int XAN_ERREUR  (unsigned int num_erreur);                /* Dans xanes/erreurs.c   */

#endif /* _ERREURS_H_ */
