/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
   Les messages d'erreur (+ quelques autres petites choses allant avec)
   (c) Emmanuel CURIS 1996-1997

   25 mars 1998
     * Textes des messages d'alerte fait dans Interface : ALERTES.RSC - plus sympa

   16 mars 1998
     * Inclus "erreurs.h" (fichier associ...)

    6 janvier 1998
     * Modifi is_nan() : utilise 20 octets de moins...
     * Inclus ..\etendu.gem\erreurs.h

   15 dcembre 1997
     * Fonction is_nan() cre et fonctionne correctement

   24, 25 & 27 novembre 1997
     * Cration de l'historique
     * Ajout message d'erreur NON_SAUVE
     * Ajout la fonction is_inf() : renvoie VRAI si un double vaut +Inf ou -Inf
     * Inclusion de gem_var.h
     * Corrig le nom du #define caractristique
*/

#define _EXAFS_ERREURS_ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SYSTEME.H"

#include "EXAFS.H"
#include "GRAPHES.H"

#include "ERREURS.H"

#if !defined(_A_FP_CLASS_) && !defined(_A_IS_INF_) /* Aucune fonction de test par dfaut */

/* ~~~~~~~~~~~~~~~ Fonctions de test vitant bien des erreurs... ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* --------------- Test de l'infini : renvoie VRAI si x = +Inf ou x = -Inf, FAUX sinon ------- */

int is_inf(double x)
{
  double p_infini = 1.0/0.0, m_infini = -1.0/0.0;

  if (x == p_infini) return VRAI; /* x vaut + l'infini */
  if (x == m_infini) return VRAI; /* x vaut - l'infini */

  return FAUX;
}

/* --------------- Test de Not a Number : renvoie VRAI si x = Nan, FAUX sinon ---------------- */

char tst_nan[20]; /* On suppose 20 caractres au plus dans un flottant crit par sprintf */

int is_nan(double x)
{
  sprintf(tst_nan, "%f", x);
  if (tst_nan[0] == 'N') /* Nan crit Nan dans une chane par sprintf... */
  {
    return VRAI;
  }

  return FAUX;
}

#endif /* !defined(_A_FP_CLASS_) && !defined(_A_IS_INF_) */

/* ~~~~~~~~~~~~~~~ Messages d'erreur spcifiques du programme ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* --------------- Textes :  rcuprer dans ALERTES.RSH... ---------------------------------- */

#ifdef _FRANCAIS_

static char *alertes[] = 
{
  "[1][---- Traitement d'un graphe ---| "
     "|  Ce graphe contient des points"
     "|doubles (m"e_CIRC"me X) : cette op"e_AIGU"ra-"
     "|tion est impossible.][Abandon]",
  "[3][- Calcul du signal d'absorption| "
     "|   On trouve I0 <= 0 ! Cette"
     "|valeur est absurde ! Coupure du"
     "|faisceau lors de l'acquisition?][Abandon|Continuer]",
  "[1][------ Erreur de calcul ------| "
     "|  Ce calcul conduit "a_GRAVE" effectuer"
     "|une division par z"e_AIGU"ro !][Annuler]",
  "[1][------- Valeur absurde -------| "
     "|   La valeur propos"e_AIGU"e est tout"
     "|"a_GRAVE" fait incompatible avec l'uti-"
     "|lisation que l'on doit en faire][Annuler]",
  "[1][---- Traitement du graphe ----| "
     "|   Ce graphe n'a pas "e_AIGU"t"e_AIGU" tri"e_AIGU", "
     "|ce qui interdit la r"e_AIGU"alisation "
     "|de l'op"e_AIGU"ration demand"e_AIGU"e.][Abandon]",
  "[1][----- Trop peu de points ----| "
     "|   Un tel calcul conduirait "a_GRAVE
     "|un spectre  contenant un seul"
     "|point, ce qui est impossible.][Abandon]",
  "[1][--- Incoh"e_AIGU"rence des graphes ---| "
     "|  Les graphes choisis n'ont pas"
     "|tous le m"e_CIRC"me nombre de points."
     "|  Op"e_AIGU"ration impossible.][Annuler]",
  "[1][--- Incoh"e_AIGU"rence des graphes ---| "
     "|  Les graphes choisis sont dis-"
     "|joints (pas de X commun)."
     "|  Op"e_AIGU"ration impossible.][Abandon]",
  "[3][- Calcul du signal d'absorption| "
     "|  On trouve I1 <= 0, impossible"
     "|en transmission !][Continuer|Annuler]",
  "[1][------- Graphe prot"e_AIGU"g"e_AIGU" -------| "
     "|  Ce graphe est utilis"e_AIGU" dans un"
     "|calcul et ne peut "e_CIRC"tre modifi"e_AIGU".][Abandon]",
  "[3][---- Extraction de l'EXAFS ----| "
     "|    Pas d'absorption atomique"
     "|d"e_AIGU"finie ! La normalisation du"
     "|signal est impossible.][Continuer]",
  "[2][---- Quitter ce module ----| "
     "|   Que  faire en quittant ce"
     "|module : effectuer le calcul"
     "|ou fermer sans calculer ?][Calculer|Fermer|Annuler]",
  "[2][----- Module d"e_AIGU"j"a_GRAVE" actif -----"
     "|   Ce module est d"e_AIGU"j"a_GRAVE" utilis"e_AIGU"."
     "|Faut-il juste l'activer ou le"
     "|r"e_AIGU"initialiser  avec le graphe"
     "|courant ?][Activer|R"e_AIGU"initialiser|Annuler]",
  "[2][- "E_AIGU"limination d'une aberrance -| "
     "|      Ce spectre contient-il un"
     "|point aberrant que vous vouliez"
     "|"o_CIRC"ter ?][Aucun|Oui]",
  "[1][---- Param"e_AIGU"trage incorrect ----| "
     "|   Les bornes indiqu"e_AIGU"es sont"
     "|incorrectes (invers"e_AIGU"es ou se"
     "|r"e_AIGU"duisant "a_GRAVE" un seul point).][Abandon]",
  "[1][----- Param"e_GRAVE"tre incorrect -----| "
     "|  Le pas indiqu"e_AIGU" pour le calcul"
     "|est incorrect  (n"e_AIGU"gatif, nul ou"
     "|sup"e_AIGU"rieur "a_GRAVE" l'intervalle).][Abandon]",
  "[1][---- Calculs sur un graphe ----| "
     "|  Le graphe indiqu"e_AIGU" ne contient"
     "|pas assez de points pour que le"
     "|calcul soit pertinent.][Abandon]",
  "[1][---- Calculs sur un graphe ----| "
     "|  Ce type de calcul n'a de sens"
     "|que sur un graphe complexe.][Abandon]",
  "[1][---- Calculs sur un graphe ----| "
     "|  Ce type de calculs ne peut se"
     "|faire que sur un graphe conte-"
     "|nant 2"n_EXPOSANT" points...][Abandon]",
  "[3][------ Effacer un graphe ------| "
     "|  Ce graphe n'a pas "e_AIGU"t"e_AIGU" sauv"e_AIGU" !"
     "|Voulez-vous le sauver, l'effa-"
     "|cer ou annuler l'op"e_AIGU"ration ?][Sauver|Effacer|Annuler]",
  "[1][---- Calculs sur un graphe ----| "
     "|  Cette op"e_AIGU"ration ne peut pas"
     "|"e_CIRC"tre effectu"e_AIGU"e  sur un graphe"
     "|complexe.][Abandon]",
  "[3][---- ERREUR INTERNE GRAVE ----| "
     "|La liste des graphes en m"e_AIGU"moire"
     "|n'est plus coh"e_AIGU"rente ! Sauvez"
     "|tout et quittez le programme.][Compris]",
  "[1][----- Liste de graphes ----| "
     "|   Ce graphe se trouve d"e_AIGU"j"a_GRAVE
     "|dans la liste !][Abandon]",
  "[3][------- Erreur survenue -------| "
     "|   Une erreur est survenue lors"
     "|des op"e_AIGU"rations demand"e_AIGU"es."
     "|  Origine de l'erreur inconnue.][Continuer]"
};

#endif

/* --------------- Routines d'affichage ------------------------------------------------------ */

int EXF_ERREUR(int num_erreur)
{

  if (num_erreur <= MAX_ALERTE)
    return form_alert(1, alertes[num_erreur]);
  else
  {
    char _message[170];

    _message[0] = '[';
    _message[1] = INTERROGE;
    strcpy(_message +   2,"][ ----- Erreur inconnue ------ |");
    strcpy(_message +  35,"       L'op"e_AIGU"ration demand"e_AIGU"e a |");
    strcpy(_message +  66," provoqu"e_AIGU" une erreur inconnue |");
    sprintf(_message + 97," de num"e_AIGU"ro %d. |", num_erreur);
    strcpy(_message + 127,"|                              ]");
    strcpy(_message + 159,"[Annuler]");
    _message[168] = 0;
    return form_alert(1, _message);
  }
}
