/* LASE - Traitement de l'E.X.A.F.S. sur Atari & X-Window
   Tout ce qui concerne l'EXAFS sens strict (extraction des oscillations)

   (c) 1996, 1998 - Emmanuel CURIS ; cration du fichier : 27 mai 1998

   Messages d'erreur de ce module
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "SYSTEME.H"

#include "ERREURS.H"

#define NOMBRE_MESSAGES 2

#ifdef _FRANCAIS_

static const char *messages[] = 
{
  "[1][- Extraction du signal EXAFS -| "
     "|   Le "MU"0 obtenu contient des"
     "|valeurs n"e_AIGU"gatives ! Ce "MU"0 est"
     "|donc peu plausible.][ Compris ]",

  "[2][Normalisation du signal EXAFS | "
     "|   Valeur de E0 incorrecte    "
     "| (n"e_AIGU"gative ou nulle).][Annuler]"
};

#endif

#ifdef _ENGLISH_

static const char *messages[] = 
{
  "[1][------ EXAFS extraction ------| "
     "|   The "MU"0 obtained has some"
     "|negatives values ! This "MU"0 is"
     "|not very realistic.][ Ok ]",

  "[2][----- EXAFS normalisation ----| "
     "|   E0 value not correct "
     "| (negative or null).][ Cancel ]"
};

#endif

int EXAFS_ERREUR(unsigned int num_erreur, ...)
{
  char *texte, message_complet[500];
  va_list params;

  if (num_erreur >= NOMBRE_MESSAGES)
  {
    printf(" **** Module d'extraction du signal EXAFS ****\n");
    printf(" Erreur de code inconnu : %u\n", num_erreur);
    printf(" Merci de me pr"e_AIGU"venir en d"e_AIGU"crivant les conditions\n");
    return 0;
  }

  switch (num_erreur)
  {
  case MU0_NEGATIF:
  case E0_INCORRECT:
    texte = (char *) messages[num_erreur];
    break;
  }

  return form_alert(1, texte);
}
