/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
							Toutes les fonctions de traitement statistique de l'E.X.A.F.S.
   (c) Emmanuel CURIS 1998
   
   FICHIER A INCLURE

  16 mars 1998
    * Dclaration de DISP_calcule() : calcul effectif de la dispersion standard

	13 mars 1998
		* Cration du fichier
    * Dclaration de ERR_dispersion() : paramtrages des calculs de dispersion standard
*/

#ifndef _EXAFS_STAT_H_

#define _EXAFS_STAT_H_ 

/* ------------- dispersion standard des spectres E.X.A.F.S. ------------------- */

typedef struct
{
	unsigned long prem_affiche; /* Premier spectre affich dans le slecteur */
	int num_choisi;   /* Entre choisie (< 0 : aucune choisie) */
	unsigned long nbr_choisis;  /* Nombre de spectres choisis pour le calcul */
	boolean *liste_graphes;     /* VRAI si le graphe est slectionn         */
} DISP_infos;

void ERR_dispersion(void); /* Paramtrage de la dispersion standard */

boolean GER_dispersion(int objet, int x, int y); /* Gestion de l'arbre */
void DISP_gere_asc(int objet, int x, int y);
void DISP_prep_asc(void);                  /* Prparation du slecteur */

Graphe *DISP_calc(double *x, double *y, TRI_infos *infos, unsigned long nbr_blocs,
                  unsigned long nbr_points, double correction, double *moyenne);

#endif /* _EXAFS_STAT_H_ */