/* LASE - Logiciel d'analyse des spectres EXAFS
   (C) Emmanuel CURIS, 1998 - fichier cr le 14 juin 1998

   Macros de conversion VDI -> Postscript : devrait faciliter les conversions de code...
   Unit de base : 1/100 mm, points carrs font cette dimension.
*/

#include <stdio.h>
#include <stdlib.h>

#include <SYSTEME.H>
#include "PS_VDI.H"

static int type_marker;
static int epais_ligne;
static int txt_ali_hor = ALI_LEFT, txt_ali_vert = ALI_BASE; /* Faon d'afficher le texte */
static float haut_txt = 0;

void PS_pline(FILE *fichier, unsigned int nbr_pts, int *points)
{
  unsigned int i;

  fprintf(fichier, "%d %d moveto ", points[0], points[1]);
  for (i = 2 ; i < 2 * nbr_pts ; i += 2)
    fprintf(fichier, "%d %d lineto ", points[i], points[i + 1]);
  fprintf(fichier, "stroke\n");
}

void PS_pmarker(FILE *fichier, unsigned int nbr_pts, int *points)
{
}

void PS_gtext(FILE *fichier, int x, int y, char *chaine)
{
  /* On positionne en X suivant la valeur de ALI_??? */

  if ( txt_ali_hor == ALI_CENTER )
  {
    /* stringwidth donne Dx et Dy -> pop limine Dy, on travaille sur Dx aprs */
    fprintf(fichier, "%d (%s) stringwidth pop 2 div sub ", x, chaine);
  }
  else if ( txt_ali_hor == ALI_RIGHT )
  {
    fprintf(fichier, "%d (%s) stringwidth pop sub ", x, chaine);
  }
  else
    fprintf(fichier, "%d ", x); /* Si inconnu, ALI_LEFT */

  /* On s'occupe maintenant de la position verticale */

  if ( txt_ali_vert == ALI_HALF ) /* Demande  tre au milieu */
  {
    /*    fprintf(fichier, "%d currentfont /FontBBox get 1 get ", y);
	  fprintf(fichier, "currentfont /FontBBox get 3 get add 2 div add moveto "); */
    fprintf(fichier, "%f moveto ", ( (float) y ) + haut_txt / 2.0 );
  }
  else if ( txt_ali_vert == ALI_TOP )
    fprintf(fichier, "%f moveto ", ( (float) y ) - haut_txt);
    /*    fprintf(fichier, "%d currentfont /FontBBox get 3 get sub moveto ", y); */
  else if ( txt_ali_vert == ALI_BOTTOM )
    fprintf(fichier, "%d currentfont /FontBBox get 1 get sub moveto ", y);
  else /* Par dfaut : ALI_BASE : on ne se fatigue pas... */
    fprintf(fichier, "%d moveto ", y);  /* Ligne de base : normal */  

  fprintf(fichier, "(%s) show\n", chaine); /* Affiche la chane      */
}

void PS_haut_texte(FILE *fichier, float haut_texte, float *haut_reelle)
{
  haut_txt = haut_texte * 2540.0 / 72.0 ; /* hauteur relle en 1/100 mm */
  fprintf(fichier, "currentfont %f scalefont setfont\n", haut_txt); /* On met  la taille */
  *haut_reelle = haut_txt; /* Hauteur en units Postscript */
}

void PS_sl_type(FILE *fichier, int type)
{
  switch (type)
  {
  case LDASHED:
    fprintf(fichier, "[400 400] 0 setdash\n");
    break;

  case DOTTED:
    fprintf(fichier, "[200 600] 0 setdash\n");
    break;

  case DASHDOT:
    fprintf(fichier, "[800 300 200 300] 0 setdash\n");
    break;

  case DASH:
    fprintf(fichier, "[800 800] 0 setdash\n");
    break;

  case DASHDOTDOT:
    fprintf(fichier, "[500 300 200 200 100 300] 0 setdash\n");
    break;

  default:
    fprintf(fichier, "[] 0 setdash\n"); /* Pas de pointill */
  }
}

void PS_st_alignment(FILE *fichier, int hor, int ver, int *hor_eu, int *ver_eu)
{
  if (hor_eu) *hor_eu = hor;
  if (ver_eu) *ver_eu = ver;

  txt_ali_hor  = hor;
  txt_ali_vert = ver;
}

