/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
				   Macros de gestion des arbres GEM de paramtrage de FEFF
   (c) Emmanuel CURIS, 9 janvier 1998 (cration) - 

 27 mars 1998
   * Mise au propre des #include

 11 fvrier 1998
   * Corrig l'erreur d'affichage de l'ascenseur des atomes FEFF, quand on effaait tous les atomes
       (et la mme chose pour les couches de rflexions simples au passage...)
       Il faut changer la position AVANT la taille !
   * Corrig erreur : quand on changeait le potentiel de l'absorbeur, ascenseur plantait...

 9, 12, 20 janvier 1998
   * Si aucun atome, met le bouton  toute la hauteur : plus joli...
                     dsactive correctement les boutons (commentaire non ferm !)
   * Cration de SS_init_defil()
   * Cration de SS_gere_defil() : semble OK
   * Fonction FATM_init_defil() adapte pour tre plus utile
   * Fonction FATM_gere_defil() ralise - tourne entirement (joie !)
   * Fonction d'init. de l'afficheur des atomes FEFF -> rcupr de FEFF.C
                                                     -> poursuivie...
*/

#define _FEFF_GEM_ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SYSTEME.H"
#include "EXAFS.H"
#include "ATOMES.H"

#include "FEFF_GEM.H"
#include "SH_FEFF.H"
#include "FEFF.H"

extern FEFF_INP params_feff; /* Dfinie dans ..\FEFF.C */
extern int _rien_; /* Dfinie dans un des trucs d'EXAFS */

/* ------------------- Gestion du dfileur des atomes FEFF ------------------------- *
 *************************************************************************************/

/* ------------------- Initialisation de ce dfileur --------------------------------\
 |  Renvoie PAS_PROBLEME si pas d'erreur                                             |
 |                                                                                   |
 | infos : les infos FEFF : mises  jour pour ce qui concerne ce dfileur            |
 \---------------------------------------------------------------------------------- */

int FATM_init_defil(FEF_infos *infos)
{
  FEFF_atome *atome;
  int i;
  unsigned int nbr_atomes;
  boolean existe;

  /* Existe-t-il des atomes FEFF ? */
	
  existe = ! ( (params_feff.absorbeur == NULL) && (params_feff.prem_atome == NULL) );

  OBJ_active(FEFF_PAR_STRUCT, FEF_X_ATOME, existe); /* Affichage des coordonnes */
  OBJ_active(FEFF_PAR_STRUCT, FEF_Y_ATOME, existe);
  OBJ_active(FEFF_PAR_STRUCT, FEF_Z_ATOME, existe);
  OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_POT, existe);

  OBJ_active(FEFF_PAR_STRUCT, FEF_EFFACER,   existe); /* Oprations sur les atomes */
  OBJ_active(FEFF_PAR_STRUCT, FEF_TT_EFFACE, existe);
  OBJ_active(FEFF_PAR_STRUCT, FEF_COPIER,    existe);

  if ( existe == FAUX ) /* Il n'existe pas d'atomes */
  {
    int i; /* On dsactive tout ce qui va avec */
    
    for (i = FEF_NOM_PREM_ATM; i <= FEF_NOM_DERN_ATM ; i++) /* La liste des noms */
    {
      OBJ_active (FEFF_PAR_STRUCT, i, FORCE_NON);
      OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON);
      met_chaine(FEFF_PAR_STRUCT, i, 6, "", TXT_REMPLACE);
    }
    infos->prem_atome = -2;
    infos->atm_choisi =  0; /* Aucun atome slectionn */

    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT , FORCE_NON); /* Ascenseur indisponible */
    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_FND   , FORCE_NON);
    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, FORCE_NON);
    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES , FORCE_NON);

    OBJ_taille(FEFF_PAR_STRUCT, FEF_ATM_FND, -1, -1, &_rien_, &i);
    OBJ_position(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, 0, &_rien_, &_rien_);
    OBJ_taille  (FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, i, &_rien_, &_rien_);

    return PAS_PROBLEME; /* Rien d'autre  faire... */
  }

  if ( (infos->atm_choisi < 1) /* Pas d'atome slectionn dfini */
       || (infos->atm_choisi > FEF_NOM_DERN_ATM - FEF_NOM_PREM_ATM + 1) )
    infos->atm_choisi = 1;

  nbr_atomes = params_feff.nbr_atomes;
  if ( params_feff.absorbeur ) /* Il existe en plus un atome absorbeur */
    nbr_atomes++;

  existe = (nbr_atomes > FEF_NOM_DERN_ATM - FEF_NOM_PREM_ATM + 1);
  /* VRAI : plus d'objets que de places */

  OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, existe);
  OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES , existe);

  if ( existe ) /* Plus d'atomes que de place disponible */
  {
    int haut_total, index, nbr_visibles = FEF_NOM_DERN_ATM - FEF_NOM_PREM_ATM + 1;
    float taille_asc, pos_asc;

    /* Flche de dfilement vers le haut */

    if ( infos->prem_atome > 0 )
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT, FORCE_OUI); /* Atomes avant */
    else if ( ( infos->prem_atome == 0 ) && (params_feff.absorbeur) )
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT, FORCE_OUI); /* Atomes avant */
    else
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT, FORCE_NON); /* Pas d'atome avant */

    /* Taille de l'ascenseur */

    OBJ_taille(FEFF_PAR_STRUCT, FEF_ATM_FND, -1, -1, &_rien_, &haut_total);

    taille_asc  = ( (float) nbr_visibles) / (float) nbr_atomes;
    taille_asc *= haut_total;
    if (taille_asc < 5)
      taille_asc = 5; /* 5 pixels minimum, sinon illisible */

    /* Position de l'ascenseur */

    index = infos->prem_atome;
    if (params_feff.absorbeur) /* Numro du premier atome, 1 ... nbr_atomes */
      index++;

    pos_asc  = (float) index / (float) (nbr_atomes - nbr_visibles);
    pos_asc *= (float) (haut_total - (int) taille_asc);
    
    OBJ_position(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, (int) pos_asc, &_rien_, &_rien_);
    OBJ_taille(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, (int) taille_asc, &_rien_, &_rien_);	

    /* Le fond  - forcment actif */

    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_FND, FORCE_OUI);

    /* Flche de dfilement vers le bas */

    index = infos->prem_atome + nbr_visibles;
    if (params_feff.absorbeur)
    	index++; /* Numro du dernier atome en commenant  1 = absorbeur */

    if (index >= nbr_atomes) /* Suprieur au nombre rel d'atomes */
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES, FORCE_NON); /* Pas d'atome aprs */
    else
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES, FORCE_OUI); /* Un atome aprs */
  }
  else /* Moins d'atomes que de place disponible */
  {
    int hauteur;

    if (params_feff.absorbeur) /* Il y a un atome absorbeur */
      infos->prem_atome = -1;
    else
      infos->prem_atome =  0; /* On indique le premier atome affich */

    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT,  FORCE_NON); /* Pas d'atome avant */
    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_FND   , FORCE_NON);
    OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES,  FORCE_NON); /* Pas d'atome aprs */

    OBJ_taille(FEFF_PAR_STRUCT, FEF_ATM_FND, -1, -1, &_rien_, &hauteur);
    OBJ_position(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, 0, &_rien_, &_rien_);
    OBJ_taille(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, hauteur, &_rien_, &_rien_);
  }

  i = FEF_NOM_PREM_ATM;

  /* On choisit l'atome de dmarrage */

  if ( (params_feff.absorbeur == NULL) /* Pas d'absorbeur */
       && (infos->prem_atome == -1) ) /* Mais dfini comme atome de dpart */
    infos->prem_atome = 0; /* On corrige donc */

  if (infos->prem_atome == -1)
  {
    atome = params_feff.absorbeur;
    met_chaine (FEFF_PAR_STRUCT, FEF_NOM_PREM_ATM, 6, atome->nom, TXT_REMPLACE);
    OBJ_active (FEFF_PAR_STRUCT, FEF_NOM_PREM_ATM, FORCE_OUI);
    OBJ_choisit(FEFF_PAR_STRUCT, FEF_NOM_PREM_ATM, (infos->atm_choisi == 1));
    if (infos->atm_choisi == 1) /* Cet atome est choisi */
    {
      met_fvaleur(FEFF_PAR_STRUCT, FEF_X_ATOME, atome->atome->x);
      met_fvaleur(FEFF_PAR_STRUCT, FEF_Y_ATOME, atome->atome->y);
      met_fvaleur(FEFF_PAR_STRUCT, FEF_Z_ATOME, atome->atome->z);
      met_valeur (FEFF_PAR_STRUCT, FEF_ATM_POT, atome->potentiel);
    }

    i++;
    atome = params_feff.prem_atome; /* On passe au suivant */
  }
  else
  {
    int i = 0;
    
    atome = params_feff.prem_atome;
    while (i < infos->prem_atome)
    {
      atome = atome->suivant;
      i++;
    }
  }

  /* On traite les objets restants */

  for ( ; (atome) && (i <= FEF_NOM_DERN_ATM) ; atome = atome->suivant, i++ )
  {
    met_chaine (FEFF_PAR_STRUCT, i, 6, atome->nom, TXT_REMPLACE);
    if ( (i - FEF_NOM_PREM_ATM + 1) == infos->atm_choisi)
    {
      OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_OUI );
      met_fvaleur(FEFF_PAR_STRUCT, FEF_X_ATOME, atome->atome->x);
      met_fvaleur(FEFF_PAR_STRUCT, FEF_Y_ATOME, atome->atome->y);
      met_fvaleur(FEFF_PAR_STRUCT, FEF_Z_ATOME, atome->atome->z);
      met_valeur (FEFF_PAR_STRUCT, FEF_ATM_POT, atome->potentiel);
    }
    else
      OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON );

    OBJ_active(FEFF_PAR_STRUCT, i, FORCE_OUI);
  }
  for ( ; i <= FEF_NOM_DERN_ATM ; i++) /* Au cas o il y a moins d'atomes que d'objets */
  {
    met_chaine(FEFF_PAR_STRUCT, i, 6, "", TXT_REMPLACE);
    OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON);
    OBJ_active(FEFF_PAR_STRUCT, i, FORCE_NON);			
  }

  return PAS_PROBLEME;
}

/* ------------------- Gestion de ce dfileur ---------------------------------------\
 |  Renvoie PAS_PROBLEME si tout va bien
 |
 | infos     : les infos FEFF : mises  jour pour ce qui concerne ce dfileur        |
 | num_objet : l'objet sur lequel on a cliqu -> il faut le grer...                 |
 | x, y      : coordonnes de la souris au moment du clic                            |
 \---------------------------------------------------------------------------------- */

int FATM_gere_defil(FEF_infos *infos, int num_objet, int x, int y)
{
  /* Cas le plus simple : clic sur un atome de la liste */

  if ( (num_objet >= FEF_NOM_PREM_ATM) && (num_objet <= FEF_NOM_DERN_ATM) )
  {
    FEFF_atome *atome;
    int index_atome, nv_pot;

    /* On commence par sauver les paramtres de l'ancien atome choisi */
    
    index_atome = infos->prem_atome + (infos->atm_choisi - 1);

    if (index_atome < 0) /* On tait sur l'atome absorbeur */
      atome = params_feff.absorbeur;
    else
    {
      int i = 0;
      atome = params_feff.prem_atome;
      
      while (i < index_atome)
      {
	atome = atome->suivant;
	i++;
      }
    }

    /*    printf("Nouvelles coordonnes : %f %f %f\n", prend_fvaleur(FEFF_PAR_STRUCT, FEF_X_ATOME),
	   prend_fvaleur(FEFF_PAR_STRUCT, FEF_Y_ATOME),
	   prend_fvaleur(FEFF_PAR_STRUCT, FEF_Z_ATOME)); */

    atome->atome->x = prend_fvaleur(FEFF_PAR_STRUCT, FEF_X_ATOME); /* Coordonnes */
    atome->atome->y = prend_fvaleur(FEFF_PAR_STRUCT, FEF_Y_ATOME);
    atome->atome->z = prend_fvaleur(FEFF_PAR_STRUCT, FEF_Z_ATOME);

    nv_pot = prend_valeur(FEFF_PAR_STRUCT, FEF_ATM_POT);
    if ( nv_pot != atome->potentiel ) /* On change le potentiel */
    {
      if (nv_pot == 0)
      {
	int retour = 1;
	
	if (params_feff.absorbeur) /* Il y a dj un atome absorbeur */
	{
	  retour = FEFF_ERREUR(ABSORBEUR_DEFINI, 0);
	  
	  if (retour == 1) /* On veut le remplacer */
	  {
	    int i;
	    /* On lui attribue un paramtre : premier libre ou de mme no atomique */

	    for (i = 1 ; i < 8 ; i++)
	    {
	      if (params_feff.potentiels[i] <= 0)
		params_feff.potentiels[i] = params_feff.absorbeur->atome->num_atomique;
	      if (params_feff.potentiels[i] == params_feff.absorbeur->atome->num_atomique)
		break;
	    }
	    params_feff.absorbeur->potentiel = i;

	    /* On l'insre en dbut de liste */

	    params_feff.absorbeur->suivant = params_feff.prem_atome;
	    params_feff.prem_atome = params_feff.absorbeur;
	    params_feff.nbr_atomes++; /* Un atome de plus dans la liste */
	    index_atome++; /* On a dcal d'un cran */
	  }
	}

	if (retour == 1) /* On remplace l'absorbeur */
	{
	  params_feff.absorbeur = atome;

	  atome = params_feff.prem_atome;
	  if (index_atome == 0) /* C'est cet atome que l'on a dplac */
	  {
	    params_feff.prem_atome = params_feff.absorbeur->suivant;
	  }
	  else /* On cherche l'atome prcdent */
	  {
	    while (atome->suivant != params_feff.absorbeur)
	      atome = atome->suivant;
	    atome->suivant = params_feff.absorbeur->suivant; /* On extrait de la liste */
	  }

	  params_feff.absorbeur->suivant = NULL; /* Pas d'atome aprs */
	  params_feff.nbr_atomes--; /* Un atome de moins dans la liste */
	  params_feff.absorbeur->potentiel = 0;
	}
      }			
      else if (atome->potentiel == 0) /* On perd l'atome absorbeur */
      {
	/* On le rajoute donc en dbut de liste, en fait */

	params_feff.absorbeur->suivant = params_feff.prem_atome;
	params_feff.prem_atome = params_feff.absorbeur;
	params_feff.absorbeur  = NULL; /* Plus d'absorbeur */
	params_feff.nbr_atomes++;      /* Un atome de plus dans la liste */
	params_feff.prem_atome->potentiel = nv_pot; /* Nouveau potentiel */
	
	infos->prem_atome = 0; /* Plus d'absorbeur... */
      }
      else /* Cas sympathique... */
	atome->potentiel = nv_pot; /* Nouveau potentiel de l'atome */
    }

    /* Maintenant, on dfini le nouvel atome comme slectionn */

    infos->atm_choisi = (num_objet - FEF_NOM_PREM_ATM) + 1;

    FATM_init_defil(infos); /* On refait le slecteur */

    return PAS_PROBLEME; /* On a fini, tout va bien */
  }

  switch (num_objet)
  {
  case FEF_ATM_AVANT: /* On clique sur la flche vers le haut */
    if   (infos->prem_atome < -1) return -1; /* Pas normal */
    if ( (infos->prem_atome <  0) && (params_feff.absorbeur == NULL) ) return -1;

    if ( (infos->prem_atome == -1) /* Il y a un absorbeur ici */
      || ( (infos->prem_atome == 0) && (params_feff.absorbeur == NULL) ) )
    {
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_AVANT, FORCE_NON);
      OBJ_active(FEFF_PAR_STRUCT, FEF_ATM_APRES, FORCE_OUI);
      return -2; /* Bizarre quand mme */
    }

    infos->prem_atome--; /* Mais atome slectionn reste au mme endroit... */
    FATM_init_defil(infos);
    
    break;

  case FEF_ATM_FND:   /* On clique sur le fond -> +/-10 atomes */
    {
      int x_fnd, y_fnd;

      objc_offset(arbres[FEFF_PAR_STRUCT].adresse, FEF_ATM_FND, &x_fnd, &y_fnd);
      x -= x_fnd;
      y -= y_fnd; /* Coordonnes relatives  l'objet */

      if (y < 0) return -1; /* Problme... */
      OBJ_position(FEFF_PAR_STRUCT, FEF_ATM_BOUTON, -1, -1, &x_fnd, &y_fnd);
      if (y <= y_fnd) /* On a cliqu avant le bouton */
      {
	infos->prem_atome -= 10;
	if (infos->prem_atome < 0)
	{
	  if (params_feff.absorbeur)
	    infos->prem_atome = -1;
	  else
	    infos->prem_atome = 0;
	}
      }
      else /* On a cliqu aprs le bouton */
      {
	int nbr_visibles = FEF_NOM_DERN_ATM - FEF_NOM_PREM_ATM + 1;
	unsigned int nbr_atomes = params_feff.nbr_atomes;

	if (params_feff.absorbeur)
	  nbr_atomes++;

	infos->prem_atome += 10;
	if (infos->prem_atome + nbr_visibles > nbr_atomes)
	{
	  infos->prem_atome = nbr_atomes - nbr_visibles -1;
	}
      }

      FATM_init_defil(infos);
    }
    break;

  case FEF_ATM_BOUTON: /* Clic sur le poussoir */
    {
      float nv_pos;
      unsigned int nbr_atomes   = params_feff.nbr_atomes,
      nbr_visibles = FEF_NOM_DERN_ATM - FEF_NOM_PREM_ATM + 1;
      
      if (params_feff.absorbeur)
	nbr_atomes++;

      nv_pos  = graf_slidebox(arbres[FEFF_PAR_STRUCT].adresse, FEF_ATM_FND, FEF_ATM_BOUTON, 1); /* Position en pour-mille - vertical */
      nv_pos *= nbr_atomes - nbr_visibles;
      nv_pos /= 1000;

      infos->prem_atome = (int) nv_pos;
      if (params_feff.absorbeur)
	infos->prem_atome--;

      FATM_init_defil(infos);
    }
    break;
    
  case FEF_ATM_APRES: /* On clique sur la flche vers le bas */
    infos->prem_atome++;
    FATM_init_defil(infos);
    break;
  }

  return PAS_PROBLEME;
}

/* ------------------- Gestion du dfileur des couches de rflexion simple --------- *
 *                                                                                   *
 *************************************************************************************/

/* ------------------- Initialisation de ce dfileur --------------------------------\
 |  Renvoie PAS_PROBLEME si pas d'erreur                                             |
 |  Le dfileur accepte jusqu' 14 caractres
 |                                                                                   |
 | infos : les infos FEFF : mises  jour pour ce qui concerne ce dfileur            |
 \---------------------------------------------------------------------------------- */

int SS_init_defil(FEF_infos *infos)
{
	FEFF_SS *couche;
	int i;
	unsigned int nbr_ss; /* Nombre de couches */
	boolean existe;

	/* Existe-t-il des couches SS ? */
	
	existe = (params_feff.prem_ss != NULL);

	OBJ_choisit(FEFF_PAR_STRUCT, FEF_SS_OK, existe); /* Option active... */

	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_INDEX, existe); /* Affichage des coordonnes */
	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_POT, existe);
	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_DEG, existe);
	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_DIST, existe);

	OBJ_active(FEFF_PAR_STRUCT, FEF_EFF_SS,   existe); /* Oprations sur les atomes */

	if ( existe == FAUX ) /* Il n'existe pas de couche SS */
	{
		int i; /* On dsactive tout ce qui va avec */

		for (i = FEF_PREM_SS; i <= FEF_DERN_SS ; i++) /* La liste des noms */
		{
			OBJ_active (FEFF_PAR_STRUCT, i, FORCE_NON);
			OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON);
			met_chaine(FEFF_PAR_STRUCT, i, 14, "", TXT_COPIER);
		}
		infos->prem_ss    = -1;
		infos->ss_choisie =  0; /* Aucune couche slectionne */

		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_AVANT , FORCE_NON); /* Ascenseur indisponible */
		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_FOND  , FORCE_NON);
		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_BOUTON, FORCE_NON);
		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES , FORCE_NON);

		OBJ_taille(FEFF_PAR_STRUCT, FEF_SS_FOND, -1, -1, &_rien_, &i);
		OBJ_position(FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, 0, &_rien_, &_rien_);
		OBJ_taille  (FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, i, &_rien_, &_rien_);

		return PAS_PROBLEME; /* Rien d'autre  faire... */
	}

	nbr_ss = params_feff.nbr_ss; /* Nombre de couches */
	existe = (nbr_ss > FEF_DERN_SS - FEF_PREM_SS + 1); /* VRAI -> plus d'objets que de places */

	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_BOUTON, existe);
	OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES , existe);

	if ( existe ) /* Plus de couches que de place disponible */
	{
		int haut_total, index, nbr_visibles = FEF_DERN_SS - FEF_PREM_SS + 1;
		float taille_asc, pos_asc;

    /* Flche de dfilement vers le haut */

		if ( infos->prem_ss > 0 )
			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_AVANT, FORCE_OUI); /* Couches avant */
		else
			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_AVANT, FORCE_NON); /* Pas de couche avant */

	  /* Taille de l'ascenseur */

		OBJ_taille(FEFF_PAR_STRUCT, FEF_SS_FOND, -1, -1, &_rien_, &haut_total);

		taille_asc  = ( (float) nbr_visibles) / (float) nbr_ss;
		taille_asc *= haut_total;
		if (taille_asc < 5)
			taille_asc = 5; /* 5 pixels minimum, sinon illisible */

    /* Position de l'ascenseur */

		index = infos->prem_ss;

		pos_asc  = (float) index / (float) (nbr_ss - nbr_visibles);
		pos_asc *= (float) (haut_total - (int) taille_asc);
		OBJ_position(FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, (int) pos_asc, &_rien_, &_rien_);
		OBJ_taille  (FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, (int) taille_asc, &_rien_, &_rien_);	

		/* Le fond  - forcment actif */

		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_FOND, FORCE_OUI);

    /* Flche de dfilement vers le bas */

    index = infos->prem_ss + nbr_visibles;

    if (index >= nbr_ss) /* Suprieur au nombre rel d'atomes */
 			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES, FORCE_NON); /* Pas d'atome aprs */
		else
 			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES, FORCE_OUI); /* Un atome aprs */
	}
	else /* Moins d'atomes que de place disponible */
	{
		int hauteur;

		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_AVANT,  FORCE_NON); /* Pas d'atome avant */
		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_FOND ,  FORCE_NON);
		OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES,  FORCE_NON); /* Pas d'atome aprs */

		OBJ_taille(FEFF_PAR_STRUCT, FEF_SS_FOND, -1, -1, &_rien_, &hauteur);
		OBJ_position(FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, 0, &_rien_, &_rien_);
		OBJ_taille  (FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, hauteur, &_rien_, &_rien_);
	}

	/* On choisit la couche de dmarrage */

	i = 0;
	couche = params_feff.prem_ss;
	while (i < infos->prem_ss)
	{
		couche = couche->suivante;
		i++;
	}

	/* On traite les objets restants */
	
	for (i = FEF_PREM_SS ; (couche) && (i <= FEF_DERN_SS) ; couche = couche->suivante, i++ )
	{
	  char nom_couche[15];

	  sprintf(nom_couche, "Couche %d", infos->prem_ss + i - FEF_PREM_SS + 1);
	  met_chaine (FEFF_PAR_STRUCT, i, 14, nom_couche, TXT_COPIER);
	  if ( (i - FEF_PREM_SS + 1) == infos->ss_choisie)
	  {
	    OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_OUI );
	    met_valeur (FEFF_PAR_STRUCT, FEF_SS_INDEX, couche->index);
	    met_valeur (FEFF_PAR_STRUCT, FEF_SS_POT  , couche->potentiel);
	    met_valeur (FEFF_PAR_STRUCT, FEF_SS_DEG  , couche->degenerescence);
	    met_fvaleur(FEFF_PAR_STRUCT, FEF_SS_DIST , couche->distance);
	  }
	  else
	    OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON );
		
	  OBJ_active(FEFF_PAR_STRUCT, i, FORCE_OUI);
	}
	for ( ; i <= FEF_DERN_SS ; i++) /* Au cas o il y a moins de couches que d'objets */
	{
		met_chaine(FEFF_PAR_STRUCT, i, 14, " ", TXT_COPIER);
		OBJ_choisit(FEFF_PAR_STRUCT, i, FORCE_NON);
		OBJ_active(FEFF_PAR_STRUCT, i, FORCE_NON);			
	}

	return PAS_PROBLEME;
}

/* ------------------- Gestion de ce dfileur ---------------------------------------\
 |  Renvoie PAS_PROBLEME si tout va bien
 |
 | infos     : les infos FEFF : mises  jour pour ce qui concerne ce dfileur        |
 | num_objet : l'objet sur lequel on a cliqu -> il faut le grer...                 |
 | x, y      : coordonnes de la souris au moment du clic                            |
 \---------------------------------------------------------------------------------- */

int SS_gere_defil(FEF_infos *infos, int num_objet, int x, int y)
{
	/* Cas le plus simple : clic sur un atome de la liste */

	if ( (num_objet >= FEF_PREM_SS) && (num_objet <= FEF_DERN_SS) )
	{
		FEFF_SS *couche;
		int index_couche, nv_index, i = 0;

		/* On commence par sauver les paramtres de l'ancien atome choisi */

		index_couche = infos->prem_ss + (infos->ss_choisie - 1);

		couche = params_feff.prem_ss;
		while (i < index_couche)
		{
			couche = couche->suivante;
			i++;
		}

		couche->potentiel      = prend_valeur (FEFF_PAR_STRUCT, FEF_SS_POT);  /* Potentiel de la couche */
		couche->degenerescence = prend_valeur (FEFF_PAR_STRUCT, FEF_SS_DEG);  /* Dgnrescence de la couche */
		couche->distance       = prend_fvaleur(FEFF_PAR_STRUCT, FEF_SS_DIST); /* Distance de la couche  l'absorbeur */

		nv_index = prend_valeur(FEFF_PAR_STRUCT, FEF_SS_INDEX); /* Nouvel index de la couche */
		if ( nv_index != couche->index ) /* On change l'index de couche */
		{
		  FEFF_SS *autre = params_feff.prem_ss;

		  while (autre)
		  {
		    if ( (autre != couche) && (autre->index == nv_index) )
		    {
		      FEFF_ERREUR(FSS_EXISTE_DEJA, nv_index);
		      nv_index = -1;
		    }
		    autre = autre->suivante;
		  }
		}
		if (nv_index >= 0) /* Index plausible */
		{
		  couche->index = nv_index;
		}

		/* Maintenant, on dfini la nouvelle couche comme slectionne */

		infos->ss_choisie = (num_objet - FEF_PREM_SS) + 1;

		SS_init_defil(infos); /* On refait le slecteur */

		return PAS_PROBLEME; /* On a fini, tout va bien */
	}

	switch (num_objet)
	{
	case FEF_SS_AVANT: /* On clique sur la flche vers le haut */
		if ( (infos->prem_ss < 0) ) return -1;

		if ( infos->prem_ss == 0 )
		{
			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_AVANT, FORCE_NON);
			OBJ_active(FEFF_PAR_STRUCT, FEF_SS_APRES, FORCE_OUI);
			return -2; /* Bizarre quand mme */
		}

		infos->prem_ss--; /* Mais atome slectionn reste au mme endroit... */
		SS_init_defil(infos);
		break;

	case FEF_SS_FOND:   /* On clique sur le fond -> +/-10 couches */
		{
			int x_fnd, y_fnd;

			objc_offset(arbres[FEFF_PAR_STRUCT].adresse, FEF_SS_FOND, &x_fnd, &y_fnd);
			x -= x_fnd;
			y -= y_fnd; /* Coordonnes relatives  l'objet */

			if (y < 0) return -1; /* Problme... */

			OBJ_position(FEFF_PAR_STRUCT, FEF_SS_BOUTON, -1, -1, &x_fnd, &y_fnd);
			if (y <= y_fnd) /* On a cliqu avant le bouton */
			{
				infos->prem_ss -= 10;
				if (infos->prem_ss < 0)
				{
					infos->prem_ss = 0;
				}
			}
			else /* On a cliqu aprs le bouton */
			{
				int nbr_visibles = FEF_DERN_SS - FEF_PREM_SS + 1;
				unsigned int nbr_couches = params_feff.nbr_ss;

				infos->prem_ss += 10;
				if (infos->prem_ss + nbr_visibles > nbr_couches)
				{
					infos->prem_ss = nbr_couches - nbr_visibles;
				}
			}

			SS_init_defil(infos);
		}
		break;

	case FEF_SS_BOUTON: /* Clic sur le poussoir */
	  {
	  	float nv_pos;
	  	unsigned int nbr_ss   = params_feff.nbr_ss,
	  	             nbr_visibles = FEF_DERN_SS - FEF_PREM_SS + 1;

	  	nv_pos  = graf_slidebox(arbres[FEFF_PAR_STRUCT].adresse, FEF_SS_FOND, FEF_SS_BOUTON, 1); /* Position en pour-mille - vertical */
			nv_pos *= nbr_ss - nbr_visibles;
			nv_pos /= 1000;

			infos->prem_ss = (int) nv_pos;

			SS_init_defil(infos);
	  }
	  break;

  case FEF_SS_APRES: /* On clique sur la flche vers le bas */
  	infos->prem_ss++;
  	SS_init_defil(infos);
  	break;
	}

	return PAS_PROBLEME;
}
