/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
				   Gestion des objets ncessaires aux descriptions structurales
				       pour le paramtrage de FEFF [dclarations]
   (c) Emmanuel CURIS 1996 - 1998

 16 janvier 1998
   * Dclaration de SS_nouvelle()

  9 janvier 1998
   * Cration du fichier
   * Dclaration de FATM_creer()
   *                FATM_effacer()
*/

#ifndef _FEFF_STRUCT_H_

#define _FEFF_STRUCT_H_ 

#ifndef __INC_FEFF_ /* Fichier feff.h non inclus */

#include "FEFF.H"

#endif

typedef struct /* infos ncessaires  cela */
{
  int prem_atome; /* -1 = atome absorbeur, 0 = premier de la liste ,-2 = aucun */
  int atm_choisi; /* Atome slectionn dans le dfileur   */
  int prem_ss;    /* Premire couche de rflexion simple  */
  int ss_choisie; /* Couche slectionne dans le dfileur */
  int prem_ovl;   /* Premieres infos de recouvrement      */
  int ovl_choisi; /* Recouvrement choisi dans le dfileur */
  int ovl_etudie; /* Le potentiel pour lequel on tudie le recouvrement */
} FEF_infos;

/* --------------- Structures de recouvrement (OVERLAP) - - - - - - - - - - - - - */

FEFF_OVERLAP *OVL_creer  (int potentiel, int pot_recouvre, int nbr_atomes, float distance);
boolean       OVL_effacer(FEFF_OVERLAP *param, boolean forcer);

/* --------------- Structures de rflexion simple (SS) - - - - - - - - - - - - -  */

FEFF_SS *SS_creer  (int index, int potentiel, int degenerescence, float distance);
boolean  SS_effacer(FEFF_SS *couche, boolean forcer);

void SS_nouvelle(void); /* Interface pour la cration de la nouvelle couche */

/* --------------- Atomes FEFF (ATOMS) - - - - - - - - - - - - - - - - - - - - -  */

FEFF_atome *FATM_creer  (Atome *atome, int potentiel, char *nom);
boolean     FATM_effacer(FEFF_atome *atome, boolean forcer);

#endif /* _FEFF_STRUCT_H_ */
