/* LASE - Logiciel d'analyse des spectres EXAFS
   (C) 1998, Emmanuel CURIS - Cration du fichier le 27 juin 1998

   Shell pour le programme xanes, de calcul thorique du xanes  partir de feff
   (xanes : programme en fortran de Bruce Raven)
*/

#include <stdio.h>
#include <stdlib.h>

#include <SYSTEME.H>

#include <EXAFS.H>
#include <FEFF.H>

/* ****** Fonctions locales de de fichier ******** */

static boolean gere_arbre_feff(int objet, int x_souris, int y_souris);

/* ****** Dclaration des fonctions diverses ***** */

/* ~~~~~~ Rglage des paramtres de FEFF spcifiques de la version pour xanes ~~~~~~ */

/* ------ Fonction d'appel : installe et relit les valeurs des paramtres ---------- */

void xanes_feff(void)
{
  int i;

  OBJ_choisit(FEFF_MODIFIE_XAN, FXAN_ACTIF, params_feff.Utiliser_Xanes);
  OBJ_active (FEFF_MODIFIE_XAN, FXAN_XANES, params_feff.XANES >= 0 );
  met_valeur (FEFF_MODIFIE_XAN, FXAN_XANES, params_feff.XANES);
  met_valeur (FEFF_MODIFIE_XAN, FXAN_VINTFIX, params_feff.VINTFIX);
  met_valeur (FEFF_MODIFIE_XAN, EGRID_NBR_PTS, params_feff.EGRID.nombre);
  gere_ascenseur(FEFF_MODIFIE_XAN, EGRID_MOINS, 0, 5, 1, FAUX, ROOT, 0, 0);
  for (i = 0 ; i < 5 ; i++)
  {
    met_fvaleur(FEFF_MODIFIE_XAN, EGRID_POINT_1 + i, params_feff.EGRID.position[i]);
    OBJ_active(FEFF_MODIFIE_XAN, EGRID_POINT_1 + i, params_feff.EGRID.nombre > i);
    met_fvaleur(FEFF_MODIFIE_XAN, EMESH_POINT_1 + i, params_feff.EGRID.delta_x[i]);
    OBJ_active(FEFF_MODIFIE_XAN, EMESH_POINT_1 + i, params_feff.EGRID.nombre > i);
  }

  arbres[FEFF_MODIFIE_XAN].fonction.arbre = gere_arbre_feff;

  if ( ext_formdo(FEFF_MODIFIE_XAN) == FXAN_ANNULE )
    return; /* On annule les modifications */

  params_feff.Utiliser_Xanes = OBJ_choisit(FEFF_MODIFIE_XAN, FXAN_ACTIF, QUESTION);
  if (params_feff.XANES >= 0)
    params_feff.XANES = prend_valeur(FEFF_MODIFIE_XAN, FXAN_XANES);
  params_feff.VINTFIX = prend_valeur(FEFF_MODIFIE_XAN, FXAN_VINTFIX);

  params_feff.EGRID.nombre = prend_valeur (FEFF_MODIFIE_XAN, EGRID_NBR_PTS);
  for (i = 0 ; i < 5 ; i++)
  {
    params_feff.EGRID.position[i] = prend_fvaleur(FEFF_MODIFIE_XAN, EGRID_POINT_1 + i);
    params_feff.EGRID.delta_x[i]  = prend_fvaleur(FEFF_MODIFIE_XAN, EMESH_POINT_1 + i);
  }
}

/* ------ Fonction de gestion de l'arbre associ (adaptation "temps rel") --------- */

static boolean gere_arbre_feff(int objet, int x_souris, int y_souris)
{
  switch (objet)
  {
  case FXAN_OK:
  case FXAN_ANNULE:
    return -objet; /* Pour tre sr de bien sortir mme si clavier... */

  case EGRID_MOINS: /* Ascenseur : nombre de points pour EGRID */
  case EGRID_FOND:
  case EGRID_NBR_PTS:
  case EGRID_PLUS:
    {
      int ancien = prend_valeur(FEFF_MODIFIE_XAN, EGRID_NBR_PTS);
      int nouveau = gere_ascenseur(FEFF_MODIFIE_XAN, EGRID_MOINS, 0, 5, 1,
				   FAUX, objet, x_souris, y_souris);

      if (nouveau != ancien)
      {
	int i;
	for (i = 0 ; i < 5 ; i++)
	{
	  OBJ_active(FEFF_MODIFIE_XAN, EGRID_POINT_1 + i, nouveau > i);
	  OBJ_active(FEFF_MODIFIE_XAN, EMESH_POINT_1 + i, nouveau > i);
	}
      }
    }
    return VRAI;

  default:
    OBJ_choisit(FEFF_MODIFIE_XAN, objet, ECHANGE);
    return VRAI;
  }
}


