/* Traitement de l'E.X.A.F.S. sur Atari
                  Tout ce qui concerne le chargement/la sauvegarde de fichiers rutilisables
   (c) 1996  1998 - Emmanuel CURIS

  19 avril 1998
    * Fins de lignes PC ne passaient plus dans fichiers ASCII -> corrig

  13 avril 1998
    * Trouv comment lire les fichiers MAC : il faut fopen(..., "rb") -> fins de ligne pas sautes
    * Chargement de fichiers, format interne : utilise fread() -> portable; il faut fopen(..., "rb")
    * Sauvegarde de fichiers, format interne : utilise fwrite(), mme chose...

  10 - 13, 16, 18, 23 & 24, 26 mars 1998
    * Remplac tous les effacer_graphe() par GRF_efface()
    * Chang la faon de faire l'en-tte EMC\233 : devrait compiler avec GCC (esprons...)
    * Chang la faon de faire la moyenne des I en cas d'absorption : log ( I0 / [I1 + ... In] ) - merci Bruno...
    * Utilis "systeme.h" au dbut -> plus portable...
    * Modifi ELEM_somme() : logique plus facile  comprendre
    * Import ASCII fonctionne (dans toutes ses options normalement)
    * Changer les fichiers  inclure en majuscules : devrait tourner sous unix...
    * Inclus "erreurs.h" pour l'exafs
    * Corrig ligne_l3/multilment : sparait les graphes au lieu de moyenner
    * Titres plus adapts dans DCI_somme() en cas de somme ou de moyenne
    * Possibilit de choisir la faon de moyenner les spectres, en absorption
    * Rorganis l'appel de l'extraction : squelette pour l'analyse de fichier
                                           type de ligne test une seule fois
    * Modifi les DCI_??? : ne ferment pas le fichier -> appels successifs possibles
    * Supprim LII_separer() : remplace par DCI_separe() et autres
               LII_mono()    : plus utilise, car identique  DCI_separe pour 1 lment
               L13_somme()   : remplace par DCI_somme, plus puissante...
    * Somme des lments d'un fichier, nouvelle version : devrait tourner pour LII et LI/III
    * Utilisation possible de deux chambres d'ionisation successives
    * Tri des spectres lors du chargement fonctionne

   5 & 6, 9 & 10 fvrier 1998
    * L13_separe utilise ELEM_separe() -> plus joli et charge I0, I1 et le signal correctement !
    * Renomm L13_separe en DCI_separe [commun  EXAFS II et XIII]
    * Utilisable sur une ligne EXAFS II -> davantage de fichiers chargeables !
    * Ralisation de ELEM_separe()
    * limination des creer_graphe dans L13_mono()
    * L13_mono() utilise ELEM_separe() -> plus lisible
    * Renomm L13_mono en DCI_mono : commun  EXAFS II et XIII, puisque format de fichier semblable !
    * Inclusion de fichiers.h
    * Commenc l'criture de l'historique lors de la sauvegarde

   6 & 7, 19 & 20 janvier 1998
    * Ajout plusieurs extensions pour l'extraction : *.DAT, *.FLU, *.XAN et combinaisons
    * Utilisation de plusieurs extensions avec Selectric : au chargement des fichiers...
    * Corrig le titre du slecteur de fichier lors du chargement d'un fichier, format interne
    * Ajout inclusion de ERREURS.H
    * Dplac les fonctions d'export d'image dans export.c

  22.11 ; (2, 15).12.1997
    * Remplac Fcreate(, 1) par Fcreate(, 0) : fichier non protg en criture -> devrait tourner sous MagiCMac maintenant.
    * Procdure de chargement : renvoi toujours NULL en cas d'erreur
    * VERSION 1.1 - Format de fichier interne modifi, sauve maintenant plus de choses...
    * Remplac quelques effacer_graphe() par GRF_efface()
    * Cration de cet historique
    * Conversion char -> int dans fef_xmu : pas d'avertissement de GCC
    * Conversion \233 ->  (code 233 en octal...) -  oblig pour compatibilit avec les anciens fichiers
	          vite une bte erreur de compilation avec le GCC
*/

#define _FICHIERS_ 

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SYSTEME.H"

#include "EXAFS.H"
#include "GRAPHES.H"

#include "ERREURS.H"
#include "FICHIERS.H"
#include "FOURIER.H" /* Pour sauvegarde de TF_infos */

static FILE *fichier; /* Sert partout, alors... - mais seulement dans ce module */

/* ------------------ Chargement d'un graphe (format interne) ----------------- *
 ********************************************************************************/

struct 
{
  unsigned long marque;     /* Est cense valoir EMC\233 */
  int           version;    /* Numro de version */
  unsigned long nbr_points; /* Dans le graphe */
  int           type;       /* Type du graphe */
  unsigned long lg_titre;   /* Longueur du titre */
} en_tete;

Graphe *charger(char *nom) /* On charge un graphe */
{
  char **liste_noms,
        *extensions[] = { "*.EXP", "*.TF", "*.EXF", "*.BRT", "*.MU0", "*.AMP", "*.PHA", "*.SAV" };
  Graphe *charge;
  int nbr_fichier,index;

  if (nom == NULL) /* L'utilisateur va choisir le spectre */
  {

#ifdef _FRANCAIS_
    liste_noms = CH_selecteur("*.*", "Fichier "a_GRAVE" charger", 8, &extensions, &nbr_fichier);
#endif
#ifdef _ENGLISH_
    liste_noms = CH_selecteur("*.*", "File to load", 8, &extensions, &nbr_fichier);
#endif

    if (liste_noms == NULL) return NULL; /* Aucun fichier  traiter */
  }
  else /* Chargement automatique... */
  {
    nbr_fichier = 1;
    liste_noms = (char **) malloc( sizeof(char *) );
    liste_noms[0] = (char *) malloc( strlen(nom) * sizeof(char) );
    strcpy(liste_noms[0],nom);
  }

  for (index = 0 ; index < nbr_fichier ; index++)
  {
    sprintf(_intermediaire,"%s%s%c",nom_fichier,liste_noms[index],0);
    charge = ch_interne(_intermediaire);
    if (charge)
    {
      graphe_courant = charge;
    }
    free(liste_noms[index]);
  }
  free(liste_noms);

  /* On fait afficher ce graphe */

  if (graphe_courant) /* Il y a un graphe actif */
  {
    GRF_aller( graphe_courant );
  }

  return charge; /* Adresse du spectre charg */
}

Graphe *ch_interne(char *nom)
{
  Graphe *charge;
  FILE *fichier;

  fichier = fopen(nom, "rb"); /* Chargement en binaire, pour voir */
  if (fichier == NULL)
  {
    ERREUR(ERREUR_LECTURE);
    return NULL;
  }
		
  fread(&en_tete, sizeof(en_tete), 1, fichier);

  if ( en_tete.marque != 0x454D439BL ) /* EMC\233 */
  {
    ERREUR(FORMAT_INCONNU);
    fclose(fichier);
    return NULL;
  }

  if (en_tete.version < 10) /* Premire version utilisable du programme */
  {
    form_alert(1,"[1][ Num"e_AIGU"ro de version ill"e_AIGU"gal | chargement annul"e_AIGU" ][ Aaargh! ]");
    fclose(fichier);
    return NULL;
  }
  else if (en_tete.version > VERSION)
  {
    ERREUR(TROP_VIEUX);
    fclose(fichier);
    return NULL;
  }

  if (en_tete.version == 10) /* Premire version du programme : tout n'est pas sauv */
  {
    char *titre;
    int type = GR_NORMAL;

    if ( en_tete.type == GR_TF )
      type = GR_IM_MOD; /* Seul cas de spectre complexe possible... */

    titre = (char *) malloc( sizeof(char) * ( en_tete.lg_titre + 1) );
    if ( titre == NULL )
    {
      ERREUR(MANQUE_MEMOIRE);
      return NULL;
    }
    fread(titre, sizeof(char), en_tete.lg_titre, fichier);

    titre[en_tete.lg_titre] = 0;     /* Fin de chane pas sauve... */

#ifdef _FRANCAIS_
    charge = GRF_creer(en_tete.nbr_points, en_tete.type, type, titre,
		       "Sans l"e_AIGU"gende", "Sans l"e_AIGU"gende", SS_UNITE, SS_UNITE);
#endif
#ifdef _ENGLISH_
    charge = GRF_creer(en_tete.nbr_points, en_tete.type, type, titre,
		       "No legend", "No legend", SS_UNITE, SS_UNITE);
#endif

    free(titre); /* Plus besoin de lui */
    if (charge == NULL)
    {	
      fclose(fichier);
      return NULL;
    }

    fread( &(charge->x_min), sizeof(double), 1, fichier);
    fread( &(charge->x_max), sizeof(double), 1, fichier);
    fread( &(charge->y_min), sizeof(double), 1, fichier);
    fread( &(charge->y_max), sizeof(double), 1, fichier);

    fread(charge->x, sizeof(double), en_tete.nbr_points, fichier);
    if ( en_tete.type == GR_TF )
      fread(charge->y, sizeof(Complexe), en_tete.nbr_points, fichier);
    else
      fread(charge->y, sizeof(double), en_tete.nbr_points, fichier);
  }
  else if (en_tete.version >= 11)/* Nouvelles versions : contiennent plus d'informations... */
  {
    unsigned long lng_chaine;
    char *titre, *leg_x, *leg_y;
    int type, unit_x, unit_y;

    fread( &type, sizeof(int), 1, fichier);

    titre = (char *) malloc( sizeof(char) * ( en_tete.lg_titre + 1) );
    if ( titre == NULL )
    {
      ERREUR(MANQUE_MEMOIRE);
      return NULL;
    }
    fread(titre, sizeof(char), en_tete.lg_titre, fichier);
    titre[en_tete.lg_titre] = 0;     /* Fin de chane pas sauve... */
    
    fread( &lng_chaine, sizeof(unsigned long), 1, fichier);
    leg_x = (char *) malloc( sizeof(char) * ( lng_chaine + 1) );
    if ( leg_x == NULL )
    {
      ERREUR(MANQUE_MEMOIRE);
      free(titre);
      return NULL;
    }
    fread( leg_x, sizeof(char), lng_chaine, fichier);
    leg_x[lng_chaine] = 0;                 /* Fin de chane pas sauve...      */
		
    fread( &unit_x, sizeof(int), 1, fichier);

    fread( &lng_chaine, sizeof(unsigned long), 1, fichier);
    leg_y = (char *) malloc( sizeof(char) * ( lng_chaine + 1) );
    if ( leg_y == NULL )
    {
      ERREUR(MANQUE_MEMOIRE);
      free(titre); free(leg_x);
      return NULL;
    }
    fread( leg_y, sizeof(char), lng_chaine, fichier);

    fread( &unit_y, sizeof(int), 1, fichier);

    charge = GRF_creer(en_tete.nbr_points, en_tete.type, type, titre, leg_x, leg_y, unit_x, unit_y);
    free(titre); free(leg_x); free(leg_y); /* Plus besoin d'eux */
    if (charge == NULL)
    {	
      fclose(fichier);
      return NULL;
    }

    fread( &(charge->x_min), sizeof(double), 1, fichier); /* Bornes */
    fread( &(charge->x_max), sizeof(double), 1, fichier);
    fread( &(charge->y_min), sizeof(double), 1, fichier);
    fread( &(charge->y_max), sizeof(double), 1, fichier);

    fread(charge->x, sizeof(double), en_tete.nbr_points, fichier); /* Donnes */
    if ( charge->drapeaux.complexe ) /* Graphe complexe */
      fread(charge->y, sizeof(Complexe), en_tete.nbr_points, fichier);
    else
      fread(charge->y, sizeof(double), en_tete.nbr_points, fichier);

    fread( &(charge->style  ), sizeof(int), 1,  fichier); /* Paramtres de dessin */
    fread( &(charge->couleur), sizeof(int), 1,  fichier);

    if ( en_tete.type == GR_TF ) /* Une transforme de Fourier : infos complmentaires ? */
    {
      boolean infos_tf;

      fread(&infos_tf, sizeof(boolean), 1, fichier);

      if (infos_tf == VRAI) /* Oui : infos de fentrage... */
      {
	TF_infos *infos = (TF_infos *) malloc( sizeof(TF_infos) );
	if (infos)
	{
	  fread( &(infos->k_min), sizeof(double), 1, fichier);
	  fread( &(infos->k_max), sizeof(double), 1, fichier);
	  fread( &(infos->param_fenetre), sizeof(double), 1, fichier);
	  fread( &(infos->type_fenetre ), sizeof(double), 1, fichier);
	  fread( &(infos->degre), sizeof(double), 1, fichier);

	  infos->amplitude = NULL; /* Tout ceci n'a pas d'intrt */
	  infos->phase     = NULL;
	  infos->graphe    = NULL;
	  infos->fenetre   = NULL;
	  charge->pointeur = (void *) infos;

	  if ( en_tete.version >= 12 ) /* Les paramtres symtrique et k1/k2 sont sauvs */
	  {
	    fread( &(infos->k_1)       , sizeof(double) , 1, fichier);
	    fread( &(infos->k_2)       , sizeof(double) , 1, fichier);
	    fread( &(infos->symetrique), sizeof(boolean), 1, fichier);
	  }
	  else /* Ces infos n'ont pas t sauves -> on en dfinit au hasard */
	  {
	    infos->k_1 = infos->k_min + 1;
	    infos->k_2 = infos->k_max - 1;
	    infos->symetrique = VRAI;
	  }
	}
	else
	{
	  ERREUR(MANQUE_MEMOIRE);
	}
      }
    }
  }

  fclose(fichier);

  charge->drapeaux.sauve = VRAI; /* On vient de le charger => pas t modifi */

  return charge;
}

/* ------------------ Sauvegarde d'un graphe (format interne) ----------------- *
 ********************************************************************************/

boolean sauver(Graphe *graphe) /* On sauve le graphe */
{
  char masque[7] = {0, 0, 0, 0, 0, 0, 0};
  FILE *fichier;
  int divers;
  unsigned long lng_chaine;
  char *nom_fichier;

  if (graphe->type >= 0)
    sprintf(masque, "*.%s", extensions[graphe->type]);
  else
    sprintf(masque, "*.*");

#ifdef _FRANCAIS_
  nom_fichier = SV_selecteur(masque, "Sauver le spectre");
#endif
#ifdef _ENGLISH_
  nom_fichier = SV_selecteur(masque, "Save the current spectrum");
#endif
  if (nom_fichier == NULL)
    return FAUX; /* On n'a pas pu sauver */

  fichier = fopen(nom_fichier, "wb");
  if (fichier == NULL)
  {
    ERREUR(ERREUR_ECRITURE);
    free(nom_fichier);
    return FAUX;
  }

  if (Histoire)
  {
    fprintf(Histoire, "Graphe %s sauv"e_AIGU" sous le nom %s\n", graphe->nom, nom_fichier);
  }
  free(nom_fichier);

  /* En-tte du fichier */
  en_tete.marque     = 0x454D439BL; /* EMC\233 */
  en_tete.version    = VERSION;   /* Numro de version */
  en_tete.nbr_points = graphe->nombre_point;
  en_tete.type       = graphe->type;
  en_tete.lg_titre   = strlen(graphe->nom); /* Longueur du titre */

  fwrite( &en_tete, sizeof(en_tete), 1, fichier);

  divers = (int) graphe->drapeaux.complexe;
  fwrite(&divers, sizeof(int), 1, fichier);

  fwrite(graphe->nom, sizeof(char), en_tete.lg_titre, fichier);

  lng_chaine = strlen(graphe->axe_x);                    /* Lgende, axe des X */
  fwrite(&lng_chaine, sizeof(unsigned long), 1, fichier);
  fwrite(graphe->axe_x, sizeof(char), lng_chaine, fichier);
  fwrite( &(graphe->unit_x), sizeof(int), 1, fichier);

  lng_chaine = strlen(graphe->axe_y);                    /* Lgende, axe des Y */
  fwrite(&lng_chaine, sizeof(unsigned long), 1, fichier);
  fwrite(graphe->axe_y, sizeof(char), lng_chaine, fichier);
  fwrite( &(graphe->unit_y), sizeof(int), 1, fichier);

  fwrite( &(graphe->x_min), sizeof(double), 1, fichier); /* Bornes */
  fwrite( &(graphe->x_max), sizeof(double), 1, fichier);
  fwrite( &(graphe->y_min), sizeof(double), 1, fichier);
  fwrite( &(graphe->y_max), sizeof(double), 1, fichier);

  fwrite(graphe->x, sizeof(double), en_tete.nbr_points, fichier);
  if ( graphe->drapeaux.complexe == GR_NORMAL )
    fwrite(graphe->y, sizeof(double), en_tete.nbr_points, fichier);
  else
    fwrite(graphe->y, sizeof(Complexe), en_tete.nbr_points, fichier);

  fwrite( &(graphe->style  ), sizeof(int), 1, fichier);
  fwrite( &(graphe->couleur), sizeof(int), 1, fichier);
  
  if ( en_tete.type == GR_TF ) /* Une transforme de Fourier : infos complmentaires ? */
  {
    boolean infos_tf = ( graphe->pointeur != 0 ) ;

    fwrite(&infos_tf, sizeof(boolean), 1, fichier);

    if (infos_tf == VRAI) /* Oui : infos de fentrage... */
    {
      TF_infos *infos = (TF_infos *) (graphe->pointeur);

      fwrite( &(infos->k_min)        , sizeof(double) , 1, fichier);
      fwrite( &(infos->k_max)        , sizeof(double) , 1, fichier);
      fwrite( &(infos->param_fenetre), sizeof(double) , 1, fichier);
      fwrite( &(infos->type_fenetre) , sizeof(double) , 1, fichier);
      fwrite( &(infos->degre)        , sizeof(double) , 1, fichier);
      fwrite( &(infos->k_1)          , sizeof(double) , 1, fichier);
      fwrite( &(infos->k_2)          , sizeof(double) , 1, fichier);
      fwrite( &(infos->symetrique)   , sizeof(boolean), 1, fichier);
    }
  }

  fclose(fichier);

  graphe->drapeaux.sauve = VRAI; /* On a sauv le graphe */
  return VRAI; /* Sauvegarde a russi */
}

/* ------------------ Conversion des fichiers exprimentaux en fichiers A=f(E) -*
 ********************************************************************************/

/* ~~~~~~~~~~~~~~~~~~ Routines gnrales ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ------------------ Paramtrages et appel des routines adquates ------------ */
 
void extraire(void)
{
  int index, nbr_fichier = 0, ligne;
  boolean redessin; /* VRAI si on doit redessiner                   */
  char **noms,             /* Les adresses des noms des fichiers  charger */
    *extensions[] = { "*.FLU", "*.DAT", "*.XAN", "*.FLU, *.XAN", "*.FLU, *.DAT", "*.DAT, *.XAN" };
  char nm_fichier[300];    /* Le nom total                                 */
  char masque[12] = "*.DAT,*.XAN";
  MOD_extrait type;        /* Le type de fichier que l'on va traiter       */

  do
  {
    index = ext_formdo(TYPE_LIGNE);
    if (index == EXTRAIT_ANNULER)
      return;

    if (index == EXTRAIT_ANALYSE) /* On demande d'analyser un fichier */
    {
    }
  } while (index != EXTRAIT_OK);

  /* Paramtres d'extraction */

  type.fluoresce      = OBJ_choisit(TYPE_LIGNE, FLUORESCENCE, QUESTION);   /* VRAI : fluorescence */
  type.deux_chambres  = OBJ_choisit(TYPE_LIGNE, LGN_2_CHAMBRES, QUESTION); /* VRAI : enregistrement avec chambres I1 et I2 */
  type.multi_spectres = OBJ_choisit(TYPE_LIGNE, MULTI_SPECTRES, QUESTION); /* VRAI : plusieurs spectres  la suite */
  if ( type.multi_spectres ) /* Comment les traiter */
  {
    type.ajouter_spectres  = OBJ_choisit(TYPE_LIGNE, MSPR_SOMME    , QUESTION);
    type.moyenner_spectres = OBJ_choisit(TYPE_LIGNE, MSPR_MOYENNE  , QUESTION);
    type.fondre_spectres   = OBJ_choisit(TYPE_LIGNE, MSPR_FUSION   , QUESTION);
    type.spr_sigma_log     = OBJ_choisit(TYPE_LIGNE, MSPR_SIGMA_LOG, QUESTION);
  }
  type.multi_elements = OBJ_choisit(TYPE_LIGNE, MULTI_ELEMENTS, QUESTION); /* VRAI si plusieurs lments */
  if ( type.multi_elements ) /* Comment les traiter */
  {
    type.ajouter_elements  = OBJ_choisit(TYPE_LIGNE, MULTI_ELEM_SOMME, QUESTION);
    type.moyenner_elements = OBJ_choisit(TYPE_LIGNE, MULTI_ELEM_MOYEN, QUESTION);
    type.elm_sigma_log     = OBJ_choisit(TYPE_LIGNE, MELM_SIGMA_LOG  , QUESTION);
  }
  type.garde_i0     = OBJ_choisit(TYPE_LIGNE, LGN_GARDE_I0    , QUESTION); /* VRAI : garder I0 */
  type.garde_i1     = OBJ_choisit(TYPE_LIGNE, LGN_GARDE_I1    , QUESTION); /* VRAI : garder I1 */
  type.garde_i2     = OBJ_choisit(TYPE_LIGNE, LGN_GARDE_I2    , QUESTION); /* VRAI : garder I2 */
  type.garde_signal = OBJ_choisit(TYPE_LIGNE, LIG_GARDE_SIGNAL, QUESTION); /* VRAI : garder le signal */
  type.doublons     = OBJ_choisit(TYPE_LIGNE, EXTRAIT_DOUBLONS, QUESTION); /* VRAI : liminer les doublons  */
  type.tri          = OBJ_choisit(TYPE_LIGNE, EXTRAIT_TRIER   , QUESTION); /* VRAI : trier au chargement    */

  if ( OBJ_choisit(TYPE_LIGNE, LURE_1, QUESTION) ) /* Ligne EXAFS I / III / 13 - DCI */
    ligne = LURE_1;
  else if ( OBJ_choisit(TYPE_LIGNE, LURE_2, QUESTION) ) /* Ligne EXAFS II */
    ligne = LURE_2;

  if ( ligne != LURE_1 ) /* Autre ligne -> pas de fichier *.XAN */
    masque[5] = 0;

  if ( type.fluoresce ) /* Fichiers de fluorescence */
  {
    masque[2] = 'F';
    masque[3] = 'L';
    masque[4] = 'U';
  }

#ifdef _FRANCAIS_
  noms = CH_selecteur(masque, "Fichier exp"e_AIGU"rimental "a_GRAVE" traiter",
		      6, &extensions, &nbr_fichier);
#endif
#ifdef _ENGLISH_
  noms = CH_selecteur(masque,"Exprimental file to load", 6, &extensions, &nbr_fichier);
#endif
  if (noms == NULL) return; /* Aucun fichier  traiter */

	if ( Histoire ) /* Paramtres gnraux de l'extraction */
	{
		fprintf(Histoire, "\n --- Rcupration d'un spectre exprimental\n");
		if ( ligne == LURE_2 )
			fprintf(Histoire, "   Ligne    : type EXAFS  2 (logiciel de Robert Cortes)\n");
		else if ( ligne == LURE_1 )
			fprintf(Histoire, "   Ligne    : type EXAFS 13 (logiciel Acquvisu)\n");
		if (type.fluoresce)
			fprintf(Histoire, "   Type     : fluorescence\n");
		else
			fprintf(Histoire, "   Type     : transmission\n");
		if (type.multi_spectres)
			fprintf(Histoire, "   Format   : %d spectres  la suite dans le fichier\n", prend_valeur(TYPE_LIGNE, NOMBRE_SPECTRES) );
		else
		  fprintf(Histoire, "   Format   : un seul spectre dans le fichier\n");
		if (type.multi_elements)
		  fprintf(Histoire, "              %d lments\n", prend_valeur(TYPE_LIGNE, NOMBRE_ELEMENTS) );
		else
		  fprintf(Histoire, "              monolment\n");
		if (type.deux_chambres)
			fprintf(Histoire, "              deux chambres d'ionisation successives\n");
	}

	redessin = FAUX; /* Pas de redessin par dfaut */
	for (index = 0 ; index < nbr_fichier ; index++)
	{
		sprintf(nm_fichier, "%s%s%c", nom_fichier, noms[index], 0); /* Le nom du fichier */

		if (Histoire)
  		fprintf(Histoire, "\n   Fichier  : %s\n", nm_fichier);

		if ( ligne == LURE_1 ) /* Fichier enregistr au LURE, avec # comme commentaire */
			redessin |= ligne_l3(nm_fichier, &type);

		if ( ligne == LURE_2 ) /* Au L.U.R.E., 1 ligne d'en-tte non-indique */
			redessin |= ligne_l2(nm_fichier, &type);

		free(noms[index]); /* Plus besoin de ce nom */
	}
	free(noms);          /* Plus besoin de la liste de noms */

	if (redessin == VRAI)
	{
		FEN_redessin( principale );
		FEN_redessin( trace_fenetre );
		FEN_redessin( ARB_fenetre( &(arbres[CHOIX_GRAPHE]) ) );
	}
}

/* --------------- Fichiers pour deux chambres d'ionisation : un spectre par chambre ------\
 |     Renvoie VRAI si tout s'est bien pass, FAUX en cas d'erreur                         |
 |             les tableaux passs en paramtres remplis avec le spectre                   |
 |     Suppose que le fichier soit compos de lignes E I0 I1 I2                            |
 |                                                                                         |
 | fichier      : le fichier  lire, positionn au dbut des donnes pour ce spectre       |
 | nbr_points   : le nombre de points dans chacun des spectres                             |
 | type         : informations pour l'extraction (fluorescence ou absorption, en gros      |
 | x            : tableau qui contiendra les nergies (x) pour le spectre lu               |
 | y_1          : contient le spectre de la premire chambre d'ionisation                  |
 | y_2          : contient le spectre de la seconde chambre d'ionisation                   |
 | i_0          : contient la valeur de i_0 (commune  tous les lments)                  |
 | i_1          : contient la valeur de i_1 (premire chambre d'ionisation)                |
 | i_2          : contient la valeur de i_2 (seconde chambre d'ionisation)                 |
 \---------------------------------------------------------------------------------------- */

boolean ELEM_2chambres(FILE *fichier, unsigned long nbr_points, MOD_extrait *type,
                       double *x, double *y_1, double *y_2, double *i_0, double *i_1, double *i_2)
{
	double I0, I1, I2;        /* Les valeurs lues dans le fichier */
	unsigned long index;      /* Point en cours de lecture        */

	if ( (x == NULL) || ( (y_1 == NULL) && (y_2 == NULL) 
	                   && (i_0 == NULL) && (i_1 == NULL) && (i_2 == NULL) ) )
	{
		return FAUX; /* Rien pour enregistrer des donnes ! */
	}

	/* On lit le fichier */

	for (index = 0 ; index < nbr_points ; index++, x++)
	{
		fscanf(fichier,"%lf%lf%lf%lf", x, &I0, &I1, &I2); /* Valeurs communes  tous les spectres */

		if (i_0) /* On charge les I0 */
		{
			*i_0 = I0;
			i_0++;
		}

		if (I0 == 0) /* Valeur aberrante -> problme lors de l'enregistrement ? */
		{
			int reponse = EXF_ERREUR(ERR_I0);
			if ( (reponse == 1) || (index < 2) )/* On annule le chargement */
			{
				return FAUX; /* On annule le chargement */
			}
			else /* On saute toutes les lignes suivantes - fin du spectre mise  zro */
			{
				if ( y_1 ) /* On veut ce spectre */
				{
					*y_1 = 0; /* Indfinie --> on prend 0 pour simplifier */
					y_1++;
				}
				if ( y_2 )
				{
					*y_2 = 0; y_2++;
				}
				if ( i_1  ) /* On veut i_1 */
				{
					*i_1 = I1; i_1++;
				}
				if ( i_2  ) /* On veut i_2 */
					i_2[index] = I2;

				for ( ; index < nbr_points ; index++, x++ )
				{
					fscanf(fichier, "%lf%lf%lf%lf", x, &I0, &I1, &I2); /* Ligne suivante */
					if (i_0)
					{
						*i_0 = I0;
						i_0++;
					}

					if ( y_1 ) /* On veut ce spectre */
					{
						*y_1 = 0; /* Indfinie --> on prend 0 pour simplifier */
						y_1++;
					}
					if ( y_2 )
					{
						*y_2 = 0; y_2++;
					}
					if ( i_1  ) /* On veut i_1 */
					{
						*i_1 = I1; i_1++;
					}
					if ( i_2  ) /* On veut i_2 */
						i_2[index] = I2;
				}
				 
				return VRAI;
			}
		}

		/* On est l dans le cas normal (I0 non nul) */

		if ( y_1 ) /* On veut calculer le spectre de la chambre 1 */
		{
			if (type->fluoresce) /* On est en fluorescence */
			{
			  *y_1 = I1 / I0; y_1++;
			}
			else                 /* On est en absorbance   */
		  {
        if (I1 == 0)
			  {
 	        form_alert(1,"[2][ I1 = 0 en absorbance ! | C'est mauvais signe... | Signal arbitrairement pris nul ][ Suite ]");
				  *y_1 = 0; y_1++;
			  }
			  else
			  {
			    *y_1 = log( I0 / I1 ); /* logarithme nprien */
			    y_1++;
        }
			}
		}
			
		if ( y_2 ) /* On veut calculer le spectre de la chambre 2 */
		{
			if (type->fluoresce) /* On est en fluorescence */
			{
				if ( I1 == 0 )
				{
					form_alert(1,"[2][ I1 = 0 pour la seconde chambre ! | C'est mauvais signe... | Signal arbitrairement pris nul ][ Suite ]");
					*y_2 = 0; y_2++;						
				}
				else
				{
					*y_2 = I2 / I1; y_2++;
				}
			}
			else                 /* On est en absorbance   */
		  {
			  if ( (I2 == 0) || (I1 == 0) )
			  {
				  form_alert(1,"[2][ I1 = 0 en absorbance ! | C'est mauvais signe... | Signal arbitrairement pris nul ][ Suite ]");
				  *y_2 = 0; y_2++;
			  }
			  else
			  {
			    *y_2 = log( I1 / I2 ); /* logarithme nprien */
			    y_2++;
			  }
			}
		}

		if ( i_1  ) /* On veut garder la valeur de I1 pour cet lment */
		{
			*i_1 = I1; i_1++;
		}
		if ( i_2  ) /* On veut garder la valeur de I2 pour cet lment */
		{
			i_2[index] = I2;
		}
	}

	return VRAI; /* Chargement a eu lieu dans problme */
}

/* ------------ Exafs II : fusionner les spectres choisis en un seul --------------------------------------- */

boolean LII_fondre(char *nom, FILE *fichier, unsigned long nbr_lignes, MOD_extrait *type)
{
	OBJECT *adresse = arbres[CHOIX_SPECTRE].adresse;
	Graphe *spectre, *gr_i0, *gr_i1;
	double energie, i_0, i_1;
	register double *zone_x, *zone_y;
	unsigned int nbr_elements, tot_element;
	unsigned long nbr_pts, index; /* Nombre de points par lment */
	int retour,i,j;
	TRI_infos *infos_tri, *inf_i0, *inf_i1;   /* Infos de tri... */
	boolean reserve;

	tot_element = prend_valeur(TYPE_LIGNE, NOMBRE_SPECTRES); /* Nombre d'lments dans le fichier */
	if (tot_element == 0)
	{
		form_alert(1,"[3][ Vous avez oubli de spcifier | le nombre d'lments ! ][ Annuler ]");
		fclose(fichier);
		return FAUX;
	}

	if (nbr_lignes % tot_element)
	{
		form_alert(1,"[2][ Nombre d'lment incorrect | ou fichier tronqu ][ Annuler ]");
		fclose(fichier);
		return FAUX;
	}
	nbr_pts = (int) ( nbr_lignes / tot_element );

	for (retour = 0 ; retour < 22 ; retour++)
	{
		OB_STATE(adresse, EXTRAIT_1 + retour) &= ~SELECTED; /* Par dfaut, aucun n'est pris */
		if ( retour < tot_element )
			OB_STATE(adresse, EXTRAIT_1 + retour) &= ~DISABLED;
		else
			OB_STATE(adresse, EXTRAIT_1 + retour) |= DISABLED;
	}
	retour = ext_formdo(CHOIX_SPECTRE);
	if (retour == SOMME_ANULLE)
	{
		fclose(fichier);
		return FAUX; /* On a fini ! */
	}

	if ( OB_STATE(adresse, EXTRAIT_TOUS) & SELECTED ) /* On les garde tous */
		nbr_elements = tot_element;
	else
	{
		nbr_elements = 0; /* Nombre d'lments effectivement utiliss */
		for (i = 0 ; i < 22 ; i++)
		{
			if ( OB_STATE(adresse, 	EXTRAIT_1 + i) & SELECTED ) /* On garde l'lment */
				nbr_elements++;
		}
		if (tot_element > 22)
			nbr_elements += (tot_element - 22); /* Plus de 22 lments -> tous les ultrieurs sont gards */

		if (nbr_elements == 0)
		{
			form_alert(1,"[3][ Aucun lment slectionn ! | Il n'y a donc rien  charger. ][ Annuler ]");
			fclose(fichier);
			return FAUX;
		}
	}

	/* On rserve tout ce qu'il faut pour charger */

	spectre = creer_graphe(nbr_elements * nbr_pts, GR_BRUT); /* On cre le graphe */
	if (spectre == NULL)
	{
		fclose(fichier);
		return FAUX;
	}

	infos_tri = (TRI_infos *) malloc( sizeof(TRI_infos) * nbr_elements );
	if (infos_tri == NULL)
	{
		ERREUR(MANQUE_MEMOIRE);
		fclose(fichier);
		GRF_efface(spectre, VRAI, VRAI);
		return FAUX;
	}

	if ( type->garde_i0 )
	{
		gr_i0 = creer_graphe(nbr_elements * nbr_pts, GR_I0);
		if ( gr_i0 == NULL )
		{
			type->garde_i0 = FAUX;
		}
	}
	if ( type->garde_i0 )
	{
		inf_i0 = (TRI_infos *) malloc( sizeof(TRI_infos) * nbr_elements );
		if (inf_i0 == NULL)
		{
			ERREUR(MANQUE_MEMOIRE);
			GRF_efface(gr_i0, VRAI, VRAI);
			type->garde_i0 = FAUX;
		}
	}

	if ( type->garde_i1 )
	{
		gr_i1 = creer_graphe(nbr_elements * nbr_pts, GR_I1);
		if ( gr_i1 == NULL )
		{
			type->garde_i1 = FAUX;
		}
	}
	if ( type->garde_i1 )
	{
		inf_i1 = (TRI_infos *) malloc( sizeof(TRI_infos) * nbr_elements );
		if (inf_i1 == NULL)
		{
			ERREUR(MANQUE_MEMOIRE);
			GRF_efface(gr_i1, VRAI, VRAI);
			type->garde_i1 = FAUX;
		}
	}

	/* Lecture des graphes dans le fichier */

	j = 0; /* Index : numro rel d'lment */
	for (i = 0 ; i < tot_element ; i++)
	{
	  if (i < 22)
	  {
	    if ( ( OB_STATE(adresse, EXTRAIT_1 + i) & SELECTED )   /* On veut celui-ci seulement */
	      || ( OB_STATE(adresse, EXTRAIT_TOUS ) & SELECTED ) ) /* On les veut tous           */
	      reserve = VRAI;
	    else
	      reserve = FAUX;
	  }
	  else
	    reserve = VRAI;

	  if (reserve == VRAI)
	  {
	    infos_tri[j].xpoint_depart = (double *) malloc( (size_t) (sizeof(double) * nbr_pts ) );
	    infos_tri[j].ypoint_depart = (double *) malloc( (size_t) (sizeof(double) * nbr_pts ) );

	    if ( (infos_tri[j].xpoint_depart == NULL) || (infos_tri[j].ypoint_depart == NULL) )
	    {
	      ERREUR(MANQUE_MEMOIRE);
	      for (i = 0 ; i <= j ; i++)
	      {
		free(infos_tri[i].xpoint_depart);
		free(infos_tri[i].ypoint_depart);
	      }
	      free(infos_tri);
	      if (type->garde_i0) free(inf_i0);
	      if (type->garde_i1) free(inf_i1);
	      GRF_efface(spectre, VRAI, VRAI);
	      fclose(fichier);
	      return FAUX;
	    }
	    zone_x = infos_tri[j].xpoint_depart;
	    zone_y = infos_tri[j].ypoint_depart;

	    infos_tri[j].nbr_points = nbr_pts;
	    infos_tri[j].position = 0; /* On commence en position 0, c'est plus sr */

	    if ( type->garde_i0 )
	    {
	      inf_i0[j].ypoint_depart = (double *) malloc( sizeof(double) * nbr_pts );
	      if ( inf_i0[j].ypoint_depart == NULL )
	      {
		int k;

		ERREUR(MANQUE_MEMOIRE);
		for (k = 0 ; k <= j ; k++)
		{
		  free(inf_i0[k].ypoint_depart);
		}
		free(inf_i0);
		GRF_efface(gr_i0, VRAI, VRAI);
		type->garde_i0 = FAUX;
	      }
	      else
	      {
		inf_i0[j].xpoint_depart = zone_x;
		inf_i0[j].nbr_points = nbr_pts;
		inf_i0[j].position = 0;
	      }
	    }

			if ( type->garde_i1 )
			{
				inf_i1[j].ypoint_depart = (double *) malloc( sizeof(double) * nbr_pts );
				if ( inf_i1[j].ypoint_depart == NULL )
				{
					int k;

					ERREUR(MANQUE_MEMOIRE);
					for (k = 0 ; k <= j ; k++)
					{
						free(inf_i1[k].ypoint_depart);
					}
					free(inf_i1);
					GRF_efface(gr_i1, VRAI, VRAI);
					type->garde_i1 = FAUX;
				}
				else
				{
					inf_i1[j].xpoint_depart = zone_x;
					inf_i1[j].nbr_points = nbr_pts;
					inf_i1[j].position = 0;
				}
			}
		}

		for (index = 0 ; index < nbr_pts ; index++)
		{
			fscanf(fichier,"%lf %lf %lf",&energie,&i_0,&i_1); /* On lit la ligne */
			if (i_0 == 0)
			{
				int k;

				EXF_ERREUR(ERR_I0); /* Impossible de charger -> on annule le chargement */

				if (type->garde_i1)
				{
					for (k = 0 ; k <= j ; k++)
					{
						free(inf_i1[k].ypoint_depart);
					}
					free(inf_i1);
					GRF_efface(gr_i1, VRAI, VRAI);
				}	

				if (type->garde_i1)
				{
					for (k = 0 ; k <= j ; k++)
					{
						free(inf_i0[k].ypoint_depart);
					}
					free(inf_i0);
					GRF_efface(gr_i0, VRAI, VRAI);
				}

				for (k = 0 ; k <= j ; k++)
				{
					free(infos_tri[k].xpoint_depart);
					free(infos_tri[k].ypoint_depart);
				}
				free(infos_tri);
				GRF_efface(spectre, VRAI, VRAI);

				fclose(fichier);
				return FAUX;
			}

			if (reserve == VRAI) /* On veut la mmoriser */
			{
				*zone_x = energie;
				if (type->fluoresce == FAUX)
					*zone_y = log( i_0 / i_1 );
				else
					*zone_y = i_1/i_0;
				zone_x++; zone_y++;

				if ( type->garde_i0 )
					(inf_i0[j].ypoint_depart)[index] = i_0;
				
				if ( type->garde_i1 )
					(inf_i1[j].ypoint_depart)[index] = i_1;
			}
		}

		if (reserve == VRAI)
		  j++; /* On passe au graphe suivant */
    else if (Histoire)
    	fprintf(Histoire, " --> Le spectre numro %d n'a pas t utilis\n", i + 1);
	}

	fclose(fichier); /* Fini de lire les donnes */

	/* Ici, on a donc les graphes voulus chargs dans les graphes[]->x/y */
	/* On ralise donc leur tri */

	tri_blocs(spectre->x, spectre->y, infos_tri, nbr_elements, spectre->nombre_point);
	tri_doublons(spectre, VRAI ); /* On limine les doublons */
	GRF_bornes(spectre, DESORDONNE, DESORDONNE); /* On installe les bornes */

	if ( type->garde_i0 )
	{
	  tri_blocs(gr_i0->x, gr_i0->y, inf_i0, nbr_elements, gr_i0->nombre_point);
	  tri_doublons(gr_i0, VRAI );
	  GRF_bornes(gr_i0, DESORDONNE, DESORDONNE);

	  sprintf(_intermediaire,"%s (I0, fusion)%c", nom, 0);
	  strncpy(gr_i0->nom, _intermediaire, LG_TITRE);
	}

	if ( type->garde_i1 )
	{
	  tri_blocs(gr_i1->x, gr_i1->y, inf_i1, nbr_elements, gr_i1->nombre_point);
	  tri_doublons(gr_i1, VRAI );
	  GRF_bornes(gr_i1, DESORDONNE, DESORDONNE);

	  sprintf(_intermediaire,"%s (I1, fusion)%c", nom, 0);
	  strncpy(gr_i1->nom, _intermediaire, LG_TITRE);
	}

	if (strlen(nom) >= LG_TITRE)
	{
		sprintf(spectre->nom,"Nom de fichier trop long%c",0);
	}
	else
		sprintf(spectre->nom,"%s (fusion)%c",nom,0);

	spectre->drapeaux.sauve = FAUX; /* Pas sauv */
	free(infos_tri);
	if (type->garde_i0) free(inf_i0);
	if (type->garde_i1) free(inf_i1);

	GRF_aller(spectre); /* On affiche ce graphe */
	return VRAI;
}

/* --------------- Lignes du DCI, deux chambres d'ionisation -------------------------------------------------\
 |    Renvoie VRAI si le chargement s'est bien pass, FAUX sinon                                              |
 |    Suppose un fichier de format ENERGIE I0 I1 I2 pour charger correctement                                 |
 |                                                                                                            |
 | nom        : le nom du fichier charg                                                                      |
 | fichier    : le fichier  lire, positionn au dbut des donnes                                            |
 | nbr_lignes : le nombre de lignes  lire (contiennent les donnes)                                          |
 | type       : infos pour le chargement                                                                      |
 \----------------------------------------------------------------------------------------------------------- */

boolean DCI_2chambres(char *nom, FILE *fichier, unsigned long nbr_lignes, MOD_extrait *type)
{
	Graphe *spectre_1 = NULL, *spectre_2 = NULL,
	       *gr_i0 = NULL, *gr_i1 = NULL, *gr_i2 = NULL; /* Graphes contenant le rsultat */
	double *x = NULL, *y_1 = NULL, *y_2 = NULL,
	       *I0 = NULL, *I1 = NULL, *I2 = NULL; /* Valeurs des zones de lecture */
	boolean reponse;

	/* On rserve le graphe correspondant */

	if ( type->garde_signal)
	{
		char titre[300];

		sprintf(titre, "%s (chambre 1)", nom);
		spectre_1 = GRF_creer(nbr_lignes, GR_BRUT, GR_NORMAL, titre, "nergie", "Absorbance", UNIT_EV, UNIT_ARB);
		if (spectre_1 == NULL)
		{
			type->garde_signal = FAUX; /* On ne garde pas le spectre, finalement */
		}
		else
		{
			x   = spectre_1->x;    /* On lit les X l-dedans   */
			y_1 = spectre_1->y;    /* On crit les Y ici       */

			if (Histoire)
			{
				fprintf(Histoire, "   Signal 1 : %s (%ld points)\n", spectre_1->nom, spectre_1->nombre_point);
			}

			sprintf(titre, "%s (chambre 2)", nom);
	
			spectre_2 = GRF_creer(nbr_lignes, GR_BRUT, GR_NORMAL, titre, "nergie", "Absorbance", UNIT_EV, UNIT_ARB);
			if (spectre_2)
			{
				y_2 = spectre_2->y;
				if (Histoire)
				{
					fprintf(Histoire, "   Signal 2 : %s (%ld points)\n", spectre_2->nom, spectre_2->nombre_point);
				}
			}
			else if (Histoire)
			{
				fprintf(Histoire, "   Signal 2 : n'a pas pu tre cr\n");
			}
		}
	}

	if ( type->garde_i0 ) /* On veut garder i0 */
	{
		char titre[300];

		sprintf(titre, "%s (I0)", nom);
		gr_i0 = GRF_creer(nbr_lignes, GR_I0, GR_NORMAL, titre, "nergie", "Nombre de coups", UNIT_EV, SS_UNITE);
		if (gr_i0 == NULL)
		{
			type->garde_i0 = FAUX; /* On ne peut pas le garder... */
		}
		else
		{
			if (x == NULL) /* Pas encore de x dfini */
				x = gr_i0->x;
			I0 = gr_i0->y; /* On enregistre I0 */

			if (Histoire)
			{
				fprintf(Histoire, "   I0       : %s (%ld points)\n", gr_i0->nom, gr_i0->nombre_point);
			}
		}
	}

	if ( type->garde_i1 ) /* On veut garder i1 */
	{
		char titre[300];

		sprintf(titre, "%s (I1)", nom);
		gr_i1 = GRF_creer(nbr_lignes, GR_I1, GR_NORMAL, titre, "nergie", "Nombre de coups", UNIT_EV, SS_UNITE);
		if (gr_i1 == NULL)
		{
			type->garde_i1 = FAUX; /* On ne peut pas le garder... */
		}
		else
		{
			if (x == NULL)
				x = gr_i1->x; /* Si zone de lecture des x pas encore dfinie */
			I1 = gr_i1->y;  /* Adresse de lecture de I1 */

			if (Histoire)
			{
				fprintf(Histoire, "   I1       : %s (%ld points)\n", gr_i1->nom, gr_i1->nombre_point);
			}
		}
	}

	if ( type->garde_i2 ) /* On veut garder I2 */
	{
		char titre[300];

		sprintf(titre, "%s (I2)", nom);
		gr_i2 = GRF_creer(nbr_lignes, GR_I1, GR_NORMAL, titre, "nergie", "Nombre de coups", UNIT_EV, SS_UNITE);
		if (gr_i2 == NULL)
		{
			type->garde_i2 = FAUX; /* On ne peut pas le garder... */
		}
		else
		{
			if (x == NULL)
				x = gr_i2->x; /* Si zone de lecture des x pas encore dfinie */
			I2 = gr_i2->y; /* Adresse de lecture de I2 */

			if (Histoire)
			{
				fprintf(Histoire, "   I2       : %s (%ld points)\n", gr_i2->nom, gr_i2->nombre_point);
			}
		}
	}

	if ( x == NULL ) /* Aucune information n'est charge */
	{
		printf("Aucune information  charger ! Chargement annul\n");
		printf(" ------- Appuyer sur une touche --------\n");
		evnt_keybd();
		return FAUX;
	}

	/* On lit le fichier */

	reponse = ELEM_2chambres(fichier, nbr_lignes, type, x, y_1, y_2, I0, I1, I2);
	if (reponse == FAUX) /* Une erreur est survenue -> on efface les graphes */
	{
		GRF_efface(spectre_1, VRAI, VRAI); /* On efface quoi qu'il arrive */
		GRF_efface(spectre_2, VRAI, VRAI);
		GRF_efface(gr_i0, VRAI, VRAI);
		GRF_efface(gr_i1, VRAI, VRAI);
		GRF_efface(gr_i2, VRAI, VRAI);

		return FAUX; /* Problme... */
	}

	/* Lecture termine */
	/* On recopie les X dans les spectres qui ne les ont pas */

	if ( spectre_2 ) /* S'il existe, c'est que spectre_1 existe aussi, forcment */
	{
		memcpy(spectre_2->x, x, sizeof(double) * nbr_lignes);
	}

	if ( (gr_i0) && (x != gr_i0->x) ) /* Le spectre existe et ne contient pas les X */
	{
		memcpy(gr_i0->x, x, sizeof(double) * nbr_lignes);
	}

	if ( (gr_i1) && (x != gr_i1->x) )
	{
		memcpy(gr_i1->x, x, sizeof(double) * nbr_lignes);
	}

	if ( (gr_i2) && (x != gr_i2->x) )
	{
		memcpy(gr_i2->x, x, sizeof(double) * nbr_lignes);
	}

	/* Tri du graphe, sur place */

	if (type->tri) /* On demande le tri des graphes */
	{
		tri_en_place(spectre_1);
		tri_en_place(spectre_2);
		tri_en_place(gr_i0);
		tri_en_place(gr_i1);
		tri_en_place(gr_i2);
	}

	/* limination des ventuels doublons */

	if (type->doublons) /* On limine les doublons au vol */
	{
		if (spectre_1)
		{
			unsigned long nbr_doublons = tri_doublons(spectre_1, VRAI); /* On les moyenne */
			if (nbr_doublons)
			{
				sprintf(_intermediaire,"[3][ On a moyenn | %ld doublons ][ Compris ]", nbr_doublons);
				form_alert(1,_intermediaire);
			}
			else
				form_alert(1,"[3][ Aucun doublon n'a t | mis en vidence ][ Bien ]");
		}

		if (spectre_2)
			tri_doublons(spectre_2, VRAI);

		if (type->garde_i0)
			tri_doublons(gr_i0, VRAI);
		if (type->garde_i1)
			tri_doublons(gr_i1, VRAI);
		if (type->garde_i2)
			tri_doublons(gr_i2, VRAI);
	}

	GRF_bornes(spectre_1, DESORDONNE, DESORDONNE); /* On met les bornes - aprs car doublons peuvent modifier */
	GRF_bornes(spectre_2, DESORDONNE, DESORDONNE);
	GRF_bornes(gr_i0, DESORDONNE, DESORDONNE);  /* si NULL : revient directement -> pas de problme...     */
	GRF_bornes(gr_i1, DESORDONNE, DESORDONNE);
	GRF_bornes(gr_i2, DESORDONNE, DESORDONNE);

	GRF_aller(spectre_1);

	return VRAI;
}

/* --------------- Lignes du DCI, un seul spectre dans le fichier, un seul lment ---------------------------\
 |    Renvoie VRAI si le chargement s'est bien pass, FAUX sinon                                              |
 |    Suppose un fichier de format ENERGIE IO I1 pour charger correctement                                    |
 |                                                                                                            |
 | nom        : le nom du fichier charg                                                                      |
 | fichier    : le fichier  lire, positionn au dbut des donnes                                            |
 | nbr_lignes : le nombre de lignes  lire (contiennent les donnes)                                          |
 | type       : infos pour le chargement                                                                      |
 \----------------------------------------------------------------------------------------------------------- */

boolean DCI_mono(char *nom, FILE *fichier, unsigned long nbr_lignes, MOD_extrait *type)
{
	Graphe *spectre = NULL, *gr_i0 = NULL, *gr_i1 = NULL; /* Graphes contenant le rsultat */
	double *x = NULL, *I0 = NULL, **I1 = NULL, **y = NULL; /* Valeurs des zones de lecture */
	boolean reponse;

	/* On rserve le graphe correspondant */

	if ( type->garde_signal)
	{
		spectre = GRF_creer(nbr_lignes, GR_BRUT, GR_NORMAL, nom, "nergie", "Absorbance", UNIT_EV, UNIT_ARB);
		if (spectre == NULL)
		{
			type->garde_signal = FAUX; /* On ne garde pas le spectre, finalement */
		}
		else
		{
			x = spectre->x;    /* On lit les X l-dedans   */
			y = &(spectre->y); /* On crit les Y dans y[0] */

			if (Histoire)
			{
				fprintf(Histoire, "   Signal   : %s (%ld points)\n", spectre->nom, spectre->nombre_point);
			}
		}
	}

	if ( type->garde_i0 ) /* On veut garder i0 */
	{
		char titre[300];

		sprintf(titre, "%s (I0)", nom);
		gr_i0 = GRF_creer(nbr_lignes, GR_I0, GR_NORMAL, titre, "nergie", "Nombre de coups", UNIT_EV, SS_UNITE);
		if (gr_i0 == NULL)
		{
			type->garde_i0 = FAUX; /* On ne peut pas le garder... */
		}
		else
		{
			if (x == NULL) /* Pas encore de x dfini */
				x = gr_i0->x;
			I0 = gr_i0->y; /* On enregistre I0 */

			if (Histoire)
			{
				fprintf(Histoire, "   I0       : %s (%ld points)\n", gr_i0->nom, gr_i0->nombre_point);
			}
		}
	}

	if ( type->garde_i1 ) /* On veut garder i1 */
	{
		char titre[300];

		sprintf(titre, "%s (I1)", nom);
		gr_i1 = GRF_creer(nbr_lignes, GR_I1, GR_NORMAL, titre, "nergie", "Nombre de coups", UNIT_EV, SS_UNITE);
		if (gr_i1 == NULL)
		{
			type->garde_i1 = FAUX; /* On ne peut pas le garder... */
		}
		else
		{
			if (x == NULL)
				x = gr_i1->x; /* Si zone de lecture des x pas encore dfinie */
			I1 = &(gr_i1->y); /* Adresse de lecture de I1 */

			if (Histoire)
			{
				fprintf(Histoire, "   I1       : %s (%ld points)\n", gr_i1->nom, gr_i1->nombre_point);
			}
		}
	}

	if ( x == NULL ) /* Aucune information n'est charge */
	{
		printf("Aucune information  charger ! Chargement annul\n");
		printf(" ------- Appuyer sur une touche --------\n");
		evnt_keybd();
		return FAUX;
	}

	/* On lit le fichier */

	reponse = ELEM_separe(fichier, nbr_lignes, 1, type, x, y, I0, I1);
	if (reponse == FAUX) /* Une erreur est survenue -> on efface les graphes */
	{
		GRF_efface(spectre, VRAI, VRAI); /* On efface quoi qu'il arrive */
		GRF_efface(gr_i0, VRAI, VRAI);
		GRF_efface(gr_i1, VRAI, VRAI);

		return FAUX; /* Problme... */
	}

	/* Lecture termine */
	/* On recopie les X dans les spectres qui ne les ont pas */

	if ( (gr_i0) && (x != gr_i0->x) ) /* Le spectre existe et ne contient pas les X */
	{
		memcpy(gr_i0->x, x, sizeof(double) * nbr_lignes);
	}

	if ( (gr_i1) && (x != gr_i1->x) )
	{
		memcpy(gr_i1->x, x, sizeof(double) * nbr_lignes);
	}

	/* Si demand, on tri tout a */

	if (type->tri)
	{
		tri_en_place(spectre);
		tri_en_place(gr_i0);
		tri_en_place(gr_i1);
	}

	/* limination des ventuels doublons */

	if (type->doublons) /* On limine les doublons au vol */
	{
		if (spectre)
		{
			unsigned long nbr_doublons = tri_doublons(spectre, VRAI); /* On les moyenne */
			if (nbr_doublons)
			{
				sprintf(_intermediaire,"[3][ On a moyenn | %ld doublons ][ Compris ]", nbr_doublons);
				form_alert(1,_intermediaire);
			}
			else
				form_alert(1,"[3][ Aucun doublon n'a t | mis en vidence ][ Bien ]");
		}

		if (type->garde_i0)
			tri_doublons(gr_i0, VRAI);
		if (type->garde_i1)
			tri_doublons(gr_i1, VRAI);
	}

	GRF_bornes(spectre, DESORDONNE, DESORDONNE); /* On met les bornes - aprs car doublons peuvent modifier */
	GRF_bornes(gr_i0, DESORDONNE, DESORDONNE);   /* si NULL : revient directement -> pas de problme...     */
	GRF_bornes(gr_i1, DESORDONNE, DESORDONNE);

	GRF_aller(spectre);

	return VRAI;
}

/* ------------------ Importation d'un graphe --------------------------------- *
 ********************************************************************************/

/* ------------------ Routine gnrale ---------------------------------------- */

void importer(void)
{
	int retour,index,nbr_fichier = 0;
	boolean redessin = FAUX; /* VRAI si on doit redessiner */
	char **liste_noms;

	OBJ_active(FORMAT_EXPORT, IMPORT_FEFF, FORCE_OUI); /* Import FEFF possible */
	met_chaine(FORMAT_EXPORT, TITRE_IMP_EXP, 0, "Format d'import", TXT_REMPLACE);
	retour = ext_formdo(FORMAT_EXPORT);

	switch (retour)
	{
	case EDA:
		liste_noms = CH_selecteur("*.TXT","Import d'un fichier EDA",0,NULL,&nbr_fichier);
		if (liste_noms)
		{
			for (index = 0 ; index < nbr_fichier ; index++)
			{
				sprintf(_intermediaire,"%s%s%c",nom_fichier,liste_noms[index],0);
				redessin |= import_eda(_intermediaire);
				free(liste_noms[index]);
			}
			free(liste_noms);
		}
		break;

	case GNUPLOT:
		break;

	case ASCII:
		if ( ext_formdo(IMPORT_ASCII) == ASCII_ANNULER ) /* On annule */
			return;

		liste_noms = CH_selecteur("*.*", "Import d'un fichier ASCII", 0, NULL, &nbr_fichier);
		if (liste_noms)
		{
			int nbr_colonnes = prend_valeur(IMPORT_ASCII, ASCII_NBR_COLONN),
			    x_colonne    = prend_valeur(IMPORT_ASCII, ASCII_COLONNE_X),
			    y_colonne    = prend_valeur(IMPORT_ASCII, ASCII_COLONNE_Y);
			unsigned int en_tete = prend_valeur(IMPORT_ASCII, ASCII_IGNORE_DEB);
			char commentaire;
			int i;

			commentaire = *lit_chaine(IMPORT_ASCII, ASCII_COMMENTAIR, 0, NULL, TXT_COPIER);

			for (i = 0 ; i < nbr_fichier ; i++)
			{
				sprintf(_intermediaire, "%s%s", nom_fichier, liste_noms[i]);
				redessin |= import_ascii(_intermediaire, nbr_colonnes, x_colonne, y_colonne,
				                          en_tete, commentaire);
				free(liste_noms[i]);
			}
			free(liste_noms);
		}
		break;

	case IMPORT_FEFF:
		redessin = import_feff();
		break;
	}
	
	if (redessin == VRAI)
	{
		/* Demander le type du graphe import, si graphe "sans type" */

		FEN_redessin(principale);
		FEN_redessin( trace_fenetre );
		FEN_redessin( ARB_fenetre(arbres + CHOIX_GRAPHE) );
	}
}

/* --------------------- Import d'un fichier ASCII (gnrique) -----------------\
 |    Renvoie VRAI si l'import a russi                                         |
 |                                                                              |
 | nom          : le nom du fichier  importer                                  |
 | nbr_colonnes : nombre de colonnes dans le fichier                            |
 | colonne_x    : colonne  utiliser pour les X                                 |
 | colonne_y    : colonne  utiliser pour les Y                                 |
 | en_tete      : nombre de lignes  passer = en-tte                           |
 | commentaire  : ignorer les lignes qui commencent par ce caractre            |
 \----------------------------------------------------------------------------- */

boolean import_ascii(char *nom, int nbr_colonnes, int x_colonne, int y_colonne,
                     unsigned int en_tete, char commentaire)
{
  boolean compter = FAUX, debut_ligne = VRAI;
  FILE *fichier;
  int c;
  register double *x, *y;
  unsigned long nbr_lignes = 0, nbr_en_tete = 0, i;
  long debut = 0; /* Dbut des donnes... */
  Graphe *graphe;

	fichier = fopen(nom, "rb");
	if (fichier == NULL)
	{
		ERREUR(ERREUR_LECTURE); /* Erreur  la lecture */
		return FAUX;
	}

	do
	{
	  c = fgetc(fichier); /* On lit un caractre */
	
	  if ( debut_ligne == VRAI )
	  {
	    if ( ( c == commentaire )         /* Commentaire -> ignorer */
	      || ( c == 10 ) || ( c == 13 ) ) /* Ignore les lignes vides -> permet de lire le format PC : 13/10 */
	    {
	      compter = FAUX; /* On ne compte pas la ligne */
	    }
	    else
	      compter = VRAI; /* On compte la ligne */

	    debut_ligne = FAUX;
	  }

		if ( (c == 10) || (c == 13) ) /* Fin de ligne, normalement tout type */
		{
			debut_ligne = VRAI; /* On va commencer une ligne */

			if (nbr_en_tete < en_tete) /* On n'a pas fini l'en-tte */
			{
				nbr_en_tete++;
				if (nbr_en_tete == en_tete) /* C'est la dernire ligne de l'en-tte */
					debut = ftell(fichier); /* On note la position de dbut */

				c = fgetc(fichier);
				if (c != 10) /* Ce n'tait pas une fin de ligne PC */
					ungetc(c, fichier);
			}
			else if (compter) /* On utilise cette ligne */
			{
				nbr_lignes++; /* Une ligne de plus */
			}
		}
	} while (c != EOF); /* Tant qu'il y a des donnes */

	if (nbr_lignes < 2) /* Trop peu de donnes */
	{
		printf("Le fichier ne contient pas assez de lignes\n");
		printf("Appuyez sur une touche pour continuer\n");
		evnt_keybd();

		fclose(fichier);
		return FAUX;
	}

	graphe = GRF_creer(nbr_lignes, GR_SSTYPE,	GR_NORMAL, nom, "Sans lgende", "Sans lgende", SS_UNITE, SS_UNITE);
	if (graphe == NULL)
	{
		fclose(fichier);
		return FAUX;
	}

	x = graphe->x; y = graphe->y;

	fseek(fichier, debut, SEEK_SET);

	i = 0;
	do
	{
		c = fgetc(fichier);
		if ((char) c != commentaire) /* Ce n'est pas une ligne de commentaire */
		{
			int j;
			double rien;

			fseek(fichier, -1, SEEK_CUR); /* On recule d'un caractre */

			for (j = 0 ; j < nbr_colonnes ; j++)
			{
				if (j == x_colonne - 1)
				{
					fscanf(fichier, "%lf", x);
					x++;
				}
				else if (j == y_colonne - 1)
				{
					fscanf(fichier, "%lf", y);
					y++;
				}
				else
				{
					fscanf(fichier, "%lf", &rien);
				}
			}
			i++; /* On vient de lire une ligne de donnes */

			c = fgetc(fichier); /* On lit le caractre suivant */
		}

		/* On ignore la fin de la ligne si ncessaire */

		while ( (c != EOF) && (c != '\n') && (c != 10) && (c != 13) )
		{
			c = fgetc(fichier); /* On saute la fin de la ligne */
		}
	} while (i < nbr_lignes); /* Tant que l'on n'a pas tout lu */

	fclose(fichier); /* C'est bon */

	GRF_bornes(graphe, DESORDONNE, DESORDONNE);
	GRF_aller(graphe);
	return VRAI;
}

/* --------------------- Import d'un fichie EDAPLOT --------------------------- 
              Renvoie VRAI si l'import a russi                                 */

boolean import_eda(char *nom)
{
	unsigned long nombre_lignes=0;
	float x,y;
	register double *zone_x,*zone_y;
	unsigned long index;
	Graphe *spectre;

	fichier = fopen(nom,"r");
	if (fichier == NULL)
	{
		return FAUX;
	}
	
	/* Dcompte du nombre de lignes */

	while	( feof(fichier) == FAUX ) /* Tant que l'on n'est pas  la fin */
	{
		if (fgetc(fichier) == 10)
			 nombre_lignes++;
	}

	/* On revient au dbut du fichier */

	fseek(fichier, 0, 0);
	
	/* On cr le graphe correspondant */
	
	spectre = creer_graphe(nombre_lignes,-1); /* Un couple de points par ligne */
	if (spectre == NULL)                      /* On n'a pas pu crer le graphe */
	{
		fclose(fichier);
		return FAUX;
	}

	/* On lit maintenant le fichier */

	zone_x = spectre->x;
	zone_y = spectre->y;

	fscanf(fichier,"%f %f",&y,&x);						 /* Lit la premire ligne x,y */
	spectre->x_min = (double) x;
	spectre->x_max = (double) x;
	spectre->y_min = (double) y;
	spectre->y_max = (double) y;
	*zone_x = (double) x;
	*zone_y = (double) y;

	for (index = 1 ; index < nombre_lignes ; index ++)
	{
		zone_x++;
		zone_y++;
		fscanf(fichier,"%f %f",&y,&x);
	
		if ( x < spectre->x_min ) spectre->x_min = x;
		if ( x > spectre->x_max ) spectre->x_max = x;
		if ( y < spectre->y_min ) spectre->y_min = y;
		if ( y > spectre->y_max ) spectre->y_max = y;

		*zone_x = (double) x;
		*zone_y = (double) y;
	}

	strncpy(spectre->nom, nom, LG_TITRE);

	GRF_aller( spectre );

	return VRAI; /* Chargement effectu sans encombres */
}

/* ------------------ Exportation d'un graphe --------------------------------- *
 ********************************************************************************/

/* ------------------ Routine gnrale ---------------------------------------- */

void exporter(void)
{
	int retour;

	OBJ_active(FORMAT_EXPORT, IMPORT_FEFF, FORCE_NON); /* Pas d'export FEFF */
	met_chaine(FORMAT_EXPORT, TITRE_IMP_EXP, 0, "Format d'export", TXT_REMPLACE);
	retour = ext_formdo(FORMAT_EXPORT);
	
	switch (retour)
	{
	case EDA:
		export_eda();
		break;

	case GNUPLOT: /* Export GNUplot */
		break;

	case ASCII:   /* Export format libre ASCII */
		break;
	}
}

/* --------------------- Export d'un fichier EDAPLOT --------------------------- */

void export_eda(void)
{
  FILE *fichier;
  register double *zone_x,*zone_y;
  unsigned long index;
  char *nom_fichier;

#ifdef _FRANCAIS_
  nom_fichier = SV_selecteur("*.TXT", "Exporter au format EDA");
#endif
#ifdef _ENGLISH_
  nom_fichier = SV_selecteur("*.TXT", "Export in EDA fileformat");
#endif
  if (nom_fichier == NULL)
    return; /* On n'a pas pu sauver */

  fichier = fopen(nom_fichier, "w");
  if (fichier == NULL)
  {
    ERREUR(ERREUR_ECRITURE);
    free(nom_fichier);
    return;
  }

  if (Histoire)
  {
    fprintf(Histoire, "Graphe %s export"e_AIGU" au format EDA (%s)\n", graphe_courant->nom, nom_fichier);
  }
  free(nom_fichier);

  zone_x = graphe_courant->x;
  zone_y = graphe_courant->y;
	
  for (index = 0 ; index < graphe_courant->nombre_point ; index++)
  {
    fprintf(fichier,"%f %f\n", *zone_y, *zone_x);
    zone_x++;
    zone_y++;
  }
	
  fclose(fichier);
}
