/* LASE - Logiciel d'analyse des spectres EXAFS
   (c) 1998, Emmanuel CURIS - cration du fichier : 3 juin 1998

   Toutes les fonctions qui interviennent pour le lissage de courbes
*/

#ifndef _LISSAGE_H_

#define _LISSAGE_H_ 

/* ****** Mthode des moindres carrs *************************** */

/* ------ Polynme simple, degr indiffrent -------------------- */

double moindre2(Graphe *graphe, int degre, char nbr_zones, double *zones, double *poly);

int Gauss(int degre, double *matrice, double *coefs);

/* ------ Succession de polynmes avec plusieurs points d'ancrage [juris] */

double  moindrej(Graphe *graphe, int degre, char nbr_zones, double *zones, double *coefs);

/* ****** Mthode des splines : interface utilisateur *********** */

Graphe *lisse_graphe(Graphe *source); /* Dans LISSER.c */

/* ****** Mthode des splines _pour les spectres rels_ ********* */

/* ------ Prparations des tableaux ----------------------------- */

double SPL_prepare(Graphe *graphe, char nbr_zones, double *zones, 
                   double **b, double **c, double **d, double **tableau,
		   unsigned long *nbr_points);
double SPL_tt_prep(Graphe *graphe, double **b, double **c, double **d);

/* ------ Calculs des points avec ces tableaux ------------------ */

double SPL_calcule(double x, unsigned long nbr_pts, double *tableau,
		   double *b, double *c, double *d);
double SPL_tt_calc(Graphe *graphe, double x, double *b, double *c, double *d);

/* ------ Pour calculer en une fois tout un spectre liss ------- */

Graphe *lisse_reel(Graphe *source, unsigned long nv_points);

/* ****** Mthode des splines _pour les spectres complexes_ ***** */

/* ------ Prparations des tableaux ----------------------------- */

double CSPL_prepare(Graphe *graphe, int nbr_zones, double *zones, 
	 	    Complexe **b, Complexe **c, Complexe **d, double **tab_x, Complexe **tab_y,
		    unsigned long *nbr_points);
double CSPL_tt_prep(Graphe *graphe, Complexe **b, Complexe **c, Complexe **d);

/* ------ Calculs des points avec ces tableaux ------------------ */

Complexe CSPL_calcule(double x, unsigned long nbr_pts, double *tab_x, Complexe *tab_y,
		      Complexe *b, Complexe *c, Complexe *d);
Complexe CSPL_tt_calc(Graphe *graphe, double x, Complexe *b, Complexe *c, Complexe *d);

/* ------ Pour calculer en une fois tout un spectre liss ------- */

Graphe *lisse_complexe(Graphe *source, unsigned long nv_points);

#endif /* _LISSAGE_H_ */

