/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
                  Programme principal : rpartition des vnements
   (c) Emmanuel CURIS 1996 - 1998

	tat : essayer de comprendre pourquoi init de RCT_courant marche pas !

  1, 19, 23 avril 1998
    * Revu la gestion du rticule : plus propre, plus facile, compatible X
    * Modifi les tests de sortie du programme : plus logiques, compatibles X
    * Revu le protocole d'interface : initialise() renvoie VRAI si initialisation a RUSSI
    * Ajout option "Effacer tous les graphes" (dans le menu Graphes)
    * Termin remplacement de vdi_handle par _PRG_station

  13, 16-18, 26 mars 1998
    * Remplac les effacer_graphe() par GRF_efface()
    * Utilisation de _PRG_station plutt que de vdi_handle
    * Inclusion de "systeme.h"
    * Prise en compte de l'arbre d'import ASCII
    * Fichiers  inclure en majuscules -> reconnus sous unix
    * Nouvelles options de menu : MEN_EXF_REFAIRE traite correctement
    * Inclus "extrait.h" (pour appel des fonctions depuis le menu)
    * Prise en compte de l'arbre d'extraction en une fois de l'EXAFS.
    * Inclusion de math.h (pour avoir fabs)
    * Amlioration de l'affichage des coordonnes : notation scientifique si ncessaire
    * Appel de la procdure pour les barres d'erreur
    * Inclusion de exf_stat.h, ncessaire pour ce faire...

  5 & 6, 11 fvrier 1998
    * Prise en compte de l'arbre de calcul des barres d'erreur
    * Inclusion de fichiers.h
    * Adapt prep_graphes  la nouvelle version de l'arbre de paramtrage de l'extraction
    * Appel de l'import des atomes appele maintenant arbre de choix du format
    * Fermeture de l'historique en quittant, si ncessaire

  6 & 7, 12 & 13, 16, 19, 28 janvier 1998
    * Appel du chargement des fichiers FEFF.INP ajout
    * Options d'impression et d'export GEM/IMG inactives si pas de GDOS
    * Titres de menu erreurs et affichage inactifs au dmarrage
    * Corrig appel de "initialise" : NBR_RSC et TOTAL inverss !
    * Appel de l'initialisation des arbres des atomes
                                           du shell FEFF
    * Appel de la liste des atomes (en fentre)
    * Chang quelques ob_state en OBJ_??? dans prep_arbres
    * Prise en compte du nouveau protocole d'impression
    * Utilisation de rsc.h pour les arbres
    * Prparation d'un mode DEBUG : debug.h -> pour le lancement
          + sauvegarde dans le fichier "exafs.dbg"
    * Prise en compte de FEFF_structure() [gestion de l'arbre]
    * Appel de la lecture des fichiers CCDB (premire version)
    * Modifi protocole d'appel de l'export d'images
    * Inclusion de export.h
                de atomes.h -> utilisation des atomes possibles
    * Inclusion des arbres 53 & 54
    * Appel de FEF_struct() ajout

  1-3, 9-11, 15 dcembre 1997
    * Utilisation de ARB_init() -> moins de choses dans prep_arbres...
    * Ajout arbres : paramtrage du potentiel pour FEFF.INP
	              paramtrage gnral de FEFF
    * Sauvegarde d'un fichier FEFF.INP peut tre appele
    * Ajout quelques raccourcis pour le menu de thorie
    * Ajout raccourci clavier : ^T = appel du menu de thorie
    * Amlior l'affichage de l'arbre FEFF_PARAM_GENE
    * Appel de FEF_gene()
    * Appel du calcul de la drive seconde (XANES) fonctionne
    * Appel de la dcomposition d'un graphe sur 2 autres fonctionne
    * Transport init du menu dans prep_arbres()
    * Modifi appel des calculs de drive : utilise GRF_derive()
                                                     DER_lisse() et DER_seconde()

  21-24, 27 & 28 novembre 1997
    * Modifi fortement l'interface : rorganisation des menus - 2 familles de menus
    * Ajout ^F = calcul de la TF
    * Utilisation des types de graphes dfinis dans le ressource
    * Ajout de l'inclusion de gem_var.h (variables globales librairie GEM)
    * Ajout l'appel de la fonction GER_tronque()
                     de la fonction de troncature des graphes
    * corrig des redessins de pointeur dans le redessin de la fentre principale
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SYSTEME.H"

#include "DEBUG.H"

#include "EXAFS.H"
#include "GRAPHES.H"

#include "EXF_STAT.H"
#include "EXPORT.H"
#include "EXTRAIT.H"
#include "FICHIERS.H"
#include "FOURIER.H"
#include "IMPRIME.H"
#include "LISSAGE.H"
#include "XT_CALC.H" /* Pour XAN_extrait */
#include "XANES.H"

#ifndef _LIMITE_ /* Seulement dans la version complte */

# include "ATOMES.H"
# include "FEFF.H" /* Besoin pour les appels de ces fonctions... */
# include "couches.h"

#endif

#define NBR_RSC 71
#define TOTAL_ARBRES NBR_RSC /* Tous les arbres sont dans le ressource */

#ifdef MODE_DEBOGAGE

FILE *debogage; /* Fichier contenant le rsultat du dbogage */

#endif

#ifdef _D_MEMOIRE_

#define free(a) { fprintf(debogage, "On libre : pointeur %p\n",a); free(a); }

#endif

/* ~~~~~~~~ Fonctions extrieures appeles dans ce module ~~~~~~~~ */

void init_ncouches(void); /* Dans N_couches/general.c */

/* ~~~~~~~~ Fonctions locales  cette procdure ~~~~~~~~~~~~~~~~~~ */

static boolean CLV_men_ajuste(unsigned int touche, int etat, int *renvoi);

/* ----------------- La fonction principale - le coeur du programme, comme toujours ------------------- */

int main(int nbr_param, char *liste_param[])
{
  boolean fin = FAUX;    /* VRAI si on quitte le programme            */
  int retour;
  int x, y, n_clic, bouton, etat;
  unsigned int touche;
  Graphe *graphe = NULL;

#ifdef _D_LANCEMENT_
  int i;
#endif

#ifdef MODE_DEBOGAGE
  debogage = fopen("exafs.dbg","w");
  if (debogage == NULL)
  {
    printf("Dbogage dans le fichier impossible. Lancement annul\n");
    return -1;
  }
#endif

#ifdef _D_LANCEMENT_	
  fprintf(debogage, "   %d paramtres passs - en voici la liste : \n", nbr_param);
  for (i = 0 ; i < nbr_param ; i++)
  {
    fprintf(debogage, "    Paramtres %d : %s\n", i, liste_param[i]);
  }
  fprintf(debogage, "On va lancer l'initialisation - pour %d arbres, dont %d dans le resource\n",
	  TOTAL_ARBRES, NBR_RSC);
#endif		

  if (initialise("EXAFS.RSC", TOTAL_ARBRES, NBR_RSC) == FAUX)
  {
#ifdef _FRANCAIS_
    printf("Impossible de lancer le programme : erreur "a_GRAVE" l'initialisation\n");
#endif
#ifdef _ENGLISH_
    printf("Error while initializing program. Programm will quit\n");
#endif

#ifdef _D_LANCEMENT_
    fprintf(debogage, "On quitte le programme : l'initialisation a renvoy un chec\n");
#endif

    return -1;
  }

  prep_arbres(); /* On rend les arbres plus jolis...  part car long et sans intrt */

#ifndef _LIMITE_ /* Seulement dans la version complte */
  ATM_init();      /* Initialisation des atomes      */
  FEFF_init();     /* Initialisation du shell FEFF   */
  init_ncouches(); /* Initialisation de l'ajustement */
#endif

  installe_menu(MENU, MEN_extrait);

  /* Ouverture de la fentre de travail */

  principale = creer_fenetre(NAME|FULLER|MOVER|INFO|SIZER|UPARROW|DNARROW|VSLIDE,
			     "LASE : Logiciel d'analyse des spectres E.X.A.F.S.", NULL,
			     redessine_travail, ASC_principale,
			     CLV_principale, CLC_principale, MSG_principale,
			     RCT_principale, (boolean (*)(Fenetre *)) NULL );
  ouvre_fenetre(principale, x_gem, y_gem, larg_gem, haut_gem); /* Tout l'cran */

  if (principale == NULL)
  {
    form_alert(1,"[2][ Impossible d'ouvrir la fen"e_CIRC"tre | principale du programme ][ Quitter ]");
    fin_programme(MENU);
    return -1; /* Erreur survenue... */
  }
  principale->drapeaux.redessin = VRAI; /* Message de redessin pour tout si chgmt de taille     */
  principale->drapeaux.pointeur = VRAI; /* Contient un pointeur */

  principale->msg_masque.plein_ecran  = VRAI;
  principale->msg_masque.taille = VRAI;

  RCT_courant.x1 = 40;
  RCT_courant.y1 = 10;
  RCT_courant.x2 = principale->w_larg - 10; /* Rectangle de trac */
  RCT_courant.y2 = principale->w_haut - 40;

  RCT_courant.axe_x.graduation.gradue  = GRADUE_DECIMAL;
  RCT_courant.axe_y.graduation.gradue  = GRADUE_DECIMAL;
  RCT_courant.prem_graphe = &DES_courant;

  FEN_ascenseur(principale, ASC_VERTICAL, 0, 1000);

  /* Si on a pass des fichiers en paramtre, on essaye de les charger...              */
  /* NB : avec le TOS 4.04 (Falcon), on ne peut passer qu'un seul fichier en paramtre */

  if (nbr_param > 1)
  {
    int compteur; /* NB : pour une raison ou une autre, plante ! */
    
    for (compteur = 1 ; compteur < nbr_param ; compteur++)
      graphe = charger(liste_param[compteur]);
  }
  else
  {
    graphe = charger(NULL);
  }
  if (graphe != NULL)
    graphe_courant = graphe;

  /* Attente des vnements */

  while (fin == FAUX)
  {
    retour = 0;
    while (retour != _FIN_PRG)
    {
      retour = attend_evenement(MU_BUTTON|MU_MESAG,
				0,0,0,0,0,0, /* Pas de bote ni de compteur */
				&x, &y, &bouton, &etat, &touche, &n_clic);
    }

    fin = GRF_tteffacer(); /* On efface tous les graphes - fin = VRAI : on a pu => on quitte */
  }

#ifndef _LIMITE_ /* Seulement dans la version complte */

  FEFF_termine(); /* On libre tout ce qui a t utilis pour le modle FEFF */

  if (ATM_premier) /* Il existe des atomes */
  {
    Atome *atome;

    for (atome = ATM_premier ; atome; atome = atome->suivant)
    {
      ATM_efface(atome); /* On les efface donc - voir pour rendre plus propre ! */
    }
  }

#endif

  if (Histoire)
    fclose(Histoire);

#ifdef MODE_DEBOGAGE

  fclose(debogage);

#endif

  fin_programme(_PRG_menu); /* On veut effectivement quitter, donc on se prpare  quitter */
  return 0;                 /* Pas d'erreur survenue                                       */
}

/* -------------------- Gestion des options de menu ------------------------------------------- *
 ************************************************************************************************/

/* ~~~~~~~~~~~~~~~~~~~~ Menu d'extraction (traitement de spectres exprimentaux) ~~~~~~~~~~~~~~ */

boolean MEN_extrait(int option)
{
  Graphe *retour = NULL;
  char reponse;

  switch (option)
  {
  case INFOS:
    appelle_arbre(INFORMATIONS,NAME|CLOSER|MOVER,
		  "Informations sur le programme",0);
    return VRAI;
	
  case CHARGER:        /* Charger un graphe comme graphe courant */
    retour = charger(NULL);
    break;

  case SAUVER:         /* Sauver le graphe courant */
    sauver(graphe_courant);
    return VRAI;

  case IMPORTER:       /* Importer un fichier (ASCII) */
    importer();
    break;

  case EXPORTER:       /* Exporter un fichier "ASCII" */
    exporter();
    break;

  case MEN_EXPORTIMAGE: /* Exporter une image du graphe courant */
    EXP_image(FAUX);
    break;

  case EXTRAIRE:       /* Extraire le XANES/EXAFS d'un fichier exprimental */
    extraire();
    break;
	
  case CONFIG:
    break;
	
  case QUITTER:        /* Quitter le programme */
    reponse = form_alert(2,"[2][ Voulez-vous vraiment | quitter le programme ? ][ Oui | Non ]");
    if (reponse == 1) /* On veut quitter */
      return _FIN_PRG;
    break;
	
  case MODE_DESSIN:    /* Paramtres de trac des graphes */
#ifdef _FRANCAIS_
    appelle_arbre(CHOIX_GRAPHE, NAME|CLOSER|MOVER,
                  "Param"e_GRAVE"tres de trac"e_AIGU" des graphes", 0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(CHOIX_GRAPHE, NAME|CLOSER|MOVER,
                  "Parameters for tracing graphes", 0);
#endif

    prep_geregraphe(VRAI); /* On le prpare en mettant le graphe courant visible */
    return VRAI;

  case MEN_TT_EFFACER: /* Effacer tous les graphes en mmoire */
    GRF_tteffacer();
    return VRAI;
	
  case DESSINER:       /* Tracer un (des) graphes         */
    TRC_ouvre();
    return VRAI;
	
  case DECAL_GRAPHES:  /* Superposer des graphes aprs les avoir dcals */
    break;
	
  case IMP_GRAPHE:     /* Imprimer le graphe courant */
    imprimer(FAUX);
    break;

  case MEN_TRONQUE_GRF:
    GRF_tronque(graphe_courant);
    return VRAI;

  case DERIVE_GRAPHE:  /* Drive du graphe courant (calcul tout bte) */
    reponse = form_alert(1,"[2][ D"e_AIGU"riv"e_AIGU"e rapide ou pr"e_AIGU"cise? ][ Rapide | Pr"e_AIGU"cise ]");
    if (reponse == 1)
      retour = GRF_derive(graphe_courant, DER_RAPIDE);
    else
      retour = GRF_derive(graphe_courant, DER_SPLINE);
    break;
	
  case INTEGRE_GRAPHE: /* Intgration du graphe courant         */
    retour = GRF_integre(graphe_courant);
    break;
	
  case ABERRANCE:      /* Effacer une aberrance du spectre */
    aberrance(graphe_courant);
    return VRAI;

  case GRF_DECOMP_BASE: /* Dcomposer un graphe sur une base de 2 graphes */
    GRF_decompose(graphe_courant);
    return VRAI;

  case MEN_FONDRE:     /* Fusion de divers graphes */
    retour = fondre();
    break;

  case OP_DIVERSES:    /* Oprations diverses sur 1 ou plusieurs graphes */
#ifdef _FRANCAIS_
    appelle_arbre(GRF_OPERATIONS, NAME|CLOSER|MOVER,
		  "R"e_AIGU"aliser des op"e_AIGU"rations sur un/des graphe(s)", 0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(GRF_OPERATIONS, NAME|CLOSER|MOVER,
		  "Make some operations on one/many graphes");
#endif
    return VRAI;

  case MEN_MOYENNER:   /* Moyenne de plusieurs graphes          */
    retour = moyenner();
    break;

  case MEN_CLC_SIGNAL: /* Calculer signal  partir de I0 et I1  */
    retour = XAN_extrait();
    break;

  case MEN_CONV_ABS_FLU: /* Signal de transmission <-> de fluorescence */
    break;

  case MEN_CORR_NRJ:   /* Corriger les nergies d'un spectre    */
    corr_energie(graphe_courant);
    break;
	
  case MATRICE:        /* Enlever la contribution de la matrice */
    MAT_ouvre(graphe_courant);
    return VRAI;

  case CHERCHE_E0:     /* Recherche de l'nergie de seuil */
    cherche_e0(graphe_courant,VRAI);
    break;

    /* ~~~~~~ Options concernant plus particulirement le XANES ~~~~~~~~~~~~~~~~~~~ */

  case XANES_TOUT:     /* Faire tout le XANES d'un coup (comme EDAXANES)   */
    TT_xanes = VRAI; /* On veut faire tout le traitement du XANES */
    MAT_ouvre(graphe_courant);
    return VRAI;

  case DERIVEE_UN:     /* Drive premire */
    retour = GRF_derive(graphe_courant, DER_SPLINE);
    break;
	
  case DERIVEE_DEUX:   /* Drive seconde           */
    {
      double *b, *c, *d, erreur;

      erreur = SPL_tt_prep(graphe_courant, &b, &c, &d);
      if (erreur < 0) /* Calcul ne peut pas avoir lieu */
	return VRAI;
      retour = DER_seconde(graphe_courant, graphe_courant->nombre_point, b, c, d);
      free(b); free(c); free(d); /* On libre la mmoire */
    }
    break;

  case XAN_NORMALISE:  /* Normalisation du XANES   */
    norm_xanes(graphe_courant);
    return VRAI;
	
  case INT_PRESEUIL:   /* Intgration du prseuil  */
    XAN_integre(graphe_courant);
    return VRAI;
	
    /* ~~~~~~ Options concernant les spectres EXAFS surtout ~~~~~~~~~~~~~~~~~~~~~~~~ */
	
  case EXAFS_TOUT:     /* On fait tout l'EXAFS d'un coup  */
    TT_exafs = VRAI;
    MAT_ouvre(graphe_courant);
    return VRAI;

  case MEN_EXF_REFAIRE: /* On reproduit l'extraction  l'identique */
    EXF_reproduit(graphe_courant);
    return VRAI;

  case OTE_MU0_1:      /* Enlever _0, premire tape   */
    MU1_ouvre(graphe_courant);
    return VRAI;
	
  case OTE_MU0_2:      /* Enlever _0, deuxime tape   */
    mu0_soustrait = GRF_choisir(GR_MU0);
    MU2_ouvre(graphe_courant, mu0_soustrait);
    return VRAI;
	
  case OTE_MU0_3:      /* Enlever _0, troisime tape  */
    mu0_soustrait = GRF_choisir(GR_MU0);
    MU3_ouvre(graphe_courant, mu0_soustrait);
    return VRAI;

  case MEN_MU0_TOTAL:  /* ^Oter _0 dj calcul          */
    MU0_ouvre(graphe_courant, GRF_choisir(GR_MU0));
    return VRAI;

  case MEN_EXF_NORMALIS: /* Normaliser un spectre EXAFS */
    retour = norm_exafs(graphe_courant);
    break;

  case MAGNIFIER:      /* Multiplier par k^n              */
    magnifier(graphe_courant);
    break;
	
  case CONVERSION:     /* Conversion E <-> k               */
    retour = convert(graphe_courant);
    break;
		
  case TF:             /* Transforme de Fourier du spectre courant */
    TF_ouvre(graphe_courant);
    return VRAI;

  case FILTRE_PIC:     /* TF inverse en isolant une rgion de la TF */
    TFI_ouvre(graphe_courant);
    return VRAI;

  case CORR_AMPLITUDE: /* Correction de l'amplitude                */
    retour = corr_amplitude(graphe_courant, 0, 0, 0);
    break;
	
  case CORR_PHASE:     /* Correction de la phase                   */
    retour = corr_phase(graphe_courant, 0);
    break;
	
  case MEN_DISP_STAND: /* Calcul de la dispersion standard */
    ERR_dispersion();
    break;

  default:
    break;
  }
	
  if (retour != NULL) /* Il faut redessiner */
    GRF_aller(retour);         /* On va  ce graphe comme graphe courant */
  else
    GRF_aller(graphe_courant); /* On va au graphe courant dj existant  */

  return VRAI; /* On ne quitte pas, le message a t trait */
}

#ifndef _LIMITE_ /* Version complte uniquement */

/* ~~~~~~~~~~~~~~~~~~~~ Menu regroupant les calculs d'ajustement ~~~~~~~~~~~~~~~~~~~~~~~ */

boolean MEN_ajuste(int option)
{
  switch (option)
  {
  case MEN_AJ_INFOS:   /* Appeler les informations     */
#ifdef _FRANCAIS_
    appelle_arbre(INFORMATIONS, NAME|CLOSER|MOVER, "Informations sur le programme",0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(INFORMATIONS, NAME|CLOSER|MOVER, "Programm informations",0);
#endif
    return VRAI;

  case AJ_GENERAUX:
#ifdef _FRANCAIS_
    appelle_arbre(AJUSTE_GENERAL, NAME|CLOSER|MOVER,
		  "Param"e_GRAVE"tres g"e_AIGU"n"e_AIGU"raux de l'ajustement par n couches", 0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(AJUSTE_GENERAL, NAME|CLOSER|MOVER,
		  "General parameters for fitting, n-layers model", 0);
#endif
    return VRAI;

  case AJ_INITIAL:
  {
    Fenetre *fenetre;

#ifdef _FRANCAIS_
    fenetre = appelle_arbre(PARAM_COUCHES, NAME|CLOSER|MOVER|ASC_HORIZONTAL,
			    "Param"e_GRAVE"tres structuraux de l'ajustement par n couches", 0);
#endif
#ifdef _ENGLISH_
    fenetre = appelle_arbre(PARAM_COUCHES, NAME|CLOSER|MOVER,
			    "Structural parameters for fitting, n-layers model", 0);
#endif

    fenetre->ascenseur = ASC_nc_couches; /* Gestion de l'ascenseur */
  }
    return VRAI;

  case AJ_DEMARRE: /* On lance l'ajustement */
    lancer_ncouches(graphe_courant);
    break;    
  }

  return VRAI;
}

/* ~~~~~~~~~~~~~~~~~~~~ Menu regroupant les calculs thoriques pousss ~~~~~~~~~~~~~~~~~ */

boolean MEN_theorie(int option)
{
  Graphe *retour = NULL;

  switch (option)
  {
  case MENTH_INFOS:    /* Appeler les informations     */
#ifdef _FRANCAIS_
    appelle_arbre(INFORMATIONS, NAME|CLOSER|MOVER, "Informations sur le programme",0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(INFORMATIONS, NAME|CLOSER|MOVER, "Programm informations",0);
#endif
    return VRAI;
	
  case MENTH_MU0:      /* Calculer un [mu]0 thorique  */
    retour = CTH_mu0();
    break;

  case MEN_CALC_PHASE: /* Calculer une phase thorique */
    retour = CTH_phase();
    break;

  case MEN_LST_ATOMES: /* Afficher la liste des atomes */
#ifdef _FRANCAIS_
    appelle_arbre(LISTE_ATOMES, NAME|CLOSER|MOVER, "Liste des atomes en m"e_AIGU"moire", 0);
#endif
#ifdef _ENGLISH_
    appelle_arbre(LISTE_ATOMES, NAME|CLOSER|MOVER, "Atoms currently in memory", 0);
#endif
    return VRAI;

  case ATM_IMPORT_CCDB: /* Importer une liste d'atomes */
    ATM_import();
    return VRAI;

  case FEFF_GENERAUX: /* Paramtres gnraux de FEFF */
    FEF_gene();
    return VRAI;

  case FEFF_POTENTIEL: /* Paramtres de calcul du potentiel de FEFF */
    FEF_modele();
    return VRAI;

  case FEFF_STRUCTURE: /* Paramtres structuraux pour FEFF */
    FEF_struct();
    return VRAI;

  case FEFF_CHARGE:   /* On veut charger un fichier FEFF.INP */
    FEFF_charge();
    return VRAI;

  case FEFF_SAUVER:   /* On veut sauver le fichier FEFF.INP */
    FEFF_sauve();
    return VRAI;

  case MEN_XAN_FEFF: /* Modification des paramtres FEFF modifis pour xanes */
    xanes_feff();
    return VRAI;
  }

  if (retour)
    GRF_aller(retour);
  else
    GRF_aller(graphe_courant);

  return VRAI;
}

#endif /* ndef _LIMITE_ */

/* ~~~~~~~~~~~~~~~~~ Raccourcis claviers des arbres GEM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ----------------- Raccourcis du menu ------------------------------------------------ */

boolean CLA_menu(unsigned int touche, int etat, int *renvoi)
{
  char code;
  Graphe *graphe;

  *renvoi = 0; /* On ne quitte pas un menu de toute faon... */

  if (etat & K_CTRL) /* On appuyait sur Control */
  {
    code = (char) (touche);
    if (code > 0) /* Code ASCII => pas une touche spciale */
    {
      switch ( code + 'A' - 1 )
      {
      case 'A':   /* ^A = appeler le menu d'Ajustements            */
	GER_infos(EXF_AJUSTEMENTS, 0, 0);
	return VRAI;

      case 'C':   /* ^C = Charger */
	return MEN_extrait(CHARGER);

      case 'E':   /* ^E = Extraire signal d'un fichier exprimental */
	return MEN_extrait(EXTRAIRE);

      case 'F':   /* ^F = transforme de Fourier d'un graphe        */
	return MEN_extrait(TF);

      case 'M':   /* ^M = Meilleure droite */
	graphe = ajuste(graphe_courant);
	if (graphe != NULL)
	{
	  graphe_courant = graphe;
	}
	break;

      case 'Q':		/* ^Q = Quitter */
	return MEN_extrait(QUITTER);
	
      case 'S':   /* ^S = Sauver graphe (format interne) */
	return MEN_extrait(SAUVER);

      case 'T':   /* ^T = appeler le menu des calculs Thoriques */
	GER_infos(CALC_THEORIQUES, 0, 0);
	break;

      case 'X':   /* ^X = lancer l'extraction complte du XANES */
	return MEN_extrait(XANES_TOUT);
		
      default:
	/* printf("On appuyait sur la lettre no : %d (%c)\n",(char) ('A' + touche - 1),(char) ('A' + touche - 1)); */
	break;
      }
    }
  }

  return FAUX; /* Par dfaut, message non-trait */
}

#ifndef _LIMITE_ /* Seulement dans la version complte */

/* ------------------- Raccourcis du menu de thorie ------------------ */

boolean CLV_men_theorie(unsigned int touche, int etat, int *renvoi)
{
  char code;

  *renvoi = 0; /* On ne quitte pas un menu de toute faon... */

  if (etat & K_CTRL) /* On appuyait sur Control */
  {
    code = (char) (touche);
    if (code > 0) /* Code ASCII => pas une touche spciale */
    {
      switch ( code + 'A' - 1 )
      {
      case 'A':   /* ^A = appeler le menu d'Ajustements            */
	GER_infos(EXF_AJUSTEMENTS, 0, 0);
	return VRAI;

      case 'E':   /* ^E = appeler le menu d'Extraction d'un graphe */
	GER_infos(TRAITE_SPECTRES, 0, 0);
	return VRAI;

      case 'Q':		/* ^Q = Quitter */
	return MEN_extrait(QUITTER);

      default:
	/* printf("On appuyait sur la lettre no : %d (%c)\n",(char) ('A' + touche - 1),(char) ('A' + touche - 1)); */
	break;
      }
    }
  }

  return FAUX; /* Par dfaut, message non-trait */
}

/* ------------------- Raccourcis du menu d'ajustements -------------- */

static boolean CLV_men_ajuste(unsigned int touche, int etat, int *renvoi)
{
  char code;

  *renvoi = 0; /* On ne quitte pas un menu de toute faon... */

  if (etat & K_CTRL) /* On appuyait sur Control */
  {
    code = (char) (touche);
    if (code > 0) /* Code ASCII => pas une touche spciale */
    {
      switch ( code + 'A' - 1 )
      {
      case 'E':   /* ^E = appeler le menu d'Extraction d'un graphe */
	GER_infos(TRAITE_SPECTRES, 0, 0);
	return VRAI;

      case 'Q':		/* ^Q = Quitter */
	return MEN_extrait(QUITTER);

      case 'T':   /* ^T = appeler le menu de calculs thoriques    */
	GER_infos(EXF_AJUSTEMENTS, 0, 0);
	return VRAI;

      default:
	/* printf("On appuyait sur la lettre no : %d (%c)\n",(char) ('A' + touche - 1),(char) ('A' + touche - 1)); */
	break;
      }
    }
  }

  return FAUX; /* Par dfaut, message non-trait */
}

#endif /* ndef _LIMITE_ */

/* ------------- Gestion de la fentre principale --------------------- *
 ************************************************************************/

/* ~~~~~~~~~~~~~ Ascenseur de la fentre principale ~~~~~~~~~~~~~~~~~~~ */

void ASC_principale(Fenetre *fenetre, int type, int ss_type, int position)
{
  boolean redessin = FAUX;
  char compteur = 0;
  unsigned long num_graphe = 0, index = 0;
  Graphe *graphe = premier_graphe;

  if (fenetre == NULL)  return; /* Ne devrait jamais arriver normalement... */
  if (nbr_graphes == 0) return; /* Aucun graphe en mmoire : inutile de dfiler... */

  if (type == WM_ARROWED) /* On a utilis une des flches de l'ascenseur */
  {
    switch (ss_type) /* Action qui peut tre envisage */
    {
    case WA_UPPAGE: /* On remonte de 10 graphes   */
      while ( (graphe_courant->precedent != NULL) && (compteur < 10) )
      {
	graphe_courant = graphe_courant->precedent;
	compteur++;
      }
      if (compteur > 0) redessin = VRAI;
      break;
	
    case WA_DNPAGE: /* On redescend de 10 graphes */
      while ( (graphe_courant->suivant != NULL) && (compteur < 10) )
      {
	graphe_courant = graphe_courant->suivant;
	compteur++;
      }
      if (compteur > 0) redessin = VRAI;
      break;
	
    case WA_UPLINE: /* Graphe prcdent           */
      if (graphe_courant->precedent != NULL)
      {
	graphe_courant = graphe_courant->precedent;
	redessin = VRAI;
      }
      break;
	
    case WA_DNLINE: /* Graphe suivant             */
      if (graphe_courant->suivant != NULL)
      {
	graphe_courant = graphe_courant->suivant;
	redessin = VRAI;
      }
      break;
    }
  }
  else if (type == WM_VSLID) /* Ascenseur vertical dplac */
  {
    num_graphe = (position * (nbr_graphes - 1)) / 1000;

    /* On va au graphe dsir */
    graphe = premier_graphe;
    for (index = 0 ; index < num_graphe ; index++)
      graphe = graphe->suivant;

    if (graphe != graphe_courant) /* Si c'est un autre graphe */
    {
      graphe_courant = graphe;
      redessin = VRAI;
    }
    else
    {
      position = ( 1000 * num_graphe ) / (nbr_graphes - 1);
      FEN_ascenseur(fenetre, ASC_VERTICAL, position, -1);
    }
  }

  if (redessin == VRAI)        /* On a chang de graphe courant */
    GRF_aller(graphe_courant); /* On va  ce graphe */
}

/* ~~~~~~~~~~~~~ Clic souris sur cette fentre ~~~~~~~~~~~~~~~~~~~~~~~~ */

boolean CLC_principale(Fenetre *fenetre, int bouton, int n_clic, int etat,
		       int x_souris, int y_souris)
{
#if GEM
  int handle;

  wind_get(0, WF_TOP, &handle);
  if (handle != fenetre->handle) /* Clic alors que l'on n'est pas la fentre principale */
  {
    wind_set(fenetre->handle, WF_TOP); /* On la passe au premier plan */
    return VRAI;
  }
#endif

  if (graphe_courant == NULL) /* Pas de graphe */
    return VRAI; /* Rien  faire */

  RCT_courant.prem_graphe->graphe  = graphe_courant;

  points[0] = fenetre->w_x;
  points[1] = fenetre->w_y;
  points[2] = fenetre->w_x + fenetre->w_larg - 1;
  points[3] = fenetre->w_y + fenetre->w_haut - 1;
  vs_clip(_PRG_station->handle, 1, points);

  if (bouton == 1) /* Clic du bouton gauche */
  {
    boolean modifie = FAUX; /* VRAI -> pb. de pointeurs */

    points[0] += RCT_courant.x1;                points[1] += RCT_courant.y1;
    points[2]  = fenetre->w_x + RCT_courant.x2; points[3] = fenetre->w_y + RCT_courant.y2;

    /* On efface le pointeur, s'il y a lieu */

    if ( (_y_pointeur >= points[1]) && (_y_pointeur <= points[3])
      && (_x_pointeur >= points[0]) && (_x_pointeur <= points[2]) )
    {
      wind_update(BEG_UPDATE); /* On coupe l'AES     */
      wind_update(BEG_MCTRL);
      graf_mouse (M_OFF,NULL); /* On coupe la souris */

      vswr_mode(_PRG_station->handle, MD_INVERSE);
      vsl_type (_PRG_station->handle, 1);
      vsl_color(_PRG_station->handle, NOIR);

      points[1] = _y_pointeur;
      points[3] = _y_pointeur;
      v_pline(_PRG_station->handle,2,points);

      points[0] = _x_pointeur;
      points[1] = fenetre->w_y + RCT_courant.y1;
      points[2] = _x_pointeur;
      points[3] = fenetre->w_y + RCT_courant.y2;
      v_pline(_PRG_station->handle,2,points);

      graf_mouse (M_ON,NULL);
      wind_update(END_UPDATE); /* On remet l'AES */
      wind_update(END_MCTRL);
    }

    modifie = CLC_Rgraphe(fenetre, NULL, x_souris - fenetre->w_x, y_souris - fenetre->w_y,
			  n_clic, etat);

    if (modifie == FAUX) /* On a annul -> remettre le pointeur */
    {
      points[0] = fenetre->w_x + RCT_courant.x1; points[1] = fenetre->w_y + RCT_courant.y1;
      points[2] = fenetre->w_x + RCT_courant.x2; points[3] = fenetre->w_y + RCT_courant.y2;

      /* On remet le pointeur, s'il y a lieu */

      if ( (_y_pointeur >= points[1]) && (_y_pointeur <= points[3])
        && (_x_pointeur >= points[0]) && (_x_pointeur <= points[2]) )
      {
	wind_update(BEG_UPDATE); /* On coupe l'AES     */
	wind_update(BEG_MCTRL);
	graf_mouse (M_OFF,NULL);  /* On coupe la souris */

	vswr_mode(_PRG_station->handle, MD_INVERSE);
	vsl_type (_PRG_station->handle, 1);
	vsl_color(_PRG_station->handle, NOIR);

	points[0] = fenetre->w_x + RCT_courant.x1;
	points[1] = _y_pointeur;
	points[2] = fenetre->w_x + RCT_courant.x2;
	points[3] = _y_pointeur;
	v_pline(_PRG_station->handle,2,points);

	points[0] = _x_pointeur;
	points[1] = fenetre->w_y + RCT_courant.y1;
	points[2] = _x_pointeur;
	points[3] = fenetre->w_y + RCT_courant.y2;
	v_pline(_PRG_station->handle,2,points);

	graf_mouse (M_ON,NULL);
	wind_update(END_UPDATE); /* On remet l'AES */
	wind_update(END_MCTRL);
      }
    }
    return VRAI; /* vnement trait */
  }

  /* On est ici -> on a utilis le bouton droit : afficher infos sur le graphe */

  return VRAI;
}

/* ~~~~~~~~~~~~~ Gestion du clavier dans cette fentre ~~~~~~~~~~~~~~~~ */

boolean CLV_principale(Fenetre *fenetre, unsigned int touche, int etat)
{
  char ascii,code_clavier;

  ascii = (char) touche;
  code_clavier = (char) (touche >> 8);

  switch (ascii) /* D'abord les codes ASCII */
  {
  case '+': /* Grossir  la partie visible du spectre : *2 */
    return VRAI;
    
  case '-': /* Diminuer la partie visible du spectre : /2 */
    return VRAI;

  case 127: /* Delete -> effacer le graphe */
    if ( etat & K_CTRL ) /* Ctrl-Del : on force l'effacement si graphe pas sauv */
      GRF_efface(graphe_courant, VRAI, FAUX);
    else
      GRF_efface(graphe_courant, FAUX, FAUX);
    GRF_aller (graphe_courant);
    return VRAI;
  }

  switch (code_clavier) /* Touches spciales */
  {
  case 72: /* Flche vers le haut : passer au graphe prcdent */
    if (etat & K_CTRL) /* Ctrl-flche -> premier graphe */
      GRF_aller(premier_graphe);
    else if ( (etat & K_LSHIFT) || (etat & K_RSHIFT) )
      ASC_principale(fenetre, WM_ARROWED, WA_UPPAGE, 0);
    else
      ASC_principale(fenetre, WM_ARROWED, WA_UPLINE, 0);
    return VRAI;

  case 75: /* Flche vers la gauche : dcaler le graphe de 10% */
    return VRAI;

  case 77: /* Flche vers la droite : dcaler le graphe de 10% */
    return VRAI;

  case 80: /* Flche vers le bas : passer au graphe suivant */
    if (etat & K_CTRL) /* Ctrl-flche -> dernier graphe */
      GRF_aller(dernier_graphe);
    else if ( (etat & K_LSHIFT) || (etat & K_RSHIFT) )
      ASC_principale(fenetre, WM_ARROWED, WA_DNPAGE, 0);
    else
      ASC_principale(fenetre, WM_ARROWED, WA_DNLINE, 0);
    return VRAI;

  case 1: /* Ctrl-Esc : sortie rapide sans confirmation */
    return _FIN_PRG;

  default:
    /*	printf("Code clavier : %d\n", code_clavier);
	evnt_keybd(); */
    break;
  }

  return FAUX;
}

/* ~~~~~~~~~~~~~ Redessin dans cette fentre ~~~~~~~~~~~~~~~~~~~~~~~~~~ */

void redessine_travail(Fenetre *fenetre, int x, int y, int larg ,int haut)
{
  double x_echelle, y_echelle;

  vsl_type (_PRG_station->handle, 1);
  vswr_mode(_PRG_station->handle, MD_REMPLACE);
  vsf_color(_PRG_station->handle, BLANC); /* couleur de remplissage: blanc */

  /* On met le fond blanc */
  points[0] = x;            points[1] = y;            /* Coin suprieur gauche */
  points[2] = x + larg - 1; points[3] = y + haut - 1; /* Coin suprieur droit  */
  v_bar(_PRG_station->handle, points);

  if (graphe_courant == NULL) /* Aucun graphe en mmoire */
  {
    vst_alignment(_PRG_station->handle, ALI_CENTER, ALI_HALF, &_rien_, &_rien_);
    vst_color(_PRG_station->handle, NOIR);
#ifdef _FRANCAIS_
    v_gtext  (_PRG_station->handle, fenetre->w_x + fenetre->w_larg/2, 
	      fenetre->w_y + fenetre->w_haut/2, "Pas de graphe en m"e_AIGU"moire");
#endif
#ifdef _ENGLISH_
    v_gtext  (_PRG_station->handle, fenetre->w_x + fenetre->w_larg/2,
	      fenetre->w_y + fenetre->w_haut/2, "No graphe in memory");
#endif

    return;
  }

  if ( (RCT_courant.x_min == RCT_courant.x_max)   /* Bornes non diffrencies */
    || (RCT_courant.y_min == RCT_courant.y_max) )
  {
    points[0] = fenetre->w_x + RCT_courant.x2;
    points[1] = fenetre->w_y + RCT_courant.y1;
    points[2] = fenetre->w_x + RCT_courant.x1;
    points[3] = fenetre->w_y + RCT_courant.y2;
    vsl_color(_PRG_station->handle, NOIR);
    v_pline  (_PRG_station->handle, 2, points);

    points[0]  = fenetre->w_x + RCT_courant.x1;
    points[1]  = fenetre->w_y + RCT_courant.y1;
    points[2]  = fenetre->w_x + RCT_courant.x2;
    points[3]  = points[1];
    points[4]  = points[2];
    points[5]  = fenetre->w_y + RCT_courant.y2;
    points[6]  = points[0];
    points[7]  = points[5];
    points[8]  = points[0];
    points[9]  = points[1];
    points[10] = points[4];
    points[11] = points[5];
    v_pline(_PRG_station->handle,6,points);

    return;
  }

  /* On trace un cadre dlimitant la zone de dessin (+ axes, lgendes,...) */

  strncpy(RCT_courant.axe_x.legende, graphe_courant->axe_x, 50);
  strncpy(RCT_courant.axe_y.legende, graphe_courant->axe_y, 50);

  TRC_cadre(_PRG_station, &RCT_courant, fenetre->w_x, fenetre->w_y);
  
  /* On trace le graphe (de sa couleur) */

  x_echelle = (double) (RCT_courant.x2 - RCT_courant.x1) / (RCT_courant.x_max - RCT_courant.x_min);
  y_echelle = (double) (RCT_courant.y2 - RCT_courant.y1) / (RCT_courant.y_max - RCT_courant.y_min);

  RCT_courant.prem_graphe->graphe  = graphe_courant;
  RCT_courant.prem_graphe->couleur = graphe_courant->couleur;
  RCT_courant.prem_graphe->style   = graphe_courant->style;

  TRC_graphe(_PRG_station, RCT_courant.prem_graphe, 
	     fenetre->w_x + RCT_courant.x1, fenetre->w_y + RCT_courant.y1,
             RCT_courant.x_min, RCT_courant.x_max, RCT_courant.y_min, RCT_courant.y_max,
             x_echelle, y_echelle);
}

/* ~~~~~~~~~~~~~ Gestion du "rticule" sur le graphe ~~~~~~~~~~~~~~~~~~~~~~~~~~ */

boolean RCT_principale(Fenetre *fenetre, int x, int y)
{
  char val_x[20], val_y[20];
  double x_echelle,y_echelle;
  double x_reel,y_reel;

  if (graphe_courant == NULL) return VRAI; /* Pas de graphe -> pas de pointeur */

  if (RCT_courant.x_min == RCT_courant.x_max) return VRAI;
  if (RCT_courant.y_min == RCT_courant.y_max) return VRAI;

  wind_update(BEG_UPDATE);     /* On coupe l'AES le temps du dessin */
  wind_update(BEG_MCTRL);
  graf_mouse(M_OFF,NULL);      /* On coupe la souris  - Compendium :  faire _aprs_ le BEG_UPDATE */

  vswr_mode(_PRG_station->handle, MD_INVERSE);
  vsl_type (_PRG_station->handle, 1);    /* Ligne continue     */
  vsl_color(_PRG_station->handle, NOIR); /*       noire        */

  points[0] = fenetre->w_x + RCT_courant.x1; points[1] = fenetre->w_y + RCT_courant.y1;
  points[2] = fenetre->w_x + RCT_courant.x2; points[3] = fenetre->w_y + RCT_courant.y2;
  vs_clip(_PRG_station->handle, 1, points);

  if ( ( (_x_pointeur >= points[0]) && (_x_pointeur <= points[2]) )   /* Le pointeur X y tait       */
    && ( (_y_pointeur >= points[1]) && (_y_pointeur <= points[3]) ) ) /* Le pointeur Y y tait aussi */
  {
    points[0] = _x_pointeur; points[2] = _x_pointeur;
    v_pline(_PRG_station->handle,2,points);

    points[0] = fenetre->w_x + RCT_courant.x1; points[1] = _y_pointeur;
    points[2] = fenetre->w_x + RCT_courant.x2; points[3] = _y_pointeur;
    v_pline(_PRG_station->handle,2,points);
  }

  points[0] = fenetre->w_x + RCT_courant.x1; points[1] = fenetre->w_y + RCT_courant.y1;
  points[2] = fenetre->w_x + RCT_courant.x2; points[3] = fenetre->w_y + RCT_courant.y2;

  if ( ( (y < points[1]) || (y > points[3]) )   /* Le pointeur en Y n'y est pas          */
    || ( (x < points[0]) || (x > points[2]) ) ) /* Le pointeur en X n'y est pas non plus */
  {
    if ( ( (_x_pointeur >= points[0]) && (_x_pointeur <= points[2]) ) 
      && ( (_y_pointeur >= points[1]) && (_y_pointeur <= points[3]) ) )
      /* On vient juste de sortie de la zone du graphe */
    {
#ifdef _FRANCAIS_
      if (graphe_courant->type == GR_SSTYPE)
	FEN_infos(fenetre, "Sans type");
      else if ( graphe_courant->type == GR_INTERNE )
	FEN_infos(fenetre,  "Usage interne - ne pas modifier sous peine de r"e_AIGU"sultats aberrants");
      else if ( graphe_courant->type >= 0 )
	FEN_infos(fenetre, (char *) Type_graphe[graphe_courant->type]);
      else
	FEN_infos(fenetre, "Spectre de type inconnu...");
#endif
#ifdef _ENGLISH_
      if (graphe_courant->type == GR_SSTYPE)
	FEN_infos(fenetre, "No type");
      else if ( graphe_courant->type == GR_INTERNE )
	FEN_infos(fenetre,  "Internale usage - please don't change, or expect strange results");
      else if ( graphe_courant->type >= 0 )
	FEN_infos(fenetre, (char *) Type_graphe[graphe_courant->type]);
      else
	FEN_infos(fenetre, "Unknown type...");
#endif
    }

    graf_mouse(M_ON,NULL);       /* Souris visible */
    wind_update(END_MCTRL);
    wind_update(END_UPDATE);     /* On remet l'AES */
    return VRAI;
  }

  x_echelle = (double) (RCT_courant.x2 - RCT_courant.x1) / (RCT_courant.x_max - RCT_courant.x_min);
  x_reel = RCT_courant.x_min + (x - (fenetre->w_x + RCT_courant.x1)) / x_echelle;

  y_echelle = (double) (RCT_courant.y2 - RCT_courant.y1) / (RCT_courant.y_max - RCT_courant.y_min);
  y_reel = RCT_courant.y_max - (y - (fenetre->w_y + RCT_courant.y1)) / y_echelle;
  
  points[1] = y; points[3] = y;
  v_pline(_PRG_station->handle,2,points);

  points[0] = x; points[1] = fenetre->w_y + RCT_courant.y1;
  points[2] = x; points[3] = fenetre->w_y + RCT_courant.y2;
  v_pline(_PRG_station->handle,2,points);

  if ( ( fabs(x_reel) < 1e-3 ) || ( fabs(x_reel) > 1e6 ) )
  {
    sprintf(val_x, "%e", x_reel);
  }
  else
  {
    sprintf(val_x, "%f", x_reel);
  }

  if ( (fabs(y_reel) < 1e-3) || (fabs(y_reel) > 1e6) )
    sprintf(val_y, "%e", y_reel);
  else
    sprintf(val_y, "%f", y_reel);

  if (graphe_courant->type == GR_SSTYPE)
    sprintf(_intermediaire, "X=%s, Y=%s - Sans type", val_x, val_y);
  else if ( graphe_courant->type == GR_INTERNE )
    sprintf(_intermediaire, "X=%s, Y=%s - Usage interne - ne pas modifier sous peine de r"e_AIGU"sultats aberrants",
	    val_x, val_y);
  else if ( graphe_courant->type >= 0 )
    sprintf(_intermediaire, "X=%s, Y=%s - %s", val_x, val_y, (char *) Type_graphe[graphe_courant->type] );
  else
    sprintf(_intermediaire, "X=%s, Y=%s - Spectre de type inconnu...", val_x, val_y);

  FEN_infos(fenetre, _intermediaire);

  graf_mouse(M_ON,NULL);       /* On raffiche la souris */
  wind_update(END_MCTRL);
  wind_update(END_UPDATE);     /* On remet l'AES */
  return VRAI; /* vnement trait */
}

/* ------------------ Messages pour cette fentre (permet d'viter quelques problmes de pointeurs...)  */

boolean MSG_principale(Fenetre *fenetre)
{
  int nv_larg, nv_haut;
  double inter, x_facteur, y_facteur;

  switch ( buffer[0] )
  {
  case WM_SIZED:  /* Fentre redimensionne */
    /* Reu : changement de taille pas encore ralis -> ancienne largeur dans w_larg et w_haut */

    wind_calc(WC_WORK, NAME|FULLER|MOVER|INFO|SIZER|UPARROW|DNARROW|VSLIDE, /* Les attributs de la fentre */
	      buffer[4], buffer[5], buffer[6], buffer[7], &_rien_, &_rien_, &nv_larg, &nv_haut);

    x_facteur = ( (double) nv_larg ) / ( (double) fenetre->w_larg ); /* Facteurs d'homothtie */
    y_facteur = ( (double) nv_haut ) / ( (double) fenetre->w_haut ); /* Attention : coordonnes de la zone totale... */

    inter = (float) RCT_courant.x1;
    RCT_courant.x1 = (int) (inter * x_facteur);
    inter = (float) RCT_courant.y1;
    RCT_courant.y1 = (int) (inter * y_facteur);
    inter = (float) RCT_courant.x2;
    RCT_courant.x2 = (int) (inter * x_facteur);
    inter = (float) RCT_courant.y2;
    RCT_courant.y2 = (int) (inter * y_facteur);
    return VRAI;
    
  case WM_FULLED: /* Fentre plein cran    */
    /* Reu : changement effectu -> ancienne taille dans o_x, o_y, o_larg, o_haut */

    wind_calc(WC_WORK, NAME|FULLER|MOVER|INFO|SIZER|UPARROW|DNARROW|VSLIDE, /* Les attributs de la fentre */
	      fenetre->o_x,fenetre->o_y,fenetre->o_larg,fenetre->o_haut,&_rien_,&_rien_,&nv_larg,&nv_haut);

    x_facteur = ( (double) fenetre->w_larg ) / ( (double) nv_larg ); /* Facteurs d'homothtie */
    y_facteur = ( (double) fenetre->w_haut ) / ( (double) nv_haut ); /* Attention : coordonnes de la zone totale... */

    inter = (float) RCT_courant.x1;
    RCT_courant.x1 = (int) (inter * x_facteur);
    inter = (float) RCT_courant.y1;
    RCT_courant.y1 = (int) (inter * y_facteur);
    inter = (float) RCT_courant.x2;
    RCT_courant.x2 = (int) (inter * x_facteur);
    inter = (float) RCT_courant.y2;
    RCT_courant.y2 = (int) (inter * y_facteur);

    return VRAI;
  }

  return FAUX; /* Message non trait */
}

/* ------------------ Pour l'aspect gnral du programme -------------------------------- *
 ******************************************************************************************/

#define NBR_LIGNES_D_INFOS 32

/* ------------------ Prparation de l'aspect des arbres GEM ---------------------------- */

void prep_arbres(void)
{
  int i,larg_obj;
  OBJECT *adresse;
  extern const char *TXT_informations[];

  /* Menu principal */
  adresse = arbres[MENU].adresse;
  menu_ienable(adresse, SAUVER, 0);
  menu_ienable(adresse, EXPORTER, 0);	
  menu_ienable(adresse, TIT_GRAPHES,    0);
  menu_ienable(adresse, TIT_EXTRACTION, 0);
  menu_ienable(adresse, TIT_FILTRAGE,   0);
  menu_ienable(adresse, TIT_ERREURS,    0);
  menu_ienable(adresse, TIT_TRACE,      0);
  menu_ienable(adresse, IMP_GRAPHE, (gdos != -2)); /* Impression inactive sans GDOS */
  arbres[MENU].clavier = CLA_menu;

  /* Import des graphes : on corrige le chevauchement des boutons */
  adresse = arbres[TYPE_LIGNE].adresse;
  OB_HEIGHT(adresse, LIGNES_FOND) += 3;
  OB_Y     (adresse, LURE_2)      += 1;
  OB_Y     (adresse, ITALIE)      += 2;
  OB_Y     (adresse, AUTRE_LIGNE) += 3;
  OBJ_active (TYPE_LIGNE, LIGNES_SAUT, FORCE_NON);
  OBJ_active (TYPE_LIGNE, ENERGIE,     FORCE_NON);
  OBJ_active (TYPE_LIGNE, COLONNE_I0,  FORCE_NON);
  OBJ_active (TYPE_LIGNE, COLONNE_I1,  FORCE_NON);
  arbres[TYPE_LIGNE].fonction.arbre = GER_extrait; /* Fonction grant cet arbre */

  /* Slecteur de graphes : on vite le chevauchement de l'ascenseur... */
  adresse = arbres[CHOIX_GRAPHE].adresse;
  OB_X    (adresse,GRAPHE_AVANT) += 1;
  OB_X    (adresse,GRAPHE_FOND)  += 1;
  OB_Y    (adresse,GRAPHE_FOND)  += 1;
  OB_X    (adresse,GRAPHE_APRES) += 1;
  OB_HEIGHT(adresse,GRAPHE_FOND) -= 2;
  ( (USERBLK *) OB_SPEC(adresse,LIGNE_GRAPHE ))->ub_code = USR_style; /* Style de ligne */
  arbres[CHOIX_GRAPHE].fonction.arbre = GER_graphes;

  /* Informations : change des menus */
  arbres[INFORMATIONS].fonction.arbre = GER_infos;
  arbres[INFORMATIONS].pointeur = NULL;
  OB_X(arbres[INFORMATIONS].adresse, INFOS_PREM_TEXTE - 1) += 1;
  PDFL_textes(INFORMATIONS, INFOS_PREM_TEXTE, INFOS_DERN_TEXTE,
	      INFOS_AVANT, INFOS_APRES, INFOS_FOND, INFOS_FOND + 1,
	      NBR_LIGNES_D_INFOS, (char **) TXT_informations, NULL, NBR_LIGNES_D_INFOS + 1, 55, 0);
#ifdef _LIMITE_ /* Version limite -> pas de calculs thoriques, pas d'ajustements */
  OBJ_active(INFORMATIONS, CALC_THEORIQUES, FORCE_NON);
  OBJ_active(INFORMATIONS, EXF_AJUSTEMENTS, FORCE_NON);
#endif

  /* Menu des couleurs : on le met  la bonne largeur */
  adresse = arbres[CHX_COULEUR].adresse;
  for (i = ROOT ; i < 16 ; i++)
    OB_WIDTH(adresse,i) = OB_WIDTH(arbres[CHOIX_GRAPHE].adresse,COULEUR_GRAPHE);

  /* limination de la contribution de la matrice : chevauchement des boutons de mthode */
  adresse = arbres[ELIM_MUMATRICE].adresse;
  OB_WIDTH(adresse,2)          += 1;
  OB_HEIGHT(adresse,2)         += 1;
  OB_X(adresse, ELIM_MUM_AVANT) += 1;
  OB_X(adresse, ELIM_MUM_FOND)  += 1;
  OB_Y(adresse, ELIM_MUM_FOND)  += 1;
  OB_HEIGHT(adresse, ELIM_MUM_FOND) -= 2;
  OB_X(adresse, ELIM_MUM_APRES) += 1;
  OB_HEIGHT(adresse,ROOT)      += 1;
  arbres[ELIM_MUMATRICE].fonction.arbre = GER_matrice;

  /* limination de [mu]0, premire tape : choix de la mthode */
  adresse = arbres[ELIM_MU0_1].adresse;
  OB_HEIGHT(adresse,ROOT)     += 1;
  OB_HEIGHT(adresse,12)       += 1;
  OB_Y(adresse,ELIM_MU0_LENT) += 1;
  arbres[ELIM_MU0_1].fonction.arbre = GER_mu01;

  /* Import de fichiers FEFF : chevauchement des boutons de choix */
  adresse = arbres[IMPORTE_FEFF].adresse;
  OB_WIDTH(adresse,2)       += 1;
  OB_HEIGHT(adresse,2)      += 1;
  OB_X(adresse,FEFF_CHIP)   += 1;
  OB_Y(adresse,FEFF_CHI)    += 1;
  OB_X(adresse,FEFF_XMU)    += 1;
  OB_Y(adresse,FEFF_XMU)    += 1;
  OB_X(adresse,FEFF_AMP)    += 1;
  OB_X(adresse,FEFF_PHASE)  += 2;
  OB_Y(adresse,FEFF_REDFAC) += 1;
  OB_X(adresse,FEFF_LIBRE)  += 1;
  OB_Y(adresse,FEFF_LIBRE)  += 1;
  OB_X(adresse,FEFF_RE_PH)  += 2;
  OB_Y(adresse,FEFF_RE_PH)  += 1;
  OB_Y(adresse,FEFF_PHIM2KR) += 2;
  OB_X(adresse, FEFF_EXAFS) += 1;
  OB_Y(adresse, FEFF_EXAFS) += 2;
  OB_X(adresse, FEFF_EXAFS + 1) += 2;
  OB_Y(adresse, FEFF_EXAFS + 1) += 2;
  OB_Y(adresse, FEFF_UNIQUE) += 1;
  arbres[IMPORTE_FEFF].fonction.arbre = GER_feff;
  
  /* limination de mu0, deuxime tape */
  arbres[ELIM_MUO_DEUX].fonction.arbre = GER_mu02;

  /* Demande d'un graphe de type donn  l'utilisateur */
  arbres[CHX_GRAPHE].fonction.arbre = GER_choix;

  /* Dbut de la transformation de Fourier */
  adresse = arbres[DEBUT_TF].adresse;
  OB_Y(adresse,TF_COR_AMP) -= 1;
  OB_WIDTH(adresse,TF_COR_AMP) += 1;
  OB_X(adresse,TF_COR_AMP_AV) += 1;
  OB_X(adresse,TF_COR_AMP_FOND) += 1;
  OB_Y(adresse,TF_COR_AMP_FOND) += 1;
  OB_HEIGHT(adresse,TF_COR_AMP_FOND) -= 2;
  OB_X(adresse,TF_COR_AMP_AP) += 1;
  OB_Y(adresse,TF_COR_PHASE) -= 1;
  OB_WIDTH(adresse,TF_COR_PHASE) += 1;
  OB_X(adresse,TF_COR_PHA_AV) += 1;
  OB_X(adresse,TF_COR_PHA_FOND) += 1;
  OB_Y(adresse,TF_COR_PHA_FOND) += 1;
  OB_HEIGHT(adresse,TF_COR_PHA_FOND) -= 2;
  OB_X(adresse,TF_COR_PHA_AP) += 1;	
  arbres[DEBUT_TF].fonction.arbre = GER_debTF;

  /* Sauvegarde au format GEM */
  adresse = arbres[PARAM_GEM].adresse;
  OB_Y(adresse,GEM_A4_PAYSAGE)  += 1;   /* Paramtres de sauvegarde GEM */
  arbres[PARAM_GEM].fonction.arbre = GER_svgem;

  /* Menu des styles : objets USERDEF et bonne dimension */
  adresse = arbres[CHOIX_STYLE].adresse;
  larg_obj = OB_WIDTH(arbres[CHOIX_GRAPHE].adresse,LIGNE_GRAPHE);
  OB_WIDTH(adresse,ROOT) = larg_obj;
  for (i = 1 ; i <= 12 ; i++)
  {
    OB_WIDTH(adresse,i) = larg_obj;
    ( (USERBLK *) OB_SPEC(adresse,i) )->ub_code = USR_style;
    ( (USERBLK *) OB_SPEC(adresse,i) )->ub_parm = i-1;
  }		

  /* Dcomposition d'une TF : chevauchement des boutons */	
  adresse = arbres[DECOMP_FOURIER].adresse;
  OB_X(adresse,DTF_IMAG)   += 1;
  OB_Y(adresse,DTF_MODULE) += 1;
  OB_X(adresse,DTF_ARG)    += 1;
  OB_Y(adresse,DTF_ARG)    += 1;

  /* Calcul de la TF inverse : chevauchement des boutons de choix de fentre */
  adresse = arbres[PARAM_TFI].adresse;
  OB_Y(adresse, TFI_AMPLITUDE) += 1;         OB_Y(adresse, TFI_MIT)      += 1;
  OB_Y(adresse, TFI_PHASE)     += 2;         OB_Y(adresse, TFI_GENERALE) += 2;
  OB_Y(adresse, TFI_COMPLEXE)  += 3;
  OB_X(adresse, TFI_FEN_AVANT) += 1;
  OB_X(adresse, TFI_FOND_ASC)  += 1;
  OB_X(adresse, TFI_FEN_APRES) += 1;
  arbres[PARAM_TFI].fonction.arbre = GER_paramtfi;

  /* limination de mu_0, troisime tape */
  arbres[ELIM_MU0_TROIS].fonction.arbre = GER_mu03;

  /* Intgration du prseuil */
  adresse = arbres[INTG_XANES].adresse;
  arbres[INTG_XANES].fonction.arbre = GER_intg;

  /* Tri d'un graphe */
  adresse = arbres[ORDONNE_GRAPHE].adresse;
  OB_Y(adresse, TRI_NBR_BLOCS) += (int) ( OB_HEIGHT(adresse, TRI_NBR_BLOCS) / 2 );
  arbres[ORDONNE_GRAPHE].fonction.arbre = GER_tri;

  /* Fusion de deux graphes */
  adresse = arbres[FUSION_GRAPHES].adresse;
  OB_X(adresse,FUSION_AVANT) += 1;
  OB_X(adresse,FUSION_APRES) += 1;
  OB_X(adresse,FUSION_FOND)  += 1;
  OB_Y(adresse,FUSION_FOND)  += 1;
  OB_HEIGHT(adresse,FUSION_FOND) -= 2;
  arbres[FUSION_GRAPHES].fonction.arbre = GER_fusion;

  /* limination d'une aberrance */
  adresse = arbres[ELIM_ABERRANCE].adresse;
  OB_HEIGHT(adresse,ROOT)   += 1;
  OB_X(adresse,ABER_POLY2)  += 1;
  OB_Y(adresse,ABER_SPLINE) += 1;
  arbres[ELIM_ABERRANCE].fonction.arbre = GER_aberrance;

  /* Paramtrage du trac des axes sur les graphes */
  adresse = arbres[PARAM_LEGENDE].adresse;
  ( (USERBLK *) OB_SPEC(adresse, LEG_STYLE) )->ub_code = USR_style; /* Trac de la ligne           */
  ( (USERBLK *) OB_SPEC(adresse, LEG_STYLE) )->ub_parm = 0;            /* Ligne continue par dfaut   */
  ( (USERBLK *) OB_SPEC(adresse, LEG_FNT_NOM) )->ub_code = USR_fonte;  /* Texte avec la fonte choisie */
  ( (USERBLK *) OB_SPEC(adresse, LEG_FNT_NOM) )->ub_parm = 0;          /* Fonte systme par dfaut    */	
  OB_Y(adresse, LEG_GRAD_DECIMAL) += 1;
  OB_Y(adresse, LEG_GRAD_LOG) += 2;
  arbres[PARAM_LEGENDE].fonction.arbre = GER_legende;

#ifndef _LIMITE_ /* Seulement dans la version complte */
  /* Calcul d'une phase thorique */
  adresse = arbres[CALC_PHASE].adresse;
  arbres[CALC_PHASE].fonction.arbre = GER_phase;
#endif

  /* Sous-menu des options de trac de plusieurs graphes */
  OBJ_active(SSMEN_RECTANGLES, SSMEN_IMPRIME, gdos != -2); /* Impression seulement si GDOS actif */

  /* Troncature d'un graphe */
  arbres[TRONQUE_GRAPHE].fonction.arbre = GER_tronque;

  /* Type d'image  exporter */
  if (gdos == -2) /* GDOS absent */
  {
    OBJ_active(TYPE_IMAGE, IMG_GEM, FORCE_NON);
    OBJ_active(TYPE_IMAGE, IMG_IMG, FORCE_NON);
  }

  /* Normalisation d'un X.A.N.E.S. */
  arbres[NORM_XANES].fonction.arbre = GER_xnorm;

  /* TF : chevauchement des boutons de choix de fentre */
  adresse = arbres[PARAM_FOURIER].adresse;
  OB_X(adresse, FOUR_FEN_AVANT)   += 1;
  OB_X(adresse, FOUR_FEN_APRES)   += 1;
  OB_X(adresse, FOUR_FEN_BOUTON - 1) += 1;
  OB_Y(adresse, FOUR_FEN_BOUTON - 1) += 1;
  OB_HEIGHT(adresse, FOUR_FEN_BOUTON - 1) -= 2;

  /* TFI, arbre en fentre */
  adresse = arbres[PARAM_FOUR_INVER].adresse;
  OB_X(adresse, TF_INV_FEN_AVANT) += 1;
  OB_X(adresse, TF_INV_FEN_APRES) += 1;
  OB_X(adresse, TF_INV_FEN_FOND)  += 1;
  OB_Y(adresse, TF_INV_FEN_FOND)  += 1;
  OB_HEIGHT(adresse, TF_INV_FEN_FOND) -= 2;

  /* Extraction de l'EXAFS en utilisant un mu0 dj calcul */
  arbres[OTE_MU0_CALC].fonction.arbre = GER_mu0;	

  /* Dcomposition d'un graphe sur une base de 2 graphes */
  arbres[DECOMP_GRAPHE].fonction.arbre = GER_decompose;

#ifndef _LIMITE_ /* Seulement dans la version complte */

  /* Menu des calculs thoriques */
  arbres[MEN_THEORIE].clavier = CLV_men_theorie;

  /* Menu des ajustements        */
  arbres[MEN_AJUSTE].clavier = CLV_men_ajuste;

#endif /* _LIMITE_ */

  /* Calcul des barres d'erreur pour une srie de spectres E.X.A.F.S. */
  adresse = arbres[BARRE_ERREUR].adresse;
  arbres[BARRE_ERREUR].fonction.arbre = GER_dispersion;
  OB_X(adresse, BERR_GRF_AVANT)   += 1;
  OB_X(adresse, BERR_GRF_ASC_FND) += 1;
  OB_X(adresse, BERR_GRF_APRES)   += 1;
  OB_Y(adresse, BERR_TITRE_X) += OB_HEIGHT(adresse, BERR_TITRE_X) / 2;
  OB_Y(adresse, BERR_TITRE_Y) += OB_HEIGHT(adresse, BERR_TITRE_Y) / 2;

  /* Extraction en une seule tape du spectre E.X.A.F.S. */
  arbres[EXAFS_GENERAL].fonction.arbre = GER_reproduit;
}
