/* Dfinition de quelques constantes revenant souvent en physique,... */

/* Dfinitions dans le systme SI - venant du H prpa */

#define AVOGADRO        6.022045e23     /* mol^-1 - Rivail */
#define BOLTZMANN       1.380658e-23    /* J/K    */
#define CHARGE_ELECTRON 1.6021892e-19   /* C      - Rivail */
#define EPSILON_0       8.85418782e-12  /* F/m    - Rivail */
#define FARADAY         96485.31        /* C/mol  */
#define GAZ_PARFAIT     8.314410        /* J/mol  - Rivail */
#define FACTEUR_LANDE   2.0023193134    /* s. u.  - Rivail */
#define MASSE_ELECTRON  9.109534e-31    /* kg     - Rivail */
#define MASSE_NEUTRON   1.674928e-27    /* kg     */
#define MASSE_PROTON    1.6726485e-27   /* kg     - Rivail */
#define MAGNETON_BOHR   9.274078e-24    /* J/T    - Rivail */
#define MU_0            12.566370614e-7 /* H/m    */
#define NRJ_HARTREE     4.359814e-18    /* J      - Rivail */
#define PLANCK          6.626176e-34    /* J.s    - Rivail */
#define PLANCK_REDUITE  1.0545887e-34   /* J.s    - Rivail */
#define RAYON_BOHR      5.2917706e-11   /* m      - Rivail */
#define RYDBERG         1.097373153e7   /* m^-1   */
#define VITESSE_LUMIERE 2.99792458e8    /* m/s    - Rivail */

/* Quelques quivalences */

#define H_BARRE         PLANCK_REDUITE

/* Dfinitions de quelques facteurs de conversion */

#define EV_V_JOULE      CHARGE_ELECTRON /* 1 eV = 1,6.10^-19 J */
#define M_V_ANGSTROM    1e10            /* 1 m  = 10^10       */
#define ANGSTROM_V_M    1e-10           /* 1   = 10^-10 m     */ 

/* Quelques constantes mathmatiques usuelles, non-dfinies en ANSI strict, pour GCC */

#define MIN_DOUBLE -4e4930 /* Extrmes pour les valeurs non-NaN en double... */
#define MAX_DOUBLE  4e4930

#ifndef M_PI /* Exemple type : M_PI pour pi */

#define M_LN2        0.69314718055994530942
#define M_PI         3.14159265358979323846
#define M_SQRT2      1.41421356237309504880
#define M_E          2.7182818284590452354
#define M_LOG2E      1.4426950408889634074
#define M_LOG10E     0.43429448190325182765
#define M_LN10       2.30258509299404568402
#define M_PI_2       1.57079632679489661923
#define M_PI_4       0.78539816339744830962
#define M_1_PI       0.31830988618379067154
#define M_2_PI       0.63661977236758134308
#define M_2_SQRTPI   1.12837916709551257390
#define M_SQRT1_2    0.70710678118654752440

#endif /* M_PI */
