/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
			   Tout ce qui concerne la superposition de divers graphes, ainsi que leur trac...
   (c) Emmanuel CURIS 1996 - 1997

   26 mars 1998
     * Utilisation des stations VDI avances (Station_VDI) -> plus portable [j'espre...]
     * Remplac _tous_ les vdi_handle par _PRG_station->handle

   16 mars 1998
     * Inclus "erreurs.h" pour prototypes de isnan() et isinf()

   6, 12 & 13, 19 janvier 1998
     * Corrig RCT_trace : plantait si rect == NULL (aucun rectangle) (sur Falcon en tout cas)
     * Dans chg_legende() : remplac OB_??? par OBJ_???
     * Dans TRC_poly, utilis _PRG_station->handle au lieu de vdi_handle
     * Dans TRC_cadre, vrifie que les bornes ne sont pas des NaN
     * Impression des graphes superposs : premier essai - pour voir ! a tourne !
     * Inclus les messages d'erreur GEM <erreurs.h>
     * Modifi le protocole d'appel de l'export d'images
     * Inclus export.h

  24 - 28 novembre 1997
     * Trac d'une grille : cration de la fonction TRC_grille()
                               choix du pas de la grille amlior
	                       paramtre indiquant si on est X/Y normal ou tourn de +90 degrs
                               effectif pour l'axe X et l'axe Y; paramtrage fonctionne
     * Ajout l'affichage des coordonnes dans la fentre de trac des graphes
     * Modifi TRC_cadre : ne plante plus si une des bornes est infinie (joie...)
     * Complt le paramtrage des lgendes : texte, style de grille, taille de fonte, unit
     * Corrig erreur de calcul des y dans CLC_rect (le calcul des bornes choisies par un rectangle)
     * Corrig le calcul de lieu_centre -> vite la succession des 2 qd on clic sur le bord bas
     * Modifi TRC_poly() : ne trace que si le point apparat dans la zone indique en paramtres
     * Commenc le squelette de RCT_trace (affichage d'un pointeur sur des graphes superposs)
     * Cration de cet historique
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SYSTEME.H"

#include "GRAPHES.H"

#include "ERREURS.H"
#include "EXAFS.H"
#include "EXPORT.H"
#include "IMPRIME.H"

/* ~~~~~~~~~~~ Ouverture de la fentre de trac de plusieurs graphes ~~~~~ */

void TRC_ouvre(void)
{
  Cadre *rect = NULL;

  if (trace_fenetre) /* La fentre existe dj -> on la met au premier plan */
  {
    if (trace_fenetre->drapeaux.ouverte == VRAI) /* Dj ouverte */
    {
      FEN_premierplan(trace_fenetre);
      
      /* Voir pour le pointeur ventuellement */
    }
    else
      FEN_reouvre(trace_fenetre);

    return; /* Rien d'autre  faire */
  }

  /* La fentre n'existe pas */

#ifdef _FRANCAIS_
  trace_fenetre = creer_fenetre(CLOSER|MOVER|FULLER|NAME|INFO|SIZER,
				"Mise en forme des r"e_AIGU"sultats","",
				RDS_trace, (void (*)(Fenetre *, int, int, int)) NULL,
				(boolean (*)(Fenetre *, unsigned int, int)) NULL,
				CLC_trace, MSG_trace, RCT_trace,
				(boolean (*)(Fenetre *)) NULL );
#endif
#ifdef _ENGLISH_
  trace_fenetre = creer_fenetre(CLOSER|MOVER|FULLER|NAME|INFO|SIZER,
				"Paging of the results","",
				RDS_trace, (void (*)(Fenetre *, int, int, int)) NULL,
				(boolean (*)(Fenetre *, unsigned int, int)) NULL,
				CLC_trace, MSG_trace, RCT_trace,
				(boolean (*)(Fenetre *)) NULL );
#endif

  if (trace_fenetre == NULL) return; /* Problme  l'ouverture de la fentre */

  trace_fenetre->drapeaux.redessin = VRAI;
  trace_fenetre->msg_masque.plein_ecran  = VRAI;
  trace_fenetre->msg_masque.taille       = VRAI;
  trace_fenetre->msg_masque.premier_plan = VRAI;
  trace_fenetre->msg_masque.fermeture    = VRAI;

  ouvre_fenetre(trace_fenetre,x_gem,y_gem,larg_gem,haut_gem); /* On l'ouvre */

  if (prem_rectangle == NULL) /* Aucun rectangle n'a t dfini */
  {
    /* On cre le premier rectangle */
    rect = REC_creer(REC_GRAPHE, 0, 0,
		     trace_fenetre->w_larg, trace_fenetre->w_haut);
    if (rect == NULL)
    {
      ferme_fenetre(trace_fenetre);
      trace_fenetre = NULL;
      return;
    }
  }
}

/* ~~~~~~~~~~~ Gestion de la fentre de trac de plusieurs graphes ~~~~~~~ */

/* ----------- Redessin de la fentre -------------------------------------\
 |   Comme d'habitude, le clipping est dj mis et l'AES entirement coup |
 |   Paramtres aussi comme d'habitude                                     |
 \------------------------------------------------------------------------ */

void RDS_trace(Fenetre *fenetre, int x, int y, int larg, int haut)
{
	int x_rect,y_rect,larg_rect,haut_rect;
	Cadre *rect;

	vswr_mode(_PRG_station->handle, MD_REMPLACE);

	vsf_color(_PRG_station->handle, BLANC);
	points[0] = x;
	points[1] = y;
	points[2] = x + larg;
	points[3] = y + haut;
	v_bar(_PRG_station->handle,points); /* Le fond en blanc de toute faon */

	if (prem_rectangle == NULL)
	{
		points[0] = fenetre->w_x + fenetre->w_larg / 2;
		points[1] = fenetre->w_y + fenetre->w_haut / 2 - 20;
		v_gtext(_PRG_station->handle,points[0],points[1],"Aucun rectangle n'est dfini...");
		
		points[1] += 40;
		v_gtext(_PRG_station->handle,points[0],points[1],"Control-R pour en crer un");
		return; /* Rien d'autre  faire */
	}

	for (rect = prem_rectangle ; rect ; rect = rect->apres )
	{
		x_rect = fenetre->w_x + rect->x;                 /* Dimensions du rectangle trait */
		y_rect = fenetre->w_y + rect->y;
		larg_rect = rect->larg - rect->x;
		haut_rect = rect->haut - rect->y;
		if ( Rc_intersect(x,y,larg,haut,&x_rect,&y_rect,&larg_rect,&haut_rect) )
		/* Le rectangle est dans la zone  redessiner */
		{
			points[0] = x_rect; points[1] = y_rect;
			points[2] = x_rect + larg_rect; points[3] = y_rect + haut_rect;
			vs_clip(_PRG_station->handle,1,points); /* On limite le dessin  cette portion de rectangle */

			points[0] = fenetre->w_x + rect->x;     points[1] = fenetre->w_y + rect->y;
			points[2] = fenetre->w_x + rect->larg ; points[3] = points[1];
			points[4] = points[2];                  points[5] = fenetre->w_y + rect->haut;
			points[6] = points[0];                  points[7] = points[5];
			points[8] = points[0];                  points[9] = points[1];
			vsl_color(_PRG_station->handle, NOIR);
			vsl_type (_PRG_station->handle, 3);
			v_pline(_PRG_station->handle,5,points); /* Cadre pour ce rectangle, en pointills */

			switch (rect->type)
			{
			case REC_GRAPHE: /* Rectangle contient des graphes... */
				DES_Rgraphe(_PRG_station,fenetre,rect);
				break;
			}
		}
	}
}

/* ----------- Gestion des messages reus par la fentre ----------------- */

boolean MSG_trace(Fenetre *fenetre)
{
	Cadre *rect = prem_rectangle;
	float x_facteur,y_facteur,inter;
	int rien,nv_larg,nv_haut; /* Nouvelles dimensions de la fentre */

	switch (buffer[0])
	{
	case WM_TOPPED: /* On veut passer la fentre au premier plan */
		FEN_premierplan(fenetre);
		return VRAI;

	case WM_CLOSED: /* On ferme la fentre */
		FEN_ferme(fenetre, VRAI);
		return VRAI;

	case WM_FULLED: /* Fentre plein cran */
		/* Reu : changement effectu -> ancienne taille dans o_x, o_y, o_larg, o_haut */
		if (rect == NULL) return VRAI;
		wind_calc(WC_WORK,CLOSER|MOVER|FULLER|NAME|INFO|SIZER, /* Les attributs de la fentre */
		          fenetre->o_x,fenetre->o_y,fenetre->o_larg,fenetre->o_haut,&rien,&rien,&nv_larg,&nv_haut);

		x_facteur = ( (double) fenetre->w_larg ) / ( (double) nv_larg ); /* Facteurs d'homothtie */
		y_facteur = ( (double) fenetre->w_haut ) / ( (double) nv_haut ); /* Attention : coordonnes de la zone totale... */

		for ( ; rect ; rect = rect->apres )
		{
			rect->x    = (int) ( ( (float) rect->x)    * x_facteur );
			rect->y    = (int) ( ( (float) rect->y)    * y_facteur );
			rect->larg = (int) ( ( (float) rect->larg) * x_facteur );
			rect->haut = (int) ( ( (float) rect->haut) * y_facteur );
			if ( rect->type == REC_GRAPHE )
			{
				inter = (float) ((Rect_graphe *) rect->pointeur)->x1;
				((Rect_graphe *) rect->pointeur)->x1 = (int) (inter * x_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->y1;
				((Rect_graphe *) rect->pointeur)->y1 = (int) (inter * y_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->x2;
				((Rect_graphe *) rect->pointeur)->x2 = (int) (inter * x_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->y2;
				((Rect_graphe *) rect->pointeur)->y2 = (int) (inter * y_facteur);
			}
		}
		return VRAI;

	case WM_SIZED:  /* Fentre redimensionne -> mettre  jour les positions des rectangles */
		/* Quand on le reoit : changement de taille pas encore ralise -> ancienne largeur dans o_larg et o_haut */
		if (rect == NULL) return VRAI; /* Aucun rectangle */

		wind_calc(WC_WORK,CLOSER|MOVER|FULLER|NAME|INFO|SIZER, /* Les attributs de la fentre */
		          buffer[4],buffer[5],buffer[6],buffer[7],&rien,&rien,&nv_larg,&nv_haut);

		x_facteur = ( (double) nv_larg ) / ( (double) fenetre->w_larg ); /* Facteurs d'homothtie */
		y_facteur = ( (double) nv_haut ) / ( (double) fenetre->w_haut ); /* Attention : coordonnes de la zone totale... */

		for ( ; rect ; rect = rect->apres )
		{
			rect->x    = (int) ( ( (float) rect->x)    * x_facteur );
			rect->y    = (int) ( ( (float) rect->y)    * y_facteur );
			rect->larg = (int) ( ( (float) rect->larg) * x_facteur );
			rect->haut = (int) ( ( (float) rect->haut) * y_facteur );
			if ( rect->type == REC_GRAPHE )
			{
				inter = (float) ((Rect_graphe *) rect->pointeur)->x1;
				((Rect_graphe *) rect->pointeur)->x1 = (int) (inter * x_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->y1;
				((Rect_graphe *) rect->pointeur)->y1 = (int) (inter * y_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->x2;
				((Rect_graphe *) rect->pointeur)->x2 = (int) (inter * x_facteur);
				inter = (float) ((Rect_graphe *) rect->pointeur)->y2;
				((Rect_graphe *) rect->pointeur)->y2 = (int) (inter * y_facteur);
			}
		}
		return VRAI;

	}

	return VRAI;
}

/* ----------- Gestion des clics sur cette fentre ----------------------- */

boolean CLC_trace(Fenetre *fenetre, int bouton, int n_clic, int etat, int x, int y)
{
  Position lieu_clic = {0, 0, 0, 0, 0, 0, 0, 0};
  Cadre *rect;

#if GEM
  int handle;

  wind_get(0, WF_TOP, &handle, &_rien_, &_rien_, &_rien_);
  if (handle != fenetre->handle)
  {
    wind_set(fenetre->handle, WF_TOP); /* On passe la fentre au premier plan */
    return VRAI;
  }
#endif

  /* Ici : la fentre est au premier plan */

  points[0] = fenetre->w_x;                points[1] = fenetre->w_y;
  points[2] = points[0] + fenetre->w_larg; points[3] = points[1] + fenetre->w_haut;
  vs_clip(_PRG_station->handle, 1, points); /* On met donc le clipping */

  /* On passe en coordonnes relatives  la zone de travail */
  x -= fenetre->w_x;
  y -= fenetre->w_y;

/*	if ( (x < 0) || (y < 0) || (x > fenetre->w_larg) || (y > fenetre->w_haut) )
		return VRAI; 	/* Clic en-dehors de la zone de travail -> rien  faire */

  if (bouton == 2) /* Clic du bouton droit -> sous-menu de gestion des rectangles */
  {
    int option, retour;
    
    option = GER_ssmenu(SSMEN_RECTANGLES, -1, x, y);
    switch (option)
    {
    case SSMEN_EXPORT: /* Export d'une image (vectorielle / bitmap) */
      EXP_image(VRAI); /* Sauver une image de la fentre de trac */
      break;

    case SSMEN_IMPRIME: /* Impression de l'image */
      imprimer(VRAI);
      break;
    }
    
    return VRAI; /* On a trait -> c'est fini */
  }

  if (prem_rectangle == NULL) /* Aucun rectangle cr */
    return VRAI; /* Rien d'autre  faire */

  rect = prem_rectangle;
  while ( ( x < rect->x - 5 )              || ( y < rect->y - 5   ) 
	  || ( x > rect->x + rect->larg + 5 ) || ( y > rect->y + rect->haut + 5) )
  {
    rect = rect->apres;
    if (rect == NULL) /* Clic en dehors des rectangles */
      return VRAI;
  }

  if ( x < rect->x + 5 )             lieu_clic.bord_gauche = VRAI;
  if ( y < rect->y + 5 )             lieu_clic.bord_haut   = VRAI;
  if ( x > rect->x + rect->larg - 5) lieu_clic.bord_droit  = VRAI;
  if ( y > rect->y + rect->haut - 5) lieu_clic.bord_bas    = VRAI;
  
  if ( (lieu_clic.bord_gauche == 0) && (lieu_clic.bord_droit == 0)
     && (lieu_clic.bord_haut == 0) && (lieu_clic.bord_bas == 0) )  /* On a cliqu au centre */
  {
    switch (rect->type)
    {
    case REC_GRAPHE: /* Rectangle contenant un graphe */
      CLC_Rgraphe(fenetre, rect, x, y, n_clic, etat);
    }
  }
  else /* On dplace le rectangle */
  {
    REC_bouge(rect, &lieu_clic, x, y, fenetre->w_larg, fenetre->w_haut);
  }

  return VRAI;
}

/* ----------- Gestion du pointeur souris sur cette fentre -------------- */

boolean RCT_trace(Fenetre *fenetre, int x, int y)
{
  boolean deja_pointeur = FAUX; /* VRAI : il y avait un pointeur avant */
  int vx_x, vx_y;
  Cadre   *rect;
  Rect_graphe *R_graphe;

  if (prem_rectangle == NULL) /* Aucun rectangle cr */
    return VRAI; /* Rien d'autre  faire */

  /* On commence par effacer l'ancien pointeur souris */

  vx_x = _x_pointeur - fenetre->w_x;
  vx_y = _y_pointeur - fenetre->w_y;

  /* On cherche le rectangle sur lequel tait la souris */
  
  rect = prem_rectangle;
  while ( rect )
  {
    if ( ( vx_x > rect->x )              && ( y > rect->y              ) 
	 && ( vx_x < rect->x + rect->larg ) && ( y < rect->y + rect->haut ) )
    {
      deja_pointeur = VRAI;
      break;
    }
    rect = rect->apres;
  }
  if ( rect ) /* Il y avait bien un rectangle sous la souris */
  {
    if ( rect->type != REC_GRAPHE ) /* On n'tait pas sur un rectangle contenant un graphe */
      deja_pointeur = FAUX;
    
    if ( deja_pointeur == VRAI ) /* Il va donc falloir l'effacer */
    {
      vx_x -= rect->x;
      vx_y -= rect->y;
    }
  }

  /* Maintenant, on s'occupe de l'ventuel nouveau pointeur */

  x -= fenetre->w_x; /* On passe en coordonnes relatives  la fentre */
  y -= fenetre->w_y;

  /* On cherche le rectangle sur lequel est la souris */

  rect = prem_rectangle;
  while ( ( x < rect->x )              || ( y < rect->y              ) 
	  || ( x > rect->x + rect->larg ) || ( y > rect->y + rect->haut ) )
  {
    rect = rect->apres;
    if (rect == NULL) /* La souris n'est sur aucun rectangle */
      return VRAI;
  }

  if ( rect->type != REC_GRAPHE ) /* On n'est pas sur un rectangle contenant un graphe */
    return VRAI;

  R_graphe = (Rect_graphe *) rect->pointeur;
  if (R_graphe == NULL) /* Pas trs logique, mais bon... */
    return VRAI;
  
  x -= rect->x; /* Coordonnes relatives au rectangle */
  y -= rect->y;
  
  if ( (x >= R_graphe->x1) && (x <= R_graphe->x2)
       && (y >= R_graphe->y1) && (y <= R_graphe->y2) )
  {
    double echelle, x_reel, y_reel;
    
    echelle = (R_graphe->x_max - R_graphe->x_min) / (R_graphe->x2 - R_graphe->x1);
    if (echelle == 0) return VRAI;
    x_reel = R_graphe->x_min + (x - R_graphe->x1) * echelle;

    echelle = (R_graphe->y_max - R_graphe->y_min) / (R_graphe->y2 - R_graphe->y1);
    if (echelle == 0) return VRAI;
    y_reel = R_graphe->y_max - (y - R_graphe->y1) * echelle;
    
    sprintf(_intermediaire,"X = %f - Y = %f", x_reel, y_reel);
    FEN_infos(fenetre, _intermediaire);
  }

  return VRAI;
}

/* ~~~~~~~~~~~ Tout ce qui concerne la gestion des rectangles ~~~~~~~~~~~~ */

/* ----------- Cration d'un nouveau rectangle ----------------------------\
 |  Renvoie l'adresse du rectangle ainsi cr                              |
 |
 | type   : le type de rectangle qu'il faut crer                          |
 | x1, y1 : coordones du coin suprieur gauche                            |
 | x2, y2 : coordonnes du coin infrieur droit de ce rectangle            |
 \------------------------------------------------------------------------ */

Cadre *REC_creer(int type, int x1, int y1, int x2, int y2)
{
	Cadre   *rect;
	Rect_graphe *Rgraphe;

	rect = (Cadre *) malloc( sizeof(Cadre) );
	if (rect == NULL)
	{
		ERREUR(MANQUE_MEMOIRE);
		return NULL;
	}

	rect->type = type; /* Type du rectangle                 */
	rect->x = x1;      /* Positions par dfaut du rectangle */
	rect->y = y1;
	rect->larg = x2;
	rect->haut = y2;

	switch (type) /* Suivant le type */
	{
	case REC_GRAPHE: /* Rectangle devant contenir une superposition de graphes */
		Rgraphe = (Rect_graphe *) malloc( sizeof(Rect_graphe) );
		if (Rgraphe == NULL)
		{
			ERREUR(MANQUE_MEMOIRE);
			free(rect); /* On efface cela, qui ne sert  rien */
			return NULL;
		}
		Rgraphe->x1 = 40; /* Positions par dfaut du cadre -> place pour les lgendes */
		Rgraphe->y1 = 10;
		Rgraphe->x2 = (rect->larg - rect->x) - 10;
		Rgraphe->y2 = (rect->haut - rect->y) - 40;

		Rgraphe->nbr_graphes = 0; /* Par dfaut : on affiche les graphes marqus visibles */
		Rgraphe->prem_graphe = NULL;
		REC_bornes(Rgraphe); /* On calcule les bornes pour ce rectangle, colle au mieux avec les graphes slectionns */

		strcpy(Rgraphe->axe_x.legende,"Sans lgende"); /* Infos axe des X */
		strcpy(Rgraphe->axe_x.unite,"ss u.");
		Rgraphe->axe_x.graduation.gradue   = GRADUE_DECIMAL;
		Rgraphe->axe_x.graduation.dixieme  = VRAI;
		Rgraphe->axe_x.graduation.centieme = VRAI;
		Rgraphe->axe_x.graduation.science  = FAUX;
		Rgraphe->axe_x.graduation.grille   = FAUX;
		Rgraphe->axe_x.graduation.visible  = VRAI;
		Rgraphe->axe_x.couleurs.texte  = NOIR;
		Rgraphe->axe_x.couleurs.grille = VIOLET;
		Rgraphe->axe_x.styl_grille = 2;
		Rgraphe->axe_x.taille_txt = 1000; /* 10 points     */
		Rgraphe->axe_x.fnt_texte  = 0;    /* Fonte systme */

		Rgraphe->axe_y = Rgraphe->axe_x; /* Axe des Y : idem */

		rect->pointeur = (long) Rgraphe; /* Adresse de ces renseignements */

		break;
	}

	/* On forme la chane */

	rect->avant = NULL; /* Le rectangle est toujours plac en dbut de liste */
	rect->apres = prem_rectangle;
	if (prem_rectangle) /* Dj des rectangles en mmoire -> on forme la chane */
	{
		prem_rectangle->avant = rect;
	}
	prem_rectangle = rect; /* Nouveau premier rectangle */

	return rect; /* Le rectangle cr */
}

/* --------- Calcul des bornes de trac pour un rectangle de type Graphes ---------------- */

void REC_bornes(Rect_graphe *Rgraphe)
{
	Graphe     *graphe = premier_graphe;
	DES_graphe *param_dessin;

	if (Rgraphe == NULL) return;

	if (graphe == NULL)
	{
		Rgraphe->x_min = 0; /* Aucun graphe en mmoire -> tout  zro */
		Rgraphe->y_min = 0;
		Rgraphe->x_max = 0;
		Rgraphe->y_max = 0;
		return;
	}

	Rgraphe->x_min = -1; /* Aucun graphe slectionn -> tout  -1 */
	Rgraphe->y_min = -1;
	Rgraphe->x_max = -1;
	Rgraphe->y_max = -1;

	if ( Rgraphe->nbr_graphes == 0 ) /* On tient compte de tous les graphes visibles */
	{
		while (graphe->trace == FAUX)
		{
			graphe = graphe->suivant;
			if (graphe == NULL)
				return;
		}

		Rgraphe->x_min = graphe->x_min; /* Bornes de ce graphe */
		Rgraphe->y_min = graphe->y_min;
		Rgraphe->x_max = graphe->x_max;
		Rgraphe->y_max = graphe->y_max;
		for ( ; graphe ; graphe = graphe->suivant)
		{
			if (graphe->trace) /* On veut tracer ce graphe */
			{
				if ( Rgraphe->x_min > graphe->x_min ) Rgraphe->x_min = graphe->x_min;
				if ( Rgraphe->y_min > graphe->y_min ) Rgraphe->y_min = graphe->y_min;
				if ( Rgraphe->x_max < graphe->x_max ) Rgraphe->x_max = graphe->x_max;
				if ( Rgraphe->y_max < graphe->y_max ) Rgraphe->y_max = graphe->y_max;
			}
		}

		return; /* On a fini */
	}

	/* Il existe une liste de graphes */

	param_dessin = Rgraphe->prem_graphe;
	graphe = param_dessin->graphe;
	if (graphe == NULL) return; /* Problme survenu */

	Rgraphe->x_min = graphe->x_min;
	Rgraphe->y_min = graphe->y_min;
	Rgraphe->x_max = graphe->x_max;
	Rgraphe->y_max = graphe->y_max;

	param_dessin = param_dessin->suivant;

	for ( ; param_dessin ; param_dessin = param_dessin->suivant )
	{
		graphe = param_dessin->graphe;
		if (graphe == NULL) return;

		if ( Rgraphe->x_min > graphe->x_min ) Rgraphe->x_min = graphe->x_min;
		if ( Rgraphe->y_min > graphe->y_min ) Rgraphe->y_min = graphe->y_min;
		if ( Rgraphe->x_max < graphe->x_max ) Rgraphe->x_max = graphe->x_max;
		if ( Rgraphe->y_max < graphe->y_max ) Rgraphe->y_max = graphe->y_max;
	}
}

/* ----------- Dplacement et changement de taille d'un rectangle dans une fentre --------\
 |    Ne renvoie rien
 |
 | rect         : le rectangle  traiter
 | lieu_clic    : l'endroit o l'on a cliqu sur le cadre                                  |
 | x, y         : coordonnes prcises de la souris                                        |
 | x_max, y_max : coordonnes maximales possibles pour le coin infrieur droit             |
 |                 (coin suprieur gauche : 0, 0 car relatif  la fentre toujours...)     |
 \---------------------------------------------------------------------------------------- */

void REC_bouge(Cadre *rect, Position *lieu_clic, int x, int y, int x_max, int y_max)
{
	int vx_x, vx_y; /* Anciennes coordonnes */
}

/* ----------- Clic sur un rectangle contenant des graphes ------------------------------- */

boolean CLC_Rgraphe(Fenetre *fenetre, Cadre *rect, int x_clic, int y_clic, int n_clic, int etat)
{
  Position lieu_clic = {0, 0, 0, 0, 0, 0, 0, 0};
  Rect_graphe *Rgraphe;
  boolean modifie;
  Cadre au_cas_ou;

  if ( rect == NULL ) /* Pas de rectangle -> on traite de la fentre principale ! */
  {
    au_cas_ou.pointeur = (long) &RCT_courant;
    au_cas_ou.x    = 0;                  au_cas_ou.y    = 0;
    au_cas_ou.larg = principale->w_larg; au_cas_ou.haut = principale->w_haut;
    rect = &au_cas_ou;
  }

  Rgraphe = (Rect_graphe *) rect->pointeur;
  x_clic -= rect->x; /* On passe en coordonnes relatives  ce rectangle */
  y_clic -= rect->y;

  if ( (x_clic > Rgraphe->x1 - 5) && (x_clic < Rgraphe->x1 + 5) )
    lieu_clic.bord_gauche = VRAI;
  if ( (y_clic > Rgraphe->y1 - 5) && (y_clic < Rgraphe->y1 + 5) )
    lieu_clic.bord_haut = VRAI;
  if ( (x_clic > Rgraphe->x2 - 5) && (x_clic < Rgraphe->x2 + 5) )
    lieu_clic.bord_droit = VRAI;
  if ( (y_clic > Rgraphe->y2 - 5) && (y_clic < Rgraphe->y2 + 5) )
    lieu_clic.bord_bas = VRAI;
  if ( (x_clic > Rgraphe->x1 + 5) && (x_clic < Rgraphe->x2 - 5)
    && (y_clic > Rgraphe->y1 + 5) && (y_clic < Rgraphe->y2 - 5) )
    lieu_clic.centre = VRAI;

  if (n_clic == 2) /* Double clic */
  {
    if ( lieu_clic.bord_bas == VRAI )
    {
      char *chaine;

      chaine = (char *) OB_SPEC(arbres[PARAM_LEGENDE].adresse, LEG_TITRE);
      chaine[strlen(chaine) - 1] = 'X';

      chg_legende( &(Rgraphe->axe_x) ); /* On change les paramtres de l'axe X */
    }
    else if ( lieu_clic.bord_gauche == VRAI)
    {
      char *chaine;

      chaine = (char *) OB_SPEC(arbres[PARAM_LEGENDE].adresse, LEG_TITRE);
      chaine[strlen(chaine) - 1] = 'Y';

      chg_legende( &(Rgraphe->axe_y) );
    }
    else
      chg_bornes( Rgraphe );

    FEN_redessin(fenetre);
    return VRAI;
  }

  /* Clic simple -> on change de taille ou on choisit les bornes */

  wind_update(BEG_UPDATE); /* On coupe l'AES     */
  wind_update(BEG_MCTRL);
  graf_mouse(M_OFF,NULL);  /* On coupe la souris */

  vswr_mode(_PRG_station->handle, MD_INVERSE);

  /* On prpare pour le rectangle encadrant */
	
  vsl_type (_PRG_station->handle, 3);
  vsl_color(_PRG_station->handle, ROUGE);

  if ( ( (lieu_clic.bord_gauche == VRAI) || (lieu_clic.bord_droit == VRAI) )   /* Bord vertical   */
    && ( (lieu_clic.bord_haut   == FAUX) && (lieu_clic.bord_bas   == FAUX) ) ) /* pas un coin */
  {
    int vieux_x, vieux_y, retour, bouton;
    boolean boucle = VRAI;

    x_clic = fenetre->w_x + rect->x + Rgraphe->x1;	vieux_x  = x_clic;
    vieux_y = y_clic + rect->y;
    points[1] = fenetre->w_y + rect->y + Rgraphe->y1;
    points[3] = points[1];
    points[5] = fenetre->w_y + rect->y + Rgraphe->y2;
    points[7] = points[5];
    points[9] = points[1];

    /* On attend que le bouton soit relch */
    evnt_button(1, 3, 0, &retour, &retour, &etat, &n_clic);

    /* On dmarre */
    points[0] = x_clic - 5;
    points[2] = x_clic + 5;
    points[4] = x_clic + 5;
    points[6] = x_clic - 5;
    points[8] = x_clic - 5;
    v_pline(_PRG_station->handle, 5, points);
    
    do
    {
      unsigned int touche;

      retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
			  1, vieux_x, vieux_y, 1, 1,
			  0, 0, 0, 0, 0,
			  0, 0, 0,
			  &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

      if (vieux_x != x_clic)
      {
	v_pline(_PRG_station->handle,5,points);

	points[0] = x_clic - 5;
	points[2] = x_clic + 5;
	points[4] = x_clic + 5;
	points[6] = x_clic - 5;
	points[8] = x_clic - 5;
	v_pline(_PRG_station->handle,5,points);
      }
      vieux_x = x_clic;
      vieux_y = y_clic;

      if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
	boucle = FAUX;
    }
    while (boucle);

    if (bouton == 1) /* Clic gauche => on valide */
    {
      modifie = VRAI;
      if (lieu_clic.bord_gauche == VRAI) /* Bord de gauche */
      {
	Rgraphe->x1 = x_clic - (fenetre->w_x + rect->x); /* Nouvelle abcisse du graphe */
	if (Rgraphe->x1 >= Rgraphe->x2) Rgraphe->x1 = Rgraphe->x2 - 5;
	if (Rgraphe->x1 <= 0)           Rgraphe->x1 = 1;
      }
      else /* Bord de droite */
      {
	Rgraphe->x2 = x_clic - (fenetre->w_x + rect->x); /* Nouvelle abscisse de fin du graphe */
	if (Rgraphe->x2 <= Rgraphe->x1) Rgraphe->x2 = Rgraphe->x1  + 5;
	if (Rgraphe->x2 >= rect->larg)  Rgraphe->x2 = rect->larg - 1;
      }
    }
    else /* On efface le rectangle */
    {
      v_pline(_PRG_station->handle,5,points);
    }
  }

  if ( ( (lieu_clic.bord_haut   == VRAI) || (lieu_clic.bord_bas   == VRAI) )   /* Bord horizontal */
    && ( (lieu_clic.bord_gauche == FAUX) && (lieu_clic.bord_droit == FAUX) ) ) /* pas un coin   */
  {
    int vieux_x, vieux_y, bouton;
    unsigned int touche;
    boolean boucle = VRAI;

    vieux_x   = x_clic;
    y_clic = fenetre->w_y + rect->y + Rgraphe->y1;	vieux_y  = y_clic;
    points[0] = fenetre->w_x + rect->x + Rgraphe->x1;
    points[2] = fenetre->w_x + rect->x + Rgraphe->x2;
    points[4] = points[2];
    points[6] = points[0];
    points[8] = points[0];

    /* On attend que le bouton soit relch */
    evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);
    
    /* On dmarre */
    points[1] = y_clic - 5;
    points[3] = y_clic - 5;
    points[5] = y_clic + 5;
    points[7] = y_clic + 5;
    points[9] = y_clic - 5;
    v_pline(_PRG_station->handle,5,points);
    
    while (boucle)
    {
      int retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
			      1, vieux_x, vieux_y, 1 , 1,
			      0, 0, 0, 0, 0,
			      0, 0, 0,
			      &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

      if (vieux_y != y_clic)
      {
	v_pline(_PRG_station->handle,5,points);

	points[1] = y_clic - 5;
	points[3] = y_clic - 5;
	points[5] = y_clic + 5;
	points[7] = y_clic + 5;
	points[9] = y_clic - 5;
	v_pline(_PRG_station->handle,5,points);
      }
      vieux_x = x_clic;
      vieux_y = y_clic;

      if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
	boucle = FAUX;
    }

    if (bouton == 1) /* Clic gauche => on valide */
    {
      modifie = VRAI;
      if (lieu_clic.bord_haut)
      {
	Rgraphe->y1 = y_clic - ( fenetre->w_y + rect->y );
	if (Rgraphe->y1 >= Rgraphe->y2) Rgraphe->y1 = Rgraphe->y2 - 5;
	if (Rgraphe->y1 <= 0)           Rgraphe->y1 = 1;
      }
      else
      {
	Rgraphe->y2 = y_clic - ( fenetre->w_y + rect->y );
	if (Rgraphe->y2 <= Rgraphe->y1) Rgraphe->y2 = Rgraphe->y1 + 5;
	if (Rgraphe->y2 >= rect->haut ) Rgraphe->y2 = rect->haut - 1;
      }
    }
    else /* On efface le rectangle */
    {
      v_pline(_PRG_station->handle,5,points);
    }
  }
  
  if (lieu_clic.centre == VRAI) /* On veut juste dplacer le graphe */
  {
    if (_etat == 0) /* Aucune touche appuye -> on dfinit un rectangle de coordonnes */
    {
      int x_souris = x_clic, y_souris = y_clic, vieux_x, vieux_y, bouton;
      boolean boucle = VRAI;

      x_clic += rect->x + fenetre->w_x;
      y_clic += rect->y + fenetre->w_y;
      vieux_x = x_clic; vieux_y = y_clic;
      points[0] = x_clic;     points[1] = y_clic;
      points[2] = x_clic + 1; points[3] = y_clic;
      points[4] = x_clic + 1; points[5] = y_clic + 1;
      points[6] = x_clic;     points[7] = y_clic + 1;
      points[8] = x_clic;     points[9] = y_clic;

      /* On attend que le bouton soit relch */
      evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);
      
      /* On dmarre */
      v_pline(_PRG_station->handle, 5, points);
      do
      {
	unsigned int touche;
	int	retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
				    1, vieux_x, vieux_y, 1, 1,
				    0, 0, 0, 0, 0,
				    0, 0, 0,
				    &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

	if ( retour & MU_M1 )
	{
	  v_pline(_PRG_station->handle,5,points);
	  
	  points[2] = x_clic;
	  points[4] = x_clic; points[5] = y_clic;
	  points[7] = y_clic;
	  v_pline(_PRG_station->handle,5,points);
	}
	vieux_x = x_clic;
	vieux_y = y_clic;

	if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
	  boucle = FAUX;
      }
      while (boucle);

      if ( bouton == 1) /* On valide ce qu'on vient de faire */
      {
	double min, max;
	double echelle;

	/* On s'occupe des X */

	x_clic -= fenetre->w_x + rect->x;
	echelle = ( Rgraphe->x_max - Rgraphe->x_min ) / (Rgraphe->x2 - Rgraphe->x1);
	min = Rgraphe->x_min + (x_souris - Rgraphe->x1) * echelle;
	max = Rgraphe->x_min + (x_clic   - Rgraphe->x1) * echelle;
	if (max < min)
	{
	  double x = max; max = min; min = x;
	}
	if (max != min)
	{
	  Rgraphe->x_min = min;
	  Rgraphe->x_max = max;
	  modifie = VRAI;
	}

	/* On s'occupe des Y */

	y_clic -= fenetre->w_y + rect->y;
	echelle = ( Rgraphe->y_max - Rgraphe->y_min ) / (Rgraphe->y2 - Rgraphe->y1);
	min = Rgraphe->y_max - (y_souris - Rgraphe->y1) * echelle;
	max = Rgraphe->y_max - (y_clic   - Rgraphe->y1) * echelle;
	if (max < min)
	{
	  double y = max; max = min; min = y;
	}
	if (max != min)
	{
	  Rgraphe->y_min = min;
	  Rgraphe->y_max = max;
	  modifie = VRAI;
	}
      }
      else
	v_pline(_PRG_station->handle, 5, points);
    }
    else if ( (_etat & K_LSHIFT) || (_etat & K_RSHIFT) ) /* + Shift -> on dplace */
    {
      int x_souris = x_clic, y_souris = y_clic;
      int vieux_x, vieux_y, bouton;
      boolean boucle = VRAI;

      vieux_x  = x_clic;
      vieux_y  = y_clic;
      points[0] = fenetre->w_x + rect->x + Rgraphe->x1;
      points[1] = fenetre->w_y + rect->y + Rgraphe->y1;
      points[2] = fenetre->w_x + rect->x + Rgraphe->x2;
      points[3] = points[1];
      points[4] = points[2];
      points[5] = fenetre->w_y + rect->y + Rgraphe->y2;
      points[6] = points[0];
      points[7] = points[5];
      points[8] = points[0];
      points[9] = points[1];

			/* On attend que le bouton soit relch */
			evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);

			/* On dmarre */
			v_pline(_PRG_station->handle,5,points);
			do
			{
				unsigned int touche;
				int	retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
					                      1, vieux_x, vieux_y, 1, 1,
					                      0, 0, 0, 0, 0,
				                        0, 0, 0,
				                        &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

				if ( retour & MU_M1 )
				{
					v_pline(_PRG_station->handle,5,points);

					points[0] += x_clic - vieux_x;
					points[1] += y_clic - vieux_y;
					points[2] += x_clic - vieux_x;
					points[3] += y_clic - vieux_y;
					points[4] += x_clic - vieux_x;
					points[5] += y_clic - vieux_y;
					points[6] += x_clic - vieux_x;
					points[7] += y_clic - vieux_y;
					points[8] += x_clic - vieux_x;
					points[9] += y_clic - vieux_y;
					v_pline(_PRG_station->handle,5,points);
				}
				vieux_x = x_clic;
				vieux_y = y_clic;

				if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
					boucle = FAUX;
			}
			while (boucle);
			
			if (bouton == 1) /* On valide */
			{
				Rgraphe->x1 += x_clic - x_souris;
				Rgraphe->y1 += y_clic - y_souris;
				Rgraphe->x2 += x_clic - x_souris;
				Rgraphe->y2 += y_clic - y_souris;

				if ( Rgraphe->x1 <= 0 )
				{
					Rgraphe->x2 = 1 + Rgraphe->x2 - Rgraphe->x1;
					Rgraphe->x1 = 1;
				}
				if ( Rgraphe->y1 <= 0 )
				{
					Rgraphe->y2 = 1 + Rgraphe->y2 - Rgraphe->y1;
					Rgraphe->y1 = 1;
				}
				if ( Rgraphe->x2 >= rect->larg )
				{
					Rgraphe->x1 = rect->larg - 1 - (Rgraphe->x2 - Rgraphe->x1);
					Rgraphe->x2 = rect->larg - 1;
				}
				if ( Rgraphe->y2 >= fenetre->w_haut )
				{
					Rgraphe->y1 = rect->haut - 1 - (Rgraphe->y2 - Rgraphe->y1);
					Rgraphe->y2 = rect->haut - 1;
				}
				modifie = VRAI;
			}
			else
				v_pline(_PRG_station->handle,5,points);
		}
	}

	if ( (lieu_clic.bord_gauche == VRAI) && (lieu_clic.bord_haut == VRAI) ) /* Clic dans le coin suprieur gauche */
	{
		int vieux_x, vieux_y, bouton;
		boolean boucle = VRAI;

		x_clic = fenetre->w_x + rect->x + Rgraphe->x1; vieux_x = x_clic;
		y_clic = fenetre->w_y + rect->y + Rgraphe->y1; vieux_y = y_clic;
		points[0]  = fenetre->w_x + rect->x + Rgraphe->x2;
		points[2]  = points[0];
		points[7]  = fenetre->w_y + rect->y + Rgraphe->y2;
		points[9]  = points[7];
		points[12] = points[0];

		/* On attend que le bouton soit relch */
		evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);

		/* On dmarre */
		points[1]  = y_clic - 5;
		points[3]  = y_clic + 5;
		points[4]  = x_clic + 5;
		points[5]  = y_clic + 5;
		points[6]  = x_clic + 5;
		points[8]  = x_clic - 5;
		points[10] = x_clic - 5;
		points[11] = y_clic - 5;
		points[13] = y_clic - 5;
		v_pline(_PRG_station->handle,7,points);

		do
		{
			unsigned int touche;

			int	retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
				                       1, vieux_x, vieux_y, 1, 1,
				                       0, 0, 0, 0, 0,
				                       0, 0, 0,
				                       &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

			if ( retour & MU_M1 )
			{
				v_pline(_PRG_station->handle,7,points);

				points[1]  = y_clic - 5;
				points[3]  = y_clic + 5;
				points[4]  = x_clic + 5;
				points[5]  = y_clic + 5;
				points[6]  = x_clic + 5;
				points[8]  = x_clic - 5;
				points[10] = x_clic - 5;
				points[11] = y_clic - 5;
				points[13] = y_clic - 5;
				v_pline(_PRG_station->handle,7,points);
			}
			vieux_x = x_clic;
			vieux_y = y_clic;

			if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
				boucle = FAUX;
		}
		while (boucle);

		if (bouton == 1) /* Clic gauche => on valide */
		{
			modifie = VRAI;
			Rgraphe->x1 = x_clic - (fenetre->w_x + rect->x); /* Nouvelle abscisse du graphe */
			Rgraphe->y1 = y_clic - (fenetre->w_y + rect->y); /* Nouvelle ordonne du graphe */
			if (Rgraphe->x1 <= 0)           Rgraphe->x1 = 1;
			if (Rgraphe->x1 >= Rgraphe->x2) Rgraphe->x1 = Rgraphe->x2 - 5;
			if (Rgraphe->y1 <= 0)           Rgraphe->y1 = 1;
			if (Rgraphe->y1 >= Rgraphe->y2) Rgraphe->y1 = Rgraphe->y2 - 5;
		}
		else /* On efface le "rectangle" */
		{
			v_pline(_PRG_station->handle,7,points);
		}
	}

	if ( (lieu_clic.bord_droit == VRAI) && (lieu_clic.bord_haut == VRAI) ) /* Clic dans le coin suprieur droit */
	{
		int vieux_x, vieux_y, bouton;
		boolean boucle = VRAI;

		x_clic = fenetre->w_x + rect->x + Rgraphe->x2; vieux_x = x_clic;
		y_clic = fenetre->w_y + rect->y + Rgraphe->y1; vieux_y = y_clic;
		points[0]  = fenetre->w_x + rect->x + Rgraphe->x1;
		points[5]  = fenetre->w_y + rect->y + Rgraphe->y2;
		points[7]  = points[5];
		points[10] = points[0];
		points[12] = points[0];

		/* On attend que le bouton soit relch */
		evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);

		/* On dmarre */
		points[1]  = y_clic - 5;
		points[2]  = x_clic + 5;
		points[3]  = y_clic - 5;
		points[4]  = x_clic + 5;
		points[6]  = x_clic - 5;
		points[8]  = x_clic - 5;
		points[9]  = y_clic + 5;
		points[11] = y_clic + 5;
		points[13] = y_clic - 5;
		v_pline(_PRG_station->handle,7,points);

		do
		{
			unsigned int touche;

			int retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
			                        1, vieux_x, vieux_y, 1, 1,
			                        0, 0, 0, 0, 0,
			                        0, 0, 0,
			                        &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

			if ( retour & MU_M1 )
			{
				v_pline(_PRG_station->handle,7,points);

				points[1]  = y_clic - 5;
				points[2]  = x_clic + 5;
				points[3]  = y_clic - 5;
				points[4]  = x_clic + 5;
				points[6]  = x_clic - 5;
				points[8]  = x_clic - 5;
				points[9]  = y_clic + 5;
				points[11] = y_clic + 5;
				points[13] = y_clic - 5;
				v_pline(_PRG_station->handle,7,points);
			}
			vieux_x = x_clic;
			vieux_y = y_clic;

			if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
				boucle = FAUX;
		}
		while (boucle);

		if (bouton == 1) /* Clic gauche => on valide */
		{
			modifie = VRAI;
			Rgraphe->x2 = x_clic - (fenetre->w_x + rect->x);
			Rgraphe->y1 = y_clic - (fenetre->w_y + rect->y); /* Nouvelle ordonne du graphe */
			if (Rgraphe->x2 <= Rgraphe->x1)  Rgraphe->x2 = Rgraphe->x1 + 5;
			if (Rgraphe->x2 >= rect->larg)   Rgraphe->x2 = rect->larg - 1;
			if (Rgraphe->y1 >= Rgraphe->y2)  Rgraphe->y1 = Rgraphe->y2 - 5;
			if (Rgraphe->y1 <= 0)            Rgraphe->y1 = 1;
		}
		else /* On efface le rectangle */
		{
			v_pline(_PRG_station->handle,7,points);
		}
	}

	if ( (lieu_clic.bord_droit == VRAI) && (lieu_clic.bord_bas == VRAI) )	/* Clic dans le coin infrieur droit */
	{
		int vieux_x, vieux_y, bouton;
		boolean boucle = VRAI;

		x_clic = fenetre->w_x + rect->x + Rgraphe->x2; vieux_x = x_clic;
		y_clic = fenetre->w_y + rect->y + Rgraphe->y2; vieux_y = y_clic;
		points[1]  = fenetre->w_y + rect->x + Rgraphe->y1;
		points[4]  = fenetre->w_x + rect->y + Rgraphe->x1;
		points[6]  = points[4];
		points[11] = points[1];
		points[13] = points[1];

		/* On attend que le bouton soit relch */
		evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);

		/* On dmarre */
		points[0]  = x_clic + 5;
		points[2]  = x_clic + 5;
		points[3]  = y_clic + 5;
		points[5]  = y_clic + 5;
		points[7]  = y_clic - 5;
		points[8]  = x_clic - 5;
		points[9]  = y_clic - 5;
		points[10] = x_clic - 5;
		points[12] = y_clic + 5;
		v_pline(_PRG_station->handle,7,points);

		do
		{
			unsigned int touche;

			int retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
			                        1, vieux_x, vieux_y, 1, 1,
			                        0, 0, 0, 0, 0,
			                        0, 0, 0,
			                        &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

			if ( retour & MU_M1 )
			{
				v_pline(_PRG_station->handle,7,points);

				points[0]  = x_clic + 5;
				points[2]  = x_clic + 5;
				points[3]  = y_clic + 5;
				points[5]  = y_clic + 5;
				points[7]  = y_clic - 5;
				points[8]  = x_clic - 5;
				points[9]  = y_clic - 5;
				points[10] = x_clic - 5;
				points[12] = x_clic + 5;
				v_pline(_PRG_station->handle,7,points);
			}
			vieux_x = x_clic;
			vieux_y = y_clic;

			if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
				boucle = FAUX;
		}
		while (boucle);

		if (bouton == 1) /* Clic gauche => on valide */
		{
			modifie = VRAI;
			Rgraphe->x2 = x_clic - (fenetre->w_x + rect->x);
			Rgraphe->y2 = y_clic - (fenetre->w_y + rect->y);
			if (Rgraphe->y2 <= Rgraphe->y1) Rgraphe->y2 = Rgraphe->y1 + 5;
			if (Rgraphe->y2 >= rect->haut ) Rgraphe->y2 = rect->haut - 1;
			if (Rgraphe->x2 <= Rgraphe->x1) Rgraphe->x2 = Rgraphe->x1 - 5;
			if (Rgraphe->x2 >= rect->larg ) Rgraphe->x2 = rect->larg - 1;
		}
		else /* On efface le rectangle */
		{
			v_pline(_PRG_station->handle,7,points);
		}
	}

	if ( (lieu_clic.bord_gauche == VRAI) && (lieu_clic.bord_bas == VRAI) ) /* Clic dans le coin infrieur gauche */
	{
		int vieux_x, vieux_y, bouton;
		boolean boucle = VRAI;

		x_clic = fenetre->w_x + rect->x + Rgraphe->x1; vieux_x = x_clic;
		y_clic = fenetre->w_y + rect->y + Rgraphe->y2; vieux_y = y_clic;
		points[0]  = fenetre->w_x + rect->x + Rgraphe->x2;
		points[2]  = points[0];
		points[7]  = fenetre->w_y + rect->y + Rgraphe->y1;
		points[9]  = points[7];
		points[12] = points[0];

		/* On attend que le bouton soit relch */
		evnt_button(1, 3, 0, &_rien_, &_rien_, &etat, &n_clic);

		/* On dmarre */
		points[1]  = y_clic - 5;
		points[3]  = y_clic + 5;
		points[4]  = x_clic - 5;
		points[5]  = y_clic + 5;
		points[6]  = x_clic - 5;
		points[8]  = x_clic + 5;
		points[10] = x_clic + 5;
		points[11] = y_clic - 5;
		points[13] = y_clic - 5;
		v_pline(_PRG_station->handle,7,points);

		do
		{
			unsigned int touche;
			int retour = Evnt_multi(MU_BUTTON|MU_M1, 258, 3, 0,
			                        1, vieux_x, vieux_y, 1, 1,
			                        0, 0, 0, 0, 0,
			                        0, 0, 0,
			                        &x_clic, &y_clic, &bouton, &etat, &touche, &n_clic);

			if ( retour & MU_M1 )
			{
				v_pline(_PRG_station->handle,7,points);

				points[1]  = y_clic - 5;
				points[3]  = y_clic + 5;
				points[4]  = x_clic - 5;
				points[5]  = y_clic + 5;
				points[6]  = x_clic - 5;
				points[8]  = x_clic + 5;
				points[10] = x_clic + 5;
				points[11] = y_clic - 5;
				points[13] = y_clic - 5;
				v_pline(_PRG_station->handle,7,points);
			}
			vieux_x = x_clic;
			vieux_y = y_clic;

			if (retour & MU_BUTTON) /* On sort en cliquant une seconde fois */
				boucle = FAUX;
		}
		while (boucle);

		if (bouton == 1) /* Clic gauche => on valide */
		{
			modifie = VRAI;
			Rgraphe->x1 = x_clic - (fenetre->w_x + rect->x);
			Rgraphe->y2 = y_clic - (fenetre->w_y + rect->y);
			if (Rgraphe->y2 <= Rgraphe->y1) Rgraphe->y2 = Rgraphe->y1 + 5;
			if (Rgraphe->y2 >= rect->haut)  Rgraphe->y2 = rect->haut - 1;
			if (Rgraphe->x1 >= Rgraphe->x2) Rgraphe->x1 = Rgraphe->x2 - 5;
			if (Rgraphe->x1 <= 0)           Rgraphe->x1 = 1;
		}
		else /* On efface le rectangle */
		{
			v_pline(_PRG_station->handle,7,points);
		}
	}

	if (modifie) /* On a chang => il faut redessiner */
	{
		FEN_redessin(fenetre);
	}

	graf_mouse(M_ON,NULL);
	wind_update(END_UPDATE); /* On remet l'AES */
	wind_update(END_MCTRL);

	evnt_button(1, 3, 0, &x_clic, &y_clic, &etat, &n_clic); /* On attend que le bouton soit relch */

	return modifie;
}

/* ----------- Dessin d'un rectangle contenant des graphes ------------------------------- */

void DES_Rgraphe(Station_VDI *station, Fenetre *fenetre, Cadre *rect)
{
  Graphe *graphe;
  Rect_graphe *param_rect;
  int x,y,larg,haut;
  double x_echelle,y_echelle;

  x = rect->x; y = rect->y;
  if (fenetre) /* Il y a une fentre -> un dcalage en X, Y  utiliser */
  {
    x += fenetre->w_x;
    y += fenetre->w_y;
  }
  param_rect = (Rect_graphe *) rect->pointeur;
  larg = param_rect->x2 - param_rect->x1; /* Largeur et hauteur du rectangle _du graphe_ */
  haut = param_rect->y2 - param_rect->y1;

  TRC_cadre(station, param_rect, x, y);

  /* Les facteur d'chelle, en X et en Y */

  if ( (param_rect->x_max == param_rect->x_min) || (param_rect->y_max == param_rect->y_min) )
  {
    return;
  }

  x_echelle = (double) (larg) / fabs(param_rect->x_max - param_rect->x_min);
  y_echelle = (double) (haut) / fabs(param_rect->y_max - param_rect->y_min);

  /* On dessine maintenant les graphes  rellement dessiner */

  x += param_rect->x1; /* Coordonnes du dbut de la rgion de dessin */
  y += param_rect->y1;

  if ( param_rect->nbr_graphes == 0 ) /* On affiche les graphes qui sont marqus visibles */
  {
    DES_graphe param_dessin = {NULL, NULL, 1, 1};

    /* On parcourt les graphes et on dessine ceux qu'il faut dessiner... */

    for ( graphe = premier_graphe ; graphe ; graphe = graphe->suivant )
    {
      if (graphe->trace) /* On veut tracer le graphe */
      {
	if ( (graphe->x_min == graphe->x_max) || (graphe->y_min == graphe->y_max) )
	  continue; /* Bornes identiques -> le graphe a un probleme */

	param_dessin.graphe  = graphe; /* Donc on enregistre les paramtres qu'il faut */
	param_dessin.couleur = graphe->couleur;
	param_dessin.style   = graphe->style;
	TRC_graphe(station, &param_dessin, x, y,
		   param_rect->x_min, param_rect->x_max, param_rect->y_min, param_rect->y_max,
		   x_echelle, y_echelle);
      }
    }
  }
  else /* Il y a une vraie liste de graphes  dessiner */
  {
    DES_graphe *param_dessin;

    for (param_dessin = param_rect->prem_graphe ; param_dessin ; param_dessin = param_dessin->suivant)
    {
      TRC_graphe(station, param_dessin, x, y,
		 param_rect->x_min, param_rect->x_max, param_rect->y_min, param_rect->y_max, 
		 x_echelle, y_echelle);
    }
  }
}

/* ~~~~~~~~~~~~~~ "Primitives" de trac des graphes ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* -------------- Trac du cadre des graphes, connaissant tout ce qu'il faut --------------\
 |
 | station    : station VDI o tracer ce que l'on veut                                     |
 | rect       : paramtres sur le dessin (rectangle contenant le(s) graphe(s))             |
 | x, y,      : coordonnes de ce rectangle (coin suprieur gauche)                        |
 \---------------------------------------------------------------------------------------- */

void TRC_cadre(Station_VDI *station, Rect_graphe *rect, int x, int y)
{
  char legende[80]; /* Place pour prparer le texte de lgende */
  int x_txt, y_txt, larg_txt, haut_txt; /* Rectangle encadrant le texte */
  double x_echelle, y_echelle; /* Facteurs d'chelle */
	
  /* On trace le cadre (toujours), en noir - ligne continue */

  vsl_color(station->handle, NOIR);
  vsl_type (station->handle, 1);

  points[0] = x + rect->x1;
  points[1] = y + rect->y1;
  points[2] = x + rect->x2;
  points[3] = points[1];
  points[4] = points[2];
  points[5] = y + rect->y2;
  points[6] = points[0];
  points[7] = points[5];
  points[8] = points[0];
  points[9] = points[1];
  v_pline(station->handle,5,points); /* On trace le cadre */

  if ( (rect->x_min == rect->x_max) /* Problme... */
    || (rect->y_min == rect->y_max) )
  {
    points[0] = x + rect->x1;
    points[1] = y + rect->y1;
    points[2] = x + rect->x2;
    points[3] = y + rect->y2;
    v_pline(station->handle, 2, points);

    points[0] = x + rect->x1;
    points[1] = y + rect->y2;
    points[2] = x + rect->x2;
    points[3] = y + rect->y1;
    v_pline(station->handle, 2, points);

    if (rect->x_min == 0)  /* Aucun graphe en mmoire */
    {
      return;
    }
    if (rect->x_min == -1) /* Aucun graphe slectionn */
    {
      return;
    }
  }	

  x_echelle = (double) (rect->x2 - rect->x1) / fabs(rect->x_max - rect->x_min);
  y_echelle = (double) (rect->y2 - rect->y1) / fabs(rect->y_max - rect->y_min);

  /* On met les bornes & graduations en X */

  if ( is_inf(rect->x_min) ) return; /* Une des bornes du graphe est infinie  */
  if ( is_inf(rect->x_max) ) return; /* On sort donc, sinon risque de planter */
  if ( is_nan(rect->x_min) ) return; /* Idem pour les "Not a Number"          */
  if ( is_nan(rect->x_max) ) return;

  vst_color(station->handle, rect->axe_x.couleurs.texte); /* Couleur des textes */
  vst_alignment(station->handle, ALI_CENTER, ALI_TOP, &_rien_, &_rien_);

  if ( rect->axe_x.graduation.grille ) /* On veut une grille visible */
  {
    TRC_grille(station, rect, x, y, AXE_X, NON_TOURNE);
  }

  vsl_color(station->handle, NOIR); /* Graduations en noir */
  vsl_type (station->handle, 0);

  if (rect->axe_x.graduation.gradue == GRADUE_DECIMAL) /* On veut graduer en X, en dcimal */
  {
    int lg_tiret; /* Dimension du tiret de graduation */
    int degre;    /* On travaille sur un intervalle de cette puissance de 10 l en largeur */
    double pas, x_dep;

    lg_tiret = (rect->y2 - rect->y1) / 50;  /* 1/50 de la hauteur          */
    points[1] = y + rect->y2;               /* Position de la base du tiret */
    points[3] = points[1] - lg_tiret;       /* Position du haut du tiret    */

    degre = (int) ( log10( fabs(rect->x_max - rect->x_min) ) );
    pas = pow(10, degre); /* On commence par les graduations en unit */
    x_dep = floor(rect->x_min / pas) * pas;
    if (x_dep + pas == x_dep) /* Zoom trop grand -> prcision insuffisante */
    {
      rect->x_min = -2;
      rect->x_max = -2;
      return;
    }
    while ( x_dep < rect->x_max )
    {
      if ( x_dep > rect->x_min )
      {
	points[0] = x + rect->x1 + x_echelle * (x_dep - rect->x_min);
	points[2] = points[0];
	sprintf(_intermediaire, "%.2f%c", x_dep,0);
	v_gtext(station->handle, points[0], points[1] + 5, _intermediaire);
	v_pline(station->handle, 2, points);
      }
      x_dep += pas;
    }

    if ( rect->axe_x.graduation.dixieme ) /* On veut aussi les diximes */
    {
      int tic_5; /* Le dixime par lequel on commence */
      
      tic_5 = (int) ( ( rect->x_min - floor(rect->x_min / pas) * pas ) / (pas / 10) );
      pas /= 10;    /* On passe aux diximes */
      lg_tiret /= 4;
      x_dep = floor(rect->x_min / pas) * pas;
      if (x_dep + pas == x_dep) /* Zoom trop grand -> prcision insuffisante */
      {
	rect->axe_x.graduation.dixieme = FAUX; /* On dsactive */
	return;
      }
      while ( x_dep < rect->x_max )
      {
	if ( x_dep > rect->x_min )
	{
	  points[0] = x + rect->x1 + x_echelle * (x_dep - rect->x_min);
	  points[2] = points[0];
	  if ( tic_5 % 10 ) /* Ce n'est pas un multiple de 10 */
	  {
	    if ( (tic_5 % 5) == 0 ) /* Multiple de 5 */
	      points[3] = points[1] - 2 * lg_tiret;
	    else
	      points[3] = points[1] - lg_tiret;
	    v_pline(station->handle, 2, points);
	  }
	}
	x_dep += pas;
	tic_5++; /* Graduation suivante */
      }

      if ( rect->axe_x.graduation.centieme ) /* On veut aussi les centimes */
      {
	tic_5 = (int) ( ( rect->x_min - floor(rect->x_min / (10 * pas)) * (10 * pas) ) / (pas / 10) );
	pas /= 10;    /* On passe aux centimes */
	lg_tiret /= 2;
	x_dep = floor(rect->x_min / pas ) * pas;
	if (x_dep + pas == x_dep) /* Zoom trop grand -> prcision insuffisante */
	{
	  rect->axe_x.graduation.centieme = FAUX; /* On dsactive */
	  return;
	}
	while ( x_dep < rect->x_max )
	{
	  if ( x_dep > rect->x_min )
	  {
	    points[0] = x + rect->x1 + x_echelle * (x_dep - rect->x_min);
	    points[2] = points[0];
	    if ( tic_5 % 10 ) /* Ce n'est pas un multiple de 10 */
	    {
	      if ( (tic_5 % 5) == 0 ) /* Multiple de 5 */
		points[3] = points[1] - 2 * lg_tiret;
	      else
		points[3] = points[1] - lg_tiret;
	      v_pline(station->handle, 2, points);
	    }
	  }
	  x_dep += pas;
	  tic_5++; /* Graduation suivante */
	}
      }
    }
  }

  /* Les bornes (aprs pour tre sr qu'elles soient visibles) */

  points[0] = x + rect->x1; points[1] = y + rect->y2;

  sprintf(_intermediaire, "%.2f%c", rect->x_min, 0);
  v_gtext(station->handle, points[0], points[1] + 10, _intermediaire);
  sprintf(_intermediaire, "%.2f%c", rect->x_max, 0);
  v_gtext(station->handle, points[4], points[1] + 10, _intermediaire);

  /* La lgende de l'axe des X */

  points[0] += (rect->x2 - rect->x1) / 2;
  sprintf(legende,"%s (%s)", rect->axe_x.legende, rect->axe_x.unite);
  v_gtext(station->handle, points[0], points[1] + 20, legende);

  /* On met les bornes & graduations en Y */		

  if ( is_inf(rect->y_min) ) return; /* Si elles sont infinies, plante... boucle sans fin */
  if ( is_inf(rect->y_max) ) return;
  if ( is_nan(rect->y_min) ) return; /* Idem pour les NaN */
  if ( is_nan(rect->y_max) ) return;

  if ( rect->axe_y.graduation.grille ) /* On veut une grille visible */
  {
    TRC_grille(station, rect, x, y, AXE_Y, NON_TOURNE);
  }

  vst_color(station->handle, rect->axe_y.couleurs.texte); /* Couleur des textes */
  vsl_color(station->handle, NOIR);
  vsl_type (station->handle, 0);

  if ( rect->axe_y.graduation.gradue == GRADUE_DECIMAL ) /* On veut graduer en Y */
  {
    int lg_tiret; /* Dimension du tiret de graduation */
    int degre;    /* On travaille sur un intervalle de cette puissance de 10 l en largeur */
    double pas, y_dep;

    vst_alignment(station->handle, ALI_RIGHT, ALI_HALF, &_rien_, &_rien_);

    lg_tiret = (rect->x2 - rect->x1) / 50;  /* 1/50 de la largeur           */
    points[0] = x + rect->x1;               /* Position de la base du tiret */
    points[2] = points[0] + lg_tiret;       /* Position du haut du tiret    */

    degre = (int) ( log10( fabs(rect->y_max - rect->y_min) ) );
    pas = pow(10, degre); /* On commence par les graduations en unit */
    y_dep = floor(rect->y_min / pas) * pas;
    if (y_dep + pas == y_dep) /* Zoom trop grand -> prcision insuffisante */
    {
      rect->y_min = -2;
      rect->y_max = -2;
      return;
    }
    while ( y_dep < rect->y_max )
    {
      if ( y_dep > rect->y_min )
      {
	points[1] = y + rect->y2 - y_echelle * (y_dep - rect->y_min);
	points[3] = points[1];
	sprintf(_intermediaire, "%.2f%c", y_dep,0);
	v_gtext(station->handle, points[0] - 5, points[1], _intermediaire);
	v_pline(station->handle, 2, points);
      }
      y_dep += pas;
    }

    if ( rect->axe_y.graduation.dixieme ) /* On veut aussi les diximes */
    {
      int tic_5;

      tic_5 = (int) ( ( rect->y_min - floor(rect->y_min / pas) * pas ) / (pas / 10) );
      pas /= 10;    /* On passe aux diximes */
      lg_tiret /= 4;
      y_dep = floor(rect->y_min / pas) * pas;
      if (y_dep + pas == y_dep) /* Zoom trop grand -> prcision insuffisante */
      {
	rect->axe_y.graduation.dixieme = FAUX; /* On dsactive */
	return;
      }
      while ( y_dep < rect->y_max )
      {
	if ( y_dep > rect->y_min )
	{
	  points[1] = y + rect->y2 - y_echelle * (y_dep - rect->y_min);
	  points[3] = points[1];
	  if ( tic_5 % 10 ) /* Ce n'est pas un multiple de 10 */
	  {
	    if ( (tic_5 % 5) == 0 ) /* Multiple de 5 */
	      points[2] = points[0] + 2 * lg_tiret;
	    else
	      points[2] = points[0] + lg_tiret;
	    v_pline(station->handle, 2, points);
	  }
	}
	y_dep += pas;
	tic_5++; /* Graduation suivante */
      }

      if ( rect->axe_y.graduation.centieme ) /* On veut aussi les centimes */
      {
	tic_5 = (int) ( ( rect->y_min - floor(rect->y_min / (10 * pas)) * (10 * pas) ) / (pas / 10) );
	pas /= 10;    /* On passe aux centimes */
	lg_tiret /= 2;
	y_dep = floor(rect->y_min / pas) * pas;
	if (y_dep + pas == y_dep) /* Zoom trop grand -> prcision insuffisante */
	{
	  rect->axe_y.graduation.centieme = FAUX; /* On dsactive */
	  return;
	}
	while ( y_dep < rect->y_max )
	{
	  if ( y_dep > rect->y_min )
	  {
	    points[1] = y + rect->y2 - y_echelle * (y_dep - rect->y_min);
	    points[3] = points[1];
	    if ( tic_5 % 10 ) /* Ce n'est pas un multiple de 10 */
	    {
	      if ( (tic_5 % 5) == 0 ) /* Multiple de 5 */
		points[2] = points[0] + 2 * lg_tiret;
	      else
		points[2] = points[0] + lg_tiret;
	      v_pline(station->handle, 2, points);
	    }
	  }
	  y_dep += pas;
	  tic_5++; /* Graduation suivante */
	}
      }
    }
  }

  /* Les bornes (aprs pour tre sr qu'elles soient visibles) */

  vst_alignment(station->handle,ALI_RIGHT,ALI_HALF,&_rien_,&_rien_);
  points[0] = x + rect->x1; points[1] = y + rect->y1;

  sprintf(_intermediaire, "%.2f%c", rect->y_max, 0);
  v_gtext(station->handle, points[0] - 5, points[1], _intermediaire);
  
  sprintf(_intermediaire, "%.2f%c", rect->y_min, 0);
  v_gtext(station->handle, points[6] - 5, points[7], _intermediaire);

  /* Le titre */

  vst_alignment(station->handle, ALI_CENTER, ALI_BOTTOM, &_rien_, &_rien_);
  vst_rotation(station->handle, 900);
  points[1] += (rect->y2 - rect->y1) / 2;
  sprintf(legende,"%s (%s)", rect->axe_y.legende, rect->axe_y.unite);
  v_gtext(station->handle, points[0] - 40, points[1], legende);
  vst_rotation(station->handle, 0);

  /* Trac des axes  leur position */

  if (rect->axe_y.graduation.visible) /* On veut tracer l'axe des Y */
  {
    vsl_color(station->handle, rect->axe_y.couleurs.grille); /* Mme couleur que la grille */
    vsl_type (station->handle, 0); /* Style : continue */

    if ( (rect->x_min < 0) && (rect->x_max > 0) ) /* L'axe Y est visible */
    {
      points[0] = x + rect->x1 + rect->x_min * x_echelle;
      points[1] = y + rect->y1;
      points[2] = points[0];
      points[3] = y + rect->y2;
      v_pline(station->handle, 2, points);
    }
  }

  if (rect->axe_x.graduation.visible) /* On veut tracer l'axe des X */
  {
    vsl_color(station->handle, rect->axe_x.couleurs.grille);
    vsl_type (station->handle, 0);

    if ( (rect->y_min < 0) && (rect->y_max > 0) ) /* L'axe X est visible */
    {
      points[0] = x + rect->x1;
      points[1] = y + rect->y1 + (rect->y_max) * y_echelle;
      points[2] = x + rect->x2;
      points[3] = points[1];
      v_pline(station->handle, 2, points);
    }
  }
}

/* -------------- Trac d'une grille en fond de rectangle de graphes ----------------------\
 |     La grille est trace en utilisant les graduations en 1/10, pour que ce soit mieux...|
 |                                                                                         |
 | station : station VDI sur laquelle on travaille                                         |
 | rect    : le rectangle qui contiendra la grille                                         |
 | x, y    : coordonnes du rectangle                                                      |
 | type    : le sens (AXE_X : grille selon les X -> verticale; AXE_Y : grille selon les Y) |
 | sens    : si TOURNE : Y horizontal, imprimante; si NON_TOURNE : Y vertical, cran       |
 \---------------------------------------------------------------------------------------- */
 
void TRC_grille(Station_VDI *station, Rect_graphe *rect, int x, int y, int type, int sens)
{
  Axe axe;
  int n;
  double degre;
  double pas, depart, echelle, min, max;

  if (type == AXE_X)
  {
    axe = rect->axe_x;
    echelle = (double) (rect->x2 - rect->x1) / fabs(rect->x_max - rect->x_min);
    min = rect->x_min;
    max = rect->x_max;
  }
  else
  {
    axe = rect->axe_y;
    echelle = (double) (rect->y2 - rect->y1) / fabs(rect->y_max - rect->y_min);
    min = rect->y_min;
    max = rect->y_max;
  }

  if (min == max) /* Rien  faire... */
    return;

  if (min > max)
  {
    double x = min; min = max; max = x;
  }

  degre = log10( max - min ); /* L'intervalle est donc de 10^degre */
  n = (int) degre;  /* c'est--dire compris entre 10^n et 10^(n+1) */

  pas = pow(10, n - 1); /* Grille : tous les 10^(n-1) */
  if ( degre > n + 1 - log10(2.0) ) /* Pas compris entre 10^(n+1) / 2 et 10^(n+1) */
  {
    pas *= 5;
  }

  depart = floor( min / pas ) * pas;
  if (depart + pas == depart) /* Zoom trop grand -> prcision insuffisante */
  {
    if (type == AXE_X)
    {
      rect->x_min = -2;
      rect->x_max = -2;
    }
    else
    {
      rect->y_min = -2;
      rect->y_max = -2;
    }
    return;
  }

  while (depart <= min) /* On ne trace que si on est dans le rectangle */
    depart += pas;

  if ( rect->axe_x.styl_grille < 7 )
    vsl_type(station->handle, rect->axe_x.styl_grille);
  else
    vsm_type(station->handle, rect->axe_x.styl_grille);

  if ( (type == AXE_X) && (sens == NON_TOURNE) )
  {
    points[1] = y + rect->y1 + 1;
    points[3] = y + rect->y2 - 1;
  }
  else if ( (type == AXE_Y) && (sens == NON_TOURNE) )
  {
    points[0] = x + rect->x1 + 1;
    points[2] = x + rect->x2 - 1;
  }

  if ( axe.styl_grille < 7) /* Lignes -> pas de problme */
  {
    vsl_color(station->handle, axe.couleurs.grille);
    vsl_type (station->handle, axe.styl_grille);
		
    while ( depart < max )
    {
      if ( (type == AXE_X) && (sens == NON_TOURNE) )
      {
	points[0] = x + rect->x1 + echelle * (depart - rect->x_min);
	points[2] = points[0];
      }
      else if ( (type == AXE_Y) && (sens == NON_TOURNE) )
      {
	points[1] = y + rect->y1 + echelle * (rect->y_max - depart);
	points[3] = points[1];
      }
      v_pline(station->handle,2,points);

      depart += pas;
    }

    return;
  }		

  /* Si on est l, c'est qu'on utilise un polymark : plus dlicat... */
}

/* -------------- Trac d'un graphe connaissant la rgion o il faut le tracer ------------\
 |
 | station   : station VDI dans laquelle il faut dessiner                                  |
 | graphe    : le graphe  dessiner (en fait, les infos qui vont avec)                     |
 | x, y      : coin suprieur gauche de la zone dans laquelle dessiner le graphe           |
 | x_min     : borne X infrieure - Valeur correspondant  l'abcisse x minimale            |
 | x_max     : borne X suprieure - au-del, ce n'est pas dessin                          |
 | y_min     : borne Y infrieure - mme chose...
 | y_max     : borne Y infrieure - ordonne maximale relle (valeur en y + haut_zone)     |
 | x_echelle : chelle en X
 | y_echelle : chelle en Y
 \----------------------------------------------------------------------------------------- */

void TRC_graphe(Station_VDI *station, DES_graphe *graphe, int x, int y, 
                double x_min, double x_max, double y_min, double y_max, 
                double x_echelle, double y_echelle)
{
  Graphe *courbe; /* Adresse du graphe  dessiner */
  unsigned long i = 0;
  register double *zone_x;
  int compteur = 0;

  courbe = graphe->graphe;
  zone_x = courbe->x;

  if ( is_inf(x_min) || is_inf(x_max) || is_inf(y_min) || is_inf(y_max) ) return;
  if ( is_nan(x_min) || is_nan(x_max) || is_nan(y_min) || is_nan(y_max) ) return;

  if (x_max < courbe->x_min) return; /* Graphe hors de la zone choisie */
  if (x_min > courbe->x_max) return;
  if (y_max < courbe->y_min) return;
  if (y_min > courbe->y_max) return;

  /* Style de dessin */

  if (graphe->style >= 7)
  {
    vsm_color (station->handle, graphe->couleur);
    vsm_height(station->handle, 5); /* 5 pixels de haut pour le polymark... */
    vsm_type  (station->handle, graphe->style - 6);
  }
  else
  {
    vsl_color(station->handle, graphe->couleur);
    vsl_type (station->handle, graphe->style);
  }

  if ( courbe->drapeaux.complexe == GR_NORMAL ) /* Graphe normal : cas facile... */
  {
    register double *zone_y = courbe->y;

    while (i < courbe->nombre_point) /* Tant qu'il reste des points */
    {
      while ( (*zone_x < x_min) || (*zone_x > x_max) /* On dborde */
	   || (*zone_y < y_min) || (*zone_y > y_max) )
      {
	zone_x++; zone_y++; /* On passe au point suivant */
	i++;
	if (i >= courbe->nombre_point) return; /* On s'arrte */
      }

      compteur = 0; /* On commence un nouveau trac */
      while ( (*zone_x >= x_min) && (*zone_x <= x_max) /* On dborde */
	   && (*zone_y >= y_min) && (*zone_y <= y_max) )
      {
	points[compteur]   = x + (*(zone_x) - x_min) * x_echelle;
	points[compteur+1] = y + (y_max - *(zone_y)) * y_echelle;
	compteur += 2;
	if (compteur >= 256) /* Tableau intin plein */
	{
	  if (graphe->style < 7)
	    v_pline  (station->handle, 128, points); /* On trace ces 128 points */
	  else
	    v_pmarker(station->handle, 128, points);
	  points[0] = points[254];
	  points[1] = points[255];
	  compteur = 2;
	}
	zone_x++; zone_y++;
	i++; /* Point suivant */
	if (i >= courbe->nombre_point)
	{
	  if (compteur < 256)
	  {
	    if (graphe->style < 7)
	      v_pline  (station->handle, compteur >> 1, points);
	    else
	      v_pmarker(station->handle, compteur >> 1, points);
	  }
	  return;
	}
      }
      
      /* On trace s'il reste des points */
      if ( (compteur < 256) && (compteur > 0) )
      {
	if (graphe->style < 7)
	  v_pline  (station->handle, compteur >> 1, points); /* On trace ce qui reste */
	else
	  v_pmarker(station->handle, compteur >> 1, points);
      }
    }

    return; /* On a fini */
  }

  if (  ( courbe->drapeaux.complexe == GR_IM_MOD )
     || ( courbe->drapeaux.complexe == GR_RE_IM  ) ) /* Graphe complexe, tracer la partie imag. */
  {
    register Complexe *zone_y = (Complexe *) courbe->y;

    while (i < courbe->nombre_point) /* Tant qu'il reste des points */
    {
      while ( (*zone_x     < x_min) || (*zone_x     > x_max) /* On dborde */
	   || ( zone_y->im < y_min) || ( zone_y->im > y_max) )
      {
	zone_x++; zone_y++; /* On passe au point suivant */
	i++;
	if (i >= courbe->nombre_point) break; /* On s'arrte */
      }

      if (i >= courbe->nombre_point)
	break;

      compteur = 0; /* On commence un nouveau trac */
      while ( (*zone_x     >= x_min) && (*zone_x     <= x_max) /* On dborde */
	   && ( zone_y->im >= y_min) && ( zone_y->im <= y_max) )
      {
	points[compteur]   = x + (*(zone_x) -  x_min) * x_echelle;
	points[compteur+1] = y + (y_max - zone_y->im) * y_echelle;
	compteur += 2;
	if (compteur >= 256) /* Tableau intin plein */
	{
	  if (graphe->style < 7)
	    v_pline  (station->handle, 128, points); /* On trace ces 128 points */
	  else
	    v_pmarker(station->handle, 128, points);
	  points[0] = points[254];
	  points[1] = points[255];
	  compteur = 2;
	}
	zone_x++; zone_y++;
	i++; /* Point suivant */
	if (i >= courbe->nombre_point)
	{
	  if (compteur < 256)
	  {
	    if (graphe->style < 7)
	      v_pline  (station->handle, compteur >> 1, points); /* On trace ces points */
	    else
	      v_pmarker(station->handle, compteur >> 1, points);
	  }
	  break;
	}
      }

      /* On trace s'il reste des points */
      if ( (compteur < 256) && (compteur > 0) )
      {
	if (graphe->style < 7)
	  v_pline  (station->handle, compteur >> 1, points); /* On trace ce qui reste */
	else
	  v_pmarker(station->handle, compteur >> 1, points);
      }
    }
  }

  if ( ( courbe->drapeaux.complexe == GR_IM_MOD )
    || ( courbe->drapeaux.complexe == GR_RE_MOD ) ) /* Graphe complexe : trac du module */
  {
    register Complexe *y_courbe = (Complexe *) courbe->y;
    double module;

    vsl_color(station->handle, graphe->couleur + 1); /* On utilise la couleur suivante */
    vsm_color(station->handle, graphe->couleur + 1);

    zone_x = courbe->x;
    i = 0; compteur = 0; /* Remise des compteurs  0 */
    
    if ( y_max <= 0 ) /* Le module tant forcment positif, rien  tracer... */
      return;

    while (i < courbe->nombre_point) /* Tant qu'il reste des points */
    {
      module = sqrt( y_courbe->re * y_courbe->re + y_courbe->im * y_courbe->im );
			
      while ( (*zone_x < x_min) || (*zone_x > x_max) /* On dborde */
	   || ( module < y_min) || ( module > y_max) )
      {
	zone_x++; y_courbe++; /* On passe au point suivant */
	i++;
	if (i >= courbe->nombre_point) break; /* On s'arrte */

	module = sqrt( y_courbe->re * y_courbe->re + y_courbe->im * y_courbe->im );
      }
      if (i >= courbe->nombre_point)
	break;

      compteur = 0; /* On commence un nouveau trac */
      while ( (*zone_x >= x_min) && (*zone_x <= x_max) /* On dborde */
	   && ( module >= y_min) && ( module <= y_max) )
      {
	points[compteur]   = x + (*(zone_x) -  x_min) * x_echelle;
	points[compteur+1] = y + (  y_max   - module) * y_echelle;
	compteur += 2;
	if (compteur >= 256) /* Tableau intin plein */
	{
	  if (graphe->style < 7)
	    v_pline  (station->handle, 128, points); /* On trace ces 128 points */
	  else
	    v_pmarker(station->handle, 128, points);
	  points[0] = points[254];
	  points[1] = points[255];
	  compteur = 2;
	}
	zone_x++; y_courbe++;
	i++; /* Point suivant */
	if (i >= courbe->nombre_point)
	{
	  if (compteur < 256)
	  {
	    if (graphe->style < 7)
	      v_pline  (station->handle, compteur >> 1, points); /* On trace ces points */
	    else
	      v_pmarker(station->handle, compteur >> 1, points);
	  }
	  break;
	}

	module = sqrt( y_courbe->re * y_courbe->re + y_courbe->im * y_courbe->im );
      }

      /* On trace s'il reste des points */
      if ( (compteur < 256) && (compteur > 0) )
      {
	if (graphe->style < 7)
	  v_pline  (station->handle, compteur >> 1, points); /* On trace ce qui reste */
	else
	  v_pmarker(station->handle, compteur >> 1, points);
      }
    }
    
    return; /* On a fini */
  }
}

/* ---------------------- Trac d'un polynme dont on donne les X et les coefficients ------------\
 |    Ne renvoie rien
 |    Ne permet de dessiner qu' l'cran
 |
 | nbr_pts              : nombre de points  tracer
 | degre                : degr du polynome  tracer
 | coefs                : les coefficients
 | x                    : le tableau des X
 | x_echelle, y_echelle : chelles en X et Y
 | x_min    , x_max     : bornes admissibles en X
 | y_min    , y_max     : bornes admissibles en Y
 | x_trace  , y_trace   : origine du trac
 \---------------------------------------------------------------------------------------------- */

void TRC_poly(unsigned long nbr_pts, char degre, double *coefs, double *x,
              double x_echelle, double y_echelle, double x_trace, double y_trace,
              double x_min, double x_max, double y_min, double y_max)
{
  unsigned int compteur = 0;
  unsigned long index = 0;
  double y, x_n;
  short int i;

  if ( (x == NULL) || (coefs == NULL) ) return; /* Paramtres idiots... */

  if (degre == 0) /* On trace une constante... */
  {
    points[0] = x_trace + x_echelle * (x[0]  - x_min);
    points[1] = y_trace + y_echelle * (y_max - coefs[0]);
    points[2] = x_trace + x_echelle * (x[nbr_pts - 1] - x_min);
    points[3] = points[1];
    v_pline(_PRG_station->handle, 2, points);
    return;
  }

  if (degre == 1) /* On trace une droite */
  {
    points[0] = x_trace + x_echelle * (x[0]  - x_min);
    y = coefs[0] + coefs[1] * x[0];
    points[1] = y_trace + y_echelle * (y_max - y);
    points[2] = x_trace + x_echelle * (x[nbr_pts - 1] - x_min);
    y = coefs[0] + coefs[1] * x[nbr_pts - 1];
    points[3] = y_trace + y_echelle * (y_max - y);
    v_pline(_PRG_station->handle, 2, points);
    return;
  }

  /* Polynme de degr suprieur : on trace donc point par point... */

  /* Calcul du premier point - pour vrifier les validits */

  x_n = *x;
  y = coefs[0] + x_n * coefs[1];
  for (i = 2 ; i <= degre ; i++)
  {
    x_n *= *x;
    y += coefs[i] * x_n;
  }

  while (index < nbr_pts) /* Tant qu'il reste des points */
  {
    while ( (*x < x_min) || (*x > x_max)
	 || ( y < y_min) || ( y > y_max) ) /* On dborde */
    {
      x++; /* On passe au point suivant */
      index++;
      if (index >= nbr_pts) break; /* On s'arrte */
      
      x_n = *x;
      y = coefs[0] + x_n * coefs[1];
      for (i = 2 ; i <= degre ; i++)
      {
	x_n *= *x;
	y += coefs[i] * x_n;
      }
    }

    /* On est l <=> le point (x, y) courant doit tre trac */

    compteur = 0; /* On commence un nouveau trac */
    do
    {
      points[compteur]   = x_trace + (*x - x_min) * x_echelle;
      x_n = *x;
      y = coefs[0] + x_n * coefs[1];
      for (i = 2 ; i <= degre ; i++)
      {
	x_n *= *x;
	y += coefs[i] * x_n;
      }

      points[compteur+1] = y_trace + (y_max - y) * y_echelle;
      compteur += 2;
      if (compteur >= 256) /* Tableau intin plein */
      {
	v_pline(_PRG_station->handle, 128, points); /* On trace ces 128 points */
	points[0] = points[254];
	points[1] = points[255];
	compteur = 2;
      }
      x++;
      index++; /* Point suivant */
      if (index >= nbr_pts)
      {
	break;
      }
    }
    while ( (*x >= x_min) && (*x <= x_max)
	 && ( y >= y_min) && ( y <= y_max) ); /* On reste dans la zone de trac */

    /* On trace s'il reste des points */
    if ( (compteur < 256) && (compteur > 1) )
    {
      v_pline(_PRG_station->handle, compteur >> 1, points); /* On trace ce qui reste */
    }
  }
}

/************************ Le paramtrage du trac (axes, graphes,...) ****************************/

/* ---------------------- Paramtrage des axes (lgendes, graduation,...) ------------------------\
 |     Ne renvoie rien
 |
 | axe : adresse des infos de l'axe que l'on veut paramtrer
 \----------------------------------------------------------------------------------------------- */

void chg_legende(Axe *axe)
{
  OBJECT *adresse = arbres[PARAM_LEGENDE].adresse;

  if (axe == NULL) return; /* Rien  faire, forcment */
  
  /* On prpare l'arbre comme il faut */
  
  OB_SPEC(adresse, LEG_GRAD_COUL) &= 0xFFFFFFF0L; /* On met les 4 derniers bits  0 */
  OB_SPEC(adresse, LEG_GRAD_COUL) |= axe->couleurs.grille;
  OB_SPEC(adresse, LEG_TXT_COUL)  &= 0xFFFFFFF0L; /* On met les 4 derniers bits  0 */
  OB_SPEC(adresse, LEG_TXT_COUL)  |= axe->couleurs.texte;

  ( (USERBLK *) OB_SPEC(adresse, LEG_STYLE) )->ub_parm = axe->styl_grille;

  OBJ_choisit(PARAM_LEGENDE, LEG_NONGRADUE,    axe->graduation.gradue == PAS_GRADUE);
  OBJ_choisit(PARAM_LEGENDE, LEG_GRAD_DECIMAL, axe->graduation.gradue == GRADUE_DECIMAL);
  OBJ_choisit(PARAM_LEGENDE, LEG_GRAD_LOG,     axe->graduation.gradue == GRADUE_LOG);
  OBJ_choisit(PARAM_LEGENDE, LEG_GRILLE,  axe->graduation.grille);
  OBJ_choisit(PARAM_LEGENDE, LEG_DIX,     axe->graduation.dixieme);
  OBJ_choisit(PARAM_LEGENDE, LEG_CENT,    axe->graduation.centieme);
  OBJ_choisit(PARAM_LEGENDE, LEG_VISIBLE, axe->graduation.visible);

  met_chaine (PARAM_LEGENDE, LEG_UNITE, 0, axe->unite, TXT_COPIER);
  met_chaine (PARAM_LEGENDE, LEG_TEXTE, 0, axe->legende, TXT_COPIER);
  met_fvaleur(PARAM_LEGENDE, LEG_TXT_TAILLE, (double) axe->taille_txt / 100.0);
  
  /* On l'appelle */
  if ( ext_formdo(PARAM_LEGENDE) == LEG_ANNULE ) /* On annule les modifications */
    return;

  /* On enregistre les modifications */
  if ( OBJ_choisit(PARAM_LEGENDE, LEG_NONGRADUE,    QUESTION) )
    axe->graduation.gradue = PAS_GRADUE;
  if ( OBJ_choisit(PARAM_LEGENDE, LEG_GRAD_DECIMAL, QUESTION) )
    axe->graduation.gradue = GRADUE_DECIMAL;
  if ( OBJ_choisit(PARAM_LEGENDE, LEG_GRAD_LOG,     QUESTION) )
    axe->graduation.gradue = GRADUE_LOG;

  axe->graduation.grille   = OBJ_choisit(PARAM_LEGENDE, LEG_GRILLE,  QUESTION);
  axe->graduation.dixieme  = OBJ_choisit(PARAM_LEGENDE, LEG_DIX,     QUESTION);
  axe->graduation.centieme = OBJ_choisit(PARAM_LEGENDE, LEG_CENT,    QUESTION);
  axe->graduation.visible  = OBJ_choisit(PARAM_LEGENDE, LEG_VISIBLE, QUESTION);

  axe->couleurs.grille = (unsigned) ( OB_SPEC(adresse, LEG_GRAD_COUL) & 0xF );
  axe->couleurs.texte  = (unsigned) ( OB_SPEC(adresse, LEG_TXT_COUL ) & 0xF );
  
  axe->styl_grille = ( (USERBLK *) OB_SPEC(adresse, LEG_STYLE) )->ub_parm;

  lit_chaine(PARAM_LEGENDE, LEG_TEXTE, 49, axe->legende, TXT_COPIER); /* Lgende : 50 cars max. */
  lit_chaine(PARAM_LEGENDE, LEG_UNITE,  6, axe->unite,   TXT_COPIER); /* Unit   :  6 cars max. */

  axe->taille_txt = (int) ( 100.0 * prend_fvaleur(PARAM_LEGENDE, LEG_TXT_TAILLE) );
}

/* ---------------------- Paramtrage des bornes de trac (X et Y) -------------------------------\
 |     Ne renvoie rien
 |
 | rect : adresse du rectangle pour lequel on doit changer les bornes
 \----------------------------------------------------------------------------------------------- */

void chg_bornes(Rect_graphe *rect)
{
  int retour = 0;

  if (rect == NULL) return;

  met_fvaleur(CHG_BORNES, BORNE_XMIN, rect->x_min); /* On met les bornes actuelles */
  met_fvaleur(CHG_BORNES, BORNE_XMAX, rect->x_max);
  met_fvaleur(CHG_BORNES, BORNE_YMIN, rect->y_min);
  met_fvaleur(CHG_BORNES, BORNE_YMAX, rect->y_max);

  while (retour != BORNE_OK)
  {
    retour = ext_formdo(CHG_BORNES);
    if (retour == BORNE_ANNULE) /* On annule tout */
      return;

    if (retour == BORNE_COLLE) /* On s'arrange pour mettre les bornes "idales" */
    {
      REC_bornes( rect ); /* On calcule les bornes idales */

      met_fvaleur(CHG_BORNES, BORNE_XMIN, rect->x_min); /* On les affiche */
      met_fvaleur(CHG_BORNES, BORNE_XMAX, rect->x_max);
      met_fvaleur(CHG_BORNES, BORNE_YMIN, rect->y_min);
      met_fvaleur(CHG_BORNES, BORNE_YMAX, rect->y_max);	
    }
  }

  rect->x_min = prend_fvaleur(CHG_BORNES, BORNE_XMIN);
  rect->x_max = prend_fvaleur(CHG_BORNES, BORNE_XMAX);
  if (rect->x_min > rect->x_max) /* On vrifie le bon ordre... */
  {
    double inter = rect->x_min;
    rect->x_min = rect->x_max;
    rect->x_max = inter;
  }

  rect->y_min = prend_fvaleur(CHG_BORNES, BORNE_YMIN);
  rect->y_max = prend_fvaleur(CHG_BORNES, BORNE_YMAX);
  if (rect->y_min > rect->y_max) /* On vrifie le bon ordre... */
  {
    double inter = rect->y_min;
    rect->y_min = rect->y_max;
    rect->y_max = inter;
  }
}
