/* Traitement de l'E.X.A.F.S. sous TOS, MagiC, ...
				 Dclaration de toutes les variables globales, regroupes ici
   (c) Emmanuel CURIS 1996 - 1997

	tat : essayer de comprendre pourquoi init de RCT_courant marche pas !

  27 mars 1998
    * Utilisation de systeme.h
    * Noms de fichiers en majuscules

   5 fvrier 1998
    * Dclar le pointeur de fichier pour l'historique

   9 dcembre 1997
    * Modifi initialisation de RCT_courant : plus propre...

  26 & 27 novembre 1997
    * Supprim nom_type (ne sert plus : cod dans le ressource maintenant...)
    * Modifi paramtres par dfaut pour le graphe courant : grille pointille, grise, visible
*/

#define _VARIABLES_ 

#include <stdio.h>
#include <stdlib.h>

#include "SYSTEME.H"

#include "EXAFS.H"
#include "GRAPHES.H"

int _rien_; /* Pour les cas o une fonction renvoie une valeur totalement inutile... */

int points[256],compteur;                  /* Pour tracer les graphes */

/* ~~~~~~~~~~~ Confort de l'utilisateur, donc choses diverses ~~~~~~~~~~~~~~~~~~~~~~ */

FILE *Histoire = NULL;  /* Le fichier contenant l'historique de la sance de travail */

/* ~~~~~~~~~~~ Fentre principale (affichage du graphe courant,...) ~~~~~~~~~~~~~~~~ */

Fenetre *principale; /* Structure de fentre de la fentre principale            */

Rect_graphe RCT_courant = 
{
  40, 10, /* Position du coin suprieur gauche */
  10, 40, /*                  infrieur droit  */
  0.0, 0.0, 0.0, 0.0, /* Intervalles de trac ->  adapter au graphe courant */
  {
    { 'S', 'a', 'n', 's', ' ', 'l', '', 'g', 'e', 'n', 'd', 'e', ' ', '-', 'A', 'x', 'e', ' ', 'd', 'e', 's', ' ', 'X', 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
    {'_', '_', '_', '_', '_', '_', 0 },
    { GRADUE_DECIMAL, 1, 0, 0, 1, 0, 0 },
    { GRIS_FONCE, NOIR },
    3, 800, 0
  },
      { { 'S', 'a', 'n', 's', ' ', 'l', '', 'g', 'e', 'n', 'd', 'e', ' ', '-', 'A', 'x', 'e', ' ', 'd', 'e', 's', ' ', 'Y', 0, 0, 0,
	    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
	  {'_', '_', '_', '_', '_', '_', 0 },
	  { GRADUE_DECIMAL, 1, FAUX, FAUX, 1, FAUX, 0 },
	  { GRIS_FONCE, NOIR },
	  3, 800, 0
      },
	    1L,    /* Un seul graphe, obligatoirement */
	    NULL   /* On fera pointer dans le programme lui-mme */
}; /* Paramtres d'affichage du graphe courant */

DES_graphe DES_courant = { NULL, NULL, 1, 1 }; /* Paramtres de dessin du graphe courant */

const char *extensions[] = /* Extension associe  chaque type de graphe */
{
  "brt", "exp", "der", "de2", "*"  , "*" , "exf", "tf" , "tfi", "amp",
  "pha", "aj" , "mu0", "cmp", "rdf", "re", "im" , "abs", "arg", "i0" ,
  "i1" , "lpr", "fen", "sig", "s02"
};

#ifdef _FRANCAIS_

const char *Type_graphe[] =
{
  "Absorption brute exp"e_AIGU"rimentale",
  "Absorption de l'atome central",
  "D"e_AIGU"riv"e_AIGU"e premi"e_GRAVE"re",
  "D"e_AIGU"riv"e_AIGU"e seconde",
  "Signal E.X.A.F.S., brut",
  "Signal E.X.A.F.S., en cours de correction",
  "Signal E.X.A.F.S., propre",
  "Transform"e_AIGU"e de Fourier",
  "Transform"e_AIGU"e de Fourier inverse",
  "Amplitude d'un signal E.X.A.F.S.",
  "D"e_AIGU"phasage d'un signal E.X.A.F.S.",
  "Graphe apr"e_GRAVE"s ajustement",
  "Polyn"o_CIRC"me soustrait (absorption atomique)",
  "Diff"e_AIGU"rence de deux graphes",
  "Fonction de distribution radiale",
  "Partie r"e_AIGU"elle",
  "Partie imaginaire",
  "Module",
  "Argument",
  "Intensit"e_AIGU" dans la chambre I0",
  "Intensit"e_AIGU" dans la chambre I1",
  "Libre parcours moyen",
  "Fen"e_CIRC"tre pour la T.F.",
  "D"e_AIGU"viation standard ("e_AIGU"cart type)",
  "Facteur de r"e_AIGU"duction de l'amplitude"
};

#endif /* Franais */

#ifdef _ENGLISH_

const char *Type_graphe[] =
{
  "Raw absorption (experimental)",
  "Central atom absorption",
  "First derivative",
  "Second derivative",
  "Raw EXAFS signal",
  "EXAFS, beeing corrected",
  "Clean EXAFS signal",
  "Fourier transform",
  "Inverse Fourier transform",
  "EXAFS amplitude",
  "EXAFS dephasage",
  "Graph after fitting",
  "Atomic absorption (substracted polynom)",
  "Difference of two graphes",
  "Radial distribution function",
  "Real part",
  "Imaginary part",
  "Module",
  "Argument",
  "Intensity in I0 chamber",
  "Intensity in I1 chamber",
  "Mean free path",
  "Window for FT",
  "Standard deviation",
  "Reduction factor"
};

#endif /* Anglais */

char titre[300];      /* Pour les titres de graphes                 */

Graphe *premier_graphe = NULL; /* Premier graphe de la liste des graphes */
Graphe *dernier_graphe = NULL; /* Dernier graphe de cette liste          */
Graphe *graphe_courant = NULL; /* Graphe actuellement utilis (dans la fentre principale) */
unsigned long nbr_graphes = 0; /* Nombre de graphes en mmoire */
unsigned long num_graphe  = 0; /* Numro du graphe courant     */

Graphe *liste[14];    /* Pour la liste des graphes, dans les dialogues */

/* ~~~~~~~~~~~~~~~~ Superposition de plusieurs graphes ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

Fenetre *trace_fenetre = NULL; /* Fentre des tracs multiples */
int trace_handle  = 0; /* Handle de la fentre de tracs multiples       */

Cadre *prem_rectangle = NULL; /* Premier rectangle contenant des graphes, pour cette liste */

/* ~~~~~~~~~~~~~~~~ Diverses variables utilises de ci, de l ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

Graphe *mu0_soustrait = NULL; /* Polynme en cours de soustraction       */
Graphe *intermediaire = NULL; /* Utilis pour certains calculs (TF, TFI) */

/* ~~~~~~~~~~~~~~~~ Gestion de << macro-commandes >> ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

boolean TT_xanes = FAUX; /* VRAI -> on veut faire toutes les tapes du   XANES  la suite */
boolean TT_exafs = FAUX; /* VRAI -> on veut faire toutes les tapes de l'EXAFS  la suite */
