/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (c) 1996-1998, Emmanuel CURIS - Date de cration : 22 mai 1998

   Tout ce qui concerne le X.A.N.E.S. - fichier  inclure
*/

#ifndef _XANES_H_

#define _XANES_H_ 

/* ------- Les mthodes de soustraction de mu_matrice ------- */

#define NBR_MUM_METHODES 5

#define MUM_DROITE      0
#define MUM_VICTORINE_1 1
#define MUM_VICTORINE_2 2
#define MUM_LANSBERGER  3 /* Gard par compatibilit,  faire disparatre */
#define MUM_POLYNOME    4
#define MUM_THEORIQUE   5

#define UN_POINT    0 /* On modlise entre graphe->x_min et e1 */
#define DEUX_POINTS 1 /* On modlise entre e1p et e1 */

#define MUM_DEGRE_MAXIMAL 5 /* du polynme pour la soustraction
                               au moins 4, pour coller avec victorine 2 */

typedef struct
{
  double e_1;      /* Valeur de E1                               */
  double e_1p;     /* Valeur de E1 prime, si deux points         */
  double coefs[MUM_DEGRE_MAXIMAL + 1]; /* Valeur des coefficients de la soustraction */
  int type;        /* Type de fonction de modlisation           */
  int type_depart; /* Premier type affich                       */
  int degre;       /* Degre du polynme (1 ... 5)                */
  int mode;        /* UN_POINT ou DEUX_POINTS                    */
  Graphe *extrait; /* Graphe contenant le rsultat               */
  Graphe *mu_calc; /* Graphe contenant un mu thorique (Lansberger) */
} MAT_infos;

void MAT_ouvre     (Graphe *brut);
void MAT_calc      (Graphe *brut, MAT_infos *infos);
void MAT_soustrait (Graphe *brut, Graphe *traite, MAT_infos *infos);

boolean GER_matrice(int num_objet, int x, int y);

/* ---------- Normalisation en modlisant [mu]0 ------------------\
 |   Utilise donc la structure MU1_infos (param. identiques)      |
 \--------------------------------------------------------------- */

void    norm_xanes(Graphe *signal);
boolean GER_xnorm (int num_objet, int x, int y);

#endif /* _XANES_H_ */
