/* Traitement de l'E.X.A.F.S. sur Atari
        Fichier  inclure pour les differentes interfaces et la langue
   (c) 1996 - Emmanuel CURIS

   24 mars 1998
     * Ajout inclusion de "gem_var.h" : plus propre que dans graphes.h

   20 mars 1998
		 * Cration du fichier
		 * Rcupr les inclusions pour le GEM
		 * Dfinitions de 2 systemes (GEM & X_WINDOW) et 6 langues
*/

#ifndef _SYSTEME_H_

#define _SYSTEME_H_ 

/* ------------------- Les langues que l'on peut utiliser
         0 = langue non active
         1 = langue active
*/
/* #define const */
#define ANGLAIS  0
#define ALLEMAND 0
#define ESPAGNOL 0
#define FRANCAIS 1
#define HONGROIS 0
#define ITALIEN  0

/* -------- Codage des accents -------- (mme principe)
   ATARI  = jeu de rfrence -> pas de conversion       */

#define ATARI      0
#define ISO_8859_1 1
#define ISO_8859_2 0
#define PC_WINDOWS 0

#if ATARI
#  include <ac_atari.h>
#endif

#if ISO_8859_1
#  include "latin_1.h"
#endif

#if ISO_8859_2
#  include "latin_2.h"
#endif

/* ------------------- Les systmes d'exploitation
         0 = systme non utilis
         1 = systme utilis
*/

#define GEM      0
#define MAC      0
#define TEXTE    0 /* Si jamais quelqu'un peut tre intress... */
#define WINDOWS  0
#define X_WINDOW 1

/* ----- Partie de dclaration des inclusions en fonction de a ----- */

#if GEM /* On utilise le GEM comme systme d'interface graphique */

# ifdef __GNUC__

#  include <GEMFAST.H> /* Les diffrentes macros GEM & VDI */
#  include <AESBIND.H> /* Fonctions AES */
#  include <OSBIND.H>  /* Fonctions TOS */
#  include <VDIBIND.H> /* Fonctions VDI */

# else

#  include <portab.h>
#  include <xaes.h>
#  include <xvdi.h>
#  include <tos.h>

# endif /* __GNUC__ */

#include "..\etendu.gem\gem_sys.h"  /* Dclarations systme */

#include "..\etendu.gem\gem_gene.h"
#include "..\etendu.gem\gem_fen.h"
#include "..\etendu.gem\gem_tos.h"
#include "..\etendu.gem\gem_vdi.h"
#include "..\etendu.gem\gem_var.h"
#include "..\etendu.gem\gem_errs.h"

#endif /* GEM */

#if X_WINDOW /* X-Window comme systme graphique */

typedef int boolean;

#define FAUX       0
#define VRAI       1
#define _QUITTER 254
#define _FIN_PRG 255

#define cdecl 
#define USR_FONCTION     PARMBLK
#define CONVERT_PARMBLK (PARMBLK *)

#include <X11/X.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xmd.h>

#include "Bib_X/X_general.h"
#include "Bib_X/X_arbres.h"
#include "Bib_X/X_erreurs.h"
#include "Bib_X/X_fenetres.h"
#include "Bib_X/X_fichiers.h"
#include "Bib_X/X_objets.h"
#include "Bib_X/X_ressources.h"
#include "Bib_X/X_tos.h"
#include "Bib_X/X_var.h"
#include "Bib_X/X_vdi.h"

#include "Bib_X/X_evnt_lib.h"
#include "Bib_X/X_form_lib.h"
#include "Bib_X/X_graf_lib.h"
#include "Bib_X/X_menu_lib.h"
#include "Bib_X/X_objc_lib.h"
#include "Bib_X/X_rsrc_lib.h"
#include "Bib_X/X_wind_lib.h"

#include "Bib_X/X_v_lib.h"
#include "Bib_X/X_vs_lib.h"
#include "Bib_X/X_vq_lib.h"
#include "Bib_X/X_vdivers_lib.h"

#endif /* X_WINDOW */

#endif /* _SYSTEME_H_ */
